/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* OpenCL Builtin handling                                                    *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#include "llvm/ADT/StringRef.h"
using namespace clang;

enum OpenCLTypeID {
  OCLT_bool,
  OCLT_char,
  OCLT_double,
  OCLT_Event,
  OCLT_float,
  OCLT_half,
  OCLT_Image1d,
  OCLT_Image1dArray,
  OCLT_Image1dBuffer,
  OCLT_Image2d,
  OCLT_Image2dArray,
  OCLT_Image2dArrayDepth,
  OCLT_Image2dArrayMsaa,
  OCLT_Image2dArrayMsaaDepth,
  OCLT_Image2dDepth,
  OCLT_Image2dMsaa,
  OCLT_Image2dMsaaDepth,
  OCLT_Image3d,
  OCLT_int,
  OCLT_intptr_t,
  OCLT_long,
  OCLT_ptrdiff_t,
  OCLT_Sampler,
  OCLT_short,
  OCLT_size_t,
  OCLT_uchar,
  OCLT_uint,
  OCLT_uintPtr_t,
  OCLT_ulong,
  OCLT_ushort,
  OCLT_void_t,
  OCLT_AGenTypeN,
  OCLT_AGenTypeNNoScalar,
  OCLT_AI2UGenTypeN,
  OCLT_AIGenType1,
  OCLT_AIGenTypeN,
  OCLT_AIGenTypeNNoScalar,
  OCLT_FGenTypeN,
  OCLT_GenTypeCharVecAndScalar,
  OCLT_GenTypeCharVecNoScalar,
  OCLT_GenTypeDoubleVec1234,
  OCLT_GenTypeDoubleVecAndScalar,
  OCLT_GenTypeDoubleVecNoScalar,
  OCLT_GenTypeFloatVec1234,
  OCLT_GenTypeFloatVecAndScalar,
  OCLT_GenTypeFloatVecNoScalar,
  OCLT_GenTypeHalfVec1234,
  OCLT_GenTypeHalfVecAndScalar,
  OCLT_GenTypeHalfVecNoScalar,
  OCLT_GenTypeIntVecAndScalar,
  OCLT_GenTypeIntVecNoScalar,
  OCLT_GenTypeLongVecAndScalar,
  OCLT_GenTypeLongVecNoScalar,
  OCLT_GenTypeShortVecAndScalar,
  OCLT_GenTypeShortVecNoScalar,
  OCLT_GenTypeUCharVecAndScalar,
  OCLT_GenTypeUCharVecNoScalar,
  OCLT_GenTypeUIntVecAndScalar,
  OCLT_GenTypeUIntVecNoScalar,
  OCLT_GenTypeULongVecAndScalar,
  OCLT_GenTypeULongVecNoScalar,
  OCLT_GenTypeUShortVecAndScalar,
  OCLT_GenTypeUShortVecNoScalar,
  OCLT_IntLongFloatGenType1,
  OCLT_SGenTypeN,
  OCLT_UGenTypeN,
  OCLT_TLAllVec2,
  OCLT_TLAllUnsignedVec2,
  OCLT_TLAllVec4,
  OCLT_TLAllVec8,
  OCLT_TLAllVec16,
  OCLT_TLAllUnsignedVec4,
  OCLT_TLAllUnsignedVec8,
  OCLT_TLAllUnsignedVec16,
};

// Image access qualifier.
enum OpenCLAccessQual : unsigned char {
  OCLAQ_None,
  OCLAQ_ReadOnly,
  OCLAQ_WriteOnly,
  OCLAQ_ReadWrite
};

// Represents a return type or argument type.
struct OpenCLTypeStruct {
  // A type (e.g. float, int, ...).
  const OpenCLTypeID ID;
  // Vector size (if applicable; 0 for scalars and generic types).
  const unsigned VectorWidth;
  // 0 if the type is not a pointer.
  const bool IsPointer;
  // 0 if the type is not const.
  const bool IsConst;
  // 0 if the type is not volatile.
  const bool IsVolatile;
  // Access qualifier.
  const OpenCLAccessQual AccessQualifier;
  // Address space of the pointer (if applicable).
  const LangAS AS;
};

// One overload of an OpenCL builtin function.
struct OpenCLBuiltinStruct {
  // Index of the signature in the OpenCLTypeStruct table.
  const unsigned SigTableIndex;
  // Entries between index SigTableIndex and (SigTableIndex + NumTypes - 1) in
  // the SignatureTable represent the complete signature.  The first type at
  // index SigTableIndex is the return type.
  const unsigned NumTypes;
  // Function attribute __attribute__((pure))
  const bool IsPure;
  // Function attribute __attribute__((const))
  const bool IsConst;
  // Function attribute __attribute__((convergent))
  const bool IsConv;
  // OpenCL extension(s) required for this overload.
  const unsigned short Extension;
  // First OpenCL version in which this overload was introduced (e.g. CL20).
  const unsigned short MinVersion;
  // First OpenCL version in which this overload was removed (e.g. CL20).
  const unsigned short MaxVersion;
};

static const char *FunctionExtensionTable[] = {
  // 0: FuncExtKhrGlMsaaSharing
  "cl_khr_gl_msaa_sharing",
  // 1: FuncExtKhrGlobalInt32BaseAtomics
  "cl_khr_global_int32_base_atomics",
  // 2: FuncExtKhrGlobalInt32ExtendedAtomics
  "cl_khr_global_int32_extended_atomics",
  // 3: FuncExtKhrInt64BaseAtomics
  "cl_khr_int64_base_atomics",
  // 4: FuncExtKhrInt64ExtendedAtomics
  "cl_khr_int64_extended_atomics",
  // 5: FuncExtKhrLocalInt32BaseAtomics
  "cl_khr_local_int32_base_atomics",
  // 6: FuncExtKhrLocalInt32ExtendedAtomics
  "cl_khr_local_int32_extended_atomics",
  // 7: FuncExtKhrMipmapAndWrite3d
  "cl_khr_mipmap_image cl_khr_3d_image_writes",
  // 8: FuncExtKhrMipmapImage
  "cl_khr_mipmap_image",
  // 9: FuncExtKhrSubgroups
  "cl_khr_subgroups",
  // 10: FuncExtNone
  "",
};

static const OpenCLTypeStruct TypeTable[] = {
  // 0
  {OCLT_AGenTypeN, 0, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 1
  {OCLT_AGenTypeNNoScalar, 0, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 2
  {OCLT_AI2UGenTypeN, 0, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 3
  {OCLT_AIGenType1, 0, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 4
  {OCLT_AIGenTypeN, 0, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 5
  {OCLT_AIGenTypeNNoScalar, 0, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 6
  {OCLT_bool, 1, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 7
  {OCLT_char, 1, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 8
  {OCLT_double, 1, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 9
  {OCLT_Event, 1, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 10
  {OCLT_FGenTypeN, 0, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 11
  {OCLT_float, 1, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 12
  {OCLT_GenTypeCharVecAndScalar, 0, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 13
  {OCLT_GenTypeCharVecNoScalar, 0, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 14
  {OCLT_GenTypeDoubleVec1234, 0, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 15
  {OCLT_GenTypeDoubleVecAndScalar, 0, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 16
  {OCLT_GenTypeDoubleVecNoScalar, 0, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 17
  {OCLT_GenTypeFloatVec1234, 0, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 18
  {OCLT_GenTypeFloatVecAndScalar, 0, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 19
  {OCLT_GenTypeFloatVecNoScalar, 0, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 20
  {OCLT_GenTypeHalfVec1234, 0, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 21
  {OCLT_GenTypeHalfVecAndScalar, 0, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 22
  {OCLT_GenTypeHalfVecNoScalar, 0, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 23
  {OCLT_GenTypeIntVecAndScalar, 0, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 24
  {OCLT_GenTypeIntVecNoScalar, 0, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 25
  {OCLT_GenTypeLongVecAndScalar, 0, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 26
  {OCLT_GenTypeLongVecNoScalar, 0, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 27
  {OCLT_GenTypeShortVecAndScalar, 0, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 28
  {OCLT_GenTypeShortVecNoScalar, 0, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 29
  {OCLT_GenTypeUCharVecAndScalar, 0, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 30
  {OCLT_GenTypeUCharVecNoScalar, 0, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 31
  {OCLT_GenTypeUIntVecAndScalar, 0, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 32
  {OCLT_GenTypeUIntVecNoScalar, 0, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 33
  {OCLT_GenTypeULongVecAndScalar, 0, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 34
  {OCLT_GenTypeULongVecNoScalar, 0, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 35
  {OCLT_GenTypeUShortVecAndScalar, 0, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 36
  {OCLT_GenTypeUShortVecNoScalar, 0, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 37
  {OCLT_half, 1, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 38
  {OCLT_Image1d, 1, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 39
  {OCLT_Image1dArray, 1, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 40
  {OCLT_Image1dBuffer, 1, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 41
  {OCLT_Image2d, 1, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 42
  {OCLT_Image2dArray, 1, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 43
  {OCLT_Image2dArrayDepth, 1, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 44
  {OCLT_Image2dArrayMsaa, 1, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 45
  {OCLT_Image2dArrayMsaaDepth, 1, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 46
  {OCLT_Image2dDepth, 1, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 47
  {OCLT_Image2dMsaa, 1, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 48
  {OCLT_Image2dMsaaDepth, 1, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 49
  {OCLT_Image3d, 1, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 50
  {OCLT_int, 1, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 51
  {OCLT_IntLongFloatGenType1, 0, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 52
  {OCLT_intptr_t, 1, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 53
  {OCLT_long, 1, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 54
  {OCLT_ptrdiff_t, 1, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 55
  {OCLT_SGenTypeN, 0, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 56
  {OCLT_Sampler, 1, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 57
  {OCLT_short, 1, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 58
  {OCLT_size_t, 1, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 59
  {OCLT_uchar, 1, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 60
  {OCLT_UGenTypeN, 0, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 61
  {OCLT_uint, 1, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 62
  {OCLT_uintPtr_t, 1, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 63
  {OCLT_ulong, 1, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 64
  {OCLT_ushort, 1, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 65
  {OCLT_void_t, 1, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 66
  {OCLT_double, 2, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 67
  {OCLT_double, 3, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 68
  {OCLT_double, 4, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 69
  {OCLT_double, 8, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 70
  {OCLT_double, 16, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 71
  {OCLT_half, 2, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 72
  {OCLT_half, 3, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 73
  {OCLT_half, 4, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 74
  {OCLT_half, 8, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 75
  {OCLT_half, 16, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 76
  {OCLT_char, 2, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 77
  {OCLT_char, 3, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 78
  {OCLT_char, 4, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 79
  {OCLT_char, 8, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 80
  {OCLT_char, 16, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 81
  {OCLT_uchar, 2, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 82
  {OCLT_uchar, 3, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 83
  {OCLT_uchar, 4, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 84
  {OCLT_uchar, 8, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 85
  {OCLT_uchar, 16, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 86
  {OCLT_short, 2, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 87
  {OCLT_short, 3, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 88
  {OCLT_short, 4, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 89
  {OCLT_short, 8, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 90
  {OCLT_short, 16, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 91
  {OCLT_ushort, 2, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 92
  {OCLT_ushort, 3, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 93
  {OCLT_ushort, 4, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 94
  {OCLT_ushort, 8, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 95
  {OCLT_ushort, 16, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 96
  {OCLT_float, 2, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 97
  {OCLT_float, 3, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 98
  {OCLT_float, 4, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 99
  {OCLT_int, 2, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 100
  {OCLT_float, 8, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 101
  {OCLT_int, 3, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 102
  {OCLT_int, 4, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 103
  {OCLT_int, 8, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 104
  {OCLT_int, 16, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 105
  {OCLT_float, 16, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 106
  {OCLT_uint, 2, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 107
  {OCLT_uint, 3, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 108
  {OCLT_uint, 4, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 109
  {OCLT_uint, 8, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 110
  {OCLT_uint, 16, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 111
  {OCLT_long, 2, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 112
  {OCLT_long, 3, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 113
  {OCLT_long, 4, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 114
  {OCLT_long, 8, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 115
  {OCLT_long, 16, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 116
  {OCLT_ulong, 2, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 117
  {OCLT_ulong, 3, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 118
  {OCLT_ulong, 4, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 119
  {OCLT_ulong, 8, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 120
  {OCLT_ulong, 16, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 121
  {OCLT_FGenTypeN, 0, 1, 0, 0, OCLAQ_None, clang::LangAS::opencl_global},
  // 122
  {OCLT_GenTypeIntVecAndScalar, 0, 1, 0, 0, OCLAQ_None, clang::LangAS::opencl_global},
  // 123
  {OCLT_FGenTypeN, 0, 1, 0, 0, OCLAQ_None, clang::LangAS::opencl_local},
  // 124
  {OCLT_GenTypeIntVecAndScalar, 0, 1, 0, 0, OCLAQ_None, clang::LangAS::opencl_local},
  // 125
  {OCLT_FGenTypeN, 0, 1, 0, 0, OCLAQ_None, clang::LangAS::opencl_private},
  // 126
  {OCLT_GenTypeIntVecAndScalar, 0, 1, 0, 0, OCLAQ_None, clang::LangAS::opencl_private},
  // 127
  {OCLT_FGenTypeN, 0, 1, 0, 0, OCLAQ_None, clang::LangAS::opencl_generic},
  // 128
  {OCLT_GenTypeIntVecAndScalar, 0, 1, 0, 0, OCLAQ_None, clang::LangAS::opencl_generic},
  // 129
  {OCLT_char, 1, 0, 1, 0, OCLAQ_None, clang::LangAS::Default},
  // 130
  {OCLT_uchar, 1, 0, 1, 0, OCLAQ_None, clang::LangAS::Default},
  // 131
  {OCLT_short, 1, 0, 1, 0, OCLAQ_None, clang::LangAS::Default},
  // 132
  {OCLT_ushort, 1, 0, 1, 0, OCLAQ_None, clang::LangAS::Default},
  // 133
  {OCLT_int, 1, 0, 1, 0, OCLAQ_None, clang::LangAS::Default},
  // 134
  {OCLT_uint, 1, 0, 1, 0, OCLAQ_None, clang::LangAS::Default},
  // 135
  {OCLT_long, 1, 0, 1, 0, OCLAQ_None, clang::LangAS::Default},
  // 136
  {OCLT_ulong, 1, 0, 1, 0, OCLAQ_None, clang::LangAS::Default},
  // 137
  {OCLT_float, 1, 0, 1, 0, OCLAQ_None, clang::LangAS::Default},
  // 138
  {OCLT_double, 1, 0, 1, 0, OCLAQ_None, clang::LangAS::Default},
  // 139
  {OCLT_half, 1, 0, 1, 0, OCLAQ_None, clang::LangAS::Default},
  // 140
  {OCLT_char, 1, 1, 1, 0, OCLAQ_None, clang::LangAS::opencl_global},
  // 141
  {OCLT_uchar, 1, 1, 1, 0, OCLAQ_None, clang::LangAS::opencl_global},
  // 142
  {OCLT_short, 1, 1, 1, 0, OCLAQ_None, clang::LangAS::opencl_global},
  // 143
  {OCLT_ushort, 1, 1, 1, 0, OCLAQ_None, clang::LangAS::opencl_global},
  // 144
  {OCLT_int, 1, 1, 1, 0, OCLAQ_None, clang::LangAS::opencl_global},
  // 145
  {OCLT_uint, 1, 1, 1, 0, OCLAQ_None, clang::LangAS::opencl_global},
  // 146
  {OCLT_long, 1, 1, 1, 0, OCLAQ_None, clang::LangAS::opencl_global},
  // 147
  {OCLT_ulong, 1, 1, 1, 0, OCLAQ_None, clang::LangAS::opencl_global},
  // 148
  {OCLT_float, 1, 1, 1, 0, OCLAQ_None, clang::LangAS::opencl_global},
  // 149
  {OCLT_double, 1, 1, 1, 0, OCLAQ_None, clang::LangAS::opencl_global},
  // 150
  {OCLT_half, 1, 1, 1, 0, OCLAQ_None, clang::LangAS::opencl_global},
  // 151
  {OCLT_half, 1, 1, 0, 0, OCLAQ_None, clang::LangAS::opencl_global},
  // 152
  {OCLT_char, 1, 1, 1, 0, OCLAQ_None, clang::LangAS::opencl_local},
  // 153
  {OCLT_uchar, 1, 1, 1, 0, OCLAQ_None, clang::LangAS::opencl_local},
  // 154
  {OCLT_short, 1, 1, 1, 0, OCLAQ_None, clang::LangAS::opencl_local},
  // 155
  {OCLT_ushort, 1, 1, 1, 0, OCLAQ_None, clang::LangAS::opencl_local},
  // 156
  {OCLT_int, 1, 1, 1, 0, OCLAQ_None, clang::LangAS::opencl_local},
  // 157
  {OCLT_uint, 1, 1, 1, 0, OCLAQ_None, clang::LangAS::opencl_local},
  // 158
  {OCLT_long, 1, 1, 1, 0, OCLAQ_None, clang::LangAS::opencl_local},
  // 159
  {OCLT_ulong, 1, 1, 1, 0, OCLAQ_None, clang::LangAS::opencl_local},
  // 160
  {OCLT_float, 1, 1, 1, 0, OCLAQ_None, clang::LangAS::opencl_local},
  // 161
  {OCLT_double, 1, 1, 1, 0, OCLAQ_None, clang::LangAS::opencl_local},
  // 162
  {OCLT_half, 1, 1, 1, 0, OCLAQ_None, clang::LangAS::opencl_local},
  // 163
  {OCLT_half, 1, 1, 0, 0, OCLAQ_None, clang::LangAS::opencl_local},
  // 164
  {OCLT_char, 1, 1, 1, 0, OCLAQ_None, clang::LangAS::opencl_private},
  // 165
  {OCLT_uchar, 1, 1, 1, 0, OCLAQ_None, clang::LangAS::opencl_private},
  // 166
  {OCLT_short, 1, 1, 1, 0, OCLAQ_None, clang::LangAS::opencl_private},
  // 167
  {OCLT_ushort, 1, 1, 1, 0, OCLAQ_None, clang::LangAS::opencl_private},
  // 168
  {OCLT_int, 1, 1, 1, 0, OCLAQ_None, clang::LangAS::opencl_private},
  // 169
  {OCLT_uint, 1, 1, 1, 0, OCLAQ_None, clang::LangAS::opencl_private},
  // 170
  {OCLT_long, 1, 1, 1, 0, OCLAQ_None, clang::LangAS::opencl_private},
  // 171
  {OCLT_ulong, 1, 1, 1, 0, OCLAQ_None, clang::LangAS::opencl_private},
  // 172
  {OCLT_float, 1, 1, 1, 0, OCLAQ_None, clang::LangAS::opencl_private},
  // 173
  {OCLT_double, 1, 1, 1, 0, OCLAQ_None, clang::LangAS::opencl_private},
  // 174
  {OCLT_half, 1, 1, 1, 0, OCLAQ_None, clang::LangAS::opencl_private},
  // 175
  {OCLT_half, 1, 1, 0, 0, OCLAQ_None, clang::LangAS::opencl_private},
  // 176
  {OCLT_char, 1, 1, 1, 0, OCLAQ_None, clang::LangAS::opencl_generic},
  // 177
  {OCLT_uchar, 1, 1, 1, 0, OCLAQ_None, clang::LangAS::opencl_generic},
  // 178
  {OCLT_short, 1, 1, 1, 0, OCLAQ_None, clang::LangAS::opencl_generic},
  // 179
  {OCLT_ushort, 1, 1, 1, 0, OCLAQ_None, clang::LangAS::opencl_generic},
  // 180
  {OCLT_int, 1, 1, 1, 0, OCLAQ_None, clang::LangAS::opencl_generic},
  // 181
  {OCLT_uint, 1, 1, 1, 0, OCLAQ_None, clang::LangAS::opencl_generic},
  // 182
  {OCLT_long, 1, 1, 1, 0, OCLAQ_None, clang::LangAS::opencl_generic},
  // 183
  {OCLT_ulong, 1, 1, 1, 0, OCLAQ_None, clang::LangAS::opencl_generic},
  // 184
  {OCLT_float, 1, 1, 1, 0, OCLAQ_None, clang::LangAS::opencl_generic},
  // 185
  {OCLT_double, 1, 1, 1, 0, OCLAQ_None, clang::LangAS::opencl_generic},
  // 186
  {OCLT_half, 1, 1, 1, 0, OCLAQ_None, clang::LangAS::opencl_generic},
  // 187
  {OCLT_half, 1, 1, 0, 0, OCLAQ_None, clang::LangAS::opencl_generic},
  // 188
  {OCLT_char, 1, 1, 1, 0, OCLAQ_None, clang::LangAS::opencl_constant},
  // 189
  {OCLT_uchar, 1, 1, 1, 0, OCLAQ_None, clang::LangAS::opencl_constant},
  // 190
  {OCLT_short, 1, 1, 1, 0, OCLAQ_None, clang::LangAS::opencl_constant},
  // 191
  {OCLT_ushort, 1, 1, 1, 0, OCLAQ_None, clang::LangAS::opencl_constant},
  // 192
  {OCLT_int, 1, 1, 1, 0, OCLAQ_None, clang::LangAS::opencl_constant},
  // 193
  {OCLT_uint, 1, 1, 1, 0, OCLAQ_None, clang::LangAS::opencl_constant},
  // 194
  {OCLT_long, 1, 1, 1, 0, OCLAQ_None, clang::LangAS::opencl_constant},
  // 195
  {OCLT_ulong, 1, 1, 1, 0, OCLAQ_None, clang::LangAS::opencl_constant},
  // 196
  {OCLT_float, 1, 1, 1, 0, OCLAQ_None, clang::LangAS::opencl_constant},
  // 197
  {OCLT_double, 1, 1, 1, 0, OCLAQ_None, clang::LangAS::opencl_constant},
  // 198
  {OCLT_half, 1, 1, 1, 0, OCLAQ_None, clang::LangAS::opencl_constant},
  // 199
  {OCLT_half, 1, 1, 0, 0, OCLAQ_None, clang::LangAS::opencl_constant},
  // 200
  {OCLT_AGenTypeN, 0, 1, 0, 0, OCLAQ_None, clang::LangAS::opencl_local},
  // 201
  {OCLT_AGenTypeN, 0, 0, 1, 0, OCLAQ_None, clang::LangAS::Default},
  // 202
  {OCLT_AGenTypeN, 0, 1, 1, 0, OCLAQ_None, clang::LangAS::opencl_global},
  // 203
  {OCLT_AGenTypeN, 0, 1, 0, 0, OCLAQ_None, clang::LangAS::opencl_global},
  // 204
  {OCLT_AGenTypeN, 0, 1, 1, 0, OCLAQ_None, clang::LangAS::opencl_local},
  // 205
  {OCLT_Event, 1, 1, 0, 0, OCLAQ_None, clang::LangAS::opencl_generic},
  // 206
  {OCLT_int, 1, 0, 0, 1, OCLAQ_None, clang::LangAS::Default},
  // 207
  {OCLT_int, 1, 1, 0, 1, OCLAQ_None, clang::LangAS::opencl_global},
  // 208
  {OCLT_uint, 1, 0, 0, 1, OCLAQ_None, clang::LangAS::Default},
  // 209
  {OCLT_uint, 1, 1, 0, 1, OCLAQ_None, clang::LangAS::opencl_global},
  // 210
  {OCLT_int, 1, 1, 0, 1, OCLAQ_None, clang::LangAS::opencl_local},
  // 211
  {OCLT_uint, 1, 1, 0, 1, OCLAQ_None, clang::LangAS::opencl_local},
  // 212
  {OCLT_long, 1, 0, 0, 1, OCLAQ_None, clang::LangAS::Default},
  // 213
  {OCLT_long, 1, 1, 0, 1, OCLAQ_None, clang::LangAS::opencl_global},
  // 214
  {OCLT_ulong, 1, 0, 0, 1, OCLAQ_None, clang::LangAS::Default},
  // 215
  {OCLT_ulong, 1, 1, 0, 1, OCLAQ_None, clang::LangAS::opencl_global},
  // 216
  {OCLT_long, 1, 1, 0, 1, OCLAQ_None, clang::LangAS::opencl_local},
  // 217
  {OCLT_ulong, 1, 1, 0, 1, OCLAQ_None, clang::LangAS::opencl_local},
  // 218
  {OCLT_TLAllVec2, 0, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 219
  {OCLT_TLAllUnsignedVec2, 0, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 220
  {OCLT_TLAllVec4, 0, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 221
  {OCLT_TLAllVec8, 0, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 222
  {OCLT_TLAllVec16, 0, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 223
  {OCLT_TLAllUnsignedVec4, 0, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 224
  {OCLT_TLAllUnsignedVec8, 0, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 225
  {OCLT_TLAllUnsignedVec16, 0, 0, 0, 0, OCLAQ_None, clang::LangAS::Default},
  // 226
  {OCLT_Image1d, 0, 0, 0, 0, OCLAQ_ReadOnly, clang::LangAS::Default},
  // 227
  {OCLT_Image2d, 0, 0, 0, 0, OCLAQ_ReadOnly, clang::LangAS::Default},
  // 228
  {OCLT_Image1dArray, 0, 0, 0, 0, OCLAQ_ReadOnly, clang::LangAS::Default},
  // 229
  {OCLT_Image3d, 0, 0, 0, 0, OCLAQ_ReadOnly, clang::LangAS::Default},
  // 230
  {OCLT_Image2dArray, 0, 0, 0, 0, OCLAQ_ReadOnly, clang::LangAS::Default},
  // 231
  {OCLT_Image2dDepth, 0, 0, 0, 0, OCLAQ_ReadOnly, clang::LangAS::Default},
  // 232
  {OCLT_Image2dArrayDepth, 0, 0, 0, 0, OCLAQ_ReadOnly, clang::LangAS::Default},
  // 233
  {OCLT_Image1dBuffer, 0, 0, 0, 0, OCLAQ_ReadOnly, clang::LangAS::Default},
  // 234
  {OCLT_Image2d, 0, 0, 0, 0, OCLAQ_ReadWrite, clang::LangAS::Default},
  // 235
  {OCLT_Image1dArray, 0, 0, 0, 0, OCLAQ_ReadWrite, clang::LangAS::Default},
  // 236
  {OCLT_Image3d, 0, 0, 0, 0, OCLAQ_ReadWrite, clang::LangAS::Default},
  // 237
  {OCLT_Image2dArray, 0, 0, 0, 0, OCLAQ_ReadWrite, clang::LangAS::Default},
  // 238
  {OCLT_Image1d, 0, 0, 0, 0, OCLAQ_ReadWrite, clang::LangAS::Default},
  // 239
  {OCLT_Image1dBuffer, 0, 0, 0, 0, OCLAQ_ReadWrite, clang::LangAS::Default},
  // 240
  {OCLT_Image2dDepth, 0, 0, 0, 0, OCLAQ_ReadWrite, clang::LangAS::Default},
  // 241
  {OCLT_Image2dArrayDepth, 0, 0, 0, 0, OCLAQ_ReadWrite, clang::LangAS::Default},
  // 242
  {OCLT_Image2d, 0, 0, 0, 0, OCLAQ_WriteOnly, clang::LangAS::Default},
  // 243
  {OCLT_Image2dArray, 0, 0, 0, 0, OCLAQ_WriteOnly, clang::LangAS::Default},
  // 244
  {OCLT_Image1d, 0, 0, 0, 0, OCLAQ_WriteOnly, clang::LangAS::Default},
  // 245
  {OCLT_Image1dBuffer, 0, 0, 0, 0, OCLAQ_WriteOnly, clang::LangAS::Default},
  // 246
  {OCLT_Image1dArray, 0, 0, 0, 0, OCLAQ_WriteOnly, clang::LangAS::Default},
  // 247
  {OCLT_Image3d, 0, 0, 0, 0, OCLAQ_WriteOnly, clang::LangAS::Default},
  // 248
  {OCLT_Image2dDepth, 0, 0, 0, 0, OCLAQ_WriteOnly, clang::LangAS::Default},
  // 249
  {OCLT_Image2dArrayDepth, 0, 0, 0, 0, OCLAQ_WriteOnly, clang::LangAS::Default},
  // 250
  {OCLT_Image2dMsaa, 0, 0, 0, 0, OCLAQ_ReadOnly, clang::LangAS::Default},
  // 251
  {OCLT_Image2dArrayMsaa, 0, 0, 0, 0, OCLAQ_ReadOnly, clang::LangAS::Default},
  // 252
  {OCLT_Image2dMsaaDepth, 0, 0, 0, 0, OCLAQ_ReadOnly, clang::LangAS::Default},
  // 253
  {OCLT_Image2dArrayMsaaDepth, 0, 0, 0, 0, OCLAQ_ReadOnly, clang::LangAS::Default},
  // 254
  {OCLT_Image2dMsaa, 0, 0, 0, 0, OCLAQ_ReadWrite, clang::LangAS::Default},
  // 255
  {OCLT_Image2dArrayMsaa, 0, 0, 0, 0, OCLAQ_ReadWrite, clang::LangAS::Default},
  // 256
  {OCLT_Image2dMsaaDepth, 0, 0, 0, 0, OCLAQ_ReadWrite, clang::LangAS::Default},
  // 257
  {OCLT_Image2dArrayMsaaDepth, 0, 0, 0, 0, OCLAQ_ReadWrite, clang::LangAS::Default},
  // 258
  {OCLT_Image2dMsaa, 0, 0, 0, 0, OCLAQ_WriteOnly, clang::LangAS::Default},
  // 259
  {OCLT_Image2dArrayMsaa, 0, 0, 0, 0, OCLAQ_WriteOnly, clang::LangAS::Default},
  // 260
  {OCLT_Image2dMsaaDepth, 0, 0, 0, 0, OCLAQ_WriteOnly, clang::LangAS::Default},
  // 261
  {OCLT_Image2dArrayMsaaDepth, 0, 0, 0, 0, OCLAQ_WriteOnly, clang::LangAS::Default},
};

static const unsigned SignatureTable[] = {
  // 0
  100, 100, 
  // 2
  67, 82, 
  // 4
  68, 83, 
  // 6
  69, 84, 
  // 8
  70, 85, 
  // 10
  8, 59, 
  // 12
  66, 81, 
  // 14
  105, 105, 
  // 16
  11, 11, 
  // 18
  96, 96, 
  // 20
  97, 97, 
  // 22
  98, 98, 
  // 24
  8, 57, 
  // 26
  66, 86, 
  // 28
  67, 87, 
  // 30
  68, 88, 
  // 32
  69, 89, 
  // 34
  70, 90, 
  // 36
  11, 8, 
  // 38
  96, 66, 
  // 40
  8, 64, 
  // 42
  66, 91, 
  // 44
  97, 67, 
  // 46
  67, 92, 
  // 48
  68, 93, 
  // 50
  69, 94, 
  // 52
  70, 95, 
  // 54
  98, 68, 
  // 56
  100, 69, 
  // 58
  8, 50, 
  // 60
  66, 99, 
  // 62
  105, 70, 
  // 64
  67, 101, 
  // 66
  68, 102, 
  // 68
  69, 103, 
  // 70
  70, 104, 
  // 72
  8, 61, 
  // 74
  66, 106, 
  // 76
  67, 107, 
  // 78
  68, 108, 
  // 80
  69, 109, 
  // 82
  70, 110, 
  // 84
  8, 53, 
  // 86
  66, 111, 
  // 88
  67, 112, 
  // 90
  68, 113, 
  // 92
  69, 114, 
  // 94
  70, 115, 
  // 96
  8, 63, 
  // 98
  66, 116, 
  // 100
  67, 117, 
  // 102
  68, 118, 
  // 104
  69, 119, 
  // 106
  70, 120, 
  // 108
  37, 11, 
  // 110
  71, 96, 
  // 112
  72, 97, 
  // 114
  73, 98, 
  // 116
  74, 100, 
  // 118
  75, 105, 
  // 120
  37, 8, 
  // 122
  71, 66, 
  // 124
  72, 67, 
  // 126
  73, 68, 
  // 128
  74, 69, 
  // 130
  75, 70, 
  // 132
  37, 37, 
  // 134
  71, 71, 
  // 136
  72, 72, 
  // 138
  73, 73, 
  // 140
  74, 74, 
  // 142
  75, 75, 
  // 144
  37, 7, 
  // 146
  71, 76, 
  // 148
  72, 77, 
  // 150
  73, 78, 
  // 152
  74, 79, 
  // 154
  75, 80, 
  // 156
  37, 59, 
  // 158
  71, 81, 
  // 160
  72, 82, 
  // 162
  73, 83, 
  // 164
  74, 84, 
  // 166
  75, 85, 
  // 168
  37, 57, 
  // 170
  71, 86, 
  // 172
  72, 87, 
  // 174
  73, 88, 
  // 176
  74, 89, 
  // 178
  75, 90, 
  // 180
  11, 37, 
  // 182
  96, 71, 
  // 184
  97, 72, 
  // 186
  37, 64, 
  // 188
  71, 91, 
  // 190
  72, 92, 
  // 192
  73, 93, 
  // 194
  74, 94, 
  // 196
  75, 95, 
  // 198
  98, 73, 
  // 200
  100, 74, 
  // 202
  105, 75, 
  // 204
  37, 50, 
  // 206
  71, 99, 
  // 208
  72, 101, 
  // 210
  73, 102, 
  // 212
  74, 103, 
  // 214
  75, 104, 
  // 216
  37, 61, 
  // 218
  71, 106, 
  // 220
  72, 107, 
  // 222
  73, 108, 
  // 224
  74, 109, 
  // 226
  75, 110, 
  // 228
  37, 53, 
  // 230
  71, 111, 
  // 232
  72, 112, 
  // 234
  73, 113, 
  // 236
  74, 114, 
  // 238
  75, 115, 
  // 240
  37, 63, 
  // 242
  71, 116, 
  // 244
  72, 117, 
  // 246
  73, 118, 
  // 248
  74, 119, 
  // 250
  75, 120, 
  // 252
  7, 11, 
  // 254
  76, 96, 
  // 256
  77, 97, 
  // 258
  78, 98, 
  // 260
  79, 100, 
  // 262
  80, 105, 
  // 264
  7, 8, 
  // 266
  76, 66, 
  // 268
  77, 67, 
  // 270
  78, 68, 
  // 272
  79, 69, 
  // 274
  80, 70, 
  // 276
  7, 37, 
  // 278
  76, 71, 
  // 280
  77, 72, 
  // 282
  78, 73, 
  // 284
  79, 74, 
  // 286
  80, 75, 
  // 288
  7, 7, 
  // 290
  76, 76, 
  // 292
  77, 77, 
  // 294
  78, 78, 
  // 296
  79, 79, 
  // 298
  80, 80, 
  // 300
  7, 59, 
  // 302
  76, 81, 
  // 304
  77, 82, 
  // 306
  78, 83, 
  // 308
  79, 84, 
  // 310
  80, 85, 
  // 312
  7, 57, 
  // 314
  76, 86, 
  // 316
  11, 7, 
  // 318
  77, 87, 
  // 320
  78, 88, 
  // 322
  79, 89, 
  // 324
  80, 90, 
  // 326
  96, 76, 
  // 328
  97, 77, 
  // 330
  7, 64, 
  // 332
  76, 91, 
  // 334
  98, 78, 
  // 336
  77, 92, 
  // 338
  78, 93, 
  // 340
  79, 94, 
  // 342
  80, 95, 
  // 344
  100, 79, 
  // 346
  105, 80, 
  // 348
  7, 50, 
  // 350
  76, 99, 
  // 352
  77, 101, 
  // 354
  78, 102, 
  // 356
  79, 103, 
  // 358
  80, 104, 
  // 360
  7, 61, 
  // 362
  76, 106, 
  // 364
  77, 107, 
  // 366
  78, 108, 
  // 368
  79, 109, 
  // 370
  80, 110, 
  // 372
  7, 53, 
  // 374
  76, 111, 
  // 376
  77, 112, 
  // 378
  78, 113, 
  // 380
  79, 114, 
  // 382
  80, 115, 
  // 384
  7, 63, 
  // 386
  76, 116, 
  // 388
  77, 117, 
  // 390
  78, 118, 
  // 392
  79, 119, 
  // 394
  80, 120, 
  // 396
  59, 11, 
  // 398
  81, 96, 
  // 400
  82, 97, 
  // 402
  83, 98, 
  // 404
  84, 100, 
  // 406
  85, 105, 
  // 408
  59, 8, 
  // 410
  81, 66, 
  // 412
  82, 67, 
  // 414
  83, 68, 
  // 416
  84, 69, 
  // 418
  85, 70, 
  // 420
  59, 37, 
  // 422
  81, 71, 
  // 424
  82, 72, 
  // 426
  83, 73, 
  // 428
  84, 74, 
  // 430
  85, 75, 
  // 432
  59, 7, 
  // 434
  81, 76, 
  // 436
  82, 77, 
  // 438
  83, 78, 
  // 440
  84, 79, 
  // 442
  85, 80, 
  // 444
  59, 59, 
  // 446
  81, 81, 
  // 448
  82, 82, 
  // 450
  83, 83, 
  // 452
  84, 84, 
  // 454
  85, 85, 
  // 456
  11, 59, 
  // 458
  59, 57, 
  // 460
  81, 86, 
  // 462
  82, 87, 
  // 464
  83, 88, 
  // 466
  84, 89, 
  // 468
  85, 90, 
  // 470
  96, 81, 
  // 472
  97, 82, 
  // 474
  98, 83, 
  // 476
  59, 64, 
  // 478
  81, 91, 
  // 480
  82, 92, 
  // 482
  83, 93, 
  // 484
  84, 94, 
  // 486
  85, 95, 
  // 488
  100, 84, 
  // 490
  105, 85, 
  // 492
  59, 50, 
  // 494
  81, 99, 
  // 496
  82, 101, 
  // 498
  83, 102, 
  // 500
  84, 103, 
  // 502
  85, 104, 
  // 504
  59, 61, 
  // 506
  81, 106, 
  // 508
  82, 107, 
  // 510
  83, 108, 
  // 512
  84, 109, 
  // 514
  85, 110, 
  // 516
  59, 53, 
  // 518
  81, 111, 
  // 520
  82, 112, 
  // 522
  83, 113, 
  // 524
  84, 114, 
  // 526
  85, 115, 
  // 528
  59, 63, 
  // 530
  81, 116, 
  // 532
  82, 117, 
  // 534
  83, 118, 
  // 536
  84, 119, 
  // 538
  85, 120, 
  // 540
  57, 11, 
  // 542
  86, 96, 
  // 544
  87, 97, 
  // 546
  88, 98, 
  // 548
  89, 100, 
  // 550
  90, 105, 
  // 552
  57, 8, 
  // 554
  86, 66, 
  // 556
  87, 67, 
  // 558
  88, 68, 
  // 560
  89, 69, 
  // 562
  90, 70, 
  // 564
  57, 37, 
  // 566
  86, 71, 
  // 568
  87, 72, 
  // 570
  88, 73, 
  // 572
  89, 74, 
  // 574
  90, 75, 
  // 576
  57, 7, 
  // 578
  86, 76, 
  // 580
  87, 77, 
  // 582
  88, 78, 
  // 584
  89, 79, 
  // 586
  90, 80, 
  // 588
  57, 59, 
  // 590
  86, 81, 
  // 592
  87, 82, 
  // 594
  88, 83, 
  // 596
  89, 84, 
  // 598
  90, 85, 
  // 600
  11, 57, 
  // 602
  57, 57, 
  // 604
  86, 86, 
  // 606
  96, 86, 
  // 608
  87, 87, 
  // 610
  88, 88, 
  // 612
  89, 89, 
  // 614
  90, 90, 
  // 616
  97, 87, 
  // 618
  98, 88, 
  // 620
  57, 64, 
  // 622
  86, 91, 
  // 624
  100, 89, 
  // 626
  87, 92, 
  // 628
  88, 93, 
  // 630
  89, 94, 
  // 632
  90, 95, 
  // 634
  105, 90, 
  // 636
  57, 50, 
  // 638
  86, 99, 
  // 640
  87, 101, 
  // 642
  88, 102, 
  // 644
  89, 103, 
  // 646
  90, 104, 
  // 648
  57, 61, 
  // 650
  86, 106, 
  // 652
  87, 107, 
  // 654
  88, 108, 
  // 656
  89, 109, 
  // 658
  90, 110, 
  // 660
  57, 53, 
  // 662
  86, 111, 
  // 664
  87, 112, 
  // 666
  88, 113, 
  // 668
  89, 114, 
  // 670
  90, 115, 
  // 672
  57, 63, 
  // 674
  86, 116, 
  // 676
  87, 117, 
  // 678
  88, 118, 
  // 680
  89, 119, 
  // 682
  90, 120, 
  // 684
  64, 11, 
  // 686
  91, 96, 
  // 688
  92, 97, 
  // 690
  93, 98, 
  // 692
  94, 100, 
  // 694
  95, 105, 
  // 696
  64, 8, 
  // 698
  91, 66, 
  // 700
  92, 67, 
  // 702
  93, 68, 
  // 704
  94, 69, 
  // 706
  95, 70, 
  // 708
  64, 37, 
  // 710
  91, 71, 
  // 712
  92, 72, 
  // 714
  93, 73, 
  // 716
  94, 74, 
  // 718
  95, 75, 
  // 720
  64, 7, 
  // 722
  91, 76, 
  // 724
  92, 77, 
  // 726
  93, 78, 
  // 728
  94, 79, 
  // 730
  95, 80, 
  // 732
  64, 59, 
  // 734
  91, 81, 
  // 736
  92, 82, 
  // 738
  93, 83, 
  // 740
  94, 84, 
  // 742
  95, 85, 
  // 744
  11, 64, 
  // 746
  96, 91, 
  // 748
  64, 57, 
  // 750
  91, 86, 
  // 752
  92, 87, 
  // 754
  93, 88, 
  // 756
  94, 89, 
  // 758
  95, 90, 
  // 760
  97, 92, 
  // 762
  98, 93, 
  // 764
  100, 94, 
  // 766
  64, 64, 
  // 768
  91, 91, 
  // 770
  92, 92, 
  // 772
  93, 93, 
  // 774
  94, 94, 
  // 776
  95, 95, 
  // 778
  105, 95, 
  // 780
  64, 50, 
  // 782
  91, 99, 
  // 784
  92, 101, 
  // 786
  93, 102, 
  // 788
  94, 103, 
  // 790
  95, 104, 
  // 792
  64, 61, 
  // 794
  91, 106, 
  // 796
  92, 107, 
  // 798
  93, 108, 
  // 800
  94, 109, 
  // 802
  95, 110, 
  // 804
  64, 53, 
  // 806
  91, 111, 
  // 808
  92, 112, 
  // 810
  93, 113, 
  // 812
  94, 114, 
  // 814
  95, 115, 
  // 816
  64, 63, 
  // 818
  91, 116, 
  // 820
  92, 117, 
  // 822
  93, 118, 
  // 824
  94, 119, 
  // 826
  95, 120, 
  // 828
  50, 11, 
  // 830
  99, 96, 
  // 832
  101, 97, 
  // 834
  102, 98, 
  // 836
  103, 100, 
  // 838
  104, 105, 
  // 840
  50, 8, 
  // 842
  99, 66, 
  // 844
  101, 67, 
  // 846
  102, 68, 
  // 848
  103, 69, 
  // 850
  104, 70, 
  // 852
  50, 37, 
  // 854
  99, 71, 
  // 856
  101, 72, 
  // 858
  102, 73, 
  // 860
  103, 74, 
  // 862
  104, 75, 
  // 864
  50, 7, 
  // 866
  99, 76, 
  // 868
  101, 77, 
  // 870
  102, 78, 
  // 872
  103, 79, 
  // 874
  104, 80, 
  // 876
  50, 59, 
  // 878
  99, 81, 
  // 880
  101, 82, 
  // 882
  102, 83, 
  // 884
  103, 84, 
  // 886
  104, 85, 
  // 888
  11, 50, 
  // 890
  96, 99, 
  // 892
  50, 57, 
  // 894
  99, 86, 
  // 896
  97, 101, 
  // 898
  101, 87, 
  // 900
  102, 88, 
  // 902
  103, 89, 
  // 904
  104, 90, 
  // 906
  98, 102, 
  // 908
  100, 103, 
  // 910
  50, 64, 
  // 912
  99, 91, 
  // 914
  105, 104, 
  // 916
  101, 92, 
  // 918
  102, 93, 
  // 920
  103, 94, 
  // 922
  104, 95, 
  // 924
  50, 50, 
  // 926
  99, 99, 
  // 928
  101, 101, 
  // 930
  102, 102, 
  // 932
  103, 103, 
  // 934
  104, 104, 
  // 936
  50, 61, 
  // 938
  99, 106, 
  // 940
  101, 107, 
  // 942
  102, 108, 
  // 944
  103, 109, 
  // 946
  104, 110, 
  // 948
  50, 53, 
  // 950
  99, 111, 
  // 952
  101, 112, 
  // 954
  102, 113, 
  // 956
  103, 114, 
  // 958
  104, 115, 
  // 960
  50, 63, 
  // 962
  99, 116, 
  // 964
  101, 117, 
  // 966
  102, 118, 
  // 968
  103, 119, 
  // 970
  104, 120, 
  // 972
  61, 11, 
  // 974
  106, 96, 
  // 976
  107, 97, 
  // 978
  108, 98, 
  // 980
  109, 100, 
  // 982
  110, 105, 
  // 984
  61, 8, 
  // 986
  106, 66, 
  // 988
  107, 67, 
  // 990
  108, 68, 
  // 992
  109, 69, 
  // 994
  110, 70, 
  // 996
  61, 37, 
  // 998
  106, 71, 
  // 1000
  107, 72, 
  // 1002
  108, 73, 
  // 1004
  109, 74, 
  // 1006
  110, 75, 
  // 1008
  61, 7, 
  // 1010
  106, 76, 
  // 1012
  107, 77, 
  // 1014
  108, 78, 
  // 1016
  109, 79, 
  // 1018
  110, 80, 
  // 1020
  61, 59, 
  // 1022
  106, 81, 
  // 1024
  107, 82, 
  // 1026
  108, 83, 
  // 1028
  109, 84, 
  // 1030
  110, 85, 
  // 1032
  11, 61, 
  // 1034
  96, 106, 
  // 1036
  97, 107, 
  // 1038
  61, 57, 
  // 1040
  106, 86, 
  // 1042
  107, 87, 
  // 1044
  108, 88, 
  // 1046
  109, 89, 
  // 1048
  110, 90, 
  // 1050
  98, 108, 
  // 1052
  100, 109, 
  // 1054
  105, 110, 
  // 1056
  61, 64, 
  // 1058
  106, 91, 
  // 1060
  107, 92, 
  // 1062
  108, 93, 
  // 1064
  109, 94, 
  // 1066
  110, 95, 
  // 1068
  61, 50, 
  // 1070
  106, 99, 
  // 1072
  107, 101, 
  // 1074
  108, 102, 
  // 1076
  109, 103, 
  // 1078
  110, 104, 
  // 1080
  61, 61, 
  // 1082
  106, 106, 
  // 1084
  107, 107, 
  // 1086
  108, 108, 
  // 1088
  109, 109, 
  // 1090
  110, 110, 
  // 1092
  61, 53, 
  // 1094
  106, 111, 
  // 1096
  107, 112, 
  // 1098
  108, 113, 
  // 1100
  109, 114, 
  // 1102
  110, 115, 
  // 1104
  61, 63, 
  // 1106
  106, 116, 
  // 1108
  107, 117, 
  // 1110
  108, 118, 
  // 1112
  109, 119, 
  // 1114
  110, 120, 
  // 1116
  53, 11, 
  // 1118
  111, 96, 
  // 1120
  112, 97, 
  // 1122
  113, 98, 
  // 1124
  114, 100, 
  // 1126
  115, 105, 
  // 1128
  53, 8, 
  // 1130
  111, 66, 
  // 1132
  112, 67, 
  // 1134
  113, 68, 
  // 1136
  114, 69, 
  // 1138
  115, 70, 
  // 1140
  53, 37, 
  // 1142
  111, 71, 
  // 1144
  112, 72, 
  // 1146
  113, 73, 
  // 1148
  114, 74, 
  // 1150
  115, 75, 
  // 1152
  53, 7, 
  // 1154
  111, 76, 
  // 1156
  112, 77, 
  // 1158
  113, 78, 
  // 1160
  114, 79, 
  // 1162
  115, 80, 
  // 1164
  53, 59, 
  // 1166
  111, 81, 
  // 1168
  11, 53, 
  // 1170
  112, 82, 
  // 1172
  113, 83, 
  // 1174
  114, 84, 
  // 1176
  115, 85, 
  // 1178
  96, 111, 
  // 1180
  97, 112, 
  // 1182
  53, 57, 
  // 1184
  111, 86, 
  // 1186
  98, 113, 
  // 1188
  112, 87, 
  // 1190
  113, 88, 
  // 1192
  114, 89, 
  // 1194
  115, 90, 
  // 1196
  100, 114, 
  // 1198
  105, 115, 
  // 1200
  53, 64, 
  // 1202
  111, 91, 
  // 1204
  112, 92, 
  // 1206
  113, 93, 
  // 1208
  114, 94, 
  // 1210
  115, 95, 
  // 1212
  53, 50, 
  // 1214
  111, 99, 
  // 1216
  112, 101, 
  // 1218
  113, 102, 
  // 1220
  114, 103, 
  // 1222
  115, 104, 
  // 1224
  53, 61, 
  // 1226
  111, 106, 
  // 1228
  112, 107, 
  // 1230
  113, 108, 
  // 1232
  114, 109, 
  // 1234
  115, 110, 
  // 1236
  53, 53, 
  // 1238
  111, 111, 
  // 1240
  112, 112, 
  // 1242
  113, 113, 
  // 1244
  114, 114, 
  // 1246
  115, 115, 
  // 1248
  53, 63, 
  // 1250
  111, 116, 
  // 1252
  112, 117, 
  // 1254
  113, 118, 
  // 1256
  114, 119, 
  // 1258
  115, 120, 
  // 1260
  63, 11, 
  // 1262
  116, 96, 
  // 1264
  117, 97, 
  // 1266
  118, 98, 
  // 1268
  119, 100, 
  // 1270
  120, 105, 
  // 1272
  63, 8, 
  // 1274
  116, 66, 
  // 1276
  117, 67, 
  // 1278
  118, 68, 
  // 1280
  119, 69, 
  // 1282
  120, 70, 
  // 1284
  63, 37, 
  // 1286
  116, 71, 
  // 1288
  117, 72, 
  // 1290
  118, 73, 
  // 1292
  119, 74, 
  // 1294
  120, 75, 
  // 1296
  63, 7, 
  // 1298
  116, 76, 
  // 1300
  117, 77, 
  // 1302
  118, 78, 
  // 1304
  119, 79, 
  // 1306
  120, 80, 
  // 1308
  11, 63, 
  // 1310
  63, 59, 
  // 1312
  116, 81, 
  // 1314
  117, 82, 
  // 1316
  118, 83, 
  // 1318
  119, 84, 
  // 1320
  120, 85, 
  // 1322
  96, 116, 
  // 1324
  97, 117, 
  // 1326
  98, 118, 
  // 1328
  63, 57, 
  // 1330
  116, 86, 
  // 1332
  117, 87, 
  // 1334
  118, 88, 
  // 1336
  119, 89, 
  // 1338
  120, 90, 
  // 1340
  100, 119, 
  // 1342
  105, 120, 
  // 1344
  63, 64, 
  // 1346
  116, 91, 
  // 1348
  117, 92, 
  // 1350
  118, 93, 
  // 1352
  119, 94, 
  // 1354
  120, 95, 
  // 1356
  63, 50, 
  // 1358
  116, 99, 
  // 1360
  117, 101, 
  // 1362
  118, 102, 
  // 1364
  119, 103, 
  // 1366
  120, 104, 
  // 1368
  63, 61, 
  // 1370
  116, 106, 
  // 1372
  117, 107, 
  // 1374
  118, 108, 
  // 1376
  119, 109, 
  // 1378
  120, 110, 
  // 1380
  63, 53, 
  // 1382
  116, 111, 
  // 1384
  117, 112, 
  // 1386
  118, 113, 
  // 1388
  119, 114, 
  // 1390
  120, 115, 
  // 1392
  63, 63, 
  // 1394
  116, 116, 
  // 1396
  117, 117, 
  // 1398
  118, 118, 
  // 1400
  119, 119, 
  // 1402
  120, 120, 
  // 1404
  61, 
  // 1405
  58, 61, 
  // 1407
  58, 
  // 1408
  10, 10, 
  // 1410
  18, 31, 
  // 1412
  15, 33, 
  // 1414
  21, 35, 
  // 1416
  10, 10, 10, 
  // 1419
  19, 19, 11, 
  // 1422
  16, 16, 8, 
  // 1425
  22, 22, 37, 
  // 1428
  23, 18, 
  // 1430
  23, 15, 
  // 1432
  23, 21, 
  // 1434
  18, 18, 23, 
  // 1437
  19, 19, 50, 
  // 1440
  15, 15, 23, 
  // 1443
  16, 16, 50, 
  // 1446
  21, 21, 23, 
  // 1449
  22, 22, 50, 
  // 1452
  10, 10, 10, 10, 
  // 1456
  10, 10, 121, 
  // 1459
  18, 18, 122, 
  // 1462
  18, 18, 18, 122, 
  // 1466
  15, 15, 122, 
  // 1469
  21, 21, 122, 
  // 1472
  15, 15, 15, 122, 
  // 1476
  21, 21, 21, 122, 
  // 1480
  10, 10, 123, 
  // 1483
  18, 18, 124, 
  // 1486
  15, 15, 124, 
  // 1489
  21, 21, 124, 
  // 1492
  18, 18, 18, 124, 
  // 1496
  15, 15, 15, 124, 
  // 1500
  21, 21, 21, 124, 
  // 1504
  10, 10, 125, 
  // 1507
  18, 18, 126, 
  // 1510
  15, 15, 126, 
  // 1513
  21, 21, 126, 
  // 1516
  18, 18, 18, 126, 
  // 1520
  15, 15, 15, 126, 
  // 1524
  21, 21, 21, 126, 
  // 1528
  10, 10, 127, 
  // 1531
  18, 18, 128, 
  // 1534
  15, 15, 128, 
  // 1537
  21, 21, 128, 
  // 1540
  18, 18, 18, 128, 
  // 1544
  15, 15, 15, 128, 
  // 1548
  21, 21, 21, 128, 
  // 1552
  18, 18, 
  // 1554
  18, 18, 18, 
  // 1557
  2, 4, 
  // 1559
  4, 4, 
  // 1561
  2, 4, 4, 
  // 1564
  4, 4, 4, 
  // 1567
  5, 5, 3, 
  // 1570
  27, 12, 29, 
  // 1573
  35, 29, 29, 
  // 1576
  23, 27, 35, 
  // 1579
  31, 35, 35, 
  // 1582
  25, 23, 31, 
  // 1585
  33, 31, 31, 
  // 1588
  4, 4, 4, 4, 
  // 1592
  5, 5, 3, 3, 
  // 1596
  23, 23, 23, 23, 
  // 1600
  31, 31, 31, 31, 
  // 1604
  23, 23, 23, 
  // 1607
  31, 31, 31, 
  // 1610
  19, 11, 19, 
  // 1613
  16, 8, 16, 
  // 1616
  22, 37, 22, 
  // 1619
  19, 19, 11, 11, 
  // 1623
  16, 16, 8, 8, 
  // 1627
  8, 11, 
  // 1629
  22, 22, 37, 37, 
  // 1633
  19, 11, 11, 19, 
  // 1637
  16, 8, 8, 16, 
  // 1641
  22, 37, 37, 22, 
  // 1645
  11, 17, 
  // 1647
  66, 96, 
  // 1649
  8, 14, 
  // 1651
  37, 20, 
  // 1653
  17, 17, 
  // 1655
  14, 14, 
  // 1657
  20, 20, 
  // 1659
  97, 97, 97, 
  // 1662
  67, 67, 67, 
  // 1665
  72, 72, 72, 
  // 1668
  67, 97, 
  // 1670
  98, 98, 98, 
  // 1673
  68, 68, 68, 
  // 1676
  73, 73, 73, 
  // 1679
  11, 17, 17, 
  // 1682
  8, 14, 14, 
  // 1685
  37, 20, 20, 
  // 1688
  68, 98, 
  // 1690
  26, 16, 
  // 1692
  28, 22, 
  // 1694
  69, 100, 
  // 1696
  70, 105, 
  // 1698
  50, 4, 
  // 1700
  23, 18, 18, 
  // 1703
  50, 8, 8, 
  // 1706
  26, 16, 16, 
  // 1709
  50, 37, 37, 
  // 1712
  28, 22, 22, 
  // 1715
  0, 0, 0, 0, 
  // 1719
  55, 55, 55, 55, 
  // 1723
  55, 55, 55, 60, 
  // 1727
  60, 60, 60, 60, 
  // 1731
  60, 60, 60, 55, 
  // 1735
  18, 18, 18, 23, 
  // 1739
  18, 18, 18, 31, 
  // 1743
  15, 15, 15, 25, 
  // 1747
  15, 15, 15, 33, 
  // 1751
  21, 21, 21, 27, 
  // 1755
  21, 21, 21, 35, 
  // 1759
  76, 58, 140, 
  // 1762
  81, 58, 141, 
  // 1765
  86, 58, 142, 
  // 1768
  91, 58, 143, 
  // 1771
  99, 58, 144, 
  // 1774
  106, 58, 145, 
  // 1777
  111, 58, 146, 
  // 1780
  116, 58, 147, 
  // 1783
  96, 58, 148, 
  // 1786
  66, 58, 149, 
  // 1789
  71, 58, 150, 
  // 1792
  65, 76, 58, 140, 
  // 1796
  65, 81, 58, 141, 
  // 1800
  65, 86, 58, 142, 
  // 1804
  65, 91, 58, 143, 
  // 1808
  65, 99, 58, 144, 
  // 1812
  65, 106, 58, 145, 
  // 1816
  65, 111, 58, 146, 
  // 1820
  65, 116, 58, 147, 
  // 1824
  65, 96, 58, 148, 
  // 1828
  65, 66, 58, 149, 
  // 1832
  65, 71, 58, 150, 
  // 1836
  96, 58, 150, 
  // 1839
  65, 96, 58, 151, 
  // 1843
  65, 66, 58, 151, 
  // 1847
  77, 58, 140, 
  // 1850
  82, 58, 141, 
  // 1853
  87, 58, 142, 
  // 1856
  92, 58, 143, 
  // 1859
  101, 58, 144, 
  // 1862
  107, 58, 145, 
  // 1865
  112, 58, 146, 
  // 1868
  117, 58, 147, 
  // 1871
  97, 58, 148, 
  // 1874
  67, 58, 149, 
  // 1877
  72, 58, 150, 
  // 1880
  65, 77, 58, 140, 
  // 1884
  65, 82, 58, 141, 
  // 1888
  65, 87, 58, 142, 
  // 1892
  65, 92, 58, 143, 
  // 1896
  65, 101, 58, 144, 
  // 1900
  65, 107, 58, 145, 
  // 1904
  65, 112, 58, 146, 
  // 1908
  65, 117, 58, 147, 
  // 1912
  65, 97, 58, 148, 
  // 1916
  65, 67, 58, 149, 
  // 1920
  65, 72, 58, 150, 
  // 1924
  97, 58, 150, 
  // 1927
  65, 97, 58, 151, 
  // 1931
  65, 67, 58, 151, 
  // 1935
  78, 58, 140, 
  // 1938
  83, 58, 141, 
  // 1941
  88, 58, 142, 
  // 1944
  93, 58, 143, 
  // 1947
  102, 58, 144, 
  // 1950
  108, 58, 145, 
  // 1953
  113, 58, 146, 
  // 1956
  118, 58, 147, 
  // 1959
  98, 58, 148, 
  // 1962
  68, 58, 149, 
  // 1965
  73, 58, 150, 
  // 1968
  65, 78, 58, 140, 
  // 1972
  65, 83, 58, 141, 
  // 1976
  65, 88, 58, 142, 
  // 1980
  65, 93, 58, 143, 
  // 1984
  65, 102, 58, 144, 
  // 1988
  65, 108, 58, 145, 
  // 1992
  65, 113, 58, 146, 
  // 1996
  65, 118, 58, 147, 
  // 2000
  65, 98, 58, 148, 
  // 2004
  65, 68, 58, 149, 
  // 2008
  65, 73, 58, 150, 
  // 2012
  98, 58, 150, 
  // 2015
  65, 98, 58, 151, 
  // 2019
  65, 68, 58, 151, 
  // 2023
  79, 58, 140, 
  // 2026
  84, 58, 141, 
  // 2029
  89, 58, 142, 
  // 2032
  94, 58, 143, 
  // 2035
  103, 58, 144, 
  // 2038
  109, 58, 145, 
  // 2041
  114, 58, 146, 
  // 2044
  119, 58, 147, 
  // 2047
  100, 58, 148, 
  // 2050
  69, 58, 149, 
  // 2053
  74, 58, 150, 
  // 2056
  65, 79, 58, 140, 
  // 2060
  65, 84, 58, 141, 
  // 2064
  65, 89, 58, 142, 
  // 2068
  65, 94, 58, 143, 
  // 2072
  65, 103, 58, 144, 
  // 2076
  65, 109, 58, 145, 
  // 2080
  65, 114, 58, 146, 
  // 2084
  65, 119, 58, 147, 
  // 2088
  65, 100, 58, 148, 
  // 2092
  65, 69, 58, 149, 
  // 2096
  65, 74, 58, 150, 
  // 2100
  100, 58, 150, 
  // 2103
  65, 100, 58, 151, 
  // 2107
  65, 69, 58, 151, 
  // 2111
  80, 58, 140, 
  // 2114
  85, 58, 141, 
  // 2117
  90, 58, 142, 
  // 2120
  95, 58, 143, 
  // 2123
  104, 58, 144, 
  // 2126
  110, 58, 145, 
  // 2129
  115, 58, 146, 
  // 2132
  120, 58, 147, 
  // 2135
  105, 58, 148, 
  // 2138
  70, 58, 149, 
  // 2141
  75, 58, 150, 
  // 2144
  65, 80, 58, 140, 
  // 2148
  65, 85, 58, 141, 
  // 2152
  65, 90, 58, 142, 
  // 2156
  65, 95, 58, 143, 
  // 2160
  65, 104, 58, 144, 
  // 2164
  65, 110, 58, 145, 
  // 2168
  65, 115, 58, 146, 
  // 2172
  65, 120, 58, 147, 
  // 2176
  65, 105, 58, 148, 
  // 2180
  65, 70, 58, 149, 
  // 2184
  65, 75, 58, 150, 
  // 2188
  105, 58, 150, 
  // 2191
  65, 105, 58, 151, 
  // 2195
  65, 70, 58, 151, 
  // 2199
  76, 58, 152, 
  // 2202
  81, 58, 153, 
  // 2205
  86, 58, 154, 
  // 2208
  91, 58, 155, 
  // 2211
  99, 58, 156, 
  // 2214
  106, 58, 157, 
  // 2217
  111, 58, 158, 
  // 2220
  116, 58, 159, 
  // 2223
  96, 58, 160, 
  // 2226
  66, 58, 161, 
  // 2229
  71, 58, 162, 
  // 2232
  65, 76, 58, 152, 
  // 2236
  65, 81, 58, 153, 
  // 2240
  65, 86, 58, 154, 
  // 2244
  65, 91, 58, 155, 
  // 2248
  65, 99, 58, 156, 
  // 2252
  65, 106, 58, 157, 
  // 2256
  65, 111, 58, 158, 
  // 2260
  65, 116, 58, 159, 
  // 2264
  65, 96, 58, 160, 
  // 2268
  65, 66, 58, 161, 
  // 2272
  65, 71, 58, 162, 
  // 2276
  96, 58, 162, 
  // 2279
  65, 96, 58, 163, 
  // 2283
  65, 66, 58, 163, 
  // 2287
  77, 58, 152, 
  // 2290
  82, 58, 153, 
  // 2293
  87, 58, 154, 
  // 2296
  92, 58, 155, 
  // 2299
  101, 58, 156, 
  // 2302
  107, 58, 157, 
  // 2305
  112, 58, 158, 
  // 2308
  117, 58, 159, 
  // 2311
  97, 58, 160, 
  // 2314
  67, 58, 161, 
  // 2317
  72, 58, 162, 
  // 2320
  65, 77, 58, 152, 
  // 2324
  65, 82, 58, 153, 
  // 2328
  65, 87, 58, 154, 
  // 2332
  65, 92, 58, 155, 
  // 2336
  65, 101, 58, 156, 
  // 2340
  65, 107, 58, 157, 
  // 2344
  65, 112, 58, 158, 
  // 2348
  65, 117, 58, 159, 
  // 2352
  65, 97, 58, 160, 
  // 2356
  65, 67, 58, 161, 
  // 2360
  65, 72, 58, 162, 
  // 2364
  97, 58, 162, 
  // 2367
  65, 97, 58, 163, 
  // 2371
  65, 67, 58, 163, 
  // 2375
  78, 58, 152, 
  // 2378
  83, 58, 153, 
  // 2381
  88, 58, 154, 
  // 2384
  93, 58, 155, 
  // 2387
  102, 58, 156, 
  // 2390
  108, 58, 157, 
  // 2393
  113, 58, 158, 
  // 2396
  118, 58, 159, 
  // 2399
  98, 58, 160, 
  // 2402
  68, 58, 161, 
  // 2405
  73, 58, 162, 
  // 2408
  65, 78, 58, 152, 
  // 2412
  65, 83, 58, 153, 
  // 2416
  65, 88, 58, 154, 
  // 2420
  65, 93, 58, 155, 
  // 2424
  65, 102, 58, 156, 
  // 2428
  65, 108, 58, 157, 
  // 2432
  65, 113, 58, 158, 
  // 2436
  65, 118, 58, 159, 
  // 2440
  65, 98, 58, 160, 
  // 2444
  65, 68, 58, 161, 
  // 2448
  65, 73, 58, 162, 
  // 2452
  98, 58, 162, 
  // 2455
  65, 98, 58, 163, 
  // 2459
  65, 68, 58, 163, 
  // 2463
  79, 58, 152, 
  // 2466
  84, 58, 153, 
  // 2469
  89, 58, 154, 
  // 2472
  94, 58, 155, 
  // 2475
  103, 58, 156, 
  // 2478
  109, 58, 157, 
  // 2481
  114, 58, 158, 
  // 2484
  119, 58, 159, 
  // 2487
  100, 58, 160, 
  // 2490
  69, 58, 161, 
  // 2493
  74, 58, 162, 
  // 2496
  65, 79, 58, 152, 
  // 2500
  65, 84, 58, 153, 
  // 2504
  65, 89, 58, 154, 
  // 2508
  65, 94, 58, 155, 
  // 2512
  65, 103, 58, 156, 
  // 2516
  65, 109, 58, 157, 
  // 2520
  65, 114, 58, 158, 
  // 2524
  65, 119, 58, 159, 
  // 2528
  65, 100, 58, 160, 
  // 2532
  65, 69, 58, 161, 
  // 2536
  65, 74, 58, 162, 
  // 2540
  100, 58, 162, 
  // 2543
  65, 100, 58, 163, 
  // 2547
  65, 69, 58, 163, 
  // 2551
  80, 58, 152, 
  // 2554
  85, 58, 153, 
  // 2557
  90, 58, 154, 
  // 2560
  95, 58, 155, 
  // 2563
  104, 58, 156, 
  // 2566
  110, 58, 157, 
  // 2569
  115, 58, 158, 
  // 2572
  120, 58, 159, 
  // 2575
  105, 58, 160, 
  // 2578
  70, 58, 161, 
  // 2581
  75, 58, 162, 
  // 2584
  65, 80, 58, 152, 
  // 2588
  65, 85, 58, 153, 
  // 2592
  65, 90, 58, 154, 
  // 2596
  65, 95, 58, 155, 
  // 2600
  65, 104, 58, 156, 
  // 2604
  65, 110, 58, 157, 
  // 2608
  65, 115, 58, 158, 
  // 2612
  65, 120, 58, 159, 
  // 2616
  65, 105, 58, 160, 
  // 2620
  65, 70, 58, 161, 
  // 2624
  65, 75, 58, 162, 
  // 2628
  105, 58, 162, 
  // 2631
  65, 105, 58, 163, 
  // 2635
  65, 70, 58, 163, 
  // 2639
  76, 58, 164, 
  // 2642
  81, 58, 165, 
  // 2645
  86, 58, 166, 
  // 2648
  91, 58, 167, 
  // 2651
  99, 58, 168, 
  // 2654
  106, 58, 169, 
  // 2657
  111, 58, 170, 
  // 2660
  116, 58, 171, 
  // 2663
  96, 58, 172, 
  // 2666
  66, 58, 173, 
  // 2669
  71, 58, 174, 
  // 2672
  65, 76, 58, 164, 
  // 2676
  65, 81, 58, 165, 
  // 2680
  65, 86, 58, 166, 
  // 2684
  65, 91, 58, 167, 
  // 2688
  65, 99, 58, 168, 
  // 2692
  65, 106, 58, 169, 
  // 2696
  65, 111, 58, 170, 
  // 2700
  65, 116, 58, 171, 
  // 2704
  65, 96, 58, 172, 
  // 2708
  65, 66, 58, 173, 
  // 2712
  65, 71, 58, 174, 
  // 2716
  96, 58, 174, 
  // 2719
  65, 96, 58, 175, 
  // 2723
  65, 66, 58, 175, 
  // 2727
  77, 58, 164, 
  // 2730
  82, 58, 165, 
  // 2733
  87, 58, 166, 
  // 2736
  92, 58, 167, 
  // 2739
  101, 58, 168, 
  // 2742
  107, 58, 169, 
  // 2745
  112, 58, 170, 
  // 2748
  117, 58, 171, 
  // 2751
  97, 58, 172, 
  // 2754
  67, 58, 173, 
  // 2757
  72, 58, 174, 
  // 2760
  65, 77, 58, 164, 
  // 2764
  65, 82, 58, 165, 
  // 2768
  65, 87, 58, 166, 
  // 2772
  65, 92, 58, 167, 
  // 2776
  65, 101, 58, 168, 
  // 2780
  65, 107, 58, 169, 
  // 2784
  65, 112, 58, 170, 
  // 2788
  65, 117, 58, 171, 
  // 2792
  65, 97, 58, 172, 
  // 2796
  65, 67, 58, 173, 
  // 2800
  65, 72, 58, 174, 
  // 2804
  97, 58, 174, 
  // 2807
  65, 97, 58, 175, 
  // 2811
  65, 67, 58, 175, 
  // 2815
  78, 58, 164, 
  // 2818
  83, 58, 165, 
  // 2821
  88, 58, 166, 
  // 2824
  93, 58, 167, 
  // 2827
  102, 58, 168, 
  // 2830
  108, 58, 169, 
  // 2833
  113, 58, 170, 
  // 2836
  118, 58, 171, 
  // 2839
  98, 58, 172, 
  // 2842
  68, 58, 173, 
  // 2845
  73, 58, 174, 
  // 2848
  65, 78, 58, 164, 
  // 2852
  65, 83, 58, 165, 
  // 2856
  65, 88, 58, 166, 
  // 2860
  65, 93, 58, 167, 
  // 2864
  65, 102, 58, 168, 
  // 2868
  65, 108, 58, 169, 
  // 2872
  65, 113, 58, 170, 
  // 2876
  65, 118, 58, 171, 
  // 2880
  65, 98, 58, 172, 
  // 2884
  65, 68, 58, 173, 
  // 2888
  65, 73, 58, 174, 
  // 2892
  98, 58, 174, 
  // 2895
  65, 98, 58, 175, 
  // 2899
  65, 68, 58, 175, 
  // 2903
  79, 58, 164, 
  // 2906
  84, 58, 165, 
  // 2909
  89, 58, 166, 
  // 2912
  94, 58, 167, 
  // 2915
  103, 58, 168, 
  // 2918
  109, 58, 169, 
  // 2921
  114, 58, 170, 
  // 2924
  119, 58, 171, 
  // 2927
  100, 58, 172, 
  // 2930
  69, 58, 173, 
  // 2933
  74, 58, 174, 
  // 2936
  8, 8, 
  // 2938
  65, 79, 58, 164, 
  // 2942
  65, 84, 58, 165, 
  // 2946
  65, 89, 58, 166, 
  // 2950
  65, 94, 58, 167, 
  // 2954
  65, 103, 58, 168, 
  // 2958
  65, 109, 58, 169, 
  // 2962
  65, 114, 58, 170, 
  // 2966
  65, 119, 58, 171, 
  // 2970
  65, 100, 58, 172, 
  // 2974
  65, 69, 58, 173, 
  // 2978
  66, 66, 
  // 2980
  65, 74, 58, 174, 
  // 2984
  100, 58, 174, 
  // 2987
  65, 100, 58, 175, 
  // 2991
  65, 69, 58, 175, 
  // 2995
  67, 67, 
  // 2997
  80, 58, 164, 
  // 3000
  85, 58, 165, 
  // 3003
  90, 58, 166, 
  // 3006
  95, 58, 167, 
  // 3009
  104, 58, 168, 
  // 3012
  110, 58, 169, 
  // 3015
  115, 58, 170, 
  // 3018
  120, 58, 171, 
  // 3021
  68, 68, 
  // 3023
  105, 58, 172, 
  // 3026
  70, 58, 173, 
  // 3029
  75, 58, 174, 
  // 3032
  65, 80, 58, 164, 
  // 3036
  65, 85, 58, 165, 
  // 3040
  65, 90, 58, 166, 
  // 3044
  65, 95, 58, 167, 
  // 3048
  65, 104, 58, 168, 
  // 3052
  65, 110, 58, 169, 
  // 3056
  65, 115, 58, 170, 
  // 3060
  69, 69, 
  // 3062
  65, 120, 58, 171, 
  // 3066
  65, 105, 58, 172, 
  // 3070
  65, 70, 58, 173, 
  // 3074
  65, 75, 58, 174, 
  // 3078
  105, 58, 174, 
  // 3081
  65, 105, 58, 175, 
  // 3085
  65, 70, 58, 175, 
  // 3089
  70, 70, 
  // 3091
  76, 58, 176, 
  // 3094
  81, 58, 177, 
  // 3097
  86, 58, 178, 
  // 3100
  91, 58, 179, 
  // 3103
  99, 58, 180, 
  // 3106
  106, 58, 181, 
  // 3109
  111, 58, 182, 
  // 3112
  116, 58, 183, 
  // 3115
  96, 58, 184, 
  // 3118
  66, 58, 185, 
  // 3121
  71, 58, 186, 
  // 3124
  65, 76, 58, 176, 
  // 3128
  65, 81, 58, 177, 
  // 3132
  65, 86, 58, 178, 
  // 3136
  65, 91, 58, 179, 
  // 3140
  65, 99, 58, 180, 
  // 3144
  65, 106, 58, 181, 
  // 3148
  65, 111, 58, 182, 
  // 3152
  65, 116, 58, 183, 
  // 3156
  65, 96, 58, 184, 
  // 3160
  65, 66, 58, 185, 
  // 3164
  65, 71, 58, 186, 
  // 3168
  96, 58, 186, 
  // 3171
  65, 96, 58, 187, 
  // 3175
  65, 66, 58, 187, 
  // 3179
  77, 58, 176, 
  // 3182
  82, 58, 177, 
  // 3185
  87, 58, 178, 
  // 3188
  92, 58, 179, 
  // 3191
  101, 58, 180, 
  // 3194
  107, 58, 181, 
  // 3197
  112, 58, 182, 
  // 3200
  117, 58, 183, 
  // 3203
  97, 58, 184, 
  // 3206
  67, 58, 185, 
  // 3209
  72, 58, 186, 
  // 3212
  65, 77, 58, 176, 
  // 3216
  65, 82, 58, 177, 
  // 3220
  65, 87, 58, 178, 
  // 3224
  65, 92, 58, 179, 
  // 3228
  65, 101, 58, 180, 
  // 3232
  65, 107, 58, 181, 
  // 3236
  65, 112, 58, 182, 
  // 3240
  65, 117, 58, 183, 
  // 3244
  65, 97, 58, 184, 
  // 3248
  65, 67, 58, 185, 
  // 3252
  65, 72, 58, 186, 
  // 3256
  97, 58, 186, 
  // 3259
  65, 97, 58, 187, 
  // 3263
  65, 67, 58, 187, 
  // 3267
  78, 58, 176, 
  // 3270
  83, 58, 177, 
  // 3273
  88, 58, 178, 
  // 3276
  93, 58, 179, 
  // 3279
  102, 58, 180, 
  // 3282
  108, 58, 181, 
  // 3285
  113, 58, 182, 
  // 3288
  118, 58, 183, 
  // 3291
  98, 58, 184, 
  // 3294
  68, 58, 185, 
  // 3297
  73, 58, 186, 
  // 3300
  65, 78, 58, 176, 
  // 3304
  65, 83, 58, 177, 
  // 3308
  65, 88, 58, 178, 
  // 3312
  65, 93, 58, 179, 
  // 3316
  65, 102, 58, 180, 
  // 3320
  65, 108, 58, 181, 
  // 3324
  65, 113, 58, 182, 
  // 3328
  65, 118, 58, 183, 
  // 3332
  65, 98, 58, 184, 
  // 3336
  65, 68, 58, 185, 
  // 3340
  65, 73, 58, 186, 
  // 3344
  98, 58, 186, 
  // 3347
  65, 98, 58, 187, 
  // 3351
  65, 68, 58, 187, 
  // 3355
  79, 58, 176, 
  // 3358
  84, 58, 177, 
  // 3361
  89, 58, 178, 
  // 3364
  94, 58, 179, 
  // 3367
  103, 58, 180, 
  // 3370
  109, 58, 181, 
  // 3373
  114, 58, 182, 
  // 3376
  119, 58, 183, 
  // 3379
  100, 58, 184, 
  // 3382
  69, 58, 185, 
  // 3385
  74, 58, 186, 
  // 3388
  65, 79, 58, 176, 
  // 3392
  65, 84, 58, 177, 
  // 3396
  65, 89, 58, 178, 
  // 3400
  65, 94, 58, 179, 
  // 3404
  65, 103, 58, 180, 
  // 3408
  65, 109, 58, 181, 
  // 3412
  65, 114, 58, 182, 
  // 3416
  65, 119, 58, 183, 
  // 3420
  65, 100, 58, 184, 
  // 3424
  65, 69, 58, 185, 
  // 3428
  65, 74, 58, 186, 
  // 3432
  100, 58, 186, 
  // 3435
  65, 100, 58, 187, 
  // 3439
  65, 69, 58, 187, 
  // 3443
  80, 58, 176, 
  // 3446
  85, 58, 177, 
  // 3449
  90, 58, 178, 
  // 3452
  95, 58, 179, 
  // 3455
  104, 58, 180, 
  // 3458
  110, 58, 181, 
  // 3461
  115, 58, 182, 
  // 3464
  120, 58, 183, 
  // 3467
  105, 58, 184, 
  // 3470
  70, 58, 185, 
  // 3473
  75, 58, 186, 
  // 3476
  65, 80, 58, 176, 
  // 3480
  65, 85, 58, 177, 
  // 3484
  65, 90, 58, 178, 
  // 3488
  65, 95, 58, 179, 
  // 3492
  65, 104, 58, 180, 
  // 3496
  65, 110, 58, 181, 
  // 3500
  65, 115, 58, 182, 
  // 3504
  65, 120, 58, 183, 
  // 3508
  65, 105, 58, 184, 
  // 3512
  65, 70, 58, 185, 
  // 3516
  65, 75, 58, 186, 
  // 3520
  105, 58, 186, 
  // 3523
  65, 105, 58, 187, 
  // 3527
  65, 70, 58, 187, 
  // 3531
  76, 58, 188, 
  // 3534
  81, 58, 189, 
  // 3537
  86, 58, 190, 
  // 3540
  91, 58, 191, 
  // 3543
  99, 58, 192, 
  // 3546
  106, 58, 193, 
  // 3549
  111, 58, 194, 
  // 3552
  116, 58, 195, 
  // 3555
  96, 58, 196, 
  // 3558
  66, 58, 197, 
  // 3561
  71, 58, 198, 
  // 3564
  96, 58, 198, 
  // 3567
  65, 96, 58, 199, 
  // 3571
  65, 66, 58, 199, 
  // 3575
  77, 58, 188, 
  // 3578
  82, 58, 189, 
  // 3581
  87, 58, 190, 
  // 3584
  92, 58, 191, 
  // 3587
  101, 58, 192, 
  // 3590
  107, 58, 193, 
  // 3593
  112, 58, 194, 
  // 3596
  117, 58, 195, 
  // 3599
  97, 58, 196, 
  // 3602
  67, 58, 197, 
  // 3605
  72, 58, 198, 
  // 3608
  97, 58, 198, 
  // 3611
  65, 97, 58, 199, 
  // 3615
  65, 67, 58, 199, 
  // 3619
  78, 58, 188, 
  // 3622
  83, 58, 189, 
  // 3625
  88, 58, 190, 
  // 3628
  93, 58, 191, 
  // 3631
  102, 58, 192, 
  // 3634
  108, 58, 193, 
  // 3637
  113, 58, 194, 
  // 3640
  118, 58, 195, 
  // 3643
  98, 58, 196, 
  // 3646
  68, 58, 197, 
  // 3649
  73, 58, 198, 
  // 3652
  98, 58, 198, 
  // 3655
  65, 98, 58, 199, 
  // 3659
  65, 68, 58, 199, 
  // 3663
  79, 58, 188, 
  // 3666
  84, 58, 189, 
  // 3669
  89, 58, 190, 
  // 3672
  94, 58, 191, 
  // 3675
  103, 58, 192, 
  // 3678
  109, 58, 193, 
  // 3681
  114, 58, 194, 
  // 3684
  119, 58, 195, 
  // 3687
  100, 58, 196, 
  // 3690
  69, 58, 197, 
  // 3693
  74, 58, 198, 
  // 3696
  100, 58, 198, 
  // 3699
  65, 100, 58, 199, 
  // 3703
  65, 69, 58, 199, 
  // 3707
  80, 58, 188, 
  // 3710
  85, 58, 189, 
  // 3713
  90, 58, 190, 
  // 3716
  95, 58, 191, 
  // 3719
  104, 58, 192, 
  // 3722
  110, 58, 193, 
  // 3725
  115, 58, 194, 
  // 3728
  120, 58, 195, 
  // 3731
  105, 58, 196, 
  // 3734
  70, 58, 197, 
  // 3737
  75, 58, 198, 
  // 3740
  105, 58, 198, 
  // 3743
  65, 105, 58, 199, 
  // 3747
  65, 70, 58, 199, 
  // 3751
  11, 58, 150, 
  // 3754
  65, 11, 58, 151, 
  // 3758
  65, 8, 58, 151, 
  // 3762
  11, 58, 162, 
  // 3765
  65, 11, 58, 163, 
  // 3769
  65, 8, 58, 163, 
  // 3773
  11, 58, 174, 
  // 3776
  65, 11, 58, 175, 
  // 3780
  65, 8, 58, 175, 
  // 3784
  11, 58, 186, 
  // 3787
  65, 11, 58, 187, 
  // 3791
  65, 8, 58, 187, 
  // 3795
  8, 37, 
  // 3797
  66, 71, 
  // 3799
  11, 58, 198, 
  // 3802
  67, 72, 
  // 3804
  9, 200, 202, 58, 9, 
  // 3809
  9, 203, 204, 58, 9, 
  // 3814
  68, 73, 
  // 3816
  9, 200, 202, 58, 58, 9, 
  // 3822
  9, 203, 204, 58, 58, 9, 
  // 3828
  65, 50, 205, 
  // 3831
  65, 202, 58, 
  // 3834
  50, 207, 50, 
  // 3837
  50, 207, 
  // 3839
  50, 207, 50, 50, 
  // 3843
  69, 74, 
  // 3845
  61, 209, 61, 
  // 3848
  61, 209, 
  // 3850
  70, 75, 
  // 3852
  61, 209, 61, 61, 
  // 3856
  50, 210, 50, 
  // 3859
  50, 210, 
  // 3861
  50, 210, 50, 50, 
  // 3865
  61, 211, 61, 
  // 3868
  61, 211, 
  // 3870
  61, 211, 61, 61, 
  // 3874
  53, 213, 53, 
  // 3877
  53, 213, 
  // 3879
  53, 213, 53, 53, 
  // 3883
  63, 215, 63, 
  // 3886
  63, 215, 
  // 3888
  63, 215, 63, 63, 
  // 3892
  53, 216, 53, 
  // 3895
  53, 216, 
  // 3897
  53, 216, 53, 53, 
  // 3901
  63, 217, 63, 
  // 3904
  63, 217, 
  // 3906
  63, 217, 63, 63, 
  // 3910
  218, 218, 219, 
  // 3913
  218, 220, 219, 
  // 3916
  218, 221, 219, 
  // 3919
  218, 222, 219, 
  // 3922
  220, 218, 223, 
  // 3925
  220, 220, 223, 
  // 3928
  220, 221, 223, 
  // 3931
  220, 222, 223, 
  // 3934
  221, 218, 224, 
  // 3937
  221, 220, 224, 
  // 3940
  221, 221, 224, 
  // 3943
  221, 222, 224, 
  // 3946
  222, 218, 225, 
  // 3949
  222, 220, 225, 
  // 3952
  222, 221, 225, 
  // 3955
  222, 222, 225, 
  // 3958
  218, 218, 218, 219, 
  // 3962
  218, 220, 220, 219, 
  // 3966
  218, 221, 221, 219, 
  // 3970
  218, 222, 222, 219, 
  // 3974
  220, 218, 218, 223, 
  // 3978
  220, 220, 220, 223, 
  // 3982
  220, 221, 221, 223, 
  // 3986
  220, 222, 222, 223, 
  // 3990
  221, 218, 218, 224, 
  // 3994
  221, 220, 220, 224, 
  // 3998
  221, 221, 221, 224, 
  // 4002
  221, 222, 222, 224, 
  // 4006
  222, 218, 218, 225, 
  // 4010
  222, 220, 220, 225, 
  // 4014
  222, 221, 221, 225, 
  // 4018
  222, 222, 222, 225, 
  // 4022
  98, 226, 56, 50, 
  // 4026
  102, 226, 56, 50, 
  // 4030
  108, 226, 56, 50, 
  // 4034
  98, 226, 56, 11, 
  // 4038
  102, 226, 56, 11, 
  // 4042
  108, 226, 56, 11, 
  // 4046
  98, 227, 56, 99, 
  // 4050
  102, 227, 56, 99, 
  // 4054
  108, 227, 56, 99, 
  // 4058
  98, 227, 56, 96, 
  // 4062
  102, 227, 56, 96, 
  // 4066
  108, 227, 56, 96, 
  // 4070
  98, 228, 56, 99, 
  // 4074
  102, 228, 56, 99, 
  // 4078
  108, 228, 56, 99, 
  // 4082
  98, 228, 56, 96, 
  // 4086
  102, 228, 56, 96, 
  // 4090
  108, 228, 56, 96, 
  // 4094
  98, 229, 56, 102, 
  // 4098
  102, 229, 56, 102, 
  // 4102
  108, 229, 56, 102, 
  // 4106
  98, 229, 56, 98, 
  // 4110
  102, 229, 56, 98, 
  // 4114
  108, 229, 56, 98, 
  // 4118
  98, 230, 56, 102, 
  // 4122
  102, 230, 56, 102, 
  // 4126
  108, 230, 56, 102, 
  // 4130
  98, 230, 56, 98, 
  // 4134
  102, 230, 56, 98, 
  // 4138
  108, 230, 56, 98, 
  // 4142
  11, 231, 56, 99, 
  // 4146
  11, 232, 56, 102, 
  // 4150
  11, 231, 56, 96, 
  // 4154
  11, 232, 56, 98, 
  // 4158
  98, 227, 99, 
  // 4161
  102, 227, 99, 
  // 4164
  108, 227, 99, 
  // 4167
  98, 229, 102, 
  // 4170
  102, 229, 102, 
  // 4173
  108, 229, 102, 
  // 4176
  98, 226, 50, 
  // 4179
  102, 226, 50, 
  // 4182
  108, 226, 50, 
  // 4185
  11, 231, 99, 
  // 4188
  11, 232, 102, 
  // 4191
  98, 228, 99, 
  // 4194
  102, 228, 99, 
  // 4197
  108, 228, 99, 
  // 4200
  98, 230, 102, 
  // 4203
  102, 230, 102, 
  // 4206
  108, 230, 102, 
  // 4209
  98, 233, 50, 
  // 4212
  102, 233, 50, 
  // 4215
  108, 233, 50, 
  // 4218
  98, 234, 99, 
  // 4221
  102, 234, 99, 
  // 4224
  108, 234, 99, 
  // 4227
  98, 235, 99, 
  // 4230
  102, 235, 99, 
  // 4233
  108, 235, 99, 
  // 4236
  98, 236, 102, 
  // 4239
  102, 236, 102, 
  // 4242
  108, 236, 102, 
  // 4245
  98, 237, 102, 
  // 4248
  102, 237, 102, 
  // 4251
  108, 237, 102, 
  // 4254
  98, 238, 50, 
  // 4257
  102, 238, 50, 
  // 4260
  108, 238, 50, 
  // 4263
  98, 239, 50, 
  // 4266
  102, 239, 50, 
  // 4269
  108, 239, 50, 
  // 4272
  11, 240, 99, 
  // 4275
  11, 241, 102, 
  // 4278
  65, 242, 99, 98, 
  // 4282
  65, 242, 99, 102, 
  // 4286
  65, 242, 99, 108, 
  // 4290
  65, 243, 102, 98, 
  // 4294
  65, 243, 102, 102, 
  // 4298
  65, 243, 102, 108, 
  // 4302
  65, 244, 50, 98, 
  // 4306
  65, 244, 50, 102, 
  // 4310
  65, 244, 50, 108, 
  // 4314
  65, 246, 99, 98, 
  // 4318
  65, 246, 99, 102, 
  // 4322
  65, 246, 99, 108, 
  // 4326
  65, 247, 102, 98, 
  // 4330
  65, 247, 102, 102, 
  // 4334
  65, 247, 102, 108, 
  // 4338
  65, 248, 99, 11, 
  // 4342
  65, 249, 102, 11, 
  // 4346
  65, 245, 50, 98, 
  // 4350
  65, 245, 50, 102, 
  // 4354
  65, 245, 50, 108, 
  // 4358
  65, 234, 99, 98, 
  // 4362
  65, 234, 99, 102, 
  // 4366
  65, 234, 99, 108, 
  // 4370
  65, 237, 102, 98, 
  // 4374
  65, 237, 102, 102, 
  // 4378
  65, 237, 102, 108, 
  // 4382
  65, 238, 50, 98, 
  // 4386
  65, 238, 50, 102, 
  // 4390
  65, 238, 50, 108, 
  // 4394
  65, 239, 50, 98, 
  // 4398
  65, 239, 50, 102, 
  // 4402
  65, 239, 50, 108, 
  // 4406
  65, 235, 99, 98, 
  // 4410
  65, 235, 99, 102, 
  // 4414
  65, 235, 99, 108, 
  // 4418
  65, 236, 102, 98, 
  // 4422
  65, 236, 102, 102, 
  // 4426
  65, 236, 102, 108, 
  // 4430
  65, 240, 99, 11, 
  // 4434
  65, 241, 102, 11, 
  // 4438
  50, 226, 
  // 4440
  50, 227, 
  // 4442
  50, 229, 
  // 4444
  99, 227, 
  // 4446
  102, 229, 
  // 4448
  58, 228, 
  // 4450
  50, 233, 
  // 4452
  50, 228, 
  // 4454
  50, 230, 
  // 4456
  50, 231, 
  // 4458
  50, 232, 
  // 4460
  99, 230, 
  // 4462
  99, 231, 
  // 4464
  99, 232, 
  // 4466
  58, 230, 
  // 4468
  58, 232, 
  // 4470
  50, 244, 
  // 4472
  50, 245, 
  // 4474
  50, 242, 
  // 4476
  50, 247, 
  // 4478
  50, 246, 
  // 4480
  50, 243, 
  // 4482
  50, 248, 
  // 4484
  50, 249, 
  // 4486
  99, 242, 
  // 4488
  99, 243, 
  // 4490
  99, 248, 
  // 4492
  99, 249, 
  // 4494
  102, 247, 
  // 4496
  58, 246, 
  // 4498
  58, 243, 
  // 4500
  58, 249, 
  // 4502
  50, 238, 
  // 4504
  50, 239, 
  // 4506
  50, 234, 
  // 4508
  50, 236, 
  // 4510
  50, 235, 
  // 4512
  50, 237, 
  // 4514
  50, 240, 
  // 4516
  50, 241, 
  // 4518
  99, 234, 
  // 4520
  99, 237, 
  // 4522
  99, 240, 
  // 4524
  99, 241, 
  // 4526
  102, 236, 
  // 4528
  58, 235, 
  // 4530
  58, 237, 
  // 4532
  58, 241, 
  // 4534
  73, 227, 56, 99, 
  // 4538
  73, 229, 56, 102, 
  // 4542
  73, 226, 56, 50, 
  // 4546
  73, 228, 56, 99, 
  // 4550
  73, 230, 56, 102, 
  // 4554
  73, 227, 56, 96, 
  // 4558
  73, 228, 56, 96, 
  // 4562
  73, 229, 56, 98, 
  // 4566
  73, 230, 56, 98, 
  // 4570
  73, 226, 56, 11, 
  // 4574
  73, 227, 99, 
  // 4577
  73, 229, 102, 
  // 4580
  73, 226, 50, 
  // 4583
  73, 228, 99, 
  // 4586
  73, 230, 102, 
  // 4589
  73, 233, 50, 
  // 4592
  73, 234, 99, 
  // 4595
  73, 235, 99, 
  // 4598
  73, 236, 102, 
  // 4601
  73, 237, 102, 
  // 4604
  73, 238, 50, 
  // 4607
  73, 239, 50, 
  // 4610
  65, 242, 99, 73, 
  // 4614
  65, 243, 102, 73, 
  // 4618
  65, 244, 50, 73, 
  // 4622
  65, 245, 50, 73, 
  // 4626
  65, 246, 99, 73, 
  // 4630
  65, 247, 102, 73, 
  // 4634
  65, 234, 99, 73, 
  // 4638
  65, 237, 102, 73, 
  // 4642
  65, 238, 50, 73, 
  // 4646
  65, 239, 50, 73, 
  // 4650
  65, 235, 99, 73, 
  // 4654
  65, 236, 102, 73, 
  // 4658
  51, 51, 58, 
  // 4661
  51, 51, 58, 58, 
  // 4665
  51, 51, 58, 58, 58, 
  // 4670
  51, 51, 
  // 4672
  98, 227, 56, 96, 11, 
  // 4677
  98, 227, 56, 96, 96, 96, 
  // 4683
  102, 227, 56, 96, 11, 
  // 4688
  102, 227, 56, 96, 96, 96, 
  // 4694
  108, 227, 56, 96, 11, 
  // 4699
  108, 227, 56, 96, 96, 96, 
  // 4705
  11, 231, 56, 96, 11, 
  // 4710
  11, 231, 56, 96, 96, 96, 
  // 4716
  98, 226, 56, 11, 11, 
  // 4721
  98, 226, 56, 11, 11, 11, 
  // 4727
  102, 226, 56, 11, 11, 
  // 4732
  102, 226, 56, 11, 11, 11, 
  // 4738
  108, 226, 56, 11, 11, 
  // 4743
  108, 226, 56, 11, 11, 11, 
  // 4749
  98, 229, 56, 98, 98, 98, 
  // 4755
  98, 229, 56, 98, 11, 
  // 4760
  102, 229, 56, 98, 98, 98, 
  // 4766
  108, 229, 56, 98, 98, 98, 
  // 4772
  98, 228, 56, 96, 11, 
  // 4777
  98, 228, 56, 96, 11, 11, 
  // 4783
  102, 228, 56, 96, 11, 
  // 4788
  102, 228, 56, 96, 11, 11, 
  // 4794
  108, 228, 56, 96, 11, 
  // 4799
  108, 228, 56, 96, 11, 11, 
  // 4805
  98, 230, 56, 98, 11, 
  // 4810
  98, 230, 56, 98, 96, 96, 
  // 4816
  102, 230, 56, 98, 11, 
  // 4821
  102, 230, 56, 98, 96, 96, 
  // 4827
  108, 230, 56, 98, 11, 
  // 4832
  108, 230, 56, 98, 96, 96, 
  // 4838
  108, 232, 56, 98, 11, 
  // 4843
  108, 232, 56, 98, 96, 96, 
  // 4849
  65, 242, 99, 50, 98, 
  // 4854
  65, 242, 99, 50, 102, 
  // 4859
  65, 242, 99, 50, 108, 
  // 4864
  65, 248, 99, 50, 11, 
  // 4869
  65, 244, 50, 50, 98, 
  // 4874
  65, 244, 50, 50, 102, 
  // 4879
  65, 244, 50, 50, 108, 
  // 4884
  65, 246, 99, 50, 98, 
  // 4889
  65, 246, 99, 50, 102, 
  // 4894
  65, 246, 99, 50, 108, 
  // 4899
  65, 243, 102, 50, 98, 
  // 4904
  65, 243, 102, 50, 102, 
  // 4909
  65, 243, 102, 50, 108, 
  // 4914
  65, 249, 102, 50, 11, 
  // 4919
  65, 247, 102, 50, 98, 
  // 4924
  65, 247, 102, 50, 102, 
  // 4929
  65, 247, 102, 50, 108, 
  // 4934
  8, 7, 
  // 4936
  66, 76, 
  // 4938
  98, 250, 99, 50, 
  // 4942
  102, 250, 99, 50, 
  // 4946
  108, 250, 99, 50, 
  // 4950
  98, 251, 102, 50, 
  // 4954
  67, 77, 
  // 4956
  102, 251, 102, 50, 
  // 4960
  108, 251, 102, 50, 
  // 4964
  11, 252, 99, 50, 
  // 4968
  11, 253, 102, 50, 
  // 4972
  68, 78, 
  // 4974
  98, 254, 99, 50, 
  // 4978
  102, 254, 99, 50, 
  // 4982
  108, 254, 99, 50, 
  // 4986
  98, 255, 102, 50, 
  // 4990
  69, 79, 
  // 4992
  102, 255, 102, 50, 
  // 4996
  108, 255, 102, 50, 
  // 5000
  11, 256, 99, 50, 
  // 5004
  11, 257, 102, 50, 
  // 5008
  50, 250, 
  // 5010
  99, 250, 
  // 5012
  70, 80, 
  // 5014
  58, 253, 
  // 5016
  50, 251, 
  // 5018
  99, 251, 
  // 5020
  50, 252, 
  // 5022
  99, 252, 
  // 5024
  50, 253, 
  // 5026
  99, 253, 
  // 5028
  50, 258, 
  // 5030
  99, 258, 
  // 5032
  50, 259, 
  // 5034
  99, 259, 
  // 5036
  50, 260, 
  // 5038
  99, 260, 
  // 5040
  50, 261, 
  // 5042
  99, 261, 
  // 5044
  58, 261, 
  // 5046
  50, 254, 
  // 5048
  99, 254, 
  // 5050
  50, 255, 
  // 5052
  99, 255, 
  // 5054
  50, 256, 
  // 5056
  99, 256, 
  // 5058
  50, 257, 
  // 5060
  99, 257, 
  // 5062
  58, 257, 
};

static const OpenCLBuiltinStruct BuiltinTable[] = {
  // 1: convert_float8_sat_rtp, convert_float8_sat_rtz, convert_float8, convert_float8_rte, convert_float8_rtn, convert_float8_rtp, convert_float8_rtz, convert_float8_sat, convert_float8_sat_rte, convert_float8_sat_rtn, 
  { 0, 2, 0, 1, 0, 10, 100, 0 },
  { 56, 2, 0, 1, 0, 10, 100, 0 },
  { 200, 2, 0, 1, 0, 10, 100, 0 },
  { 344, 2, 0, 1, 0, 10, 100, 0 },
  { 488, 2, 0, 1, 0, 10, 100, 0 },
  { 624, 2, 0, 1, 0, 10, 100, 0 },
  { 764, 2, 0, 1, 0, 10, 100, 0 },
  { 908, 2, 0, 1, 0, 10, 100, 0 },
  { 1052, 2, 0, 1, 0, 10, 100, 0 },
  { 1196, 2, 0, 1, 0, 10, 100, 0 },
  { 1340, 2, 0, 1, 0, 10, 100, 0 },
  // 12: convert_double3, convert_double3_rte, convert_double3_rtn, convert_double3_rtp, convert_double3_rtz, convert_double3_sat, convert_double3_sat_rte, convert_double3_sat_rtn, convert_double3_sat_rtp, convert_double3_sat_rtz, 
  { 2, 2, 0, 1, 0, 10, 100, 0 },
  { 28, 2, 0, 1, 0, 10, 100, 0 },
  { 46, 2, 0, 1, 0, 10, 100, 0 },
  { 64, 2, 0, 1, 0, 10, 100, 0 },
  { 76, 2, 0, 1, 0, 10, 100, 0 },
  { 88, 2, 0, 1, 0, 10, 100, 0 },
  { 100, 2, 0, 1, 0, 10, 100, 0 },
  { 1668, 2, 0, 1, 0, 10, 100, 0 },
  { 2995, 2, 0, 1, 0, 10, 100, 0 },
  { 3802, 2, 0, 1, 0, 10, 100, 0 },
  { 4954, 2, 0, 1, 0, 10, 100, 0 },
  // 23: convert_double4, convert_double4_rte, convert_double4_rtn, convert_double4_rtp, convert_double4_rtz, convert_double4_sat, convert_double4_sat_rte, convert_double4_sat_rtn, convert_double4_sat_rtp, convert_double4_sat_rtz, 
  { 4, 2, 0, 1, 0, 10, 100, 0 },
  { 30, 2, 0, 1, 0, 10, 100, 0 },
  { 48, 2, 0, 1, 0, 10, 100, 0 },
  { 66, 2, 0, 1, 0, 10, 100, 0 },
  { 78, 2, 0, 1, 0, 10, 100, 0 },
  { 90, 2, 0, 1, 0, 10, 100, 0 },
  { 102, 2, 0, 1, 0, 10, 100, 0 },
  { 1688, 2, 0, 1, 0, 10, 100, 0 },
  { 3021, 2, 0, 1, 0, 10, 100, 0 },
  { 3814, 2, 0, 1, 0, 10, 100, 0 },
  { 4972, 2, 0, 1, 0, 10, 100, 0 },
  // 34: convert_double8, convert_double8_rte, convert_double8_rtn, convert_double8_rtp, convert_double8_rtz, convert_double8_sat, convert_double8_sat_rte, convert_double8_sat_rtn, convert_double8_sat_rtp, convert_double8_sat_rtz, 
  { 6, 2, 0, 1, 0, 10, 100, 0 },
  { 32, 2, 0, 1, 0, 10, 100, 0 },
  { 50, 2, 0, 1, 0, 10, 100, 0 },
  { 68, 2, 0, 1, 0, 10, 100, 0 },
  { 80, 2, 0, 1, 0, 10, 100, 0 },
  { 92, 2, 0, 1, 0, 10, 100, 0 },
  { 104, 2, 0, 1, 0, 10, 100, 0 },
  { 1694, 2, 0, 1, 0, 10, 100, 0 },
  { 3060, 2, 0, 1, 0, 10, 100, 0 },
  { 3843, 2, 0, 1, 0, 10, 100, 0 },
  { 4990, 2, 0, 1, 0, 10, 100, 0 },
  // 45: convert_double16, convert_double16_rte, convert_double16_rtn, convert_double16_rtp, convert_double16_rtz, convert_double16_sat, convert_double16_sat_rte, convert_double16_sat_rtn, convert_double16_sat_rtp, convert_double16_sat_rtz, 
  { 8, 2, 0, 1, 0, 10, 100, 0 },
  { 34, 2, 0, 1, 0, 10, 100, 0 },
  { 52, 2, 0, 1, 0, 10, 100, 0 },
  { 70, 2, 0, 1, 0, 10, 100, 0 },
  { 82, 2, 0, 1, 0, 10, 100, 0 },
  { 94, 2, 0, 1, 0, 10, 100, 0 },
  { 106, 2, 0, 1, 0, 10, 100, 0 },
  { 1696, 2, 0, 1, 0, 10, 100, 0 },
  { 3089, 2, 0, 1, 0, 10, 100, 0 },
  { 3850, 2, 0, 1, 0, 10, 100, 0 },
  { 5012, 2, 0, 1, 0, 10, 100, 0 },
  // 56: convert_double_rte, convert_double_rtn, convert_double_rtp, convert_double_rtz, convert_double_sat, convert_double_sat_rte, convert_double_sat_rtn, convert_double_sat_rtp, convert_double_sat_rtz, convert_double, 
  { 10, 2, 0, 1, 0, 10, 100, 0 },
  { 24, 2, 0, 1, 0, 10, 100, 0 },
  { 40, 2, 0, 1, 0, 10, 100, 0 },
  { 58, 2, 0, 1, 0, 10, 100, 0 },
  { 72, 2, 0, 1, 0, 10, 100, 0 },
  { 84, 2, 0, 1, 0, 10, 100, 0 },
  { 96, 2, 0, 1, 0, 10, 100, 0 },
  { 1627, 2, 0, 1, 0, 10, 100, 0 },
  { 2936, 2, 0, 1, 0, 10, 100, 0 },
  { 3795, 2, 0, 1, 0, 10, 100, 0 },
  { 4934, 2, 0, 1, 0, 10, 100, 0 },
  // 67: convert_double2_rte, convert_double2_rtn, convert_double2_rtp, convert_double2_rtz, convert_double2_sat, convert_double2_sat_rte, convert_double2_sat_rtn, convert_double2_sat_rtp, convert_double2_sat_rtz, convert_double2, 
  { 12, 2, 0, 1, 0, 10, 100, 0 },
  { 26, 2, 0, 1, 0, 10, 100, 0 },
  { 42, 2, 0, 1, 0, 10, 100, 0 },
  { 60, 2, 0, 1, 0, 10, 100, 0 },
  { 74, 2, 0, 1, 0, 10, 100, 0 },
  { 86, 2, 0, 1, 0, 10, 100, 0 },
  { 98, 2, 0, 1, 0, 10, 100, 0 },
  { 1647, 2, 0, 1, 0, 10, 100, 0 },
  { 2978, 2, 0, 1, 0, 10, 100, 0 },
  { 3797, 2, 0, 1, 0, 10, 100, 0 },
  { 4936, 2, 0, 1, 0, 10, 100, 0 },
  // 78: convert_float16_sat_rtp, convert_float16_sat_rtz, convert_float16, convert_float16_rte, convert_float16_rtn, convert_float16_rtp, convert_float16_rtz, convert_float16_sat, convert_float16_sat_rte, convert_float16_sat_rtn, 
  { 14, 2, 0, 1, 0, 10, 100, 0 },
  { 62, 2, 0, 1, 0, 10, 100, 0 },
  { 202, 2, 0, 1, 0, 10, 100, 0 },
  { 346, 2, 0, 1, 0, 10, 100, 0 },
  { 490, 2, 0, 1, 0, 10, 100, 0 },
  { 634, 2, 0, 1, 0, 10, 100, 0 },
  { 778, 2, 0, 1, 0, 10, 100, 0 },
  { 914, 2, 0, 1, 0, 10, 100, 0 },
  { 1054, 2, 0, 1, 0, 10, 100, 0 },
  { 1198, 2, 0, 1, 0, 10, 100, 0 },
  { 1342, 2, 0, 1, 0, 10, 100, 0 },
  // 89: convert_float_sat_rtz, convert_float, convert_float_rte, convert_float_rtn, convert_float_rtp, convert_float_rtz, convert_float_sat, convert_float_sat_rte, convert_float_sat_rtn, convert_float_sat_rtp, 
  { 16, 2, 0, 1, 0, 10, 100, 0 },
  { 36, 2, 0, 1, 0, 10, 100, 0 },
  { 180, 2, 0, 1, 0, 10, 100, 0 },
  { 316, 2, 0, 1, 0, 10, 100, 0 },
  { 456, 2, 0, 1, 0, 10, 100, 0 },
  { 600, 2, 0, 1, 0, 10, 100, 0 },
  { 744, 2, 0, 1, 0, 10, 100, 0 },
  { 888, 2, 0, 1, 0, 10, 100, 0 },
  { 1032, 2, 0, 1, 0, 10, 100, 0 },
  { 1168, 2, 0, 1, 0, 10, 100, 0 },
  { 1308, 2, 0, 1, 0, 10, 100, 0 },
  // 100: convert_float2_sat_rtz, convert_float2, convert_float2_rte, convert_float2_rtn, convert_float2_rtp, convert_float2_rtz, convert_float2_sat, convert_float2_sat_rte, convert_float2_sat_rtn, convert_float2_sat_rtp, 
  { 18, 2, 0, 1, 0, 10, 100, 0 },
  { 38, 2, 0, 1, 0, 10, 100, 0 },
  { 182, 2, 0, 1, 0, 10, 100, 0 },
  { 326, 2, 0, 1, 0, 10, 100, 0 },
  { 470, 2, 0, 1, 0, 10, 100, 0 },
  { 606, 2, 0, 1, 0, 10, 100, 0 },
  { 746, 2, 0, 1, 0, 10, 100, 0 },
  { 890, 2, 0, 1, 0, 10, 100, 0 },
  { 1034, 2, 0, 1, 0, 10, 100, 0 },
  { 1178, 2, 0, 1, 0, 10, 100, 0 },
  { 1322, 2, 0, 1, 0, 10, 100, 0 },
  // 111: convert_float3_sat_rtz, convert_float3, convert_float3_rte, convert_float3_rtn, convert_float3_rtp, convert_float3_rtz, convert_float3_sat, convert_float3_sat_rte, convert_float3_sat_rtn, convert_float3_sat_rtp, 
  { 20, 2, 0, 1, 0, 10, 100, 0 },
  { 44, 2, 0, 1, 0, 10, 100, 0 },
  { 184, 2, 0, 1, 0, 10, 100, 0 },
  { 328, 2, 0, 1, 0, 10, 100, 0 },
  { 472, 2, 0, 1, 0, 10, 100, 0 },
  { 616, 2, 0, 1, 0, 10, 100, 0 },
  { 760, 2, 0, 1, 0, 10, 100, 0 },
  { 896, 2, 0, 1, 0, 10, 100, 0 },
  { 1036, 2, 0, 1, 0, 10, 100, 0 },
  { 1180, 2, 0, 1, 0, 10, 100, 0 },
  { 1324, 2, 0, 1, 0, 10, 100, 0 },
  // 122: convert_float4_sat_rtz, convert_float4, convert_float4_rte, convert_float4_rtn, convert_float4_rtp, convert_float4_rtz, convert_float4_sat, convert_float4_sat_rte, convert_float4_sat_rtn, convert_float4_sat_rtp, 
  { 22, 2, 0, 1, 0, 10, 100, 0 },
  { 54, 2, 0, 1, 0, 10, 100, 0 },
  { 198, 2, 0, 1, 0, 10, 100, 0 },
  { 334, 2, 0, 1, 0, 10, 100, 0 },
  { 474, 2, 0, 1, 0, 10, 100, 0 },
  { 618, 2, 0, 1, 0, 10, 100, 0 },
  { 762, 2, 0, 1, 0, 10, 100, 0 },
  { 906, 2, 0, 1, 0, 10, 100, 0 },
  { 1050, 2, 0, 1, 0, 10, 100, 0 },
  { 1186, 2, 0, 1, 0, 10, 100, 0 },
  { 1326, 2, 0, 1, 0, 10, 100, 0 },
  // 133: convert_half, convert_half_rte, convert_half_rtn, convert_half_rtp, convert_half_rtz, convert_half_sat, convert_half_sat_rte, convert_half_sat_rtn, convert_half_sat_rtp, convert_half_sat_rtz, 
  { 108, 2, 0, 1, 0, 10, 100, 0 },
  { 120, 2, 0, 1, 0, 10, 100, 0 },
  { 132, 2, 0, 1, 0, 10, 100, 0 },
  { 144, 2, 0, 1, 0, 10, 100, 0 },
  { 156, 2, 0, 1, 0, 10, 100, 0 },
  { 168, 2, 0, 1, 0, 10, 100, 0 },
  { 186, 2, 0, 1, 0, 10, 100, 0 },
  { 204, 2, 0, 1, 0, 10, 100, 0 },
  { 216, 2, 0, 1, 0, 10, 100, 0 },
  { 228, 2, 0, 1, 0, 10, 100, 0 },
  { 240, 2, 0, 1, 0, 10, 100, 0 },
  // 144: convert_half2, convert_half2_rte, convert_half2_rtn, convert_half2_rtp, convert_half2_rtz, convert_half2_sat, convert_half2_sat_rte, convert_half2_sat_rtn, convert_half2_sat_rtp, convert_half2_sat_rtz, 
  { 110, 2, 0, 1, 0, 10, 100, 0 },
  { 122, 2, 0, 1, 0, 10, 100, 0 },
  { 134, 2, 0, 1, 0, 10, 100, 0 },
  { 146, 2, 0, 1, 0, 10, 100, 0 },
  { 158, 2, 0, 1, 0, 10, 100, 0 },
  { 170, 2, 0, 1, 0, 10, 100, 0 },
  { 188, 2, 0, 1, 0, 10, 100, 0 },
  { 206, 2, 0, 1, 0, 10, 100, 0 },
  { 218, 2, 0, 1, 0, 10, 100, 0 },
  { 230, 2, 0, 1, 0, 10, 100, 0 },
  { 242, 2, 0, 1, 0, 10, 100, 0 },
  // 155: convert_half3, convert_half3_rte, convert_half3_rtn, convert_half3_rtp, convert_half3_rtz, convert_half3_sat, convert_half3_sat_rte, convert_half3_sat_rtn, convert_half3_sat_rtp, convert_half3_sat_rtz, 
  { 112, 2, 0, 1, 0, 10, 100, 0 },
  { 124, 2, 0, 1, 0, 10, 100, 0 },
  { 136, 2, 0, 1, 0, 10, 100, 0 },
  { 148, 2, 0, 1, 0, 10, 100, 0 },
  { 160, 2, 0, 1, 0, 10, 100, 0 },
  { 172, 2, 0, 1, 0, 10, 100, 0 },
  { 190, 2, 0, 1, 0, 10, 100, 0 },
  { 208, 2, 0, 1, 0, 10, 100, 0 },
  { 220, 2, 0, 1, 0, 10, 100, 0 },
  { 232, 2, 0, 1, 0, 10, 100, 0 },
  { 244, 2, 0, 1, 0, 10, 100, 0 },
  // 166: convert_half4, convert_half4_rte, convert_half4_rtn, convert_half4_rtp, convert_half4_rtz, convert_half4_sat, convert_half4_sat_rte, convert_half4_sat_rtn, convert_half4_sat_rtp, convert_half4_sat_rtz, 
  { 114, 2, 0, 1, 0, 10, 100, 0 },
  { 126, 2, 0, 1, 0, 10, 100, 0 },
  { 138, 2, 0, 1, 0, 10, 100, 0 },
  { 150, 2, 0, 1, 0, 10, 100, 0 },
  { 162, 2, 0, 1, 0, 10, 100, 0 },
  { 174, 2, 0, 1, 0, 10, 100, 0 },
  { 192, 2, 0, 1, 0, 10, 100, 0 },
  { 210, 2, 0, 1, 0, 10, 100, 0 },
  { 222, 2, 0, 1, 0, 10, 100, 0 },
  { 234, 2, 0, 1, 0, 10, 100, 0 },
  { 246, 2, 0, 1, 0, 10, 100, 0 },
  // 177: convert_half8, convert_half8_rte, convert_half8_rtn, convert_half8_rtp, convert_half8_rtz, convert_half8_sat, convert_half8_sat_rte, convert_half8_sat_rtn, convert_half8_sat_rtp, convert_half8_sat_rtz, 
  { 116, 2, 0, 1, 0, 10, 100, 0 },
  { 128, 2, 0, 1, 0, 10, 100, 0 },
  { 140, 2, 0, 1, 0, 10, 100, 0 },
  { 152, 2, 0, 1, 0, 10, 100, 0 },
  { 164, 2, 0, 1, 0, 10, 100, 0 },
  { 176, 2, 0, 1, 0, 10, 100, 0 },
  { 194, 2, 0, 1, 0, 10, 100, 0 },
  { 212, 2, 0, 1, 0, 10, 100, 0 },
  { 224, 2, 0, 1, 0, 10, 100, 0 },
  { 236, 2, 0, 1, 0, 10, 100, 0 },
  { 248, 2, 0, 1, 0, 10, 100, 0 },
  // 188: convert_half16, convert_half16_rte, convert_half16_rtn, convert_half16_rtp, convert_half16_rtz, convert_half16_sat, convert_half16_sat_rte, convert_half16_sat_rtn, convert_half16_sat_rtp, convert_half16_sat_rtz, 
  { 118, 2, 0, 1, 0, 10, 100, 0 },
  { 130, 2, 0, 1, 0, 10, 100, 0 },
  { 142, 2, 0, 1, 0, 10, 100, 0 },
  { 154, 2, 0, 1, 0, 10, 100, 0 },
  { 166, 2, 0, 1, 0, 10, 100, 0 },
  { 178, 2, 0, 1, 0, 10, 100, 0 },
  { 196, 2, 0, 1, 0, 10, 100, 0 },
  { 214, 2, 0, 1, 0, 10, 100, 0 },
  { 226, 2, 0, 1, 0, 10, 100, 0 },
  { 238, 2, 0, 1, 0, 10, 100, 0 },
  { 250, 2, 0, 1, 0, 10, 100, 0 },
  // 199: convert_char, convert_char_rte, convert_char_rtn, convert_char_rtp, convert_char_rtz, convert_char_sat, convert_char_sat_rte, convert_char_sat_rtn, convert_char_sat_rtp, convert_char_sat_rtz, 
  { 252, 2, 0, 1, 0, 10, 100, 0 },
  { 264, 2, 0, 1, 0, 10, 100, 0 },
  { 276, 2, 0, 1, 0, 10, 100, 0 },
  { 288, 2, 0, 1, 0, 10, 100, 0 },
  { 300, 2, 0, 1, 0, 10, 100, 0 },
  { 312, 2, 0, 1, 0, 10, 100, 0 },
  { 330, 2, 0, 1, 0, 10, 100, 0 },
  { 348, 2, 0, 1, 0, 10, 100, 0 },
  { 360, 2, 0, 1, 0, 10, 100, 0 },
  { 372, 2, 0, 1, 0, 10, 100, 0 },
  { 384, 2, 0, 1, 0, 10, 100, 0 },
  // 210: convert_char2, convert_char2_rte, convert_char2_rtn, convert_char2_rtp, convert_char2_rtz, convert_char2_sat, convert_char2_sat_rte, convert_char2_sat_rtn, convert_char2_sat_rtp, convert_char2_sat_rtz, 
  { 254, 2, 0, 1, 0, 10, 100, 0 },
  { 266, 2, 0, 1, 0, 10, 100, 0 },
  { 278, 2, 0, 1, 0, 10, 100, 0 },
  { 290, 2, 0, 1, 0, 10, 100, 0 },
  { 302, 2, 0, 1, 0, 10, 100, 0 },
  { 314, 2, 0, 1, 0, 10, 100, 0 },
  { 332, 2, 0, 1, 0, 10, 100, 0 },
  { 350, 2, 0, 1, 0, 10, 100, 0 },
  { 362, 2, 0, 1, 0, 10, 100, 0 },
  { 374, 2, 0, 1, 0, 10, 100, 0 },
  { 386, 2, 0, 1, 0, 10, 100, 0 },
  // 221: convert_char3, convert_char3_rte, convert_char3_rtn, convert_char3_rtp, convert_char3_rtz, convert_char3_sat, convert_char3_sat_rte, convert_char3_sat_rtn, convert_char3_sat_rtp, convert_char3_sat_rtz, 
  { 256, 2, 0, 1, 0, 10, 100, 0 },
  { 268, 2, 0, 1, 0, 10, 100, 0 },
  { 280, 2, 0, 1, 0, 10, 100, 0 },
  { 292, 2, 0, 1, 0, 10, 100, 0 },
  { 304, 2, 0, 1, 0, 10, 100, 0 },
  { 318, 2, 0, 1, 0, 10, 100, 0 },
  { 336, 2, 0, 1, 0, 10, 100, 0 },
  { 352, 2, 0, 1, 0, 10, 100, 0 },
  { 364, 2, 0, 1, 0, 10, 100, 0 },
  { 376, 2, 0, 1, 0, 10, 100, 0 },
  { 388, 2, 0, 1, 0, 10, 100, 0 },
  // 232: convert_char4, convert_char4_rte, convert_char4_rtn, convert_char4_rtp, convert_char4_rtz, convert_char4_sat, convert_char4_sat_rte, convert_char4_sat_rtn, convert_char4_sat_rtp, convert_char4_sat_rtz, 
  { 258, 2, 0, 1, 0, 10, 100, 0 },
  { 270, 2, 0, 1, 0, 10, 100, 0 },
  { 282, 2, 0, 1, 0, 10, 100, 0 },
  { 294, 2, 0, 1, 0, 10, 100, 0 },
  { 306, 2, 0, 1, 0, 10, 100, 0 },
  { 320, 2, 0, 1, 0, 10, 100, 0 },
  { 338, 2, 0, 1, 0, 10, 100, 0 },
  { 354, 2, 0, 1, 0, 10, 100, 0 },
  { 366, 2, 0, 1, 0, 10, 100, 0 },
  { 378, 2, 0, 1, 0, 10, 100, 0 },
  { 390, 2, 0, 1, 0, 10, 100, 0 },
  // 243: convert_char8, convert_char8_rte, convert_char8_rtn, convert_char8_rtp, convert_char8_rtz, convert_char8_sat, convert_char8_sat_rte, convert_char8_sat_rtn, convert_char8_sat_rtp, convert_char8_sat_rtz, 
  { 260, 2, 0, 1, 0, 10, 100, 0 },
  { 272, 2, 0, 1, 0, 10, 100, 0 },
  { 284, 2, 0, 1, 0, 10, 100, 0 },
  { 296, 2, 0, 1, 0, 10, 100, 0 },
  { 308, 2, 0, 1, 0, 10, 100, 0 },
  { 322, 2, 0, 1, 0, 10, 100, 0 },
  { 340, 2, 0, 1, 0, 10, 100, 0 },
  { 356, 2, 0, 1, 0, 10, 100, 0 },
  { 368, 2, 0, 1, 0, 10, 100, 0 },
  { 380, 2, 0, 1, 0, 10, 100, 0 },
  { 392, 2, 0, 1, 0, 10, 100, 0 },
  // 254: convert_char16, convert_char16_rte, convert_char16_rtn, convert_char16_rtp, convert_char16_rtz, convert_char16_sat, convert_char16_sat_rte, convert_char16_sat_rtn, convert_char16_sat_rtp, convert_char16_sat_rtz, 
  { 262, 2, 0, 1, 0, 10, 100, 0 },
  { 274, 2, 0, 1, 0, 10, 100, 0 },
  { 286, 2, 0, 1, 0, 10, 100, 0 },
  { 298, 2, 0, 1, 0, 10, 100, 0 },
  { 310, 2, 0, 1, 0, 10, 100, 0 },
  { 324, 2, 0, 1, 0, 10, 100, 0 },
  { 342, 2, 0, 1, 0, 10, 100, 0 },
  { 358, 2, 0, 1, 0, 10, 100, 0 },
  { 370, 2, 0, 1, 0, 10, 100, 0 },
  { 382, 2, 0, 1, 0, 10, 100, 0 },
  { 394, 2, 0, 1, 0, 10, 100, 0 },
  // 265: convert_uchar, convert_uchar_rte, convert_uchar_rtn, convert_uchar_rtp, convert_uchar_rtz, convert_uchar_sat, convert_uchar_sat_rte, convert_uchar_sat_rtn, convert_uchar_sat_rtp, convert_uchar_sat_rtz, 
  { 396, 2, 0, 1, 0, 10, 100, 0 },
  { 408, 2, 0, 1, 0, 10, 100, 0 },
  { 420, 2, 0, 1, 0, 10, 100, 0 },
  { 432, 2, 0, 1, 0, 10, 100, 0 },
  { 444, 2, 0, 1, 0, 10, 100, 0 },
  { 458, 2, 0, 1, 0, 10, 100, 0 },
  { 476, 2, 0, 1, 0, 10, 100, 0 },
  { 492, 2, 0, 1, 0, 10, 100, 0 },
  { 504, 2, 0, 1, 0, 10, 100, 0 },
  { 516, 2, 0, 1, 0, 10, 100, 0 },
  { 528, 2, 0, 1, 0, 10, 100, 0 },
  // 276: convert_uchar2, convert_uchar2_rte, convert_uchar2_rtn, convert_uchar2_rtp, convert_uchar2_rtz, convert_uchar2_sat, convert_uchar2_sat_rte, convert_uchar2_sat_rtn, convert_uchar2_sat_rtp, convert_uchar2_sat_rtz, 
  { 398, 2, 0, 1, 0, 10, 100, 0 },
  { 410, 2, 0, 1, 0, 10, 100, 0 },
  { 422, 2, 0, 1, 0, 10, 100, 0 },
  { 434, 2, 0, 1, 0, 10, 100, 0 },
  { 446, 2, 0, 1, 0, 10, 100, 0 },
  { 460, 2, 0, 1, 0, 10, 100, 0 },
  { 478, 2, 0, 1, 0, 10, 100, 0 },
  { 494, 2, 0, 1, 0, 10, 100, 0 },
  { 506, 2, 0, 1, 0, 10, 100, 0 },
  { 518, 2, 0, 1, 0, 10, 100, 0 },
  { 530, 2, 0, 1, 0, 10, 100, 0 },
  // 287: convert_uchar3, convert_uchar3_rte, convert_uchar3_rtn, convert_uchar3_rtp, convert_uchar3_rtz, convert_uchar3_sat, convert_uchar3_sat_rte, convert_uchar3_sat_rtn, convert_uchar3_sat_rtp, convert_uchar3_sat_rtz, 
  { 400, 2, 0, 1, 0, 10, 100, 0 },
  { 412, 2, 0, 1, 0, 10, 100, 0 },
  { 424, 2, 0, 1, 0, 10, 100, 0 },
  { 436, 2, 0, 1, 0, 10, 100, 0 },
  { 448, 2, 0, 1, 0, 10, 100, 0 },
  { 462, 2, 0, 1, 0, 10, 100, 0 },
  { 480, 2, 0, 1, 0, 10, 100, 0 },
  { 496, 2, 0, 1, 0, 10, 100, 0 },
  { 508, 2, 0, 1, 0, 10, 100, 0 },
  { 520, 2, 0, 1, 0, 10, 100, 0 },
  { 532, 2, 0, 1, 0, 10, 100, 0 },
  // 298: convert_uchar4, convert_uchar4_rte, convert_uchar4_rtn, convert_uchar4_rtp, convert_uchar4_rtz, convert_uchar4_sat, convert_uchar4_sat_rte, convert_uchar4_sat_rtn, convert_uchar4_sat_rtp, convert_uchar4_sat_rtz, 
  { 402, 2, 0, 1, 0, 10, 100, 0 },
  { 414, 2, 0, 1, 0, 10, 100, 0 },
  { 426, 2, 0, 1, 0, 10, 100, 0 },
  { 438, 2, 0, 1, 0, 10, 100, 0 },
  { 450, 2, 0, 1, 0, 10, 100, 0 },
  { 464, 2, 0, 1, 0, 10, 100, 0 },
  { 482, 2, 0, 1, 0, 10, 100, 0 },
  { 498, 2, 0, 1, 0, 10, 100, 0 },
  { 510, 2, 0, 1, 0, 10, 100, 0 },
  { 522, 2, 0, 1, 0, 10, 100, 0 },
  { 534, 2, 0, 1, 0, 10, 100, 0 },
  // 309: convert_uchar8, convert_uchar8_rte, convert_uchar8_rtn, convert_uchar8_rtp, convert_uchar8_rtz, convert_uchar8_sat, convert_uchar8_sat_rte, convert_uchar8_sat_rtn, convert_uchar8_sat_rtp, convert_uchar8_sat_rtz, 
  { 404, 2, 0, 1, 0, 10, 100, 0 },
  { 416, 2, 0, 1, 0, 10, 100, 0 },
  { 428, 2, 0, 1, 0, 10, 100, 0 },
  { 440, 2, 0, 1, 0, 10, 100, 0 },
  { 452, 2, 0, 1, 0, 10, 100, 0 },
  { 466, 2, 0, 1, 0, 10, 100, 0 },
  { 484, 2, 0, 1, 0, 10, 100, 0 },
  { 500, 2, 0, 1, 0, 10, 100, 0 },
  { 512, 2, 0, 1, 0, 10, 100, 0 },
  { 524, 2, 0, 1, 0, 10, 100, 0 },
  { 536, 2, 0, 1, 0, 10, 100, 0 },
  // 320: convert_uchar16, convert_uchar16_rte, convert_uchar16_rtn, convert_uchar16_rtp, convert_uchar16_rtz, convert_uchar16_sat, convert_uchar16_sat_rte, convert_uchar16_sat_rtn, convert_uchar16_sat_rtp, convert_uchar16_sat_rtz, 
  { 406, 2, 0, 1, 0, 10, 100, 0 },
  { 418, 2, 0, 1, 0, 10, 100, 0 },
  { 430, 2, 0, 1, 0, 10, 100, 0 },
  { 442, 2, 0, 1, 0, 10, 100, 0 },
  { 454, 2, 0, 1, 0, 10, 100, 0 },
  { 468, 2, 0, 1, 0, 10, 100, 0 },
  { 486, 2, 0, 1, 0, 10, 100, 0 },
  { 502, 2, 0, 1, 0, 10, 100, 0 },
  { 514, 2, 0, 1, 0, 10, 100, 0 },
  { 526, 2, 0, 1, 0, 10, 100, 0 },
  { 538, 2, 0, 1, 0, 10, 100, 0 },
  // 331: convert_short, convert_short_rte, convert_short_rtn, convert_short_rtp, convert_short_rtz, convert_short_sat, convert_short_sat_rte, convert_short_sat_rtn, convert_short_sat_rtp, convert_short_sat_rtz, 
  { 540, 2, 0, 1, 0, 10, 100, 0 },
  { 552, 2, 0, 1, 0, 10, 100, 0 },
  { 564, 2, 0, 1, 0, 10, 100, 0 },
  { 576, 2, 0, 1, 0, 10, 100, 0 },
  { 588, 2, 0, 1, 0, 10, 100, 0 },
  { 602, 2, 0, 1, 0, 10, 100, 0 },
  { 620, 2, 0, 1, 0, 10, 100, 0 },
  { 636, 2, 0, 1, 0, 10, 100, 0 },
  { 648, 2, 0, 1, 0, 10, 100, 0 },
  { 660, 2, 0, 1, 0, 10, 100, 0 },
  { 672, 2, 0, 1, 0, 10, 100, 0 },
  // 342: convert_short2, convert_short2_rte, convert_short2_rtn, convert_short2_rtp, convert_short2_rtz, convert_short2_sat, convert_short2_sat_rte, convert_short2_sat_rtn, convert_short2_sat_rtp, convert_short2_sat_rtz, 
  { 542, 2, 0, 1, 0, 10, 100, 0 },
  { 554, 2, 0, 1, 0, 10, 100, 0 },
  { 566, 2, 0, 1, 0, 10, 100, 0 },
  { 578, 2, 0, 1, 0, 10, 100, 0 },
  { 590, 2, 0, 1, 0, 10, 100, 0 },
  { 604, 2, 0, 1, 0, 10, 100, 0 },
  { 622, 2, 0, 1, 0, 10, 100, 0 },
  { 638, 2, 0, 1, 0, 10, 100, 0 },
  { 650, 2, 0, 1, 0, 10, 100, 0 },
  { 662, 2, 0, 1, 0, 10, 100, 0 },
  { 674, 2, 0, 1, 0, 10, 100, 0 },
  // 353: convert_short3, convert_short3_rte, convert_short3_rtn, convert_short3_rtp, convert_short3_rtz, convert_short3_sat, convert_short3_sat_rte, convert_short3_sat_rtn, convert_short3_sat_rtp, convert_short3_sat_rtz, 
  { 544, 2, 0, 1, 0, 10, 100, 0 },
  { 556, 2, 0, 1, 0, 10, 100, 0 },
  { 568, 2, 0, 1, 0, 10, 100, 0 },
  { 580, 2, 0, 1, 0, 10, 100, 0 },
  { 592, 2, 0, 1, 0, 10, 100, 0 },
  { 608, 2, 0, 1, 0, 10, 100, 0 },
  { 626, 2, 0, 1, 0, 10, 100, 0 },
  { 640, 2, 0, 1, 0, 10, 100, 0 },
  { 652, 2, 0, 1, 0, 10, 100, 0 },
  { 664, 2, 0, 1, 0, 10, 100, 0 },
  { 676, 2, 0, 1, 0, 10, 100, 0 },
  // 364: convert_short4, convert_short4_rte, convert_short4_rtn, convert_short4_rtp, convert_short4_rtz, convert_short4_sat, convert_short4_sat_rte, convert_short4_sat_rtn, convert_short4_sat_rtp, convert_short4_sat_rtz, 
  { 546, 2, 0, 1, 0, 10, 100, 0 },
  { 558, 2, 0, 1, 0, 10, 100, 0 },
  { 570, 2, 0, 1, 0, 10, 100, 0 },
  { 582, 2, 0, 1, 0, 10, 100, 0 },
  { 594, 2, 0, 1, 0, 10, 100, 0 },
  { 610, 2, 0, 1, 0, 10, 100, 0 },
  { 628, 2, 0, 1, 0, 10, 100, 0 },
  { 642, 2, 0, 1, 0, 10, 100, 0 },
  { 654, 2, 0, 1, 0, 10, 100, 0 },
  { 666, 2, 0, 1, 0, 10, 100, 0 },
  { 678, 2, 0, 1, 0, 10, 100, 0 },
  // 375: convert_short8, convert_short8_rte, convert_short8_rtn, convert_short8_rtp, convert_short8_rtz, convert_short8_sat, convert_short8_sat_rte, convert_short8_sat_rtn, convert_short8_sat_rtp, convert_short8_sat_rtz, 
  { 548, 2, 0, 1, 0, 10, 100, 0 },
  { 560, 2, 0, 1, 0, 10, 100, 0 },
  { 572, 2, 0, 1, 0, 10, 100, 0 },
  { 584, 2, 0, 1, 0, 10, 100, 0 },
  { 596, 2, 0, 1, 0, 10, 100, 0 },
  { 612, 2, 0, 1, 0, 10, 100, 0 },
  { 630, 2, 0, 1, 0, 10, 100, 0 },
  { 644, 2, 0, 1, 0, 10, 100, 0 },
  { 656, 2, 0, 1, 0, 10, 100, 0 },
  { 668, 2, 0, 1, 0, 10, 100, 0 },
  { 680, 2, 0, 1, 0, 10, 100, 0 },
  // 386: convert_short16, convert_short16_rte, convert_short16_rtn, convert_short16_rtp, convert_short16_rtz, convert_short16_sat, convert_short16_sat_rte, convert_short16_sat_rtn, convert_short16_sat_rtp, convert_short16_sat_rtz, 
  { 550, 2, 0, 1, 0, 10, 100, 0 },
  { 562, 2, 0, 1, 0, 10, 100, 0 },
  { 574, 2, 0, 1, 0, 10, 100, 0 },
  { 586, 2, 0, 1, 0, 10, 100, 0 },
  { 598, 2, 0, 1, 0, 10, 100, 0 },
  { 614, 2, 0, 1, 0, 10, 100, 0 },
  { 632, 2, 0, 1, 0, 10, 100, 0 },
  { 646, 2, 0, 1, 0, 10, 100, 0 },
  { 658, 2, 0, 1, 0, 10, 100, 0 },
  { 670, 2, 0, 1, 0, 10, 100, 0 },
  { 682, 2, 0, 1, 0, 10, 100, 0 },
  // 397: convert_ushort, convert_ushort_rte, convert_ushort_rtn, convert_ushort_rtp, convert_ushort_rtz, convert_ushort_sat, convert_ushort_sat_rte, convert_ushort_sat_rtn, convert_ushort_sat_rtp, convert_ushort_sat_rtz, 
  { 684, 2, 0, 1, 0, 10, 100, 0 },
  { 696, 2, 0, 1, 0, 10, 100, 0 },
  { 708, 2, 0, 1, 0, 10, 100, 0 },
  { 720, 2, 0, 1, 0, 10, 100, 0 },
  { 732, 2, 0, 1, 0, 10, 100, 0 },
  { 748, 2, 0, 1, 0, 10, 100, 0 },
  { 766, 2, 0, 1, 0, 10, 100, 0 },
  { 780, 2, 0, 1, 0, 10, 100, 0 },
  { 792, 2, 0, 1, 0, 10, 100, 0 },
  { 804, 2, 0, 1, 0, 10, 100, 0 },
  { 816, 2, 0, 1, 0, 10, 100, 0 },
  // 408: convert_ushort2, convert_ushort2_rte, convert_ushort2_rtn, convert_ushort2_rtp, convert_ushort2_rtz, convert_ushort2_sat, convert_ushort2_sat_rte, convert_ushort2_sat_rtn, convert_ushort2_sat_rtp, convert_ushort2_sat_rtz, 
  { 686, 2, 0, 1, 0, 10, 100, 0 },
  { 698, 2, 0, 1, 0, 10, 100, 0 },
  { 710, 2, 0, 1, 0, 10, 100, 0 },
  { 722, 2, 0, 1, 0, 10, 100, 0 },
  { 734, 2, 0, 1, 0, 10, 100, 0 },
  { 750, 2, 0, 1, 0, 10, 100, 0 },
  { 768, 2, 0, 1, 0, 10, 100, 0 },
  { 782, 2, 0, 1, 0, 10, 100, 0 },
  { 794, 2, 0, 1, 0, 10, 100, 0 },
  { 806, 2, 0, 1, 0, 10, 100, 0 },
  { 818, 2, 0, 1, 0, 10, 100, 0 },
  // 419: convert_ushort3, convert_ushort3_rte, convert_ushort3_rtn, convert_ushort3_rtp, convert_ushort3_rtz, convert_ushort3_sat, convert_ushort3_sat_rte, convert_ushort3_sat_rtn, convert_ushort3_sat_rtp, convert_ushort3_sat_rtz, 
  { 688, 2, 0, 1, 0, 10, 100, 0 },
  { 700, 2, 0, 1, 0, 10, 100, 0 },
  { 712, 2, 0, 1, 0, 10, 100, 0 },
  { 724, 2, 0, 1, 0, 10, 100, 0 },
  { 736, 2, 0, 1, 0, 10, 100, 0 },
  { 752, 2, 0, 1, 0, 10, 100, 0 },
  { 770, 2, 0, 1, 0, 10, 100, 0 },
  { 784, 2, 0, 1, 0, 10, 100, 0 },
  { 796, 2, 0, 1, 0, 10, 100, 0 },
  { 808, 2, 0, 1, 0, 10, 100, 0 },
  { 820, 2, 0, 1, 0, 10, 100, 0 },
  // 430: convert_ushort4, convert_ushort4_rte, convert_ushort4_rtn, convert_ushort4_rtp, convert_ushort4_rtz, convert_ushort4_sat, convert_ushort4_sat_rte, convert_ushort4_sat_rtn, convert_ushort4_sat_rtp, convert_ushort4_sat_rtz, 
  { 690, 2, 0, 1, 0, 10, 100, 0 },
  { 702, 2, 0, 1, 0, 10, 100, 0 },
  { 714, 2, 0, 1, 0, 10, 100, 0 },
  { 726, 2, 0, 1, 0, 10, 100, 0 },
  { 738, 2, 0, 1, 0, 10, 100, 0 },
  { 754, 2, 0, 1, 0, 10, 100, 0 },
  { 772, 2, 0, 1, 0, 10, 100, 0 },
  { 786, 2, 0, 1, 0, 10, 100, 0 },
  { 798, 2, 0, 1, 0, 10, 100, 0 },
  { 810, 2, 0, 1, 0, 10, 100, 0 },
  { 822, 2, 0, 1, 0, 10, 100, 0 },
  // 441: convert_ushort8, convert_ushort8_rte, convert_ushort8_rtn, convert_ushort8_rtp, convert_ushort8_rtz, convert_ushort8_sat, convert_ushort8_sat_rte, convert_ushort8_sat_rtn, convert_ushort8_sat_rtp, convert_ushort8_sat_rtz, 
  { 692, 2, 0, 1, 0, 10, 100, 0 },
  { 704, 2, 0, 1, 0, 10, 100, 0 },
  { 716, 2, 0, 1, 0, 10, 100, 0 },
  { 728, 2, 0, 1, 0, 10, 100, 0 },
  { 740, 2, 0, 1, 0, 10, 100, 0 },
  { 756, 2, 0, 1, 0, 10, 100, 0 },
  { 774, 2, 0, 1, 0, 10, 100, 0 },
  { 788, 2, 0, 1, 0, 10, 100, 0 },
  { 800, 2, 0, 1, 0, 10, 100, 0 },
  { 812, 2, 0, 1, 0, 10, 100, 0 },
  { 824, 2, 0, 1, 0, 10, 100, 0 },
  // 452: convert_ushort16, convert_ushort16_rte, convert_ushort16_rtn, convert_ushort16_rtp, convert_ushort16_rtz, convert_ushort16_sat, convert_ushort16_sat_rte, convert_ushort16_sat_rtn, convert_ushort16_sat_rtp, convert_ushort16_sat_rtz, 
  { 694, 2, 0, 1, 0, 10, 100, 0 },
  { 706, 2, 0, 1, 0, 10, 100, 0 },
  { 718, 2, 0, 1, 0, 10, 100, 0 },
  { 730, 2, 0, 1, 0, 10, 100, 0 },
  { 742, 2, 0, 1, 0, 10, 100, 0 },
  { 758, 2, 0, 1, 0, 10, 100, 0 },
  { 776, 2, 0, 1, 0, 10, 100, 0 },
  { 790, 2, 0, 1, 0, 10, 100, 0 },
  { 802, 2, 0, 1, 0, 10, 100, 0 },
  { 814, 2, 0, 1, 0, 10, 100, 0 },
  { 826, 2, 0, 1, 0, 10, 100, 0 },
  // 463: convert_int, convert_int_rte, convert_int_rtn, convert_int_rtp, convert_int_rtz, convert_int_sat, convert_int_sat_rte, convert_int_sat_rtn, convert_int_sat_rtp, convert_int_sat_rtz, 
  { 828, 2, 0, 1, 0, 10, 100, 0 },
  { 840, 2, 0, 1, 0, 10, 100, 0 },
  { 852, 2, 0, 1, 0, 10, 100, 0 },
  { 864, 2, 0, 1, 0, 10, 100, 0 },
  { 876, 2, 0, 1, 0, 10, 100, 0 },
  { 892, 2, 0, 1, 0, 10, 100, 0 },
  { 910, 2, 0, 1, 0, 10, 100, 0 },
  { 924, 2, 0, 1, 0, 10, 100, 0 },
  { 936, 2, 0, 1, 0, 10, 100, 0 },
  { 948, 2, 0, 1, 0, 10, 100, 0 },
  { 960, 2, 0, 1, 0, 10, 100, 0 },
  // 474: convert_int2, convert_int2_rte, convert_int2_rtn, convert_int2_rtp, convert_int2_rtz, convert_int2_sat, convert_int2_sat_rte, convert_int2_sat_rtn, convert_int2_sat_rtp, convert_int2_sat_rtz, 
  { 830, 2, 0, 1, 0, 10, 100, 0 },
  { 842, 2, 0, 1, 0, 10, 100, 0 },
  { 854, 2, 0, 1, 0, 10, 100, 0 },
  { 866, 2, 0, 1, 0, 10, 100, 0 },
  { 878, 2, 0, 1, 0, 10, 100, 0 },
  { 894, 2, 0, 1, 0, 10, 100, 0 },
  { 912, 2, 0, 1, 0, 10, 100, 0 },
  { 926, 2, 0, 1, 0, 10, 100, 0 },
  { 938, 2, 0, 1, 0, 10, 100, 0 },
  { 950, 2, 0, 1, 0, 10, 100, 0 },
  { 962, 2, 0, 1, 0, 10, 100, 0 },
  // 485: convert_int3, convert_int3_rte, convert_int3_rtn, convert_int3_rtp, convert_int3_rtz, convert_int3_sat, convert_int3_sat_rte, convert_int3_sat_rtn, convert_int3_sat_rtp, convert_int3_sat_rtz, 
  { 832, 2, 0, 1, 0, 10, 100, 0 },
  { 844, 2, 0, 1, 0, 10, 100, 0 },
  { 856, 2, 0, 1, 0, 10, 100, 0 },
  { 868, 2, 0, 1, 0, 10, 100, 0 },
  { 880, 2, 0, 1, 0, 10, 100, 0 },
  { 898, 2, 0, 1, 0, 10, 100, 0 },
  { 916, 2, 0, 1, 0, 10, 100, 0 },
  { 928, 2, 0, 1, 0, 10, 100, 0 },
  { 940, 2, 0, 1, 0, 10, 100, 0 },
  { 952, 2, 0, 1, 0, 10, 100, 0 },
  { 964, 2, 0, 1, 0, 10, 100, 0 },
  // 496: convert_int4, convert_int4_rte, convert_int4_rtn, convert_int4_rtp, convert_int4_rtz, convert_int4_sat, convert_int4_sat_rte, convert_int4_sat_rtn, convert_int4_sat_rtp, convert_int4_sat_rtz, 
  { 834, 2, 0, 1, 0, 10, 100, 0 },
  { 846, 2, 0, 1, 0, 10, 100, 0 },
  { 858, 2, 0, 1, 0, 10, 100, 0 },
  { 870, 2, 0, 1, 0, 10, 100, 0 },
  { 882, 2, 0, 1, 0, 10, 100, 0 },
  { 900, 2, 0, 1, 0, 10, 100, 0 },
  { 918, 2, 0, 1, 0, 10, 100, 0 },
  { 930, 2, 0, 1, 0, 10, 100, 0 },
  { 942, 2, 0, 1, 0, 10, 100, 0 },
  { 954, 2, 0, 1, 0, 10, 100, 0 },
  { 966, 2, 0, 1, 0, 10, 100, 0 },
  // 507: convert_int8, convert_int8_rte, convert_int8_rtn, convert_int8_rtp, convert_int8_rtz, convert_int8_sat, convert_int8_sat_rte, convert_int8_sat_rtn, convert_int8_sat_rtp, convert_int8_sat_rtz, 
  { 836, 2, 0, 1, 0, 10, 100, 0 },
  { 848, 2, 0, 1, 0, 10, 100, 0 },
  { 860, 2, 0, 1, 0, 10, 100, 0 },
  { 872, 2, 0, 1, 0, 10, 100, 0 },
  { 884, 2, 0, 1, 0, 10, 100, 0 },
  { 902, 2, 0, 1, 0, 10, 100, 0 },
  { 920, 2, 0, 1, 0, 10, 100, 0 },
  { 932, 2, 0, 1, 0, 10, 100, 0 },
  { 944, 2, 0, 1, 0, 10, 100, 0 },
  { 956, 2, 0, 1, 0, 10, 100, 0 },
  { 968, 2, 0, 1, 0, 10, 100, 0 },
  // 518: convert_int16, convert_int16_rte, convert_int16_rtn, convert_int16_rtp, convert_int16_rtz, convert_int16_sat, convert_int16_sat_rte, convert_int16_sat_rtn, convert_int16_sat_rtp, convert_int16_sat_rtz, 
  { 838, 2, 0, 1, 0, 10, 100, 0 },
  { 850, 2, 0, 1, 0, 10, 100, 0 },
  { 862, 2, 0, 1, 0, 10, 100, 0 },
  { 874, 2, 0, 1, 0, 10, 100, 0 },
  { 886, 2, 0, 1, 0, 10, 100, 0 },
  { 904, 2, 0, 1, 0, 10, 100, 0 },
  { 922, 2, 0, 1, 0, 10, 100, 0 },
  { 934, 2, 0, 1, 0, 10, 100, 0 },
  { 946, 2, 0, 1, 0, 10, 100, 0 },
  { 958, 2, 0, 1, 0, 10, 100, 0 },
  { 970, 2, 0, 1, 0, 10, 100, 0 },
  // 529: convert_uint, convert_uint_rte, convert_uint_rtn, convert_uint_rtp, convert_uint_rtz, convert_uint_sat, convert_uint_sat_rte, convert_uint_sat_rtn, convert_uint_sat_rtp, convert_uint_sat_rtz, 
  { 972, 2, 0, 1, 0, 10, 100, 0 },
  { 984, 2, 0, 1, 0, 10, 100, 0 },
  { 996, 2, 0, 1, 0, 10, 100, 0 },
  { 1008, 2, 0, 1, 0, 10, 100, 0 },
  { 1020, 2, 0, 1, 0, 10, 100, 0 },
  { 1038, 2, 0, 1, 0, 10, 100, 0 },
  { 1056, 2, 0, 1, 0, 10, 100, 0 },
  { 1068, 2, 0, 1, 0, 10, 100, 0 },
  { 1080, 2, 0, 1, 0, 10, 100, 0 },
  { 1092, 2, 0, 1, 0, 10, 100, 0 },
  { 1104, 2, 0, 1, 0, 10, 100, 0 },
  // 540: convert_uint2, convert_uint2_rte, convert_uint2_rtn, convert_uint2_rtp, convert_uint2_rtz, convert_uint2_sat, convert_uint2_sat_rte, convert_uint2_sat_rtn, convert_uint2_sat_rtp, convert_uint2_sat_rtz, 
  { 974, 2, 0, 1, 0, 10, 100, 0 },
  { 986, 2, 0, 1, 0, 10, 100, 0 },
  { 998, 2, 0, 1, 0, 10, 100, 0 },
  { 1010, 2, 0, 1, 0, 10, 100, 0 },
  { 1022, 2, 0, 1, 0, 10, 100, 0 },
  { 1040, 2, 0, 1, 0, 10, 100, 0 },
  { 1058, 2, 0, 1, 0, 10, 100, 0 },
  { 1070, 2, 0, 1, 0, 10, 100, 0 },
  { 1082, 2, 0, 1, 0, 10, 100, 0 },
  { 1094, 2, 0, 1, 0, 10, 100, 0 },
  { 1106, 2, 0, 1, 0, 10, 100, 0 },
  // 551: convert_uint3, convert_uint3_rte, convert_uint3_rtn, convert_uint3_rtp, convert_uint3_rtz, convert_uint3_sat, convert_uint3_sat_rte, convert_uint3_sat_rtn, convert_uint3_sat_rtp, convert_uint3_sat_rtz, 
  { 976, 2, 0, 1, 0, 10, 100, 0 },
  { 988, 2, 0, 1, 0, 10, 100, 0 },
  { 1000, 2, 0, 1, 0, 10, 100, 0 },
  { 1012, 2, 0, 1, 0, 10, 100, 0 },
  { 1024, 2, 0, 1, 0, 10, 100, 0 },
  { 1042, 2, 0, 1, 0, 10, 100, 0 },
  { 1060, 2, 0, 1, 0, 10, 100, 0 },
  { 1072, 2, 0, 1, 0, 10, 100, 0 },
  { 1084, 2, 0, 1, 0, 10, 100, 0 },
  { 1096, 2, 0, 1, 0, 10, 100, 0 },
  { 1108, 2, 0, 1, 0, 10, 100, 0 },
  // 562: convert_uint4, convert_uint4_rte, convert_uint4_rtn, convert_uint4_rtp, convert_uint4_rtz, convert_uint4_sat, convert_uint4_sat_rte, convert_uint4_sat_rtn, convert_uint4_sat_rtp, convert_uint4_sat_rtz, 
  { 978, 2, 0, 1, 0, 10, 100, 0 },
  { 990, 2, 0, 1, 0, 10, 100, 0 },
  { 1002, 2, 0, 1, 0, 10, 100, 0 },
  { 1014, 2, 0, 1, 0, 10, 100, 0 },
  { 1026, 2, 0, 1, 0, 10, 100, 0 },
  { 1044, 2, 0, 1, 0, 10, 100, 0 },
  { 1062, 2, 0, 1, 0, 10, 100, 0 },
  { 1074, 2, 0, 1, 0, 10, 100, 0 },
  { 1086, 2, 0, 1, 0, 10, 100, 0 },
  { 1098, 2, 0, 1, 0, 10, 100, 0 },
  { 1110, 2, 0, 1, 0, 10, 100, 0 },
  // 573: convert_uint8, convert_uint8_rte, convert_uint8_rtn, convert_uint8_rtp, convert_uint8_rtz, convert_uint8_sat, convert_uint8_sat_rte, convert_uint8_sat_rtn, convert_uint8_sat_rtp, convert_uint8_sat_rtz, 
  { 980, 2, 0, 1, 0, 10, 100, 0 },
  { 992, 2, 0, 1, 0, 10, 100, 0 },
  { 1004, 2, 0, 1, 0, 10, 100, 0 },
  { 1016, 2, 0, 1, 0, 10, 100, 0 },
  { 1028, 2, 0, 1, 0, 10, 100, 0 },
  { 1046, 2, 0, 1, 0, 10, 100, 0 },
  { 1064, 2, 0, 1, 0, 10, 100, 0 },
  { 1076, 2, 0, 1, 0, 10, 100, 0 },
  { 1088, 2, 0, 1, 0, 10, 100, 0 },
  { 1100, 2, 0, 1, 0, 10, 100, 0 },
  { 1112, 2, 0, 1, 0, 10, 100, 0 },
  // 584: convert_uint16, convert_uint16_rte, convert_uint16_rtn, convert_uint16_rtp, convert_uint16_rtz, convert_uint16_sat, convert_uint16_sat_rte, convert_uint16_sat_rtn, convert_uint16_sat_rtp, convert_uint16_sat_rtz, 
  { 982, 2, 0, 1, 0, 10, 100, 0 },
  { 994, 2, 0, 1, 0, 10, 100, 0 },
  { 1006, 2, 0, 1, 0, 10, 100, 0 },
  { 1018, 2, 0, 1, 0, 10, 100, 0 },
  { 1030, 2, 0, 1, 0, 10, 100, 0 },
  { 1048, 2, 0, 1, 0, 10, 100, 0 },
  { 1066, 2, 0, 1, 0, 10, 100, 0 },
  { 1078, 2, 0, 1, 0, 10, 100, 0 },
  { 1090, 2, 0, 1, 0, 10, 100, 0 },
  { 1102, 2, 0, 1, 0, 10, 100, 0 },
  { 1114, 2, 0, 1, 0, 10, 100, 0 },
  // 595: convert_long, convert_long_rte, convert_long_rtn, convert_long_rtp, convert_long_rtz, convert_long_sat, convert_long_sat_rte, convert_long_sat_rtn, convert_long_sat_rtp, convert_long_sat_rtz, 
  { 1116, 2, 0, 1, 0, 10, 100, 0 },
  { 1128, 2, 0, 1, 0, 10, 100, 0 },
  { 1140, 2, 0, 1, 0, 10, 100, 0 },
  { 1152, 2, 0, 1, 0, 10, 100, 0 },
  { 1164, 2, 0, 1, 0, 10, 100, 0 },
  { 1182, 2, 0, 1, 0, 10, 100, 0 },
  { 1200, 2, 0, 1, 0, 10, 100, 0 },
  { 1212, 2, 0, 1, 0, 10, 100, 0 },
  { 1224, 2, 0, 1, 0, 10, 100, 0 },
  { 1236, 2, 0, 1, 0, 10, 100, 0 },
  { 1248, 2, 0, 1, 0, 10, 100, 0 },
  // 606: convert_long2, convert_long2_rte, convert_long2_rtn, convert_long2_rtp, convert_long2_rtz, convert_long2_sat, convert_long2_sat_rte, convert_long2_sat_rtn, convert_long2_sat_rtp, convert_long2_sat_rtz, 
  { 1118, 2, 0, 1, 0, 10, 100, 0 },
  { 1130, 2, 0, 1, 0, 10, 100, 0 },
  { 1142, 2, 0, 1, 0, 10, 100, 0 },
  { 1154, 2, 0, 1, 0, 10, 100, 0 },
  { 1166, 2, 0, 1, 0, 10, 100, 0 },
  { 1184, 2, 0, 1, 0, 10, 100, 0 },
  { 1202, 2, 0, 1, 0, 10, 100, 0 },
  { 1214, 2, 0, 1, 0, 10, 100, 0 },
  { 1226, 2, 0, 1, 0, 10, 100, 0 },
  { 1238, 2, 0, 1, 0, 10, 100, 0 },
  { 1250, 2, 0, 1, 0, 10, 100, 0 },
  // 617: convert_long3, convert_long3_rte, convert_long3_rtn, convert_long3_rtp, convert_long3_rtz, convert_long3_sat, convert_long3_sat_rte, convert_long3_sat_rtn, convert_long3_sat_rtp, convert_long3_sat_rtz, 
  { 1120, 2, 0, 1, 0, 10, 100, 0 },
  { 1132, 2, 0, 1, 0, 10, 100, 0 },
  { 1144, 2, 0, 1, 0, 10, 100, 0 },
  { 1156, 2, 0, 1, 0, 10, 100, 0 },
  { 1170, 2, 0, 1, 0, 10, 100, 0 },
  { 1188, 2, 0, 1, 0, 10, 100, 0 },
  { 1204, 2, 0, 1, 0, 10, 100, 0 },
  { 1216, 2, 0, 1, 0, 10, 100, 0 },
  { 1228, 2, 0, 1, 0, 10, 100, 0 },
  { 1240, 2, 0, 1, 0, 10, 100, 0 },
  { 1252, 2, 0, 1, 0, 10, 100, 0 },
  // 628: convert_long4, convert_long4_rte, convert_long4_rtn, convert_long4_rtp, convert_long4_rtz, convert_long4_sat, convert_long4_sat_rte, convert_long4_sat_rtn, convert_long4_sat_rtp, convert_long4_sat_rtz, 
  { 1122, 2, 0, 1, 0, 10, 100, 0 },
  { 1134, 2, 0, 1, 0, 10, 100, 0 },
  { 1146, 2, 0, 1, 0, 10, 100, 0 },
  { 1158, 2, 0, 1, 0, 10, 100, 0 },
  { 1172, 2, 0, 1, 0, 10, 100, 0 },
  { 1190, 2, 0, 1, 0, 10, 100, 0 },
  { 1206, 2, 0, 1, 0, 10, 100, 0 },
  { 1218, 2, 0, 1, 0, 10, 100, 0 },
  { 1230, 2, 0, 1, 0, 10, 100, 0 },
  { 1242, 2, 0, 1, 0, 10, 100, 0 },
  { 1254, 2, 0, 1, 0, 10, 100, 0 },
  // 639: convert_long8, convert_long8_rte, convert_long8_rtn, convert_long8_rtp, convert_long8_rtz, convert_long8_sat, convert_long8_sat_rte, convert_long8_sat_rtn, convert_long8_sat_rtp, convert_long8_sat_rtz, 
  { 1124, 2, 0, 1, 0, 10, 100, 0 },
  { 1136, 2, 0, 1, 0, 10, 100, 0 },
  { 1148, 2, 0, 1, 0, 10, 100, 0 },
  { 1160, 2, 0, 1, 0, 10, 100, 0 },
  { 1174, 2, 0, 1, 0, 10, 100, 0 },
  { 1192, 2, 0, 1, 0, 10, 100, 0 },
  { 1208, 2, 0, 1, 0, 10, 100, 0 },
  { 1220, 2, 0, 1, 0, 10, 100, 0 },
  { 1232, 2, 0, 1, 0, 10, 100, 0 },
  { 1244, 2, 0, 1, 0, 10, 100, 0 },
  { 1256, 2, 0, 1, 0, 10, 100, 0 },
  // 650: convert_long16, convert_long16_rte, convert_long16_rtn, convert_long16_rtp, convert_long16_rtz, convert_long16_sat, convert_long16_sat_rte, convert_long16_sat_rtn, convert_long16_sat_rtp, convert_long16_sat_rtz, 
  { 1126, 2, 0, 1, 0, 10, 100, 0 },
  { 1138, 2, 0, 1, 0, 10, 100, 0 },
  { 1150, 2, 0, 1, 0, 10, 100, 0 },
  { 1162, 2, 0, 1, 0, 10, 100, 0 },
  { 1176, 2, 0, 1, 0, 10, 100, 0 },
  { 1194, 2, 0, 1, 0, 10, 100, 0 },
  { 1210, 2, 0, 1, 0, 10, 100, 0 },
  { 1222, 2, 0, 1, 0, 10, 100, 0 },
  { 1234, 2, 0, 1, 0, 10, 100, 0 },
  { 1246, 2, 0, 1, 0, 10, 100, 0 },
  { 1258, 2, 0, 1, 0, 10, 100, 0 },
  // 661: convert_ulong, convert_ulong_rte, convert_ulong_rtn, convert_ulong_rtp, convert_ulong_rtz, convert_ulong_sat, convert_ulong_sat_rte, convert_ulong_sat_rtn, convert_ulong_sat_rtp, convert_ulong_sat_rtz, 
  { 1260, 2, 0, 1, 0, 10, 100, 0 },
  { 1272, 2, 0, 1, 0, 10, 100, 0 },
  { 1284, 2, 0, 1, 0, 10, 100, 0 },
  { 1296, 2, 0, 1, 0, 10, 100, 0 },
  { 1310, 2, 0, 1, 0, 10, 100, 0 },
  { 1328, 2, 0, 1, 0, 10, 100, 0 },
  { 1344, 2, 0, 1, 0, 10, 100, 0 },
  { 1356, 2, 0, 1, 0, 10, 100, 0 },
  { 1368, 2, 0, 1, 0, 10, 100, 0 },
  { 1380, 2, 0, 1, 0, 10, 100, 0 },
  { 1392, 2, 0, 1, 0, 10, 100, 0 },
  // 672: convert_ulong2, convert_ulong2_rte, convert_ulong2_rtn, convert_ulong2_rtp, convert_ulong2_rtz, convert_ulong2_sat, convert_ulong2_sat_rte, convert_ulong2_sat_rtn, convert_ulong2_sat_rtp, convert_ulong2_sat_rtz, 
  { 1262, 2, 0, 1, 0, 10, 100, 0 },
  { 1274, 2, 0, 1, 0, 10, 100, 0 },
  { 1286, 2, 0, 1, 0, 10, 100, 0 },
  { 1298, 2, 0, 1, 0, 10, 100, 0 },
  { 1312, 2, 0, 1, 0, 10, 100, 0 },
  { 1330, 2, 0, 1, 0, 10, 100, 0 },
  { 1346, 2, 0, 1, 0, 10, 100, 0 },
  { 1358, 2, 0, 1, 0, 10, 100, 0 },
  { 1370, 2, 0, 1, 0, 10, 100, 0 },
  { 1382, 2, 0, 1, 0, 10, 100, 0 },
  { 1394, 2, 0, 1, 0, 10, 100, 0 },
  // 683: convert_ulong3, convert_ulong3_rte, convert_ulong3_rtn, convert_ulong3_rtp, convert_ulong3_rtz, convert_ulong3_sat, convert_ulong3_sat_rte, convert_ulong3_sat_rtn, convert_ulong3_sat_rtp, convert_ulong3_sat_rtz, 
  { 1264, 2, 0, 1, 0, 10, 100, 0 },
  { 1276, 2, 0, 1, 0, 10, 100, 0 },
  { 1288, 2, 0, 1, 0, 10, 100, 0 },
  { 1300, 2, 0, 1, 0, 10, 100, 0 },
  { 1314, 2, 0, 1, 0, 10, 100, 0 },
  { 1332, 2, 0, 1, 0, 10, 100, 0 },
  { 1348, 2, 0, 1, 0, 10, 100, 0 },
  { 1360, 2, 0, 1, 0, 10, 100, 0 },
  { 1372, 2, 0, 1, 0, 10, 100, 0 },
  { 1384, 2, 0, 1, 0, 10, 100, 0 },
  { 1396, 2, 0, 1, 0, 10, 100, 0 },
  // 694: convert_ulong4, convert_ulong4_rte, convert_ulong4_rtn, convert_ulong4_rtp, convert_ulong4_rtz, convert_ulong4_sat, convert_ulong4_sat_rte, convert_ulong4_sat_rtn, convert_ulong4_sat_rtp, convert_ulong4_sat_rtz, 
  { 1266, 2, 0, 1, 0, 10, 100, 0 },
  { 1278, 2, 0, 1, 0, 10, 100, 0 },
  { 1290, 2, 0, 1, 0, 10, 100, 0 },
  { 1302, 2, 0, 1, 0, 10, 100, 0 },
  { 1316, 2, 0, 1, 0, 10, 100, 0 },
  { 1334, 2, 0, 1, 0, 10, 100, 0 },
  { 1350, 2, 0, 1, 0, 10, 100, 0 },
  { 1362, 2, 0, 1, 0, 10, 100, 0 },
  { 1374, 2, 0, 1, 0, 10, 100, 0 },
  { 1386, 2, 0, 1, 0, 10, 100, 0 },
  { 1398, 2, 0, 1, 0, 10, 100, 0 },
  // 705: convert_ulong8, convert_ulong8_rte, convert_ulong8_rtn, convert_ulong8_rtp, convert_ulong8_rtz, convert_ulong8_sat, convert_ulong8_sat_rte, convert_ulong8_sat_rtn, convert_ulong8_sat_rtp, convert_ulong8_sat_rtz, 
  { 1268, 2, 0, 1, 0, 10, 100, 0 },
  { 1280, 2, 0, 1, 0, 10, 100, 0 },
  { 1292, 2, 0, 1, 0, 10, 100, 0 },
  { 1304, 2, 0, 1, 0, 10, 100, 0 },
  { 1318, 2, 0, 1, 0, 10, 100, 0 },
  { 1336, 2, 0, 1, 0, 10, 100, 0 },
  { 1352, 2, 0, 1, 0, 10, 100, 0 },
  { 1364, 2, 0, 1, 0, 10, 100, 0 },
  { 1376, 2, 0, 1, 0, 10, 100, 0 },
  { 1388, 2, 0, 1, 0, 10, 100, 0 },
  { 1400, 2, 0, 1, 0, 10, 100, 0 },
  // 716: convert_ulong16, convert_ulong16_rte, convert_ulong16_rtn, convert_ulong16_rtp, convert_ulong16_rtz, convert_ulong16_sat, convert_ulong16_sat_rte, convert_ulong16_sat_rtn, convert_ulong16_sat_rtp, convert_ulong16_sat_rtz, 
  { 1270, 2, 0, 1, 0, 10, 100, 0 },
  { 1282, 2, 0, 1, 0, 10, 100, 0 },
  { 1294, 2, 0, 1, 0, 10, 100, 0 },
  { 1306, 2, 0, 1, 0, 10, 100, 0 },
  { 1320, 2, 0, 1, 0, 10, 100, 0 },
  { 1338, 2, 0, 1, 0, 10, 100, 0 },
  { 1354, 2, 0, 1, 0, 10, 100, 0 },
  { 1366, 2, 0, 1, 0, 10, 100, 0 },
  { 1378, 2, 0, 1, 0, 10, 100, 0 },
  { 1390, 2, 0, 1, 0, 10, 100, 0 },
  { 1402, 2, 0, 1, 0, 10, 100, 0 },
  // 727: get_work_dim, 
  { 1404, 1, 0, 1, 0, 10, 100, 0 },
  // 728: get_global_size, get_global_id, get_local_size, get_local_id, get_num_groups, get_group_id, get_global_offset, 
  { 1405, 2, 0, 1, 0, 10, 100, 0 },
  // 729: get_enqueued_local_size, 
  { 1405, 2, 0, 0, 0, 10, 200, 0 },
  // 730: get_global_linear_id, get_local_linear_id, 
  { 1407, 1, 0, 0, 0, 10, 200, 0 },
  // 731: acos, acosh, acospi, asin, asinh, asinpi, atan, atanh, atanpi, cbrt, ceil, cos, cosh, cospi, erfc, erf, exp, exp2, exp10, expm1, fabs, floor, log, log2, log10, log1p, logb, rint, round, rsqrt, sin, sinh, sinpi, sqrt, tan, tanh, tanpi, tgamma, trunc, lgamma, degrees, radians, sign, 
  { 1408, 2, 0, 1, 0, 10, 100, 0 },
  // 732: nan, 
  { 1410, 2, 0, 1, 0, 10, 100, 0 },
  { 1412, 2, 0, 1, 0, 10, 100, 0 },
  { 1414, 2, 0, 1, 0, 10, 100, 0 },
  // 735: atan2, atan2pi, copysign, fdim, fmod, hypot, maxmag, minmag, nextafter, pow, powr, remainder, 
  { 1416, 3, 0, 1, 0, 10, 100, 0 },
  // 736: fmax, fmin, 
  { 1416, 3, 0, 1, 0, 10, 100, 0 },
  { 1419, 3, 0, 1, 0, 10, 100, 0 },
  { 1422, 3, 0, 1, 0, 10, 100, 0 },
  { 1425, 3, 0, 1, 0, 10, 100, 0 },
  // 740: ilogb, 
  { 1428, 2, 0, 1, 0, 10, 100, 0 },
  { 1430, 2, 0, 1, 0, 10, 100, 0 },
  { 1432, 2, 0, 1, 0, 10, 100, 0 },
  // 743: ldexp, 
  { 1434, 3, 0, 1, 0, 10, 100, 0 },
  { 1437, 3, 0, 1, 0, 10, 100, 0 },
  { 1440, 3, 0, 1, 0, 10, 100, 0 },
  { 1443, 3, 0, 1, 0, 10, 100, 0 },
  { 1446, 3, 0, 1, 0, 10, 100, 0 },
  { 1449, 3, 0, 1, 0, 10, 100, 0 },
  // 749: pown, rootn, 
  { 1434, 3, 0, 1, 0, 10, 100, 0 },
  { 1440, 3, 0, 1, 0, 10, 100, 0 },
  { 1446, 3, 0, 1, 0, 10, 100, 0 },
  // 752: fma, mad, 
  { 1452, 4, 0, 1, 0, 10, 100, 0 },
  // 753: fract, modf, sincos, 
  { 1456, 3, 0, 0, 0, 10, 100, 200 },
  { 1480, 3, 0, 0, 0, 10, 100, 200 },
  { 1504, 3, 0, 0, 0, 10, 100, 200 },
  { 1528, 3, 0, 0, 0, 10, 200, 0 },
  // 757: frexp, lgamma_r, 
  { 1459, 3, 0, 0, 0, 10, 100, 200 },
  { 1466, 3, 0, 0, 0, 10, 100, 200 },
  { 1469, 3, 0, 0, 0, 10, 100, 200 },
  { 1483, 3, 0, 0, 0, 10, 100, 200 },
  { 1486, 3, 0, 0, 0, 10, 100, 200 },
  { 1489, 3, 0, 0, 0, 10, 100, 200 },
  { 1507, 3, 0, 0, 0, 10, 100, 200 },
  { 1510, 3, 0, 0, 0, 10, 100, 200 },
  { 1513, 3, 0, 0, 0, 10, 100, 200 },
  { 1531, 3, 0, 0, 0, 10, 200, 0 },
  { 1534, 3, 0, 0, 0, 10, 200, 0 },
  { 1537, 3, 0, 0, 0, 10, 200, 0 },
  // 769: remquo, 
  { 1462, 4, 0, 0, 0, 10, 100, 200 },
  { 1472, 4, 0, 0, 0, 10, 100, 200 },
  { 1476, 4, 0, 0, 0, 10, 100, 200 },
  { 1492, 4, 0, 0, 0, 10, 100, 200 },
  { 1496, 4, 0, 0, 0, 10, 100, 200 },
  { 1500, 4, 0, 0, 0, 10, 100, 200 },
  { 1516, 4, 0, 0, 0, 10, 100, 200 },
  { 1520, 4, 0, 0, 0, 10, 100, 200 },
  { 1524, 4, 0, 0, 0, 10, 100, 200 },
  { 1540, 4, 0, 0, 0, 10, 200, 0 },
  { 1544, 4, 0, 0, 0, 10, 200, 0 },
  { 1548, 4, 0, 0, 0, 10, 200, 0 },
  // 781: half_cos, half_exp, half_exp2, half_exp10, half_log, half_log2, half_log10, half_recip, half_rsqrt, half_sin, half_sqrt, half_tan, native_cos, native_exp, native_exp2, native_exp10, native_log, native_log2, native_log10, native_recip, native_rsqrt, native_sin, native_sqrt, native_tan, 
  { 1552, 2, 0, 1, 0, 10, 100, 0 },
  // 782: half_divide, half_powr, native_divide, native_powr, 
  { 1554, 3, 0, 1, 0, 10, 100, 0 },
  // 783: abs, 
  { 1557, 2, 0, 1, 0, 10, 100, 0 },
  // 784: clz, popcount, 
  { 1559, 2, 0, 1, 0, 10, 100, 0 },
  // 785: ctz, 
  { 1559, 2, 0, 0, 0, 10, 200, 0 },
  // 786: abs_diff, 
  { 1561, 3, 0, 1, 0, 10, 100, 0 },
  // 787: add_sat, hadd, rhadd, mul_hi, rotate, sub_sat, 
  { 1564, 3, 0, 1, 0, 10, 100, 0 },
  // 788: max, min, 
  { 1564, 3, 0, 1, 0, 10, 100, 0 },
  { 1567, 3, 0, 1, 0, 10, 100, 0 },
  { 1416, 3, 0, 1, 0, 10, 100, 0 },
  { 1419, 3, 0, 1, 0, 10, 100, 0 },
  { 1422, 3, 0, 1, 0, 10, 100, 0 },
  { 1425, 3, 0, 1, 0, 10, 100, 0 },
  // 794: upsample, 
  { 1570, 3, 0, 1, 0, 10, 100, 0 },
  { 1573, 3, 0, 1, 0, 10, 100, 0 },
  { 1576, 3, 0, 1, 0, 10, 100, 0 },
  { 1579, 3, 0, 1, 0, 10, 100, 0 },
  { 1582, 3, 0, 1, 0, 10, 100, 0 },
  { 1585, 3, 0, 1, 0, 10, 100, 0 },
  // 800: clamp, 
  { 1588, 4, 0, 1, 0, 10, 100, 0 },
  { 1592, 4, 0, 1, 0, 10, 100, 0 },
  { 1452, 4, 0, 1, 0, 10, 100, 0 },
  { 1619, 4, 0, 1, 0, 10, 100, 0 },
  { 1623, 4, 0, 1, 0, 10, 100, 0 },
  { 1629, 4, 0, 1, 0, 10, 100, 0 },
  // 806: mad_hi, mad_sat, 
  { 1588, 4, 0, 1, 0, 10, 100, 0 },
  // 807: mad24, 
  { 1596, 4, 0, 1, 0, 10, 100, 0 },
  { 1600, 4, 0, 1, 0, 10, 100, 0 },
  // 809: mul24, 
  { 1604, 3, 0, 1, 0, 10, 100, 0 },
  { 1607, 3, 0, 1, 0, 10, 100, 0 },
  // 811: step, 
  { 1416, 3, 0, 1, 0, 10, 100, 0 },
  { 1610, 3, 0, 1, 0, 10, 100, 0 },
  { 1613, 3, 0, 1, 0, 10, 100, 0 },
  { 1616, 3, 0, 1, 0, 10, 100, 0 },
  // 815: mix, 
  { 1452, 4, 0, 1, 0, 10, 100, 0 },
  { 1619, 4, 0, 1, 0, 10, 100, 0 },
  { 1623, 4, 0, 1, 0, 10, 100, 0 },
  { 1629, 4, 0, 1, 0, 10, 100, 0 },
  // 819: smoothstep, 
  { 1452, 4, 0, 1, 0, 10, 100, 0 },
  { 1633, 4, 0, 1, 0, 10, 100, 0 },
  { 1637, 4, 0, 1, 0, 10, 100, 0 },
  { 1641, 4, 0, 1, 0, 10, 100, 0 },
  // 823: length, 
  { 1645, 2, 0, 1, 0, 10, 100, 0 },
  { 1649, 2, 0, 1, 0, 10, 100, 0 },
  { 1651, 2, 0, 1, 0, 10, 100, 0 },
  // 826: normalize, 
  { 1653, 2, 0, 1, 0, 10, 100, 0 },
  { 1655, 2, 0, 1, 0, 10, 100, 0 },
  { 1657, 2, 0, 1, 0, 10, 100, 0 },
  // 829: fast_length, 
  { 1645, 2, 0, 1, 0, 10, 100, 0 },
  // 830: fast_normalize, 
  { 1653, 2, 0, 1, 0, 10, 100, 0 },
  // 831: cross, 
  { 1659, 3, 0, 1, 0, 10, 100, 0 },
  { 1662, 3, 0, 1, 0, 10, 100, 0 },
  { 1665, 3, 0, 1, 0, 10, 100, 0 },
  { 1670, 3, 0, 1, 0, 10, 100, 0 },
  { 1673, 3, 0, 1, 0, 10, 100, 0 },
  { 1676, 3, 0, 1, 0, 10, 100, 0 },
  // 837: dot, distance, 
  { 1679, 3, 0, 1, 0, 10, 100, 0 },
  { 1682, 3, 0, 1, 0, 10, 100, 0 },
  { 1685, 3, 0, 1, 0, 10, 100, 0 },
  // 840: fast_distance, 
  { 1679, 3, 0, 1, 0, 10, 100, 0 },
  // 841: isfinite, isinf, isnan, isnormal, signbit, 
  { 1428, 2, 0, 1, 0, 10, 100, 0 },
  { 840, 2, 0, 1, 0, 10, 100, 0 },
  { 1690, 2, 0, 1, 0, 10, 100, 0 },
  { 852, 2, 0, 1, 0, 10, 100, 0 },
  { 1692, 2, 0, 1, 0, 10, 100, 0 },
  // 846: any, all, 
  { 1698, 2, 0, 1, 0, 10, 100, 0 },
  // 847: isequal, isnotequal, isgreater, isgreaterequal, isless, islessequal, islessgreater, isordered, isunordered, 
  { 1700, 3, 0, 1, 0, 10, 100, 0 },
  { 1703, 3, 0, 1, 0, 10, 100, 0 },
  { 1706, 3, 0, 1, 0, 10, 100, 0 },
  { 1709, 3, 0, 1, 0, 10, 100, 0 },
  { 1712, 3, 0, 1, 0, 10, 100, 0 },
  // 852: bitselect, 
  { 1715, 4, 0, 1, 0, 10, 100, 0 },
  // 853: select, 
  { 1719, 4, 0, 1, 0, 10, 100, 0 },
  { 1723, 4, 0, 1, 0, 10, 100, 0 },
  { 1727, 4, 0, 1, 0, 10, 100, 0 },
  { 1731, 4, 0, 1, 0, 10, 100, 0 },
  { 1735, 4, 0, 1, 0, 10, 100, 0 },
  { 1739, 4, 0, 1, 0, 10, 100, 0 },
  { 1743, 4, 0, 1, 0, 10, 100, 0 },
  { 1747, 4, 0, 1, 0, 10, 100, 0 },
  { 1751, 4, 0, 1, 0, 10, 100, 0 },
  { 1755, 4, 0, 1, 0, 10, 100, 0 },
  // 863: vload2, 
  { 1759, 3, 0, 0, 0, 10, 100, 200 },
  { 1762, 3, 0, 0, 0, 10, 100, 200 },
  { 1765, 3, 0, 0, 0, 10, 100, 200 },
  { 1768, 3, 0, 0, 0, 10, 100, 200 },
  { 1771, 3, 0, 0, 0, 10, 100, 200 },
  { 1774, 3, 0, 0, 0, 10, 100, 200 },
  { 1777, 3, 0, 0, 0, 10, 100, 200 },
  { 1780, 3, 0, 0, 0, 10, 100, 200 },
  { 1783, 3, 0, 0, 0, 10, 100, 200 },
  { 1786, 3, 0, 0, 0, 10, 100, 200 },
  { 1789, 3, 0, 0, 0, 10, 100, 200 },
  { 2199, 3, 0, 0, 0, 10, 100, 200 },
  { 2202, 3, 0, 0, 0, 10, 100, 200 },
  { 2205, 3, 0, 0, 0, 10, 100, 200 },
  { 2208, 3, 0, 0, 0, 10, 100, 200 },
  { 2211, 3, 0, 0, 0, 10, 100, 200 },
  { 2214, 3, 0, 0, 0, 10, 100, 200 },
  { 2217, 3, 0, 0, 0, 10, 100, 200 },
  { 2220, 3, 0, 0, 0, 10, 100, 200 },
  { 2223, 3, 0, 0, 0, 10, 100, 200 },
  { 2226, 3, 0, 0, 0, 10, 100, 200 },
  { 2229, 3, 0, 0, 0, 10, 100, 200 },
  { 2639, 3, 0, 0, 0, 10, 100, 200 },
  { 2642, 3, 0, 0, 0, 10, 100, 200 },
  { 2645, 3, 0, 0, 0, 10, 100, 200 },
  { 2648, 3, 0, 0, 0, 10, 100, 200 },
  { 2651, 3, 0, 0, 0, 10, 100, 200 },
  { 2654, 3, 0, 0, 0, 10, 100, 200 },
  { 2657, 3, 0, 0, 0, 10, 100, 200 },
  { 2660, 3, 0, 0, 0, 10, 100, 200 },
  { 2663, 3, 0, 0, 0, 10, 100, 200 },
  { 2666, 3, 0, 0, 0, 10, 100, 200 },
  { 2669, 3, 0, 0, 0, 10, 100, 200 },
  { 3091, 3, 0, 0, 0, 10, 200, 0 },
  { 3094, 3, 0, 0, 0, 10, 200, 0 },
  { 3097, 3, 0, 0, 0, 10, 200, 0 },
  { 3100, 3, 0, 0, 0, 10, 200, 0 },
  { 3103, 3, 0, 0, 0, 10, 200, 0 },
  { 3106, 3, 0, 0, 0, 10, 200, 0 },
  { 3109, 3, 0, 0, 0, 10, 200, 0 },
  { 3112, 3, 0, 0, 0, 10, 200, 0 },
  { 3115, 3, 0, 0, 0, 10, 200, 0 },
  { 3118, 3, 0, 0, 0, 10, 200, 0 },
  { 3121, 3, 0, 0, 0, 10, 200, 0 },
  { 3531, 3, 0, 0, 0, 10, 100, 0 },
  { 3534, 3, 0, 0, 0, 10, 100, 0 },
  { 3537, 3, 0, 0, 0, 10, 100, 0 },
  { 3540, 3, 0, 0, 0, 10, 100, 0 },
  { 3543, 3, 0, 0, 0, 10, 100, 0 },
  { 3546, 3, 0, 0, 0, 10, 100, 0 },
  { 3549, 3, 0, 0, 0, 10, 100, 0 },
  { 3552, 3, 0, 0, 0, 10, 100, 0 },
  { 3555, 3, 0, 0, 0, 10, 100, 0 },
  { 3558, 3, 0, 0, 0, 10, 100, 0 },
  { 3561, 3, 0, 0, 0, 10, 100, 0 },
  // 918: vstore2, 
  { 1792, 4, 0, 0, 0, 10, 100, 200 },
  { 1796, 4, 0, 0, 0, 10, 100, 200 },
  { 1800, 4, 0, 0, 0, 10, 100, 200 },
  { 1804, 4, 0, 0, 0, 10, 100, 200 },
  { 1808, 4, 0, 0, 0, 10, 100, 200 },
  { 1812, 4, 0, 0, 0, 10, 100, 200 },
  { 1816, 4, 0, 0, 0, 10, 100, 200 },
  { 1820, 4, 0, 0, 0, 10, 100, 200 },
  { 1824, 4, 0, 0, 0, 10, 100, 200 },
  { 1828, 4, 0, 0, 0, 10, 100, 200 },
  { 1832, 4, 0, 0, 0, 10, 100, 200 },
  { 2232, 4, 0, 0, 0, 10, 100, 200 },
  { 2236, 4, 0, 0, 0, 10, 100, 200 },
  { 2240, 4, 0, 0, 0, 10, 100, 200 },
  { 2244, 4, 0, 0, 0, 10, 100, 200 },
  { 2248, 4, 0, 0, 0, 10, 100, 200 },
  { 2252, 4, 0, 0, 0, 10, 100, 200 },
  { 2256, 4, 0, 0, 0, 10, 100, 200 },
  { 2260, 4, 0, 0, 0, 10, 100, 200 },
  { 2264, 4, 0, 0, 0, 10, 100, 200 },
  { 2268, 4, 0, 0, 0, 10, 100, 200 },
  { 2272, 4, 0, 0, 0, 10, 100, 200 },
  { 2672, 4, 0, 0, 0, 10, 100, 200 },
  { 2676, 4, 0, 0, 0, 10, 100, 200 },
  { 2680, 4, 0, 0, 0, 10, 100, 200 },
  { 2684, 4, 0, 0, 0, 10, 100, 200 },
  { 2688, 4, 0, 0, 0, 10, 100, 200 },
  { 2692, 4, 0, 0, 0, 10, 100, 200 },
  { 2696, 4, 0, 0, 0, 10, 100, 200 },
  { 2700, 4, 0, 0, 0, 10, 100, 200 },
  { 2704, 4, 0, 0, 0, 10, 100, 200 },
  { 2708, 4, 0, 0, 0, 10, 100, 200 },
  { 2712, 4, 0, 0, 0, 10, 100, 200 },
  { 3124, 4, 0, 0, 0, 10, 200, 0 },
  { 3128, 4, 0, 0, 0, 10, 200, 0 },
  { 3132, 4, 0, 0, 0, 10, 200, 0 },
  { 3136, 4, 0, 0, 0, 10, 200, 0 },
  { 3140, 4, 0, 0, 0, 10, 200, 0 },
  { 3144, 4, 0, 0, 0, 10, 200, 0 },
  { 3148, 4, 0, 0, 0, 10, 200, 0 },
  { 3152, 4, 0, 0, 0, 10, 200, 0 },
  { 3156, 4, 0, 0, 0, 10, 200, 0 },
  { 3160, 4, 0, 0, 0, 10, 200, 0 },
  { 3164, 4, 0, 0, 0, 10, 200, 0 },
  // 962: vloada_half2, vload_half2, 
  { 1836, 3, 0, 0, 0, 10, 100, 200 },
  { 2276, 3, 0, 0, 0, 10, 100, 200 },
  { 2716, 3, 0, 0, 0, 10, 100, 200 },
  { 3168, 3, 0, 0, 0, 10, 200, 0 },
  { 3564, 3, 0, 0, 0, 10, 100, 0 },
  // 967: vstorea_half2, vstorea_half2_rte, vstorea_half2_rtz, vstorea_half2_rtp, vstorea_half2_rtn, 
  { 1839, 4, 0, 0, 0, 10, 100, 200 },
  { 1843, 4, 0, 0, 0, 10, 100, 200 },
  { 2279, 4, 0, 0, 0, 10, 100, 200 },
  { 2283, 4, 0, 0, 0, 10, 100, 200 },
  { 2719, 4, 0, 0, 0, 10, 100, 200 },
  { 2723, 4, 0, 0, 0, 10, 100, 200 },
  { 3171, 4, 0, 0, 0, 10, 200, 0 },
  { 3175, 4, 0, 0, 0, 10, 200, 0 },
  { 3567, 4, 0, 0, 0, 10, 100, 0 },
  { 3571, 4, 0, 0, 0, 10, 100, 0 },
  // 977: vload3, 
  { 1847, 3, 0, 0, 0, 10, 100, 200 },
  { 1850, 3, 0, 0, 0, 10, 100, 200 },
  { 1853, 3, 0, 0, 0, 10, 100, 200 },
  { 1856, 3, 0, 0, 0, 10, 100, 200 },
  { 1859, 3, 0, 0, 0, 10, 100, 200 },
  { 1862, 3, 0, 0, 0, 10, 100, 200 },
  { 1865, 3, 0, 0, 0, 10, 100, 200 },
  { 1868, 3, 0, 0, 0, 10, 100, 200 },
  { 1871, 3, 0, 0, 0, 10, 100, 200 },
  { 1874, 3, 0, 0, 0, 10, 100, 200 },
  { 1877, 3, 0, 0, 0, 10, 100, 200 },
  { 2287, 3, 0, 0, 0, 10, 100, 200 },
  { 2290, 3, 0, 0, 0, 10, 100, 200 },
  { 2293, 3, 0, 0, 0, 10, 100, 200 },
  { 2296, 3, 0, 0, 0, 10, 100, 200 },
  { 2299, 3, 0, 0, 0, 10, 100, 200 },
  { 2302, 3, 0, 0, 0, 10, 100, 200 },
  { 2305, 3, 0, 0, 0, 10, 100, 200 },
  { 2308, 3, 0, 0, 0, 10, 100, 200 },
  { 2311, 3, 0, 0, 0, 10, 100, 200 },
  { 2314, 3, 0, 0, 0, 10, 100, 200 },
  { 2317, 3, 0, 0, 0, 10, 100, 200 },
  { 2727, 3, 0, 0, 0, 10, 100, 200 },
  { 2730, 3, 0, 0, 0, 10, 100, 200 },
  { 2733, 3, 0, 0, 0, 10, 100, 200 },
  { 2736, 3, 0, 0, 0, 10, 100, 200 },
  { 2739, 3, 0, 0, 0, 10, 100, 200 },
  { 2742, 3, 0, 0, 0, 10, 100, 200 },
  { 2745, 3, 0, 0, 0, 10, 100, 200 },
  { 2748, 3, 0, 0, 0, 10, 100, 200 },
  { 2751, 3, 0, 0, 0, 10, 100, 200 },
  { 2754, 3, 0, 0, 0, 10, 100, 200 },
  { 2757, 3, 0, 0, 0, 10, 100, 200 },
  { 3179, 3, 0, 0, 0, 10, 200, 0 },
  { 3182, 3, 0, 0, 0, 10, 200, 0 },
  { 3185, 3, 0, 0, 0, 10, 200, 0 },
  { 3188, 3, 0, 0, 0, 10, 200, 0 },
  { 3191, 3, 0, 0, 0, 10, 200, 0 },
  { 3194, 3, 0, 0, 0, 10, 200, 0 },
  { 3197, 3, 0, 0, 0, 10, 200, 0 },
  { 3200, 3, 0, 0, 0, 10, 200, 0 },
  { 3203, 3, 0, 0, 0, 10, 200, 0 },
  { 3206, 3, 0, 0, 0, 10, 200, 0 },
  { 3209, 3, 0, 0, 0, 10, 200, 0 },
  { 3575, 3, 0, 0, 0, 10, 100, 0 },
  { 3578, 3, 0, 0, 0, 10, 100, 0 },
  { 3581, 3, 0, 0, 0, 10, 100, 0 },
  { 3584, 3, 0, 0, 0, 10, 100, 0 },
  { 3587, 3, 0, 0, 0, 10, 100, 0 },
  { 3590, 3, 0, 0, 0, 10, 100, 0 },
  { 3593, 3, 0, 0, 0, 10, 100, 0 },
  { 3596, 3, 0, 0, 0, 10, 100, 0 },
  { 3599, 3, 0, 0, 0, 10, 100, 0 },
  { 3602, 3, 0, 0, 0, 10, 100, 0 },
  { 3605, 3, 0, 0, 0, 10, 100, 0 },
  // 1032: vstore3, 
  { 1880, 4, 0, 0, 0, 10, 100, 200 },
  { 1884, 4, 0, 0, 0, 10, 100, 200 },
  { 1888, 4, 0, 0, 0, 10, 100, 200 },
  { 1892, 4, 0, 0, 0, 10, 100, 200 },
  { 1896, 4, 0, 0, 0, 10, 100, 200 },
  { 1900, 4, 0, 0, 0, 10, 100, 200 },
  { 1904, 4, 0, 0, 0, 10, 100, 200 },
  { 1908, 4, 0, 0, 0, 10, 100, 200 },
  { 1912, 4, 0, 0, 0, 10, 100, 200 },
  { 1916, 4, 0, 0, 0, 10, 100, 200 },
  { 1920, 4, 0, 0, 0, 10, 100, 200 },
  { 2320, 4, 0, 0, 0, 10, 100, 200 },
  { 2324, 4, 0, 0, 0, 10, 100, 200 },
  { 2328, 4, 0, 0, 0, 10, 100, 200 },
  { 2332, 4, 0, 0, 0, 10, 100, 200 },
  { 2336, 4, 0, 0, 0, 10, 100, 200 },
  { 2340, 4, 0, 0, 0, 10, 100, 200 },
  { 2344, 4, 0, 0, 0, 10, 100, 200 },
  { 2348, 4, 0, 0, 0, 10, 100, 200 },
  { 2352, 4, 0, 0, 0, 10, 100, 200 },
  { 2356, 4, 0, 0, 0, 10, 100, 200 },
  { 2360, 4, 0, 0, 0, 10, 100, 200 },
  { 2760, 4, 0, 0, 0, 10, 100, 200 },
  { 2764, 4, 0, 0, 0, 10, 100, 200 },
  { 2768, 4, 0, 0, 0, 10, 100, 200 },
  { 2772, 4, 0, 0, 0, 10, 100, 200 },
  { 2776, 4, 0, 0, 0, 10, 100, 200 },
  { 2780, 4, 0, 0, 0, 10, 100, 200 },
  { 2784, 4, 0, 0, 0, 10, 100, 200 },
  { 2788, 4, 0, 0, 0, 10, 100, 200 },
  { 2792, 4, 0, 0, 0, 10, 100, 200 },
  { 2796, 4, 0, 0, 0, 10, 100, 200 },
  { 2800, 4, 0, 0, 0, 10, 100, 200 },
  { 3212, 4, 0, 0, 0, 10, 200, 0 },
  { 3216, 4, 0, 0, 0, 10, 200, 0 },
  { 3220, 4, 0, 0, 0, 10, 200, 0 },
  { 3224, 4, 0, 0, 0, 10, 200, 0 },
  { 3228, 4, 0, 0, 0, 10, 200, 0 },
  { 3232, 4, 0, 0, 0, 10, 200, 0 },
  { 3236, 4, 0, 0, 0, 10, 200, 0 },
  { 3240, 4, 0, 0, 0, 10, 200, 0 },
  { 3244, 4, 0, 0, 0, 10, 200, 0 },
  { 3248, 4, 0, 0, 0, 10, 200, 0 },
  { 3252, 4, 0, 0, 0, 10, 200, 0 },
  // 1076: vloada_half3, vload_half3, 
  { 1924, 3, 0, 0, 0, 10, 100, 200 },
  { 2364, 3, 0, 0, 0, 10, 100, 200 },
  { 2804, 3, 0, 0, 0, 10, 100, 200 },
  { 3256, 3, 0, 0, 0, 10, 200, 0 },
  { 3608, 3, 0, 0, 0, 10, 100, 0 },
  // 1081: vstorea_half3, vstorea_half3_rte, vstorea_half3_rtz, vstorea_half3_rtp, vstorea_half3_rtn, 
  { 1927, 4, 0, 0, 0, 10, 100, 200 },
  { 1931, 4, 0, 0, 0, 10, 100, 200 },
  { 2367, 4, 0, 0, 0, 10, 100, 200 },
  { 2371, 4, 0, 0, 0, 10, 100, 200 },
  { 2807, 4, 0, 0, 0, 10, 100, 200 },
  { 2811, 4, 0, 0, 0, 10, 100, 200 },
  { 3259, 4, 0, 0, 0, 10, 200, 0 },
  { 3263, 4, 0, 0, 0, 10, 200, 0 },
  { 3611, 4, 0, 0, 0, 10, 100, 0 },
  { 3615, 4, 0, 0, 0, 10, 100, 0 },
  // 1091: vload4, 
  { 1935, 3, 0, 0, 0, 10, 100, 200 },
  { 1938, 3, 0, 0, 0, 10, 100, 200 },
  { 1941, 3, 0, 0, 0, 10, 100, 200 },
  { 1944, 3, 0, 0, 0, 10, 100, 200 },
  { 1947, 3, 0, 0, 0, 10, 100, 200 },
  { 1950, 3, 0, 0, 0, 10, 100, 200 },
  { 1953, 3, 0, 0, 0, 10, 100, 200 },
  { 1956, 3, 0, 0, 0, 10, 100, 200 },
  { 1959, 3, 0, 0, 0, 10, 100, 200 },
  { 1962, 3, 0, 0, 0, 10, 100, 200 },
  { 1965, 3, 0, 0, 0, 10, 100, 200 },
  { 2375, 3, 0, 0, 0, 10, 100, 200 },
  { 2378, 3, 0, 0, 0, 10, 100, 200 },
  { 2381, 3, 0, 0, 0, 10, 100, 200 },
  { 2384, 3, 0, 0, 0, 10, 100, 200 },
  { 2387, 3, 0, 0, 0, 10, 100, 200 },
  { 2390, 3, 0, 0, 0, 10, 100, 200 },
  { 2393, 3, 0, 0, 0, 10, 100, 200 },
  { 2396, 3, 0, 0, 0, 10, 100, 200 },
  { 2399, 3, 0, 0, 0, 10, 100, 200 },
  { 2402, 3, 0, 0, 0, 10, 100, 200 },
  { 2405, 3, 0, 0, 0, 10, 100, 200 },
  { 2815, 3, 0, 0, 0, 10, 100, 200 },
  { 2818, 3, 0, 0, 0, 10, 100, 200 },
  { 2821, 3, 0, 0, 0, 10, 100, 200 },
  { 2824, 3, 0, 0, 0, 10, 100, 200 },
  { 2827, 3, 0, 0, 0, 10, 100, 200 },
  { 2830, 3, 0, 0, 0, 10, 100, 200 },
  { 2833, 3, 0, 0, 0, 10, 100, 200 },
  { 2836, 3, 0, 0, 0, 10, 100, 200 },
  { 2839, 3, 0, 0, 0, 10, 100, 200 },
  { 2842, 3, 0, 0, 0, 10, 100, 200 },
  { 2845, 3, 0, 0, 0, 10, 100, 200 },
  { 3267, 3, 0, 0, 0, 10, 200, 0 },
  { 3270, 3, 0, 0, 0, 10, 200, 0 },
  { 3273, 3, 0, 0, 0, 10, 200, 0 },
  { 3276, 3, 0, 0, 0, 10, 200, 0 },
  { 3279, 3, 0, 0, 0, 10, 200, 0 },
  { 3282, 3, 0, 0, 0, 10, 200, 0 },
  { 3285, 3, 0, 0, 0, 10, 200, 0 },
  { 3288, 3, 0, 0, 0, 10, 200, 0 },
  { 3291, 3, 0, 0, 0, 10, 200, 0 },
  { 3294, 3, 0, 0, 0, 10, 200, 0 },
  { 3297, 3, 0, 0, 0, 10, 200, 0 },
  { 3619, 3, 0, 0, 0, 10, 100, 0 },
  { 3622, 3, 0, 0, 0, 10, 100, 0 },
  { 3625, 3, 0, 0, 0, 10, 100, 0 },
  { 3628, 3, 0, 0, 0, 10, 100, 0 },
  { 3631, 3, 0, 0, 0, 10, 100, 0 },
  { 3634, 3, 0, 0, 0, 10, 100, 0 },
  { 3637, 3, 0, 0, 0, 10, 100, 0 },
  { 3640, 3, 0, 0, 0, 10, 100, 0 },
  { 3643, 3, 0, 0, 0, 10, 100, 0 },
  { 3646, 3, 0, 0, 0, 10, 100, 0 },
  { 3649, 3, 0, 0, 0, 10, 100, 0 },
  // 1146: vstore4, 
  { 1968, 4, 0, 0, 0, 10, 100, 200 },
  { 1972, 4, 0, 0, 0, 10, 100, 200 },
  { 1976, 4, 0, 0, 0, 10, 100, 200 },
  { 1980, 4, 0, 0, 0, 10, 100, 200 },
  { 1984, 4, 0, 0, 0, 10, 100, 200 },
  { 1988, 4, 0, 0, 0, 10, 100, 200 },
  { 1992, 4, 0, 0, 0, 10, 100, 200 },
  { 1996, 4, 0, 0, 0, 10, 100, 200 },
  { 2000, 4, 0, 0, 0, 10, 100, 200 },
  { 2004, 4, 0, 0, 0, 10, 100, 200 },
  { 2008, 4, 0, 0, 0, 10, 100, 200 },
  { 2408, 4, 0, 0, 0, 10, 100, 200 },
  { 2412, 4, 0, 0, 0, 10, 100, 200 },
  { 2416, 4, 0, 0, 0, 10, 100, 200 },
  { 2420, 4, 0, 0, 0, 10, 100, 200 },
  { 2424, 4, 0, 0, 0, 10, 100, 200 },
  { 2428, 4, 0, 0, 0, 10, 100, 200 },
  { 2432, 4, 0, 0, 0, 10, 100, 200 },
  { 2436, 4, 0, 0, 0, 10, 100, 200 },
  { 2440, 4, 0, 0, 0, 10, 100, 200 },
  { 2444, 4, 0, 0, 0, 10, 100, 200 },
  { 2448, 4, 0, 0, 0, 10, 100, 200 },
  { 2848, 4, 0, 0, 0, 10, 100, 200 },
  { 2852, 4, 0, 0, 0, 10, 100, 200 },
  { 2856, 4, 0, 0, 0, 10, 100, 200 },
  { 2860, 4, 0, 0, 0, 10, 100, 200 },
  { 2864, 4, 0, 0, 0, 10, 100, 200 },
  { 2868, 4, 0, 0, 0, 10, 100, 200 },
  { 2872, 4, 0, 0, 0, 10, 100, 200 },
  { 2876, 4, 0, 0, 0, 10, 100, 200 },
  { 2880, 4, 0, 0, 0, 10, 100, 200 },
  { 2884, 4, 0, 0, 0, 10, 100, 200 },
  { 2888, 4, 0, 0, 0, 10, 100, 200 },
  { 3300, 4, 0, 0, 0, 10, 200, 0 },
  { 3304, 4, 0, 0, 0, 10, 200, 0 },
  { 3308, 4, 0, 0, 0, 10, 200, 0 },
  { 3312, 4, 0, 0, 0, 10, 200, 0 },
  { 3316, 4, 0, 0, 0, 10, 200, 0 },
  { 3320, 4, 0, 0, 0, 10, 200, 0 },
  { 3324, 4, 0, 0, 0, 10, 200, 0 },
  { 3328, 4, 0, 0, 0, 10, 200, 0 },
  { 3332, 4, 0, 0, 0, 10, 200, 0 },
  { 3336, 4, 0, 0, 0, 10, 200, 0 },
  { 3340, 4, 0, 0, 0, 10, 200, 0 },
  // 1190: vloada_half4, vload_half4, 
  { 2012, 3, 0, 0, 0, 10, 100, 200 },
  { 2452, 3, 0, 0, 0, 10, 100, 200 },
  { 2892, 3, 0, 0, 0, 10, 100, 200 },
  { 3344, 3, 0, 0, 0, 10, 200, 0 },
  { 3652, 3, 0, 0, 0, 10, 100, 0 },
  // 1195: vstorea_half4, vstorea_half4_rte, vstorea_half4_rtz, vstorea_half4_rtp, vstorea_half4_rtn, 
  { 2015, 4, 0, 0, 0, 10, 100, 200 },
  { 2019, 4, 0, 0, 0, 10, 100, 200 },
  { 2455, 4, 0, 0, 0, 10, 100, 200 },
  { 2459, 4, 0, 0, 0, 10, 100, 200 },
  { 2895, 4, 0, 0, 0, 10, 100, 200 },
  { 2899, 4, 0, 0, 0, 10, 100, 200 },
  { 3347, 4, 0, 0, 0, 10, 200, 0 },
  { 3351, 4, 0, 0, 0, 10, 200, 0 },
  { 3655, 4, 0, 0, 0, 10, 100, 0 },
  { 3659, 4, 0, 0, 0, 10, 100, 0 },
  // 1205: vload8, 
  { 2023, 3, 0, 0, 0, 10, 100, 200 },
  { 2026, 3, 0, 0, 0, 10, 100, 200 },
  { 2029, 3, 0, 0, 0, 10, 100, 200 },
  { 2032, 3, 0, 0, 0, 10, 100, 200 },
  { 2035, 3, 0, 0, 0, 10, 100, 200 },
  { 2038, 3, 0, 0, 0, 10, 100, 200 },
  { 2041, 3, 0, 0, 0, 10, 100, 200 },
  { 2044, 3, 0, 0, 0, 10, 100, 200 },
  { 2047, 3, 0, 0, 0, 10, 100, 200 },
  { 2050, 3, 0, 0, 0, 10, 100, 200 },
  { 2053, 3, 0, 0, 0, 10, 100, 200 },
  { 2463, 3, 0, 0, 0, 10, 100, 200 },
  { 2466, 3, 0, 0, 0, 10, 100, 200 },
  { 2469, 3, 0, 0, 0, 10, 100, 200 },
  { 2472, 3, 0, 0, 0, 10, 100, 200 },
  { 2475, 3, 0, 0, 0, 10, 100, 200 },
  { 2478, 3, 0, 0, 0, 10, 100, 200 },
  { 2481, 3, 0, 0, 0, 10, 100, 200 },
  { 2484, 3, 0, 0, 0, 10, 100, 200 },
  { 2487, 3, 0, 0, 0, 10, 100, 200 },
  { 2490, 3, 0, 0, 0, 10, 100, 200 },
  { 2493, 3, 0, 0, 0, 10, 100, 200 },
  { 2903, 3, 0, 0, 0, 10, 100, 200 },
  { 2906, 3, 0, 0, 0, 10, 100, 200 },
  { 2909, 3, 0, 0, 0, 10, 100, 200 },
  { 2912, 3, 0, 0, 0, 10, 100, 200 },
  { 2915, 3, 0, 0, 0, 10, 100, 200 },
  { 2918, 3, 0, 0, 0, 10, 100, 200 },
  { 2921, 3, 0, 0, 0, 10, 100, 200 },
  { 2924, 3, 0, 0, 0, 10, 100, 200 },
  { 2927, 3, 0, 0, 0, 10, 100, 200 },
  { 2930, 3, 0, 0, 0, 10, 100, 200 },
  { 2933, 3, 0, 0, 0, 10, 100, 200 },
  { 3355, 3, 0, 0, 0, 10, 200, 0 },
  { 3358, 3, 0, 0, 0, 10, 200, 0 },
  { 3361, 3, 0, 0, 0, 10, 200, 0 },
  { 3364, 3, 0, 0, 0, 10, 200, 0 },
  { 3367, 3, 0, 0, 0, 10, 200, 0 },
  { 3370, 3, 0, 0, 0, 10, 200, 0 },
  { 3373, 3, 0, 0, 0, 10, 200, 0 },
  { 3376, 3, 0, 0, 0, 10, 200, 0 },
  { 3379, 3, 0, 0, 0, 10, 200, 0 },
  { 3382, 3, 0, 0, 0, 10, 200, 0 },
  { 3385, 3, 0, 0, 0, 10, 200, 0 },
  { 3663, 3, 0, 0, 0, 10, 100, 0 },
  { 3666, 3, 0, 0, 0, 10, 100, 0 },
  { 3669, 3, 0, 0, 0, 10, 100, 0 },
  { 3672, 3, 0, 0, 0, 10, 100, 0 },
  { 3675, 3, 0, 0, 0, 10, 100, 0 },
  { 3678, 3, 0, 0, 0, 10, 100, 0 },
  { 3681, 3, 0, 0, 0, 10, 100, 0 },
  { 3684, 3, 0, 0, 0, 10, 100, 0 },
  { 3687, 3, 0, 0, 0, 10, 100, 0 },
  { 3690, 3, 0, 0, 0, 10, 100, 0 },
  { 3693, 3, 0, 0, 0, 10, 100, 0 },
  // 1260: vstore8, 
  { 2056, 4, 0, 0, 0, 10, 100, 200 },
  { 2060, 4, 0, 0, 0, 10, 100, 200 },
  { 2064, 4, 0, 0, 0, 10, 100, 200 },
  { 2068, 4, 0, 0, 0, 10, 100, 200 },
  { 2072, 4, 0, 0, 0, 10, 100, 200 },
  { 2076, 4, 0, 0, 0, 10, 100, 200 },
  { 2080, 4, 0, 0, 0, 10, 100, 200 },
  { 2084, 4, 0, 0, 0, 10, 100, 200 },
  { 2088, 4, 0, 0, 0, 10, 100, 200 },
  { 2092, 4, 0, 0, 0, 10, 100, 200 },
  { 2096, 4, 0, 0, 0, 10, 100, 200 },
  { 2496, 4, 0, 0, 0, 10, 100, 200 },
  { 2500, 4, 0, 0, 0, 10, 100, 200 },
  { 2504, 4, 0, 0, 0, 10, 100, 200 },
  { 2508, 4, 0, 0, 0, 10, 100, 200 },
  { 2512, 4, 0, 0, 0, 10, 100, 200 },
  { 2516, 4, 0, 0, 0, 10, 100, 200 },
  { 2520, 4, 0, 0, 0, 10, 100, 200 },
  { 2524, 4, 0, 0, 0, 10, 100, 200 },
  { 2528, 4, 0, 0, 0, 10, 100, 200 },
  { 2532, 4, 0, 0, 0, 10, 100, 200 },
  { 2536, 4, 0, 0, 0, 10, 100, 200 },
  { 2938, 4, 0, 0, 0, 10, 100, 200 },
  { 2942, 4, 0, 0, 0, 10, 100, 200 },
  { 2946, 4, 0, 0, 0, 10, 100, 200 },
  { 2950, 4, 0, 0, 0, 10, 100, 200 },
  { 2954, 4, 0, 0, 0, 10, 100, 200 },
  { 2958, 4, 0, 0, 0, 10, 100, 200 },
  { 2962, 4, 0, 0, 0, 10, 100, 200 },
  { 2966, 4, 0, 0, 0, 10, 100, 200 },
  { 2970, 4, 0, 0, 0, 10, 100, 200 },
  { 2974, 4, 0, 0, 0, 10, 100, 200 },
  { 2980, 4, 0, 0, 0, 10, 100, 200 },
  { 3388, 4, 0, 0, 0, 10, 200, 0 },
  { 3392, 4, 0, 0, 0, 10, 200, 0 },
  { 3396, 4, 0, 0, 0, 10, 200, 0 },
  { 3400, 4, 0, 0, 0, 10, 200, 0 },
  { 3404, 4, 0, 0, 0, 10, 200, 0 },
  { 3408, 4, 0, 0, 0, 10, 200, 0 },
  { 3412, 4, 0, 0, 0, 10, 200, 0 },
  { 3416, 4, 0, 0, 0, 10, 200, 0 },
  { 3420, 4, 0, 0, 0, 10, 200, 0 },
  { 3424, 4, 0, 0, 0, 10, 200, 0 },
  { 3428, 4, 0, 0, 0, 10, 200, 0 },
  // 1304: vloada_half8, vload_half8, 
  { 2100, 3, 0, 0, 0, 10, 100, 200 },
  { 2540, 3, 0, 0, 0, 10, 100, 200 },
  { 2984, 3, 0, 0, 0, 10, 100, 200 },
  { 3432, 3, 0, 0, 0, 10, 200, 0 },
  { 3696, 3, 0, 0, 0, 10, 100, 0 },
  // 1309: vstorea_half8, vstorea_half8_rte, vstorea_half8_rtz, vstorea_half8_rtp, vstorea_half8_rtn, 
  { 2103, 4, 0, 0, 0, 10, 100, 200 },
  { 2107, 4, 0, 0, 0, 10, 100, 200 },
  { 2543, 4, 0, 0, 0, 10, 100, 200 },
  { 2547, 4, 0, 0, 0, 10, 100, 200 },
  { 2987, 4, 0, 0, 0, 10, 100, 200 },
  { 2991, 4, 0, 0, 0, 10, 100, 200 },
  { 3435, 4, 0, 0, 0, 10, 200, 0 },
  { 3439, 4, 0, 0, 0, 10, 200, 0 },
  { 3699, 4, 0, 0, 0, 10, 100, 0 },
  { 3703, 4, 0, 0, 0, 10, 100, 0 },
  // 1319: vload16, 
  { 2111, 3, 0, 0, 0, 10, 100, 200 },
  { 2114, 3, 0, 0, 0, 10, 100, 200 },
  { 2117, 3, 0, 0, 0, 10, 100, 200 },
  { 2120, 3, 0, 0, 0, 10, 100, 200 },
  { 2123, 3, 0, 0, 0, 10, 100, 200 },
  { 2126, 3, 0, 0, 0, 10, 100, 200 },
  { 2129, 3, 0, 0, 0, 10, 100, 200 },
  { 2132, 3, 0, 0, 0, 10, 100, 200 },
  { 2135, 3, 0, 0, 0, 10, 100, 200 },
  { 2138, 3, 0, 0, 0, 10, 100, 200 },
  { 2141, 3, 0, 0, 0, 10, 100, 200 },
  { 2551, 3, 0, 0, 0, 10, 100, 200 },
  { 2554, 3, 0, 0, 0, 10, 100, 200 },
  { 2557, 3, 0, 0, 0, 10, 100, 200 },
  { 2560, 3, 0, 0, 0, 10, 100, 200 },
  { 2563, 3, 0, 0, 0, 10, 100, 200 },
  { 2566, 3, 0, 0, 0, 10, 100, 200 },
  { 2569, 3, 0, 0, 0, 10, 100, 200 },
  { 2572, 3, 0, 0, 0, 10, 100, 200 },
  { 2575, 3, 0, 0, 0, 10, 100, 200 },
  { 2578, 3, 0, 0, 0, 10, 100, 200 },
  { 2581, 3, 0, 0, 0, 10, 100, 200 },
  { 2997, 3, 0, 0, 0, 10, 100, 200 },
  { 3000, 3, 0, 0, 0, 10, 100, 200 },
  { 3003, 3, 0, 0, 0, 10, 100, 200 },
  { 3006, 3, 0, 0, 0, 10, 100, 200 },
  { 3009, 3, 0, 0, 0, 10, 100, 200 },
  { 3012, 3, 0, 0, 0, 10, 100, 200 },
  { 3015, 3, 0, 0, 0, 10, 100, 200 },
  { 3018, 3, 0, 0, 0, 10, 100, 200 },
  { 3023, 3, 0, 0, 0, 10, 100, 200 },
  { 3026, 3, 0, 0, 0, 10, 100, 200 },
  { 3029, 3, 0, 0, 0, 10, 100, 200 },
  { 3443, 3, 0, 0, 0, 10, 200, 0 },
  { 3446, 3, 0, 0, 0, 10, 200, 0 },
  { 3449, 3, 0, 0, 0, 10, 200, 0 },
  { 3452, 3, 0, 0, 0, 10, 200, 0 },
  { 3455, 3, 0, 0, 0, 10, 200, 0 },
  { 3458, 3, 0, 0, 0, 10, 200, 0 },
  { 3461, 3, 0, 0, 0, 10, 200, 0 },
  { 3464, 3, 0, 0, 0, 10, 200, 0 },
  { 3467, 3, 0, 0, 0, 10, 200, 0 },
  { 3470, 3, 0, 0, 0, 10, 200, 0 },
  { 3473, 3, 0, 0, 0, 10, 200, 0 },
  { 3707, 3, 0, 0, 0, 10, 100, 0 },
  { 3710, 3, 0, 0, 0, 10, 100, 0 },
  { 3713, 3, 0, 0, 0, 10, 100, 0 },
  { 3716, 3, 0, 0, 0, 10, 100, 0 },
  { 3719, 3, 0, 0, 0, 10, 100, 0 },
  { 3722, 3, 0, 0, 0, 10, 100, 0 },
  { 3725, 3, 0, 0, 0, 10, 100, 0 },
  { 3728, 3, 0, 0, 0, 10, 100, 0 },
  { 3731, 3, 0, 0, 0, 10, 100, 0 },
  { 3734, 3, 0, 0, 0, 10, 100, 0 },
  { 3737, 3, 0, 0, 0, 10, 100, 0 },
  // 1374: vstore16, 
  { 2144, 4, 0, 0, 0, 10, 100, 200 },
  { 2148, 4, 0, 0, 0, 10, 100, 200 },
  { 2152, 4, 0, 0, 0, 10, 100, 200 },
  { 2156, 4, 0, 0, 0, 10, 100, 200 },
  { 2160, 4, 0, 0, 0, 10, 100, 200 },
  { 2164, 4, 0, 0, 0, 10, 100, 200 },
  { 2168, 4, 0, 0, 0, 10, 100, 200 },
  { 2172, 4, 0, 0, 0, 10, 100, 200 },
  { 2176, 4, 0, 0, 0, 10, 100, 200 },
  { 2180, 4, 0, 0, 0, 10, 100, 200 },
  { 2184, 4, 0, 0, 0, 10, 100, 200 },
  { 2584, 4, 0, 0, 0, 10, 100, 200 },
  { 2588, 4, 0, 0, 0, 10, 100, 200 },
  { 2592, 4, 0, 0, 0, 10, 100, 200 },
  { 2596, 4, 0, 0, 0, 10, 100, 200 },
  { 2600, 4, 0, 0, 0, 10, 100, 200 },
  { 2604, 4, 0, 0, 0, 10, 100, 200 },
  { 2608, 4, 0, 0, 0, 10, 100, 200 },
  { 2612, 4, 0, 0, 0, 10, 100, 200 },
  { 2616, 4, 0, 0, 0, 10, 100, 200 },
  { 2620, 4, 0, 0, 0, 10, 100, 200 },
  { 2624, 4, 0, 0, 0, 10, 100, 200 },
  { 3032, 4, 0, 0, 0, 10, 100, 200 },
  { 3036, 4, 0, 0, 0, 10, 100, 200 },
  { 3040, 4, 0, 0, 0, 10, 100, 200 },
  { 3044, 4, 0, 0, 0, 10, 100, 200 },
  { 3048, 4, 0, 0, 0, 10, 100, 200 },
  { 3052, 4, 0, 0, 0, 10, 100, 200 },
  { 3056, 4, 0, 0, 0, 10, 100, 200 },
  { 3062, 4, 0, 0, 0, 10, 100, 200 },
  { 3066, 4, 0, 0, 0, 10, 100, 200 },
  { 3070, 4, 0, 0, 0, 10, 100, 200 },
  { 3074, 4, 0, 0, 0, 10, 100, 200 },
  { 3476, 4, 0, 0, 0, 10, 200, 0 },
  { 3480, 4, 0, 0, 0, 10, 200, 0 },
  { 3484, 4, 0, 0, 0, 10, 200, 0 },
  { 3488, 4, 0, 0, 0, 10, 200, 0 },
  { 3492, 4, 0, 0, 0, 10, 200, 0 },
  { 3496, 4, 0, 0, 0, 10, 200, 0 },
  { 3500, 4, 0, 0, 0, 10, 200, 0 },
  { 3504, 4, 0, 0, 0, 10, 200, 0 },
  { 3508, 4, 0, 0, 0, 10, 200, 0 },
  { 3512, 4, 0, 0, 0, 10, 200, 0 },
  { 3516, 4, 0, 0, 0, 10, 200, 0 },
  // 1418: vloada_half16, vload_half16, 
  { 2188, 3, 0, 0, 0, 10, 100, 200 },
  { 2628, 3, 0, 0, 0, 10, 100, 200 },
  { 3078, 3, 0, 0, 0, 10, 100, 200 },
  { 3520, 3, 0, 0, 0, 10, 200, 0 },
  { 3740, 3, 0, 0, 0, 10, 100, 0 },
  // 1423: vstorea_half16, vstorea_half16_rte, vstorea_half16_rtz, vstorea_half16_rtp, vstorea_half16_rtn, 
  { 2191, 4, 0, 0, 0, 10, 100, 200 },
  { 2195, 4, 0, 0, 0, 10, 100, 200 },
  { 2631, 4, 0, 0, 0, 10, 100, 200 },
  { 2635, 4, 0, 0, 0, 10, 100, 200 },
  { 3081, 4, 0, 0, 0, 10, 100, 200 },
  { 3085, 4, 0, 0, 0, 10, 100, 200 },
  { 3523, 4, 0, 0, 0, 10, 200, 0 },
  { 3527, 4, 0, 0, 0, 10, 200, 0 },
  { 3743, 4, 0, 0, 0, 10, 100, 0 },
  { 3747, 4, 0, 0, 0, 10, 100, 0 },
  // 1433: vload_half, 
  { 3751, 3, 0, 0, 0, 10, 100, 200 },
  { 3762, 3, 0, 0, 0, 10, 100, 200 },
  { 3773, 3, 0, 0, 0, 10, 100, 200 },
  { 3784, 3, 0, 0, 0, 10, 200, 0 },
  { 3799, 3, 0, 0, 0, 10, 100, 0 },
  // 1438: vstore_half, vstore_half_rte, vstore_half_rtz, vstore_half_rtp, vstore_half_rtn, 
  { 3754, 4, 0, 0, 0, 10, 100, 200 },
  { 3758, 4, 0, 0, 0, 10, 100, 200 },
  { 3765, 4, 0, 0, 0, 10, 100, 200 },
  { 3769, 4, 0, 0, 0, 10, 100, 200 },
  { 3776, 4, 0, 0, 0, 10, 100, 200 },
  { 3780, 4, 0, 0, 0, 10, 100, 200 },
  { 3787, 4, 0, 0, 0, 10, 200, 0 },
  { 3791, 4, 0, 0, 0, 10, 200, 0 },
  // 1446: vstore_half2, vstore_half2_rte, vstore_half2_rtz, vstore_half2_rtp, vstore_half2_rtn, 
  { 1839, 4, 0, 0, 0, 10, 100, 200 },
  { 1843, 4, 0, 0, 0, 10, 100, 200 },
  { 2279, 4, 0, 0, 0, 10, 100, 200 },
  { 2283, 4, 0, 0, 0, 10, 100, 200 },
  { 2719, 4, 0, 0, 0, 10, 100, 200 },
  { 2723, 4, 0, 0, 0, 10, 100, 200 },
  { 3171, 4, 0, 0, 0, 10, 200, 0 },
  { 3175, 4, 0, 0, 0, 10, 200, 0 },
  // 1454: vstore_half3, vstore_half3_rte, vstore_half3_rtz, vstore_half3_rtp, vstore_half3_rtn, 
  { 1927, 4, 0, 0, 0, 10, 100, 200 },
  { 1931, 4, 0, 0, 0, 10, 100, 200 },
  { 2367, 4, 0, 0, 0, 10, 100, 200 },
  { 2371, 4, 0, 0, 0, 10, 100, 200 },
  { 2807, 4, 0, 0, 0, 10, 100, 200 },
  { 2811, 4, 0, 0, 0, 10, 100, 200 },
  { 3259, 4, 0, 0, 0, 10, 200, 0 },
  { 3263, 4, 0, 0, 0, 10, 200, 0 },
  // 1462: vstore_half4, vstore_half4_rte, vstore_half4_rtz, vstore_half4_rtp, vstore_half4_rtn, 
  { 2015, 4, 0, 0, 0, 10, 100, 200 },
  { 2019, 4, 0, 0, 0, 10, 100, 200 },
  { 2455, 4, 0, 0, 0, 10, 100, 200 },
  { 2459, 4, 0, 0, 0, 10, 100, 200 },
  { 2895, 4, 0, 0, 0, 10, 100, 200 },
  { 2899, 4, 0, 0, 0, 10, 100, 200 },
  { 3347, 4, 0, 0, 0, 10, 200, 0 },
  { 3351, 4, 0, 0, 0, 10, 200, 0 },
  // 1470: vstore_half8, vstore_half8_rte, vstore_half8_rtz, vstore_half8_rtp, vstore_half8_rtn, 
  { 2103, 4, 0, 0, 0, 10, 100, 200 },
  { 2107, 4, 0, 0, 0, 10, 100, 200 },
  { 2543, 4, 0, 0, 0, 10, 100, 200 },
  { 2547, 4, 0, 0, 0, 10, 100, 200 },
  { 2987, 4, 0, 0, 0, 10, 100, 200 },
  { 2991, 4, 0, 0, 0, 10, 100, 200 },
  { 3435, 4, 0, 0, 0, 10, 200, 0 },
  { 3439, 4, 0, 0, 0, 10, 200, 0 },
  // 1478: vstore_half16, vstore_half16_rte, vstore_half16_rtz, vstore_half16_rtp, vstore_half16_rtn, 
  { 2191, 4, 0, 0, 0, 10, 100, 200 },
  { 2195, 4, 0, 0, 0, 10, 100, 200 },
  { 2631, 4, 0, 0, 0, 10, 100, 200 },
  { 2635, 4, 0, 0, 0, 10, 100, 200 },
  { 3081, 4, 0, 0, 0, 10, 100, 200 },
  { 3085, 4, 0, 0, 0, 10, 100, 200 },
  { 3523, 4, 0, 0, 0, 10, 200, 0 },
  { 3527, 4, 0, 0, 0, 10, 200, 0 },
  // 1486: async_work_group_copy, 
  { 3804, 5, 0, 0, 0, 10, 100, 0 },
  { 3809, 5, 0, 0, 0, 10, 100, 0 },
  // 1488: async_work_group_strided_copy, 
  { 3816, 6, 0, 0, 0, 10, 100, 0 },
  { 3822, 6, 0, 0, 0, 10, 100, 0 },
  // 1490: wait_group_events, 
  { 3828, 3, 0, 0, 0, 10, 100, 0 },
  // 1491: prefetch, 
  { 3831, 3, 0, 0, 0, 10, 100, 0 },
  // 1492: atom_add, atom_sub, atom_xchg, 
  { 3834, 3, 0, 0, 0, 1, 100, 0 },
  { 3845, 3, 0, 0, 0, 1, 100, 0 },
  { 3856, 3, 0, 0, 0, 5, 100, 0 },
  { 3865, 3, 0, 0, 0, 5, 100, 0 },
  { 3874, 3, 0, 0, 0, 3, 100, 0 },
  { 3883, 3, 0, 0, 0, 3, 100, 0 },
  { 3892, 3, 0, 0, 0, 3, 100, 0 },
  { 3901, 3, 0, 0, 0, 3, 100, 0 },
  // 1500: atom_inc, atom_dec, 
  { 3837, 2, 0, 0, 0, 1, 100, 0 },
  { 3848, 2, 0, 0, 0, 1, 100, 0 },
  { 3859, 2, 0, 0, 0, 5, 100, 0 },
  { 3868, 2, 0, 0, 0, 5, 100, 0 },
  { 3877, 2, 0, 0, 0, 3, 100, 0 },
  { 3886, 2, 0, 0, 0, 3, 100, 0 },
  { 3895, 2, 0, 0, 0, 3, 100, 0 },
  { 3904, 2, 0, 0, 0, 3, 100, 0 },
  // 1508: atom_cmpxchg, 
  { 3839, 4, 0, 0, 0, 1, 100, 0 },
  { 3852, 4, 0, 0, 0, 1, 100, 0 },
  { 3861, 4, 0, 0, 0, 5, 100, 0 },
  { 3870, 4, 0, 0, 0, 5, 100, 0 },
  { 3879, 4, 0, 0, 0, 3, 100, 0 },
  { 3888, 4, 0, 0, 0, 3, 100, 0 },
  { 3897, 4, 0, 0, 0, 3, 100, 0 },
  { 3906, 4, 0, 0, 0, 3, 100, 0 },
  // 1516: atom_min, atom_max, atom_and, atom_or, atom_xor, 
  { 3834, 3, 0, 0, 0, 2, 100, 0 },
  { 3845, 3, 0, 0, 0, 2, 100, 0 },
  { 3856, 3, 0, 0, 0, 6, 100, 0 },
  { 3865, 3, 0, 0, 0, 6, 100, 0 },
  { 3874, 3, 0, 0, 0, 4, 100, 0 },
  { 3883, 3, 0, 0, 0, 4, 100, 0 },
  { 3892, 3, 0, 0, 0, 4, 100, 0 },
  { 3901, 3, 0, 0, 0, 4, 100, 0 },
  // 1524: atomic_add, atomic_sub, atomic_xchg, atomic_min, atomic_max, atomic_and, atomic_or, atomic_xor, 
  { 3834, 3, 0, 0, 0, 10, 100, 0 },
  { 3845, 3, 0, 0, 0, 10, 100, 0 },
  { 3856, 3, 0, 0, 0, 10, 100, 0 },
  { 3865, 3, 0, 0, 0, 10, 100, 0 },
  // 1528: atomic_inc, atomic_dec, 
  { 3837, 2, 0, 0, 0, 10, 100, 0 },
  { 3848, 2, 0, 0, 0, 10, 100, 0 },
  { 3859, 2, 0, 0, 0, 10, 100, 0 },
  { 3868, 2, 0, 0, 0, 10, 100, 0 },
  // 1532: atomic_cmpxchg, 
  { 3839, 4, 0, 0, 0, 10, 100, 0 },
  { 3852, 4, 0, 0, 0, 10, 100, 0 },
  { 3861, 4, 0, 0, 0, 10, 100, 0 },
  { 3870, 4, 0, 0, 0, 10, 100, 0 },
  // 1536: shuffle, 
  { 3910, 3, 0, 1, 0, 10, 100, 0 },
  { 3913, 3, 0, 1, 0, 10, 100, 0 },
  { 3916, 3, 0, 1, 0, 10, 100, 0 },
  { 3919, 3, 0, 1, 0, 10, 100, 0 },
  { 3922, 3, 0, 1, 0, 10, 100, 0 },
  { 3925, 3, 0, 1, 0, 10, 100, 0 },
  { 3928, 3, 0, 1, 0, 10, 100, 0 },
  { 3931, 3, 0, 1, 0, 10, 100, 0 },
  { 3934, 3, 0, 1, 0, 10, 100, 0 },
  { 3937, 3, 0, 1, 0, 10, 100, 0 },
  { 3940, 3, 0, 1, 0, 10, 100, 0 },
  { 3943, 3, 0, 1, 0, 10, 100, 0 },
  { 3946, 3, 0, 1, 0, 10, 100, 0 },
  { 3949, 3, 0, 1, 0, 10, 100, 0 },
  { 3952, 3, 0, 1, 0, 10, 100, 0 },
  { 3955, 3, 0, 1, 0, 10, 100, 0 },
  // 1552: shuffle2, 
  { 3958, 4, 0, 1, 0, 10, 100, 0 },
  { 3962, 4, 0, 1, 0, 10, 100, 0 },
  { 3966, 4, 0, 1, 0, 10, 100, 0 },
  { 3970, 4, 0, 1, 0, 10, 100, 0 },
  { 3974, 4, 0, 1, 0, 10, 100, 0 },
  { 3978, 4, 0, 1, 0, 10, 100, 0 },
  { 3982, 4, 0, 1, 0, 10, 100, 0 },
  { 3986, 4, 0, 1, 0, 10, 100, 0 },
  { 3990, 4, 0, 1, 0, 10, 100, 0 },
  { 3994, 4, 0, 1, 0, 10, 100, 0 },
  { 3998, 4, 0, 1, 0, 10, 100, 0 },
  { 4002, 4, 0, 1, 0, 10, 100, 0 },
  { 4006, 4, 0, 1, 0, 10, 100, 0 },
  { 4010, 4, 0, 1, 0, 10, 100, 0 },
  { 4014, 4, 0, 1, 0, 10, 100, 0 },
  { 4018, 4, 0, 1, 0, 10, 100, 0 },
  // 1568: read_imagef, 
  { 4022, 4, 1, 0, 0, 10, 100, 0 },
  { 4034, 4, 1, 0, 0, 10, 100, 0 },
  { 4046, 4, 1, 0, 0, 10, 100, 0 },
  { 4058, 4, 1, 0, 0, 10, 100, 0 },
  { 4070, 4, 1, 0, 0, 10, 100, 0 },
  { 4082, 4, 1, 0, 0, 10, 100, 0 },
  { 4094, 4, 1, 0, 0, 10, 100, 0 },
  { 4106, 4, 1, 0, 0, 10, 100, 0 },
  { 4118, 4, 1, 0, 0, 10, 100, 0 },
  { 4130, 4, 1, 0, 0, 10, 100, 0 },
  { 4142, 4, 1, 0, 0, 10, 100, 0 },
  { 4146, 4, 1, 0, 0, 10, 100, 0 },
  { 4150, 4, 1, 0, 0, 10, 100, 0 },
  { 4154, 4, 1, 0, 0, 10, 100, 0 },
  { 4158, 3, 1, 0, 0, 10, 100, 0 },
  { 4167, 3, 1, 0, 0, 10, 100, 0 },
  { 4176, 3, 1, 0, 0, 10, 100, 0 },
  { 4185, 3, 1, 0, 0, 10, 100, 0 },
  { 4188, 3, 1, 0, 0, 10, 100, 0 },
  { 4191, 3, 1, 0, 0, 10, 100, 0 },
  { 4200, 3, 1, 0, 0, 10, 100, 0 },
  { 4209, 3, 1, 0, 0, 10, 100, 0 },
  { 4218, 3, 1, 0, 0, 10, 100, 0 },
  { 4227, 3, 1, 0, 0, 10, 100, 0 },
  { 4236, 3, 1, 0, 0, 10, 100, 0 },
  { 4245, 3, 1, 0, 0, 10, 100, 0 },
  { 4254, 3, 1, 0, 0, 10, 100, 0 },
  { 4263, 3, 1, 0, 0, 10, 100, 0 },
  { 4272, 3, 1, 0, 0, 10, 100, 0 },
  { 4275, 3, 1, 0, 0, 10, 100, 0 },
  { 4672, 5, 1, 0, 0, 8, 100, 0 },
  { 4677, 6, 1, 0, 0, 8, 100, 0 },
  { 4705, 5, 1, 0, 0, 8, 100, 0 },
  { 4710, 6, 1, 0, 0, 8, 100, 0 },
  { 4716, 5, 1, 0, 0, 8, 100, 0 },
  { 4721, 6, 1, 0, 0, 8, 100, 0 },
  { 4749, 6, 1, 0, 0, 8, 100, 0 },
  { 4755, 5, 1, 0, 0, 8, 100, 0 },
  { 4772, 5, 1, 0, 0, 8, 100, 0 },
  { 4777, 6, 1, 0, 0, 8, 100, 0 },
  { 4805, 5, 1, 0, 0, 8, 100, 0 },
  { 4810, 6, 1, 0, 0, 8, 100, 0 },
  { 4838, 5, 1, 0, 0, 8, 100, 0 },
  { 4843, 6, 1, 0, 0, 8, 100, 0 },
  { 4938, 4, 1, 0, 0, 0, 100, 0 },
  { 4950, 4, 1, 0, 0, 0, 100, 0 },
  { 4964, 4, 1, 0, 0, 0, 100, 0 },
  { 4968, 4, 1, 0, 0, 0, 100, 0 },
  { 4974, 4, 1, 0, 0, 0, 100, 0 },
  { 4986, 4, 1, 0, 0, 0, 100, 0 },
  { 5000, 4, 1, 0, 0, 0, 100, 0 },
  { 5004, 4, 1, 0, 0, 0, 100, 0 },
  // 1620: read_imagei, 
  { 4026, 4, 1, 0, 0, 10, 100, 0 },
  { 4038, 4, 1, 0, 0, 10, 100, 0 },
  { 4050, 4, 1, 0, 0, 10, 100, 0 },
  { 4062, 4, 1, 0, 0, 10, 100, 0 },
  { 4074, 4, 1, 0, 0, 10, 100, 0 },
  { 4086, 4, 1, 0, 0, 10, 100, 0 },
  { 4098, 4, 1, 0, 0, 10, 100, 0 },
  { 4110, 4, 1, 0, 0, 10, 100, 0 },
  { 4122, 4, 1, 0, 0, 10, 100, 0 },
  { 4134, 4, 1, 0, 0, 10, 100, 0 },
  { 4161, 3, 1, 0, 0, 10, 100, 0 },
  { 4170, 3, 1, 0, 0, 10, 100, 0 },
  { 4179, 3, 1, 0, 0, 10, 100, 0 },
  { 4194, 3, 1, 0, 0, 10, 100, 0 },
  { 4203, 3, 1, 0, 0, 10, 100, 0 },
  { 4212, 3, 1, 0, 0, 10, 100, 0 },
  { 4221, 3, 1, 0, 0, 10, 100, 0 },
  { 4230, 3, 1, 0, 0, 10, 100, 0 },
  { 4239, 3, 1, 0, 0, 10, 100, 0 },
  { 4248, 3, 1, 0, 0, 10, 100, 0 },
  { 4257, 3, 1, 0, 0, 10, 100, 0 },
  { 4266, 3, 1, 0, 0, 10, 100, 0 },
  { 4683, 5, 1, 0, 0, 8, 100, 0 },
  { 4688, 6, 1, 0, 0, 8, 100, 0 },
  { 4727, 5, 1, 0, 0, 8, 100, 0 },
  { 4732, 6, 1, 0, 0, 8, 100, 0 },
  { 4760, 6, 1, 0, 0, 8, 100, 0 },
  { 4755, 5, 1, 0, 0, 8, 100, 0 },
  { 4783, 5, 1, 0, 0, 8, 100, 0 },
  { 4788, 6, 1, 0, 0, 8, 100, 0 },
  { 4816, 5, 1, 0, 0, 8, 100, 0 },
  { 4821, 6, 1, 0, 0, 8, 100, 0 },
  { 4942, 4, 1, 0, 0, 0, 100, 0 },
  { 4956, 4, 1, 0, 0, 0, 100, 0 },
  { 4978, 4, 1, 0, 0, 0, 100, 0 },
  { 4992, 4, 1, 0, 0, 0, 100, 0 },
  // 1656: read_imageui, 
  { 4030, 4, 1, 0, 0, 10, 100, 0 },
  { 4042, 4, 1, 0, 0, 10, 100, 0 },
  { 4054, 4, 1, 0, 0, 10, 100, 0 },
  { 4066, 4, 1, 0, 0, 10, 100, 0 },
  { 4078, 4, 1, 0, 0, 10, 100, 0 },
  { 4090, 4, 1, 0, 0, 10, 100, 0 },
  { 4102, 4, 1, 0, 0, 10, 100, 0 },
  { 4114, 4, 1, 0, 0, 10, 100, 0 },
  { 4126, 4, 1, 0, 0, 10, 100, 0 },
  { 4138, 4, 1, 0, 0, 10, 100, 0 },
  { 4164, 3, 1, 0, 0, 10, 100, 0 },
  { 4173, 3, 1, 0, 0, 10, 100, 0 },
  { 4182, 3, 1, 0, 0, 10, 100, 0 },
  { 4197, 3, 1, 0, 0, 10, 100, 0 },
  { 4206, 3, 1, 0, 0, 10, 100, 0 },
  { 4215, 3, 1, 0, 0, 10, 100, 0 },
  { 4224, 3, 1, 0, 0, 10, 100, 0 },
  { 4233, 3, 1, 0, 0, 10, 100, 0 },
  { 4242, 3, 1, 0, 0, 10, 100, 0 },
  { 4251, 3, 1, 0, 0, 10, 100, 0 },
  { 4260, 3, 1, 0, 0, 10, 100, 0 },
  { 4269, 3, 1, 0, 0, 10, 100, 0 },
  { 4694, 5, 1, 0, 0, 8, 100, 0 },
  { 4699, 6, 1, 0, 0, 8, 100, 0 },
  { 4738, 5, 1, 0, 0, 8, 100, 0 },
  { 4743, 6, 1, 0, 0, 8, 100, 0 },
  { 4766, 6, 1, 0, 0, 8, 100, 0 },
  { 4755, 5, 1, 0, 0, 8, 100, 0 },
  { 4794, 5, 1, 0, 0, 8, 100, 0 },
  { 4799, 6, 1, 0, 0, 8, 100, 0 },
  { 4827, 5, 1, 0, 0, 8, 100, 0 },
  { 4832, 6, 1, 0, 0, 8, 100, 0 },
  { 4946, 4, 1, 0, 0, 0, 100, 0 },
  { 4960, 4, 1, 0, 0, 0, 100, 0 },
  { 4982, 4, 1, 0, 0, 0, 100, 0 },
  { 4996, 4, 1, 0, 0, 0, 100, 0 },
  // 1692: write_imagef, 
  { 4278, 4, 0, 0, 0, 10, 100, 0 },
  { 4290, 4, 0, 0, 0, 10, 100, 0 },
  { 4302, 4, 0, 0, 0, 10, 100, 0 },
  { 4314, 4, 0, 0, 0, 10, 100, 0 },
  { 4326, 4, 0, 0, 0, 10, 100, 0 },
  { 4338, 4, 0, 0, 0, 10, 100, 0 },
  { 4342, 4, 0, 0, 0, 10, 100, 0 },
  { 4346, 4, 0, 0, 0, 10, 100, 0 },
  { 4358, 4, 0, 0, 0, 10, 100, 0 },
  { 4370, 4, 0, 0, 0, 10, 100, 0 },
  { 4382, 4, 0, 0, 0, 10, 100, 0 },
  { 4394, 4, 0, 0, 0, 10, 100, 0 },
  { 4406, 4, 0, 0, 0, 10, 100, 0 },
  { 4418, 4, 0, 0, 0, 10, 100, 0 },
  { 4430, 4, 0, 0, 0, 10, 100, 0 },
  { 4434, 4, 0, 0, 0, 10, 100, 0 },
  { 4849, 5, 0, 0, 0, 8, 100, 0 },
  { 4864, 5, 0, 0, 0, 8, 100, 0 },
  { 4869, 5, 0, 0, 0, 8, 100, 0 },
  { 4884, 5, 0, 0, 0, 8, 100, 0 },
  { 4899, 5, 0, 0, 0, 8, 100, 0 },
  { 4914, 5, 0, 0, 0, 8, 100, 0 },
  { 4919, 5, 0, 0, 0, 7, 100, 0 },
  // 1715: write_imagei, 
  { 4282, 4, 0, 0, 0, 10, 100, 0 },
  { 4294, 4, 0, 0, 0, 10, 100, 0 },
  { 4306, 4, 0, 0, 0, 10, 100, 0 },
  { 4318, 4, 0, 0, 0, 10, 100, 0 },
  { 4330, 4, 0, 0, 0, 10, 100, 0 },
  { 4350, 4, 0, 0, 0, 10, 100, 0 },
  { 4362, 4, 0, 0, 0, 10, 100, 0 },
  { 4374, 4, 0, 0, 0, 10, 100, 0 },
  { 4386, 4, 0, 0, 0, 10, 100, 0 },
  { 4398, 4, 0, 0, 0, 10, 100, 0 },
  { 4410, 4, 0, 0, 0, 10, 100, 0 },
  { 4422, 4, 0, 0, 0, 10, 100, 0 },
  { 4854, 5, 0, 0, 0, 8, 100, 0 },
  { 4874, 5, 0, 0, 0, 8, 100, 0 },
  { 4889, 5, 0, 0, 0, 8, 100, 0 },
  { 4904, 5, 0, 0, 0, 8, 100, 0 },
  { 4924, 5, 0, 0, 0, 7, 100, 0 },
  // 1732: write_imageui, 
  { 4286, 4, 0, 0, 0, 10, 100, 0 },
  { 4298, 4, 0, 0, 0, 10, 100, 0 },
  { 4310, 4, 0, 0, 0, 10, 100, 0 },
  { 4322, 4, 0, 0, 0, 10, 100, 0 },
  { 4334, 4, 0, 0, 0, 10, 100, 0 },
  { 4354, 4, 0, 0, 0, 10, 100, 0 },
  { 4366, 4, 0, 0, 0, 10, 100, 0 },
  { 4378, 4, 0, 0, 0, 10, 100, 0 },
  { 4390, 4, 0, 0, 0, 10, 100, 0 },
  { 4402, 4, 0, 0, 0, 10, 100, 0 },
  { 4414, 4, 0, 0, 0, 10, 100, 0 },
  { 4426, 4, 0, 0, 0, 10, 100, 0 },
  { 4859, 5, 0, 0, 0, 8, 100, 0 },
  { 4879, 5, 0, 0, 0, 8, 100, 0 },
  { 4894, 5, 0, 0, 0, 8, 100, 0 },
  { 4909, 5, 0, 0, 0, 8, 100, 0 },
  { 4929, 5, 0, 0, 0, 7, 100, 0 },
  // 1749: get_image_width, get_image_channel_data_type, get_image_channel_order, 
  { 4438, 2, 0, 0, 0, 10, 100, 0 },
  { 4450, 2, 0, 0, 0, 10, 100, 0 },
  { 4440, 2, 0, 0, 0, 10, 100, 0 },
  { 4442, 2, 0, 0, 0, 10, 100, 0 },
  { 4452, 2, 0, 0, 0, 10, 100, 0 },
  { 4454, 2, 0, 0, 0, 10, 100, 0 },
  { 4456, 2, 0, 0, 0, 10, 100, 0 },
  { 4458, 2, 0, 0, 0, 10, 100, 0 },
  { 4470, 2, 0, 0, 0, 10, 100, 0 },
  { 4472, 2, 0, 0, 0, 10, 100, 0 },
  { 4474, 2, 0, 0, 0, 10, 100, 0 },
  { 4476, 2, 0, 0, 0, 10, 100, 0 },
  { 4478, 2, 0, 0, 0, 10, 100, 0 },
  { 4480, 2, 0, 0, 0, 10, 100, 0 },
  { 4482, 2, 0, 0, 0, 10, 100, 0 },
  { 4484, 2, 0, 0, 0, 10, 100, 0 },
  { 4502, 2, 0, 0, 0, 10, 100, 0 },
  { 4504, 2, 0, 0, 0, 10, 100, 0 },
  { 4506, 2, 0, 0, 0, 10, 100, 0 },
  { 4508, 2, 0, 0, 0, 10, 100, 0 },
  { 4510, 2, 0, 0, 0, 10, 100, 0 },
  { 4512, 2, 0, 0, 0, 10, 100, 0 },
  { 4514, 2, 0, 0, 0, 10, 100, 0 },
  { 4516, 2, 0, 0, 0, 10, 100, 0 },
  { 5008, 2, 0, 1, 0, 0, 100, 0 },
  { 5016, 2, 0, 1, 0, 0, 100, 0 },
  { 5020, 2, 0, 1, 0, 0, 100, 0 },
  { 5024, 2, 0, 1, 0, 0, 100, 0 },
  { 5028, 2, 0, 1, 0, 0, 100, 0 },
  { 5032, 2, 0, 1, 0, 0, 100, 0 },
  { 5036, 2, 0, 1, 0, 0, 100, 0 },
  { 5040, 2, 0, 1, 0, 0, 100, 0 },
  { 5046, 2, 0, 1, 0, 0, 100, 0 },
  { 5050, 2, 0, 1, 0, 0, 100, 0 },
  { 5054, 2, 0, 1, 0, 0, 100, 0 },
  { 5058, 2, 0, 1, 0, 0, 100, 0 },
  // 1785: get_image_height, 
  { 4440, 2, 0, 0, 0, 10, 100, 0 },
  { 4442, 2, 0, 0, 0, 10, 100, 0 },
  { 4454, 2, 0, 0, 0, 10, 100, 0 },
  { 4456, 2, 0, 0, 0, 10, 100, 0 },
  { 4458, 2, 0, 0, 0, 10, 100, 0 },
  { 4474, 2, 0, 0, 0, 10, 100, 0 },
  { 4476, 2, 0, 0, 0, 10, 100, 0 },
  { 4480, 2, 0, 0, 0, 10, 100, 0 },
  { 4482, 2, 0, 0, 0, 10, 100, 0 },
  { 4484, 2, 0, 0, 0, 10, 100, 0 },
  { 4506, 2, 0, 0, 0, 10, 100, 0 },
  { 4508, 2, 0, 0, 0, 10, 100, 0 },
  { 4512, 2, 0, 0, 0, 10, 100, 0 },
  { 4514, 2, 0, 0, 0, 10, 100, 0 },
  { 4516, 2, 0, 0, 0, 10, 100, 0 },
  { 5008, 2, 0, 1, 0, 0, 100, 0 },
  { 5016, 2, 0, 1, 0, 0, 100, 0 },
  { 5020, 2, 0, 1, 0, 0, 100, 0 },
  { 5024, 2, 0, 1, 0, 0, 100, 0 },
  { 5028, 2, 0, 1, 0, 0, 100, 0 },
  { 5032, 2, 0, 1, 0, 0, 100, 0 },
  { 5036, 2, 0, 1, 0, 0, 100, 0 },
  { 5040, 2, 0, 1, 0, 0, 100, 0 },
  { 5046, 2, 0, 1, 0, 0, 100, 0 },
  { 5050, 2, 0, 1, 0, 0, 100, 0 },
  { 5054, 2, 0, 1, 0, 0, 100, 0 },
  { 5058, 2, 0, 1, 0, 0, 100, 0 },
  // 1812: get_image_depth, 
  { 4442, 2, 0, 0, 0, 10, 100, 0 },
  { 4476, 2, 0, 0, 0, 10, 100, 0 },
  { 4508, 2, 0, 0, 0, 10, 100, 0 },
  // 1815: get_image_dim, 
  { 4444, 2, 0, 0, 0, 10, 100, 0 },
  { 4446, 2, 0, 0, 0, 10, 100, 0 },
  { 4460, 2, 0, 0, 0, 10, 100, 0 },
  { 4462, 2, 0, 0, 0, 10, 100, 0 },
  { 4464, 2, 0, 0, 0, 10, 100, 0 },
  { 4486, 2, 0, 0, 0, 10, 100, 0 },
  { 4488, 2, 0, 0, 0, 10, 100, 0 },
  { 4490, 2, 0, 0, 0, 10, 100, 0 },
  { 4492, 2, 0, 0, 0, 10, 100, 0 },
  { 4494, 2, 0, 0, 0, 10, 100, 0 },
  { 4518, 2, 0, 0, 0, 10, 100, 0 },
  { 4520, 2, 0, 0, 0, 10, 100, 0 },
  { 4522, 2, 0, 0, 0, 10, 100, 0 },
  { 4524, 2, 0, 0, 0, 10, 100, 0 },
  { 4526, 2, 0, 0, 0, 10, 100, 0 },
  { 5010, 2, 0, 1, 0, 0, 100, 0 },
  { 5018, 2, 0, 1, 0, 0, 100, 0 },
  { 5022, 2, 0, 1, 0, 0, 100, 0 },
  { 5026, 2, 0, 1, 0, 0, 100, 0 },
  { 5030, 2, 0, 1, 0, 0, 100, 0 },
  { 5034, 2, 0, 1, 0, 0, 100, 0 },
  { 5038, 2, 0, 1, 0, 0, 100, 0 },
  { 5042, 2, 0, 1, 0, 0, 100, 0 },
  { 5048, 2, 0, 1, 0, 0, 100, 0 },
  { 5052, 2, 0, 1, 0, 0, 100, 0 },
  { 5056, 2, 0, 1, 0, 0, 100, 0 },
  { 5060, 2, 0, 1, 0, 0, 100, 0 },
  // 1842: get_image_array_size, 
  { 4448, 2, 0, 0, 0, 10, 100, 0 },
  { 4466, 2, 0, 0, 0, 10, 100, 0 },
  { 4468, 2, 0, 0, 0, 10, 100, 0 },
  { 4496, 2, 0, 0, 0, 10, 100, 0 },
  { 4498, 2, 0, 0, 0, 10, 100, 0 },
  { 4500, 2, 0, 0, 0, 10, 100, 0 },
  { 4528, 2, 0, 0, 0, 10, 100, 0 },
  { 4530, 2, 0, 0, 0, 10, 100, 0 },
  { 4532, 2, 0, 0, 0, 10, 100, 0 },
  { 5014, 2, 0, 1, 0, 0, 100, 0 },
  { 5044, 2, 0, 1, 0, 0, 100, 0 },
  { 5062, 2, 0, 1, 0, 0, 100, 0 },
  // 1854: read_imageh, 
  { 4534, 4, 1, 0, 0, 10, 100, 0 },
  { 4538, 4, 1, 0, 0, 10, 100, 0 },
  { 4542, 4, 1, 0, 0, 10, 100, 0 },
  { 4546, 4, 1, 0, 0, 10, 100, 0 },
  { 4550, 4, 1, 0, 0, 10, 100, 0 },
  { 4554, 4, 1, 0, 0, 10, 100, 0 },
  { 4558, 4, 1, 0, 0, 10, 100, 0 },
  { 4562, 4, 1, 0, 0, 10, 100, 0 },
  { 4566, 4, 1, 0, 0, 10, 100, 0 },
  { 4570, 4, 1, 0, 0, 10, 100, 0 },
  { 4574, 3, 1, 0, 0, 10, 100, 0 },
  { 4577, 3, 1, 0, 0, 10, 100, 0 },
  { 4580, 3, 1, 0, 0, 10, 100, 0 },
  { 4583, 3, 1, 0, 0, 10, 100, 0 },
  { 4586, 3, 1, 0, 0, 10, 100, 0 },
  { 4589, 3, 1, 0, 0, 10, 100, 0 },
  { 4592, 3, 1, 0, 0, 10, 100, 0 },
  { 4595, 3, 1, 0, 0, 10, 100, 0 },
  { 4598, 3, 1, 0, 0, 10, 100, 0 },
  { 4601, 3, 1, 0, 0, 10, 100, 0 },
  { 4604, 3, 1, 0, 0, 10, 100, 0 },
  { 4607, 3, 1, 0, 0, 10, 100, 0 },
  // 1876: write_imageh, 
  { 4610, 4, 0, 0, 0, 10, 100, 0 },
  { 4614, 4, 0, 0, 0, 10, 100, 0 },
  { 4618, 4, 0, 0, 0, 10, 100, 0 },
  { 4622, 4, 0, 0, 0, 10, 100, 0 },
  { 4626, 4, 0, 0, 0, 10, 100, 0 },
  { 4630, 4, 0, 0, 0, 10, 100, 0 },
  { 4634, 4, 0, 0, 0, 10, 100, 0 },
  { 4638, 4, 0, 0, 0, 10, 100, 0 },
  { 4642, 4, 0, 0, 0, 10, 100, 0 },
  { 4646, 4, 0, 0, 0, 10, 100, 0 },
  { 4650, 4, 0, 0, 0, 10, 100, 0 },
  { 4654, 4, 0, 0, 0, 10, 100, 0 },
  // 1888: work_group_all, work_group_any, 
  { 924, 2, 0, 0, 1, 10, 200, 0 },
  // 1889: work_group_broadcast, 
  { 4658, 3, 0, 0, 1, 10, 200, 0 },
  { 4661, 4, 0, 0, 1, 10, 200, 0 },
  { 4665, 5, 0, 0, 1, 10, 200, 0 },
  // 1892: work_group_reduce_add, work_group_scan_exclusive_add, work_group_scan_inclusive_add, work_group_reduce_min, work_group_scan_exclusive_min, work_group_scan_inclusive_min, work_group_reduce_max, work_group_scan_exclusive_max, work_group_scan_inclusive_max, 
  { 4670, 2, 0, 0, 1, 10, 200, 0 },
  // 1893: get_image_num_mip_levels, 
  { 4438, 2, 0, 0, 0, 8, 100, 0 },
  { 4440, 2, 0, 0, 0, 8, 100, 0 },
  { 4442, 2, 0, 0, 0, 8, 100, 0 },
  { 4452, 2, 0, 0, 0, 8, 100, 0 },
  { 4454, 2, 0, 0, 0, 8, 100, 0 },
  { 4456, 2, 0, 0, 0, 8, 100, 0 },
  { 4458, 2, 0, 0, 0, 8, 100, 0 },
  { 4470, 2, 0, 0, 0, 8, 100, 0 },
  { 4474, 2, 0, 0, 0, 8, 100, 0 },
  { 4476, 2, 0, 0, 0, 8, 100, 0 },
  { 4478, 2, 0, 0, 0, 8, 100, 0 },
  { 4480, 2, 0, 0, 0, 8, 100, 0 },
  { 4482, 2, 0, 0, 0, 8, 100, 0 },
  { 4484, 2, 0, 0, 0, 8, 100, 0 },
  { 4502, 2, 0, 0, 0, 8, 100, 0 },
  { 4506, 2, 0, 0, 0, 8, 100, 0 },
  { 4508, 2, 0, 0, 0, 8, 100, 0 },
  { 4510, 2, 0, 0, 0, 8, 100, 0 },
  { 4512, 2, 0, 0, 0, 8, 100, 0 },
  { 4514, 2, 0, 0, 0, 8, 100, 0 },
  { 4516, 2, 0, 0, 0, 8, 100, 0 },
  // 1914: get_image_num_samples, 
  { 5008, 2, 0, 1, 0, 0, 100, 0 },
  { 5016, 2, 0, 1, 0, 0, 100, 0 },
  { 5020, 2, 0, 1, 0, 0, 100, 0 },
  { 5024, 2, 0, 1, 0, 0, 100, 0 },
  { 5028, 2, 0, 1, 0, 0, 100, 0 },
  { 5032, 2, 0, 1, 0, 0, 100, 0 },
  { 5036, 2, 0, 1, 0, 0, 100, 0 },
  { 5040, 2, 0, 1, 0, 0, 100, 0 },
  { 5046, 2, 0, 1, 0, 0, 100, 0 },
  { 5050, 2, 0, 1, 0, 0, 100, 0 },
  { 5054, 2, 0, 1, 0, 0, 100, 0 },
  { 5058, 2, 0, 1, 0, 0, 100, 0 },
  // 1926: get_max_sub_group_size, get_num_sub_groups, get_sub_group_size, 
  { 1404, 1, 0, 0, 0, 9, 200, 0 },
};


// Find out whether a string matches an existing OpenCL builtin function name.
// Returns: A pair <0, 0> if no name matches.
//          A pair <Index, Len> indexing the BuiltinTable if the name is
//          matching an OpenCL builtin function.
static std::pair<unsigned, unsigned> isOpenCLBuiltin(llvm::StringRef Name) {

  switch (Name.size()) {
  default: break;
  case 3:	 // 19 strings to match.
    switch (Name[0]) {
    default: break;
    case 'a':	 // 3 strings to match.
      switch (Name[1]) {
      default: break;
      case 'b':	 // 1 string to match.
        if (Name[2] != 's')
          break;
        return std::make_pair(783, 1);	 // "abs"
      case 'l':	 // 1 string to match.
        if (Name[2] != 'l')
          break;
        return std::make_pair(846, 1);	 // "all"
      case 'n':	 // 1 string to match.
        if (Name[2] != 'y')
          break;
        return std::make_pair(846, 1);	 // "any"
      }
      break;
    case 'c':	 // 3 strings to match.
      switch (Name[1]) {
      default: break;
      case 'l':	 // 1 string to match.
        if (Name[2] != 'z')
          break;
        return std::make_pair(784, 1);	 // "clz"
      case 'o':	 // 1 string to match.
        if (Name[2] != 's')
          break;
        return std::make_pair(731, 1);	 // "cos"
      case 't':	 // 1 string to match.
        if (Name[2] != 'z')
          break;
        return std::make_pair(785, 1);	 // "ctz"
      }
      break;
    case 'd':	 // 1 string to match.
      if (memcmp(Name.data()+1, "ot", 2) != 0)
        break;
      return std::make_pair(837, 3);	 // "dot"
    case 'e':	 // 2 strings to match.
      switch (Name[1]) {
      default: break;
      case 'r':	 // 1 string to match.
        if (Name[2] != 'f')
          break;
        return std::make_pair(731, 1);	 // "erf"
      case 'x':	 // 1 string to match.
        if (Name[2] != 'p')
          break;
        return std::make_pair(731, 1);	 // "exp"
      }
      break;
    case 'f':	 // 1 string to match.
      if (memcmp(Name.data()+1, "ma", 2) != 0)
        break;
      return std::make_pair(752, 1);	 // "fma"
    case 'l':	 // 1 string to match.
      if (memcmp(Name.data()+1, "og", 2) != 0)
        break;
      return std::make_pair(731, 1);	 // "log"
    case 'm':	 // 4 strings to match.
      switch (Name[1]) {
      default: break;
      case 'a':	 // 2 strings to match.
        switch (Name[2]) {
        default: break;
        case 'd':	 // 1 string to match.
          return std::make_pair(752, 1);	 // "mad"
        case 'x':	 // 1 string to match.
          return std::make_pair(788, 6);	 // "max"
        }
        break;
      case 'i':	 // 2 strings to match.
        switch (Name[2]) {
        default: break;
        case 'n':	 // 1 string to match.
          return std::make_pair(788, 6);	 // "min"
        case 'x':	 // 1 string to match.
          return std::make_pair(815, 4);	 // "mix"
        }
        break;
      }
      break;
    case 'n':	 // 1 string to match.
      if (memcmp(Name.data()+1, "an", 2) != 0)
        break;
      return std::make_pair(732, 3);	 // "nan"
    case 'p':	 // 1 string to match.
      if (memcmp(Name.data()+1, "ow", 2) != 0)
        break;
      return std::make_pair(735, 1);	 // "pow"
    case 's':	 // 1 string to match.
      if (memcmp(Name.data()+1, "in", 2) != 0)
        break;
      return std::make_pair(731, 1);	 // "sin"
    case 't':	 // 1 string to match.
      if (memcmp(Name.data()+1, "an", 2) != 0)
        break;
      return std::make_pair(731, 1);	 // "tan"
    }
    break;
  case 4:	 // 25 strings to match.
    switch (Name[0]) {
    default: break;
    case 'a':	 // 3 strings to match.
      switch (Name[1]) {
      default: break;
      case 'c':	 // 1 string to match.
        if (memcmp(Name.data()+2, "os", 2) != 0)
          break;
        return std::make_pair(731, 1);	 // "acos"
      case 's':	 // 1 string to match.
        if (memcmp(Name.data()+2, "in", 2) != 0)
          break;
        return std::make_pair(731, 1);	 // "asin"
      case 't':	 // 1 string to match.
        if (memcmp(Name.data()+2, "an", 2) != 0)
          break;
        return std::make_pair(731, 1);	 // "atan"
      }
      break;
    case 'c':	 // 3 strings to match.
      switch (Name[1]) {
      default: break;
      case 'b':	 // 1 string to match.
        if (memcmp(Name.data()+2, "rt", 2) != 0)
          break;
        return std::make_pair(731, 1);	 // "cbrt"
      case 'e':	 // 1 string to match.
        if (memcmp(Name.data()+2, "il", 2) != 0)
          break;
        return std::make_pair(731, 1);	 // "ceil"
      case 'o':	 // 1 string to match.
        if (memcmp(Name.data()+2, "sh", 2) != 0)
          break;
        return std::make_pair(731, 1);	 // "cosh"
      }
      break;
    case 'e':	 // 2 strings to match.
      switch (Name[1]) {
      default: break;
      case 'r':	 // 1 string to match.
        if (memcmp(Name.data()+2, "fc", 2) != 0)
          break;
        return std::make_pair(731, 1);	 // "erfc"
      case 'x':	 // 1 string to match.
        if (memcmp(Name.data()+2, "p2", 2) != 0)
          break;
        return std::make_pair(731, 1);	 // "exp2"
      }
      break;
    case 'f':	 // 5 strings to match.
      switch (Name[1]) {
      default: break;
      case 'a':	 // 1 string to match.
        if (memcmp(Name.data()+2, "bs", 2) != 0)
          break;
        return std::make_pair(731, 1);	 // "fabs"
      case 'd':	 // 1 string to match.
        if (memcmp(Name.data()+2, "im", 2) != 0)
          break;
        return std::make_pair(735, 1);	 // "fdim"
      case 'm':	 // 3 strings to match.
        switch (Name[2]) {
        default: break;
        case 'a':	 // 1 string to match.
          if (Name[3] != 'x')
            break;
          return std::make_pair(736, 4);	 // "fmax"
        case 'i':	 // 1 string to match.
          if (Name[3] != 'n')
            break;
          return std::make_pair(736, 4);	 // "fmin"
        case 'o':	 // 1 string to match.
          if (Name[3] != 'd')
            break;
          return std::make_pair(735, 1);	 // "fmod"
        }
        break;
      }
      break;
    case 'h':	 // 1 string to match.
      if (memcmp(Name.data()+1, "add", 3) != 0)
        break;
      return std::make_pair(787, 1);	 // "hadd"
    case 'l':	 // 2 strings to match.
      if (memcmp(Name.data()+1, "og", 2) != 0)
        break;
      switch (Name[3]) {
      default: break;
      case '2':	 // 1 string to match.
        return std::make_pair(731, 1);	 // "log2"
      case 'b':	 // 1 string to match.
        return std::make_pair(731, 1);	 // "logb"
      }
      break;
    case 'm':	 // 1 string to match.
      if (memcmp(Name.data()+1, "odf", 3) != 0)
        break;
      return std::make_pair(753, 4);	 // "modf"
    case 'p':	 // 2 strings to match.
      if (memcmp(Name.data()+1, "ow", 2) != 0)
        break;
      switch (Name[3]) {
      default: break;
      case 'n':	 // 1 string to match.
        return std::make_pair(749, 3);	 // "pown"
      case 'r':	 // 1 string to match.
        return std::make_pair(735, 1);	 // "powr"
      }
      break;
    case 'r':	 // 1 string to match.
      if (memcmp(Name.data()+1, "int", 3) != 0)
        break;
      return std::make_pair(731, 1);	 // "rint"
    case 's':	 // 4 strings to match.
      switch (Name[1]) {
      default: break;
      case 'i':	 // 2 strings to match.
        switch (Name[2]) {
        default: break;
        case 'g':	 // 1 string to match.
          if (Name[3] != 'n')
            break;
          return std::make_pair(731, 1);	 // "sign"
        case 'n':	 // 1 string to match.
          if (Name[3] != 'h')
            break;
          return std::make_pair(731, 1);	 // "sinh"
        }
        break;
      case 'q':	 // 1 string to match.
        if (memcmp(Name.data()+2, "rt", 2) != 0)
          break;
        return std::make_pair(731, 1);	 // "sqrt"
      case 't':	 // 1 string to match.
        if (memcmp(Name.data()+2, "ep", 2) != 0)
          break;
        return std::make_pair(811, 4);	 // "step"
      }
      break;
    case 't':	 // 1 string to match.
      if (memcmp(Name.data()+1, "anh", 3) != 0)
        break;
      return std::make_pair(731, 1);	 // "tanh"
    }
    break;
  case 5:	 // 28 strings to match.
    switch (Name[0]) {
    default: break;
    case 'a':	 // 4 strings to match.
      switch (Name[1]) {
      default: break;
      case 'c':	 // 1 string to match.
        if (memcmp(Name.data()+2, "osh", 3) != 0)
          break;
        return std::make_pair(731, 1);	 // "acosh"
      case 's':	 // 1 string to match.
        if (memcmp(Name.data()+2, "inh", 3) != 0)
          break;
        return std::make_pair(731, 1);	 // "asinh"
      case 't':	 // 2 strings to match.
        if (memcmp(Name.data()+2, "an", 2) != 0)
          break;
        switch (Name[4]) {
        default: break;
        case '2':	 // 1 string to match.
          return std::make_pair(735, 1);	 // "atan2"
        case 'h':	 // 1 string to match.
          return std::make_pair(731, 1);	 // "atanh"
        }
        break;
      }
      break;
    case 'c':	 // 3 strings to match.
      switch (Name[1]) {
      default: break;
      case 'l':	 // 1 string to match.
        if (memcmp(Name.data()+2, "amp", 3) != 0)
          break;
        return std::make_pair(800, 6);	 // "clamp"
      case 'o':	 // 1 string to match.
        if (memcmp(Name.data()+2, "spi", 3) != 0)
          break;
        return std::make_pair(731, 1);	 // "cospi"
      case 'r':	 // 1 string to match.
        if (memcmp(Name.data()+2, "oss", 3) != 0)
          break;
        return std::make_pair(831, 6);	 // "cross"
      }
      break;
    case 'e':	 // 2 strings to match.
      if (memcmp(Name.data()+1, "xp", 2) != 0)
        break;
      switch (Name[3]) {
      default: break;
      case '1':	 // 1 string to match.
        if (Name[4] != '0')
          break;
        return std::make_pair(731, 1);	 // "exp10"
      case 'm':	 // 1 string to match.
        if (Name[4] != '1')
          break;
        return std::make_pair(731, 1);	 // "expm1"
      }
      break;
    case 'f':	 // 3 strings to match.
      switch (Name[1]) {
      default: break;
      case 'l':	 // 1 string to match.
        if (memcmp(Name.data()+2, "oor", 3) != 0)
          break;
        return std::make_pair(731, 1);	 // "floor"
      case 'r':	 // 2 strings to match.
        switch (Name[2]) {
        default: break;
        case 'a':	 // 1 string to match.
          if (memcmp(Name.data()+3, "ct", 2) != 0)
            break;
          return std::make_pair(753, 4);	 // "fract"
        case 'e':	 // 1 string to match.
          if (memcmp(Name.data()+3, "xp", 2) != 0)
            break;
          return std::make_pair(757, 12);	 // "frexp"
        }
        break;
      }
      break;
    case 'h':	 // 1 string to match.
      if (memcmp(Name.data()+1, "ypot", 4) != 0)
        break;
      return std::make_pair(735, 1);	 // "hypot"
    case 'i':	 // 3 strings to match.
      switch (Name[1]) {
      default: break;
      case 'l':	 // 1 string to match.
        if (memcmp(Name.data()+2, "ogb", 3) != 0)
          break;
        return std::make_pair(740, 3);	 // "ilogb"
      case 's':	 // 2 strings to match.
        switch (Name[2]) {
        default: break;
        case 'i':	 // 1 string to match.
          if (memcmp(Name.data()+3, "nf", 2) != 0)
            break;
          return std::make_pair(841, 5);	 // "isinf"
        case 'n':	 // 1 string to match.
          if (memcmp(Name.data()+3, "an", 2) != 0)
            break;
          return std::make_pair(841, 5);	 // "isnan"
        }
        break;
      }
      break;
    case 'l':	 // 3 strings to match.
      switch (Name[1]) {
      default: break;
      case 'd':	 // 1 string to match.
        if (memcmp(Name.data()+2, "exp", 3) != 0)
          break;
        return std::make_pair(743, 6);	 // "ldexp"
      case 'o':	 // 2 strings to match.
        if (memcmp(Name.data()+2, "g1", 2) != 0)
          break;
        switch (Name[4]) {
        default: break;
        case '0':	 // 1 string to match.
          return std::make_pair(731, 1);	 // "log10"
        case 'p':	 // 1 string to match.
          return std::make_pair(731, 1);	 // "log1p"
        }
        break;
      }
      break;
    case 'm':	 // 2 strings to match.
      switch (Name[1]) {
      default: break;
      case 'a':	 // 1 string to match.
        if (memcmp(Name.data()+2, "d24", 3) != 0)
          break;
        return std::make_pair(807, 2);	 // "mad24"
      case 'u':	 // 1 string to match.
        if (memcmp(Name.data()+2, "l24", 3) != 0)
          break;
        return std::make_pair(809, 2);	 // "mul24"
      }
      break;
    case 'r':	 // 4 strings to match.
      switch (Name[1]) {
      default: break;
      case 'h':	 // 1 string to match.
        if (memcmp(Name.data()+2, "add", 3) != 0)
          break;
        return std::make_pair(787, 1);	 // "rhadd"
      case 'o':	 // 2 strings to match.
        switch (Name[2]) {
        default: break;
        case 'o':	 // 1 string to match.
          if (memcmp(Name.data()+3, "tn", 2) != 0)
            break;
          return std::make_pair(749, 3);	 // "rootn"
        case 'u':	 // 1 string to match.
          if (memcmp(Name.data()+3, "nd", 2) != 0)
            break;
          return std::make_pair(731, 1);	 // "round"
        }
        break;
      case 's':	 // 1 string to match.
        if (memcmp(Name.data()+2, "qrt", 3) != 0)
          break;
        return std::make_pair(731, 1);	 // "rsqrt"
      }
      break;
    case 's':	 // 1 string to match.
      if (memcmp(Name.data()+1, "inpi", 4) != 0)
        break;
      return std::make_pair(731, 1);	 // "sinpi"
    case 't':	 // 2 strings to match.
      switch (Name[1]) {
      default: break;
      case 'a':	 // 1 string to match.
        if (memcmp(Name.data()+2, "npi", 3) != 0)
          break;
        return std::make_pair(731, 1);	 // "tanpi"
      case 'r':	 // 1 string to match.
        if (memcmp(Name.data()+2, "unc", 3) != 0)
          break;
        return std::make_pair(731, 1);	 // "trunc"
      }
      break;
    }
    break;
  case 6:	 // 19 strings to match.
    switch (Name[0]) {
    default: break;
    case 'a':	 // 3 strings to match.
      switch (Name[1]) {
      default: break;
      case 'c':	 // 1 string to match.
        if (memcmp(Name.data()+2, "ospi", 4) != 0)
          break;
        return std::make_pair(731, 1);	 // "acospi"
      case 's':	 // 1 string to match.
        if (memcmp(Name.data()+2, "inpi", 4) != 0)
          break;
        return std::make_pair(731, 1);	 // "asinpi"
      case 't':	 // 1 string to match.
        if (memcmp(Name.data()+2, "anpi", 4) != 0)
          break;
        return std::make_pair(731, 1);	 // "atanpi"
      }
      break;
    case 'i':	 // 1 string to match.
      if (memcmp(Name.data()+1, "sless", 5) != 0)
        break;
      return std::make_pair(847, 5);	 // "isless"
    case 'l':	 // 2 strings to match.
      switch (Name[1]) {
      default: break;
      case 'e':	 // 1 string to match.
        if (memcmp(Name.data()+2, "ngth", 4) != 0)
          break;
        return std::make_pair(823, 3);	 // "length"
      case 'g':	 // 1 string to match.
        if (memcmp(Name.data()+2, "amma", 4) != 0)
          break;
        return std::make_pair(731, 1);	 // "lgamma"
      }
      break;
    case 'm':	 // 4 strings to match.
      switch (Name[1]) {
      default: break;
      case 'a':	 // 2 strings to match.
        switch (Name[2]) {
        default: break;
        case 'd':	 // 1 string to match.
          if (memcmp(Name.data()+3, "_hi", 3) != 0)
            break;
          return std::make_pair(806, 1);	 // "mad_hi"
        case 'x':	 // 1 string to match.
          if (memcmp(Name.data()+3, "mag", 3) != 0)
            break;
          return std::make_pair(735, 1);	 // "maxmag"
        }
        break;
      case 'i':	 // 1 string to match.
        if (memcmp(Name.data()+2, "nmag", 4) != 0)
          break;
        return std::make_pair(735, 1);	 // "minmag"
      case 'u':	 // 1 string to match.
        if (memcmp(Name.data()+2, "l_hi", 4) != 0)
          break;
        return std::make_pair(787, 1);	 // "mul_hi"
      }
      break;
    case 'r':	 // 2 strings to match.
      switch (Name[1]) {
      default: break;
      case 'e':	 // 1 string to match.
        if (memcmp(Name.data()+2, "mquo", 4) != 0)
          break;
        return std::make_pair(769, 12);	 // "remquo"
      case 'o':	 // 1 string to match.
        if (memcmp(Name.data()+2, "tate", 4) != 0)
          break;
        return std::make_pair(787, 1);	 // "rotate"
      }
      break;
    case 's':	 // 2 strings to match.
      switch (Name[1]) {
      default: break;
      case 'e':	 // 1 string to match.
        if (memcmp(Name.data()+2, "lect", 4) != 0)
          break;
        return std::make_pair(853, 10);	 // "select"
      case 'i':	 // 1 string to match.
        if (memcmp(Name.data()+2, "ncos", 4) != 0)
          break;
        return std::make_pair(753, 4);	 // "sincos"
      }
      break;
    case 't':	 // 1 string to match.
      if (memcmp(Name.data()+1, "gamma", 5) != 0)
        break;
      return std::make_pair(731, 1);	 // "tgamma"
    case 'v':	 // 4 strings to match.
      if (memcmp(Name.data()+1, "load", 4) != 0)
        break;
      switch (Name[5]) {
      default: break;
      case '2':	 // 1 string to match.
        return std::make_pair(863, 55);	 // "vload2"
      case '3':	 // 1 string to match.
        return std::make_pair(977, 55);	 // "vload3"
      case '4':	 // 1 string to match.
        return std::make_pair(1091, 55);	 // "vload4"
      case '8':	 // 1 string to match.
        return std::make_pair(1205, 55);	 // "vload8"
      }
      break;
    }
    break;
  case 7:	 // 15 strings to match.
    switch (Name[0]) {
    default: break;
    case 'a':	 // 3 strings to match.
      switch (Name[1]) {
      default: break;
      case 'd':	 // 1 string to match.
        if (memcmp(Name.data()+2, "d_sat", 5) != 0)
          break;
        return std::make_pair(787, 1);	 // "add_sat"
      case 't':	 // 2 strings to match.
        switch (Name[2]) {
        default: break;
        case 'a':	 // 1 string to match.
          if (memcmp(Name.data()+3, "n2pi", 4) != 0)
            break;
          return std::make_pair(735, 1);	 // "atan2pi"
        case 'o':	 // 1 string to match.
          if (memcmp(Name.data()+3, "m_or", 4) != 0)
            break;
          return std::make_pair(1516, 8);	 // "atom_or"
        }
        break;
      }
      break;
    case 'd':	 // 1 string to match.
      if (memcmp(Name.data()+1, "egrees", 6) != 0)
        break;
      return std::make_pair(731, 1);	 // "degrees"
    case 'i':	 // 1 string to match.
      if (memcmp(Name.data()+1, "sequal", 6) != 0)
        break;
      return std::make_pair(847, 5);	 // "isequal"
    case 'm':	 // 1 string to match.
      if (memcmp(Name.data()+1, "ad_sat", 6) != 0)
        break;
      return std::make_pair(806, 1);	 // "mad_sat"
    case 'r':	 // 1 string to match.
      if (memcmp(Name.data()+1, "adians", 6) != 0)
        break;
      return std::make_pair(731, 1);	 // "radians"
    case 's':	 // 3 strings to match.
      switch (Name[1]) {
      default: break;
      case 'h':	 // 1 string to match.
        if (memcmp(Name.data()+2, "uffle", 5) != 0)
          break;
        return std::make_pair(1536, 16);	 // "shuffle"
      case 'i':	 // 1 string to match.
        if (memcmp(Name.data()+2, "gnbit", 5) != 0)
          break;
        return std::make_pair(841, 5);	 // "signbit"
      case 'u':	 // 1 string to match.
        if (memcmp(Name.data()+2, "b_sat", 5) != 0)
          break;
        return std::make_pair(787, 1);	 // "sub_sat"
      }
      break;
    case 'v':	 // 5 strings to match.
      switch (Name[1]) {
      default: break;
      case 'l':	 // 1 string to match.
        if (memcmp(Name.data()+2, "oad16", 5) != 0)
          break;
        return std::make_pair(1319, 55);	 // "vload16"
      case 's':	 // 4 strings to match.
        if (memcmp(Name.data()+2, "tore", 4) != 0)
          break;
        switch (Name[6]) {
        default: break;
        case '2':	 // 1 string to match.
          return std::make_pair(918, 44);	 // "vstore2"
        case '3':	 // 1 string to match.
          return std::make_pair(1032, 44);	 // "vstore3"
        case '4':	 // 1 string to match.
          return std::make_pair(1146, 44);	 // "vstore4"
        case '8':	 // 1 string to match.
          return std::make_pair(1260, 44);	 // "vstore8"
        }
        break;
      }
      break;
    }
    break;
  case 8:	 // 24 strings to match.
    switch (Name[0]) {
    default: break;
    case 'a':	 // 9 strings to match.
      switch (Name[1]) {
      default: break;
      case 'b':	 // 1 string to match.
        if (memcmp(Name.data()+2, "s_diff", 6) != 0)
          break;
        return std::make_pair(786, 1);	 // "abs_diff"
      case 't':	 // 8 strings to match.
        if (memcmp(Name.data()+2, "om_", 3) != 0)
          break;
        switch (Name[5]) {
        default: break;
        case 'a':	 // 2 strings to match.
          switch (Name[6]) {
          default: break;
          case 'd':	 // 1 string to match.
            if (Name[7] != 'd')
              break;
            return std::make_pair(1492, 8);	 // "atom_add"
          case 'n':	 // 1 string to match.
            if (Name[7] != 'd')
              break;
            return std::make_pair(1516, 8);	 // "atom_and"
          }
          break;
        case 'd':	 // 1 string to match.
          if (memcmp(Name.data()+6, "ec", 2) != 0)
            break;
          return std::make_pair(1500, 8);	 // "atom_dec"
        case 'i':	 // 1 string to match.
          if (memcmp(Name.data()+6, "nc", 2) != 0)
            break;
          return std::make_pair(1500, 8);	 // "atom_inc"
        case 'm':	 // 2 strings to match.
          switch (Name[6]) {
          default: break;
          case 'a':	 // 1 string to match.
            if (Name[7] != 'x')
              break;
            return std::make_pair(1516, 8);	 // "atom_max"
          case 'i':	 // 1 string to match.
            if (Name[7] != 'n')
              break;
            return std::make_pair(1516, 8);	 // "atom_min"
          }
          break;
        case 's':	 // 1 string to match.
          if (memcmp(Name.data()+6, "ub", 2) != 0)
            break;
          return std::make_pair(1492, 8);	 // "atom_sub"
        case 'x':	 // 1 string to match.
          if (memcmp(Name.data()+6, "or", 2) != 0)
            break;
          return std::make_pair(1516, 8);	 // "atom_xor"
        }
        break;
      }
      break;
    case 'c':	 // 1 string to match.
      if (memcmp(Name.data()+1, "opysign", 7) != 0)
        break;
      return std::make_pair(735, 1);	 // "copysign"
    case 'd':	 // 1 string to match.
      if (memcmp(Name.data()+1, "istance", 7) != 0)
        break;
      return std::make_pair(837, 3);	 // "distance"
    case 'h':	 // 5 strings to match.
      if (memcmp(Name.data()+1, "alf_", 4) != 0)
        break;
      switch (Name[5]) {
      default: break;
      case 'c':	 // 1 string to match.
        if (memcmp(Name.data()+6, "os", 2) != 0)
          break;
        return std::make_pair(781, 1);	 // "half_cos"
      case 'e':	 // 1 string to match.
        if (memcmp(Name.data()+6, "xp", 2) != 0)
          break;
        return std::make_pair(781, 1);	 // "half_exp"
      case 'l':	 // 1 string to match.
        if (memcmp(Name.data()+6, "og", 2) != 0)
          break;
        return std::make_pair(781, 1);	 // "half_log"
      case 's':	 // 1 string to match.
        if (memcmp(Name.data()+6, "in", 2) != 0)
          break;
        return std::make_pair(781, 1);	 // "half_sin"
      case 't':	 // 1 string to match.
        if (memcmp(Name.data()+6, "an", 2) != 0)
          break;
        return std::make_pair(781, 1);	 // "half_tan"
      }
      break;
    case 'i':	 // 2 strings to match.
      if (Name[1] != 's')
        break;
      switch (Name[2]) {
      default: break;
      case 'f':	 // 1 string to match.
        if (memcmp(Name.data()+3, "inite", 5) != 0)
          break;
        return std::make_pair(841, 5);	 // "isfinite"
      case 'n':	 // 1 string to match.
        if (memcmp(Name.data()+3, "ormal", 5) != 0)
          break;
        return std::make_pair(841, 5);	 // "isnormal"
      }
      break;
    case 'l':	 // 1 string to match.
      if (memcmp(Name.data()+1, "gamma_r", 7) != 0)
        break;
      return std::make_pair(757, 12);	 // "lgamma_r"
    case 'p':	 // 2 strings to match.
      switch (Name[1]) {
      default: break;
      case 'o':	 // 1 string to match.
        if (memcmp(Name.data()+2, "pcount", 6) != 0)
          break;
        return std::make_pair(784, 1);	 // "popcount"
      case 'r':	 // 1 string to match.
        if (memcmp(Name.data()+2, "efetch", 6) != 0)
          break;
        return std::make_pair(1491, 1);	 // "prefetch"
      }
      break;
    case 's':	 // 1 string to match.
      if (memcmp(Name.data()+1, "huffle2", 7) != 0)
        break;
      return std::make_pair(1552, 16);	 // "shuffle2"
    case 'u':	 // 1 string to match.
      if (memcmp(Name.data()+1, "psample", 7) != 0)
        break;
      return std::make_pair(794, 6);	 // "upsample"
    case 'v':	 // 1 string to match.
      if (memcmp(Name.data()+1, "store16", 7) != 0)
        break;
      return std::make_pair(1374, 44);	 // "vstore16"
    }
    break;
  case 9:	 // 12 strings to match.
    switch (Name[0]) {
    default: break;
    case 'a':	 // 2 strings to match.
      if (memcmp(Name.data()+1, "tom", 3) != 0)
        break;
      switch (Name[4]) {
      default: break;
      case '_':	 // 1 string to match.
        if (memcmp(Name.data()+5, "xchg", 4) != 0)
          break;
        return std::make_pair(1492, 8);	 // "atom_xchg"
      case 'i':	 // 1 string to match.
        if (memcmp(Name.data()+5, "c_or", 4) != 0)
          break;
        return std::make_pair(1524, 4);	 // "atomic_or"
      }
      break;
    case 'b':	 // 1 string to match.
      if (memcmp(Name.data()+1, "itselect", 8) != 0)
        break;
      return std::make_pair(852, 1);	 // "bitselect"
    case 'h':	 // 4 strings to match.
      if (memcmp(Name.data()+1, "alf_", 4) != 0)
        break;
      switch (Name[5]) {
      default: break;
      case 'e':	 // 1 string to match.
        if (memcmp(Name.data()+6, "xp2", 3) != 0)
          break;
        return std::make_pair(781, 1);	 // "half_exp2"
      case 'l':	 // 1 string to match.
        if (memcmp(Name.data()+6, "og2", 3) != 0)
          break;
        return std::make_pair(781, 1);	 // "half_log2"
      case 'p':	 // 1 string to match.
        if (memcmp(Name.data()+6, "owr", 3) != 0)
          break;
        return std::make_pair(782, 1);	 // "half_powr"
      case 's':	 // 1 string to match.
        if (memcmp(Name.data()+6, "qrt", 3) != 0)
          break;
        return std::make_pair(781, 1);	 // "half_sqrt"
      }
      break;
    case 'i':	 // 2 strings to match.
      if (Name[1] != 's')
        break;
      switch (Name[2]) {
      default: break;
      case 'g':	 // 1 string to match.
        if (memcmp(Name.data()+3, "reater", 6) != 0)
          break;
        return std::make_pair(847, 5);	 // "isgreater"
      case 'o':	 // 1 string to match.
        if (memcmp(Name.data()+3, "rdered", 6) != 0)
          break;
        return std::make_pair(847, 5);	 // "isordered"
      }
      break;
    case 'n':	 // 2 strings to match.
      switch (Name[1]) {
      default: break;
      case 'e':	 // 1 string to match.
        if (memcmp(Name.data()+2, "xtafter", 7) != 0)
          break;
        return std::make_pair(735, 1);	 // "nextafter"
      case 'o':	 // 1 string to match.
        if (memcmp(Name.data()+2, "rmalize", 7) != 0)
          break;
        return std::make_pair(826, 3);	 // "normalize"
      }
      break;
    case 'r':	 // 1 string to match.
      if (memcmp(Name.data()+1, "emainder", 8) != 0)
        break;
      return std::make_pair(735, 1);	 // "remainder"
    }
    break;
  case 10:	 // 20 strings to match.
    switch (Name[0]) {
    default: break;
    case 'a':	 // 8 strings to match.
      if (memcmp(Name.data()+1, "tomic_", 6) != 0)
        break;
      switch (Name[7]) {
      default: break;
      case 'a':	 // 2 strings to match.
        switch (Name[8]) {
        default: break;
        case 'd':	 // 1 string to match.
          if (Name[9] != 'd')
            break;
          return std::make_pair(1524, 4);	 // "atomic_add"
        case 'n':	 // 1 string to match.
          if (Name[9] != 'd')
            break;
          return std::make_pair(1524, 4);	 // "atomic_and"
        }
        break;
      case 'd':	 // 1 string to match.
        if (memcmp(Name.data()+8, "ec", 2) != 0)
          break;
        return std::make_pair(1528, 4);	 // "atomic_dec"
      case 'i':	 // 1 string to match.
        if (memcmp(Name.data()+8, "nc", 2) != 0)
          break;
        return std::make_pair(1528, 4);	 // "atomic_inc"
      case 'm':	 // 2 strings to match.
        switch (Name[8]) {
        default: break;
        case 'a':	 // 1 string to match.
          if (Name[9] != 'x')
            break;
          return std::make_pair(1524, 4);	 // "atomic_max"
        case 'i':	 // 1 string to match.
          if (Name[9] != 'n')
            break;
          return std::make_pair(1524, 4);	 // "atomic_min"
        }
        break;
      case 's':	 // 1 string to match.
        if (memcmp(Name.data()+8, "ub", 2) != 0)
          break;
        return std::make_pair(1524, 4);	 // "atomic_sub"
      case 'x':	 // 1 string to match.
        if (memcmp(Name.data()+8, "or", 2) != 0)
          break;
        return std::make_pair(1524, 4);	 // "atomic_xor"
      }
      break;
    case 'h':	 // 4 strings to match.
      if (memcmp(Name.data()+1, "alf_", 4) != 0)
        break;
      switch (Name[5]) {
      default: break;
      case 'e':	 // 1 string to match.
        if (memcmp(Name.data()+6, "xp10", 4) != 0)
          break;
        return std::make_pair(781, 1);	 // "half_exp10"
      case 'l':	 // 1 string to match.
        if (memcmp(Name.data()+6, "og10", 4) != 0)
          break;
        return std::make_pair(781, 1);	 // "half_log10"
      case 'r':	 // 2 strings to match.
        switch (Name[6]) {
        default: break;
        case 'e':	 // 1 string to match.
          if (memcmp(Name.data()+7, "cip", 3) != 0)
            break;
          return std::make_pair(781, 1);	 // "half_recip"
        case 's':	 // 1 string to match.
          if (memcmp(Name.data()+7, "qrt", 3) != 0)
            break;
          return std::make_pair(781, 1);	 // "half_rsqrt"
        }
        break;
      }
      break;
    case 'i':	 // 1 string to match.
      if (memcmp(Name.data()+1, "snotequal", 9) != 0)
        break;
      return std::make_pair(847, 5);	 // "isnotequal"
    case 'n':	 // 5 strings to match.
      if (memcmp(Name.data()+1, "ative_", 6) != 0)
        break;
      switch (Name[7]) {
      default: break;
      case 'c':	 // 1 string to match.
        if (memcmp(Name.data()+8, "os", 2) != 0)
          break;
        return std::make_pair(781, 1);	 // "native_cos"
      case 'e':	 // 1 string to match.
        if (memcmp(Name.data()+8, "xp", 2) != 0)
          break;
        return std::make_pair(781, 1);	 // "native_exp"
      case 'l':	 // 1 string to match.
        if (memcmp(Name.data()+8, "og", 2) != 0)
          break;
        return std::make_pair(781, 1);	 // "native_log"
      case 's':	 // 1 string to match.
        if (memcmp(Name.data()+8, "in", 2) != 0)
          break;
        return std::make_pair(781, 1);	 // "native_sin"
      case 't':	 // 1 string to match.
        if (memcmp(Name.data()+8, "an", 2) != 0)
          break;
        return std::make_pair(781, 1);	 // "native_tan"
      }
      break;
    case 's':	 // 1 string to match.
      if (memcmp(Name.data()+1, "moothstep", 9) != 0)
        break;
      return std::make_pair(819, 4);	 // "smoothstep"
    case 'v':	 // 1 string to match.
      if (memcmp(Name.data()+1, "load_half", 9) != 0)
        break;
      return std::make_pair(1433, 5);	 // "vload_half"
    }
    break;
  case 11:	 // 18 strings to match.
    switch (Name[0]) {
    default: break;
    case 'a':	 // 1 string to match.
      if (memcmp(Name.data()+1, "tomic_xchg", 10) != 0)
        break;
      return std::make_pair(1524, 4);	 // "atomic_xchg"
    case 'c':	 // 1 string to match.
      if (memcmp(Name.data()+1, "onvert_int", 10) != 0)
        break;
      return std::make_pair(463, 11);	 // "convert_int"
    case 'f':	 // 1 string to match.
      if (memcmp(Name.data()+1, "ast_length", 10) != 0)
        break;
      return std::make_pair(829, 1);	 // "fast_length"
    case 'h':	 // 1 string to match.
      if (memcmp(Name.data()+1, "alf_divide", 10) != 0)
        break;
      return std::make_pair(782, 1);	 // "half_divide"
    case 'i':	 // 2 strings to match.
      if (Name[1] != 's')
        break;
      switch (Name[2]) {
      default: break;
      case 'l':	 // 1 string to match.
        if (memcmp(Name.data()+3, "essequal", 8) != 0)
          break;
        return std::make_pair(847, 5);	 // "islessequal"
      case 'u':	 // 1 string to match.
        if (memcmp(Name.data()+3, "nordered", 8) != 0)
          break;
        return std::make_pair(847, 5);	 // "isunordered"
      }
      break;
    case 'n':	 // 4 strings to match.
      if (memcmp(Name.data()+1, "ative_", 6) != 0)
        break;
      switch (Name[7]) {
      default: break;
      case 'e':	 // 1 string to match.
        if (memcmp(Name.data()+8, "xp2", 3) != 0)
          break;
        return std::make_pair(781, 1);	 // "native_exp2"
      case 'l':	 // 1 string to match.
        if (memcmp(Name.data()+8, "og2", 3) != 0)
          break;
        return std::make_pair(781, 1);	 // "native_log2"
      case 'p':	 // 1 string to match.
        if (memcmp(Name.data()+8, "owr", 3) != 0)
          break;
        return std::make_pair(782, 1);	 // "native_powr"
      case 's':	 // 1 string to match.
        if (memcmp(Name.data()+8, "qrt", 3) != 0)
          break;
        return std::make_pair(781, 1);	 // "native_sqrt"
      }
      break;
    case 'r':	 // 3 strings to match.
      if (memcmp(Name.data()+1, "ead_image", 9) != 0)
        break;
      switch (Name[10]) {
      default: break;
      case 'f':	 // 1 string to match.
        return std::make_pair(1568, 52);	 // "read_imagef"
      case 'h':	 // 1 string to match.
        return std::make_pair(1854, 22);	 // "read_imageh"
      case 'i':	 // 1 string to match.
        return std::make_pair(1620, 36);	 // "read_imagei"
      }
      break;
    case 'v':	 // 5 strings to match.
      switch (Name[1]) {
      default: break;
      case 'l':	 // 4 strings to match.
        if (memcmp(Name.data()+2, "oad_half", 8) != 0)
          break;
        switch (Name[10]) {
        default: break;
        case '2':	 // 1 string to match.
          return std::make_pair(962, 5);	 // "vload_half2"
        case '3':	 // 1 string to match.
          return std::make_pair(1076, 5);	 // "vload_half3"
        case '4':	 // 1 string to match.
          return std::make_pair(1190, 5);	 // "vload_half4"
        case '8':	 // 1 string to match.
          return std::make_pair(1304, 5);	 // "vload_half8"
        }
        break;
      case 's':	 // 1 string to match.
        if (memcmp(Name.data()+2, "tore_half", 9) != 0)
          break;
        return std::make_pair(1438, 8);	 // "vstore_half"
      }
      break;
    }
    break;
  case 12:	 // 29 strings to match.
    switch (Name[0]) {
    default: break;
    case 'a':	 // 1 string to match.
      if (memcmp(Name.data()+1, "tom_cmpxchg", 11) != 0)
        break;
      return std::make_pair(1508, 8);	 // "atom_cmpxchg"
    case 'c':	 // 8 strings to match.
      if (memcmp(Name.data()+1, "onvert_", 7) != 0)
        break;
      switch (Name[8]) {
      default: break;
      case 'c':	 // 1 string to match.
        if (memcmp(Name.data()+9, "har", 3) != 0)
          break;
        return std::make_pair(199, 11);	 // "convert_char"
      case 'h':	 // 1 string to match.
        if (memcmp(Name.data()+9, "alf", 3) != 0)
          break;
        return std::make_pair(133, 11);	 // "convert_half"
      case 'i':	 // 4 strings to match.
        if (memcmp(Name.data()+9, "nt", 2) != 0)
          break;
        switch (Name[11]) {
        default: break;
        case '2':	 // 1 string to match.
          return std::make_pair(474, 11);	 // "convert_int2"
        case '3':	 // 1 string to match.
          return std::make_pair(485, 11);	 // "convert_int3"
        case '4':	 // 1 string to match.
          return std::make_pair(496, 11);	 // "convert_int4"
        case '8':	 // 1 string to match.
          return std::make_pair(507, 11);	 // "convert_int8"
        }
        break;
      case 'l':	 // 1 string to match.
        if (memcmp(Name.data()+9, "ong", 3) != 0)
          break;
        return std::make_pair(595, 11);	 // "convert_long"
      case 'u':	 // 1 string to match.
        if (memcmp(Name.data()+9, "int", 3) != 0)
          break;
        return std::make_pair(529, 11);	 // "convert_uint"
      }
      break;
    case 'g':	 // 3 strings to match.
      if (memcmp(Name.data()+1, "et_", 3) != 0)
        break;
      switch (Name[4]) {
      default: break;
      case 'g':	 // 1 string to match.
        if (memcmp(Name.data()+5, "roup_id", 7) != 0)
          break;
        return std::make_pair(728, 1);	 // "get_group_id"
      case 'l':	 // 1 string to match.
        if (memcmp(Name.data()+5, "ocal_id", 7) != 0)
          break;
        return std::make_pair(728, 1);	 // "get_local_id"
      case 'w':	 // 1 string to match.
        if (memcmp(Name.data()+5, "ork_dim", 7) != 0)
          break;
        return std::make_pair(727, 1);	 // "get_work_dim"
      }
      break;
    case 'n':	 // 4 strings to match.
      if (memcmp(Name.data()+1, "ative_", 6) != 0)
        break;
      switch (Name[7]) {
      default: break;
      case 'e':	 // 1 string to match.
        if (memcmp(Name.data()+8, "xp10", 4) != 0)
          break;
        return std::make_pair(781, 1);	 // "native_exp10"
      case 'l':	 // 1 string to match.
        if (memcmp(Name.data()+8, "og10", 4) != 0)
          break;
        return std::make_pair(781, 1);	 // "native_log10"
      case 'r':	 // 2 strings to match.
        switch (Name[8]) {
        default: break;
        case 'e':	 // 1 string to match.
          if (memcmp(Name.data()+9, "cip", 3) != 0)
            break;
          return std::make_pair(781, 1);	 // "native_recip"
        case 's':	 // 1 string to match.
          if (memcmp(Name.data()+9, "qrt", 3) != 0)
            break;
          return std::make_pair(781, 1);	 // "native_rsqrt"
        }
        break;
      }
      break;
    case 'r':	 // 1 string to match.
      if (memcmp(Name.data()+1, "ead_imageui", 11) != 0)
        break;
      return std::make_pair(1656, 36);	 // "read_imageui"
    case 'v':	 // 9 strings to match.
      switch (Name[1]) {
      default: break;
      case 'l':	 // 5 strings to match.
        if (memcmp(Name.data()+2, "oad", 3) != 0)
          break;
        switch (Name[5]) {
        default: break;
        case '_':	 // 1 string to match.
          if (memcmp(Name.data()+6, "half16", 6) != 0)
            break;
          return std::make_pair(1418, 5);	 // "vload_half16"
        case 'a':	 // 4 strings to match.
          if (memcmp(Name.data()+6, "_half", 5) != 0)
            break;
          switch (Name[11]) {
          default: break;
          case '2':	 // 1 string to match.
            return std::make_pair(962, 5);	 // "vloada_half2"
          case '3':	 // 1 string to match.
            return std::make_pair(1076, 5);	 // "vloada_half3"
          case '4':	 // 1 string to match.
            return std::make_pair(1190, 5);	 // "vloada_half4"
          case '8':	 // 1 string to match.
            return std::make_pair(1304, 5);	 // "vloada_half8"
          }
          break;
        }
        break;
      case 's':	 // 4 strings to match.
        if (memcmp(Name.data()+2, "tore_half", 9) != 0)
          break;
        switch (Name[11]) {
        default: break;
        case '2':	 // 1 string to match.
          return std::make_pair(1446, 8);	 // "vstore_half2"
        case '3':	 // 1 string to match.
          return std::make_pair(1454, 8);	 // "vstore_half3"
        case '4':	 // 1 string to match.
          return std::make_pair(1462, 8);	 // "vstore_half4"
        case '8':	 // 1 string to match.
          return std::make_pair(1470, 8);	 // "vstore_half8"
        }
        break;
      }
      break;
    case 'w':	 // 3 strings to match.
      if (memcmp(Name.data()+1, "rite_image", 10) != 0)
        break;
      switch (Name[11]) {
      default: break;
      case 'f':	 // 1 string to match.
        return std::make_pair(1692, 23);	 // "write_imagef"
      case 'h':	 // 1 string to match.
        return std::make_pair(1876, 12);	 // "write_imageh"
      case 'i':	 // 1 string to match.
        return std::make_pair(1715, 17);	 // "write_imagei"
      }
      break;
    }
    break;
  case 13:	 // 33 strings to match.
    switch (Name[0]) {
    default: break;
    case 'c':	 // 21 strings to match.
      if (memcmp(Name.data()+1, "onvert_", 7) != 0)
        break;
      switch (Name[8]) {
      default: break;
      case 'c':	 // 4 strings to match.
        if (memcmp(Name.data()+9, "har", 3) != 0)
          break;
        switch (Name[12]) {
        default: break;
        case '2':	 // 1 string to match.
          return std::make_pair(210, 11);	 // "convert_char2"
        case '3':	 // 1 string to match.
          return std::make_pair(221, 11);	 // "convert_char3"
        case '4':	 // 1 string to match.
          return std::make_pair(232, 11);	 // "convert_char4"
        case '8':	 // 1 string to match.
          return std::make_pair(243, 11);	 // "convert_char8"
        }
        break;
      case 'f':	 // 1 string to match.
        if (memcmp(Name.data()+9, "loat", 4) != 0)
          break;
        return std::make_pair(89, 11);	 // "convert_float"
      case 'h':	 // 4 strings to match.
        if (memcmp(Name.data()+9, "alf", 3) != 0)
          break;
        switch (Name[12]) {
        default: break;
        case '2':	 // 1 string to match.
          return std::make_pair(144, 11);	 // "convert_half2"
        case '3':	 // 1 string to match.
          return std::make_pair(155, 11);	 // "convert_half3"
        case '4':	 // 1 string to match.
          return std::make_pair(166, 11);	 // "convert_half4"
        case '8':	 // 1 string to match.
          return std::make_pair(177, 11);	 // "convert_half8"
        }
        break;
      case 'i':	 // 1 string to match.
        if (memcmp(Name.data()+9, "nt16", 4) != 0)
          break;
        return std::make_pair(518, 11);	 // "convert_int16"
      case 'l':	 // 4 strings to match.
        if (memcmp(Name.data()+9, "ong", 3) != 0)
          break;
        switch (Name[12]) {
        default: break;
        case '2':	 // 1 string to match.
          return std::make_pair(606, 11);	 // "convert_long2"
        case '3':	 // 1 string to match.
          return std::make_pair(617, 11);	 // "convert_long3"
        case '4':	 // 1 string to match.
          return std::make_pair(628, 11);	 // "convert_long4"
        case '8':	 // 1 string to match.
          return std::make_pair(639, 11);	 // "convert_long8"
        }
        break;
      case 's':	 // 1 string to match.
        if (memcmp(Name.data()+9, "hort", 4) != 0)
          break;
        return std::make_pair(331, 11);	 // "convert_short"
      case 'u':	 // 6 strings to match.
        switch (Name[9]) {
        default: break;
        case 'c':	 // 1 string to match.
          if (memcmp(Name.data()+10, "har", 3) != 0)
            break;
          return std::make_pair(265, 11);	 // "convert_uchar"
        case 'i':	 // 4 strings to match.
          if (memcmp(Name.data()+10, "nt", 2) != 0)
            break;
          switch (Name[12]) {
          default: break;
          case '2':	 // 1 string to match.
            return std::make_pair(540, 11);	 // "convert_uint2"
          case '3':	 // 1 string to match.
            return std::make_pair(551, 11);	 // "convert_uint3"
          case '4':	 // 1 string to match.
            return std::make_pair(562, 11);	 // "convert_uint4"
          case '8':	 // 1 string to match.
            return std::make_pair(573, 11);	 // "convert_uint8"
          }
          break;
        case 'l':	 // 1 string to match.
          if (memcmp(Name.data()+10, "ong", 3) != 0)
            break;
          return std::make_pair(661, 11);	 // "convert_ulong"
        }
        break;
      }
      break;
    case 'f':	 // 1 string to match.
      if (memcmp(Name.data()+1, "ast_distance", 12) != 0)
        break;
      return std::make_pair(840, 1);	 // "fast_distance"
    case 'g':	 // 2 strings to match.
      if (memcmp(Name.data()+1, "et_", 3) != 0)
        break;
      switch (Name[4]) {
      default: break;
      case 'g':	 // 1 string to match.
        if (memcmp(Name.data()+5, "lobal_id", 8) != 0)
          break;
        return std::make_pair(728, 1);	 // "get_global_id"
      case 'i':	 // 1 string to match.
        if (memcmp(Name.data()+5, "mage_dim", 8) != 0)
          break;
        return std::make_pair(1815, 27);	 // "get_image_dim"
      }
      break;
    case 'i':	 // 1 string to match.
      if (memcmp(Name.data()+1, "slessgreater", 12) != 0)
        break;
      return std::make_pair(847, 5);	 // "islessgreater"
    case 'n':	 // 1 string to match.
      if (memcmp(Name.data()+1, "ative_divide", 12) != 0)
        break;
      return std::make_pair(782, 1);	 // "native_divide"
    case 'v':	 // 6 strings to match.
      switch (Name[1]) {
      default: break;
      case 'l':	 // 1 string to match.
        if (memcmp(Name.data()+2, "oada_half16", 11) != 0)
          break;
        return std::make_pair(1418, 5);	 // "vloada_half16"
      case 's':	 // 5 strings to match.
        if (memcmp(Name.data()+2, "tore", 4) != 0)
          break;
        switch (Name[6]) {
        default: break;
        case '_':	 // 1 string to match.
          if (memcmp(Name.data()+7, "half16", 6) != 0)
            break;
          return std::make_pair(1478, 8);	 // "vstore_half16"
        case 'a':	 // 4 strings to match.
          if (memcmp(Name.data()+7, "_half", 5) != 0)
            break;
          switch (Name[12]) {
          default: break;
          case '2':	 // 1 string to match.
            return std::make_pair(967, 10);	 // "vstorea_half2"
          case '3':	 // 1 string to match.
            return std::make_pair(1081, 10);	 // "vstorea_half3"
          case '4':	 // 1 string to match.
            return std::make_pair(1195, 10);	 // "vstorea_half4"
          case '8':	 // 1 string to match.
            return std::make_pair(1309, 10);	 // "vstorea_half8"
          }
          break;
        }
        break;
      }
      break;
    case 'w':	 // 1 string to match.
      if (memcmp(Name.data()+1, "rite_imageui", 12) != 0)
        break;
      return std::make_pair(1732, 17);	 // "write_imageui"
    }
    break;
  case 14:	 // 30 strings to match.
    switch (Name[0]) {
    default: break;
    case 'a':	 // 1 string to match.
      if (memcmp(Name.data()+1, "tomic_cmpxchg", 13) != 0)
        break;
      return std::make_pair(1532, 4);	 // "atomic_cmpxchg"
    case 'c':	 // 22 strings to match.
      if (memcmp(Name.data()+1, "onvert_", 7) != 0)
        break;
      switch (Name[8]) {
      default: break;
      case 'c':	 // 1 string to match.
        if (memcmp(Name.data()+9, "har16", 5) != 0)
          break;
        return std::make_pair(254, 11);	 // "convert_char16"
      case 'd':	 // 1 string to match.
        if (memcmp(Name.data()+9, "ouble", 5) != 0)
          break;
        return std::make_pair(56, 11);	 // "convert_double"
      case 'f':	 // 4 strings to match.
        if (memcmp(Name.data()+9, "loat", 4) != 0)
          break;
        switch (Name[13]) {
        default: break;
        case '2':	 // 1 string to match.
          return std::make_pair(100, 11);	 // "convert_float2"
        case '3':	 // 1 string to match.
          return std::make_pair(111, 11);	 // "convert_float3"
        case '4':	 // 1 string to match.
          return std::make_pair(122, 11);	 // "convert_float4"
        case '8':	 // 1 string to match.
          return std::make_pair(1, 11);	 // "convert_float8"
        }
        break;
      case 'h':	 // 1 string to match.
        if (memcmp(Name.data()+9, "alf16", 5) != 0)
          break;
        return std::make_pair(188, 11);	 // "convert_half16"
      case 'l':	 // 1 string to match.
        if (memcmp(Name.data()+9, "ong16", 5) != 0)
          break;
        return std::make_pair(650, 11);	 // "convert_long16"
      case 's':	 // 4 strings to match.
        if (memcmp(Name.data()+9, "hort", 4) != 0)
          break;
        switch (Name[13]) {
        default: break;
        case '2':	 // 1 string to match.
          return std::make_pair(342, 11);	 // "convert_short2"
        case '3':	 // 1 string to match.
          return std::make_pair(353, 11);	 // "convert_short3"
        case '4':	 // 1 string to match.
          return std::make_pair(364, 11);	 // "convert_short4"
        case '8':	 // 1 string to match.
          return std::make_pair(375, 11);	 // "convert_short8"
        }
        break;
      case 'u':	 // 10 strings to match.
        switch (Name[9]) {
        default: break;
        case 'c':	 // 4 strings to match.
          if (memcmp(Name.data()+10, "har", 3) != 0)
            break;
          switch (Name[13]) {
          default: break;
          case '2':	 // 1 string to match.
            return std::make_pair(276, 11);	 // "convert_uchar2"
          case '3':	 // 1 string to match.
            return std::make_pair(287, 11);	 // "convert_uchar3"
          case '4':	 // 1 string to match.
            return std::make_pair(298, 11);	 // "convert_uchar4"
          case '8':	 // 1 string to match.
            return std::make_pair(309, 11);	 // "convert_uchar8"
          }
          break;
        case 'i':	 // 1 string to match.
          if (memcmp(Name.data()+10, "nt16", 4) != 0)
            break;
          return std::make_pair(584, 11);	 // "convert_uint16"
        case 'l':	 // 4 strings to match.
          if (memcmp(Name.data()+10, "ong", 3) != 0)
            break;
          switch (Name[13]) {
          default: break;
          case '2':	 // 1 string to match.
            return std::make_pair(672, 11);	 // "convert_ulong2"
          case '3':	 // 1 string to match.
            return std::make_pair(683, 11);	 // "convert_ulong3"
          case '4':	 // 1 string to match.
            return std::make_pair(694, 11);	 // "convert_ulong4"
          case '8':	 // 1 string to match.
            return std::make_pair(705, 11);	 // "convert_ulong8"
          }
          break;
        case 's':	 // 1 string to match.
          if (memcmp(Name.data()+10, "hort", 4) != 0)
            break;
          return std::make_pair(397, 11);	 // "convert_ushort"
        }
        break;
      }
      break;
    case 'f':	 // 1 string to match.
      if (memcmp(Name.data()+1, "ast_normalize", 13) != 0)
        break;
      return std::make_pair(830, 1);	 // "fast_normalize"
    case 'g':	 // 2 strings to match.
      if (memcmp(Name.data()+1, "et_", 3) != 0)
        break;
      switch (Name[4]) {
      default: break;
      case 'l':	 // 1 string to match.
        if (memcmp(Name.data()+5, "ocal_size", 9) != 0)
          break;
        return std::make_pair(728, 1);	 // "get_local_size"
      case 'n':	 // 1 string to match.
        if (memcmp(Name.data()+5, "um_groups", 9) != 0)
          break;
        return std::make_pair(728, 1);	 // "get_num_groups"
      }
      break;
    case 'i':	 // 1 string to match.
      if (memcmp(Name.data()+1, "sgreaterequal", 13) != 0)
        break;
      return std::make_pair(847, 5);	 // "isgreaterequal"
    case 'v':	 // 1 string to match.
      if (memcmp(Name.data()+1, "storea_half16", 13) != 0)
        break;
      return std::make_pair(1423, 10);	 // "vstorea_half16"
    case 'w':	 // 2 strings to match.
      if (memcmp(Name.data()+1, "ork_group_a", 11) != 0)
        break;
      switch (Name[12]) {
      default: break;
      case 'l':	 // 1 string to match.
        if (Name[13] != 'l')
          break;
        return std::make_pair(1888, 1);	 // "work_group_all"
      case 'n':	 // 1 string to match.
        if (Name[13] != 'y')
          break;
        return std::make_pair(1888, 1);	 // "work_group_any"
      }
      break;
    }
    break;
  case 15:	 // 24 strings to match.
    switch (Name[0]) {
    default: break;
    case 'c':	 // 17 strings to match.
      if (memcmp(Name.data()+1, "onvert_", 7) != 0)
        break;
      switch (Name[8]) {
      default: break;
      case 'd':	 // 4 strings to match.
        if (memcmp(Name.data()+9, "ouble", 5) != 0)
          break;
        switch (Name[14]) {
        default: break;
        case '2':	 // 1 string to match.
          return std::make_pair(67, 11);	 // "convert_double2"
        case '3':	 // 1 string to match.
          return std::make_pair(12, 11);	 // "convert_double3"
        case '4':	 // 1 string to match.
          return std::make_pair(23, 11);	 // "convert_double4"
        case '8':	 // 1 string to match.
          return std::make_pair(34, 11);	 // "convert_double8"
        }
        break;
      case 'f':	 // 1 string to match.
        if (memcmp(Name.data()+9, "loat16", 6) != 0)
          break;
        return std::make_pair(78, 11);	 // "convert_float16"
      case 'i':	 // 5 strings to match.
        if (memcmp(Name.data()+9, "nt_", 3) != 0)
          break;
        switch (Name[12]) {
        default: break;
        case 'r':	 // 4 strings to match.
          if (Name[13] != 't')
            break;
          switch (Name[14]) {
          default: break;
          case 'e':	 // 1 string to match.
            return std::make_pair(463, 11);	 // "convert_int_rte"
          case 'n':	 // 1 string to match.
            return std::make_pair(463, 11);	 // "convert_int_rtn"
          case 'p':	 // 1 string to match.
            return std::make_pair(463, 11);	 // "convert_int_rtp"
          case 'z':	 // 1 string to match.
            return std::make_pair(463, 11);	 // "convert_int_rtz"
          }
          break;
        case 's':	 // 1 string to match.
          if (memcmp(Name.data()+13, "at", 2) != 0)
            break;
          return std::make_pair(463, 11);	 // "convert_int_sat"
        }
        break;
      case 's':	 // 1 string to match.
        if (memcmp(Name.data()+9, "hort16", 6) != 0)
          break;
        return std::make_pair(386, 11);	 // "convert_short16"
      case 'u':	 // 6 strings to match.
        switch (Name[9]) {
        default: break;
        case 'c':	 // 1 string to match.
          if (memcmp(Name.data()+10, "har16", 5) != 0)
            break;
          return std::make_pair(320, 11);	 // "convert_uchar16"
        case 'l':	 // 1 string to match.
          if (memcmp(Name.data()+10, "ong16", 5) != 0)
            break;
          return std::make_pair(716, 11);	 // "convert_ulong16"
        case 's':	 // 4 strings to match.
          if (memcmp(Name.data()+10, "hort", 4) != 0)
            break;
          switch (Name[14]) {
          default: break;
          case '2':	 // 1 string to match.
            return std::make_pair(408, 11);	 // "convert_ushort2"
          case '3':	 // 1 string to match.
            return std::make_pair(419, 11);	 // "convert_ushort3"
          case '4':	 // 1 string to match.
            return std::make_pair(430, 11);	 // "convert_ushort4"
          case '8':	 // 1 string to match.
            return std::make_pair(441, 11);	 // "convert_ushort8"
          }
          break;
        }
        break;
      }
      break;
    case 'g':	 // 3 strings to match.
      if (memcmp(Name.data()+1, "et_", 3) != 0)
        break;
      switch (Name[4]) {
      default: break;
      case 'g':	 // 1 string to match.
        if (memcmp(Name.data()+5, "lobal_size", 10) != 0)
          break;
        return std::make_pair(728, 1);	 // "get_global_size"
      case 'i':	 // 2 strings to match.
        if (memcmp(Name.data()+5, "mage_", 5) != 0)
          break;
        switch (Name[10]) {
        default: break;
        case 'd':	 // 1 string to match.
          if (memcmp(Name.data()+11, "epth", 4) != 0)
            break;
          return std::make_pair(1812, 3);	 // "get_image_depth"
        case 'w':	 // 1 string to match.
          if (memcmp(Name.data()+11, "idth", 4) != 0)
            break;
          return std::make_pair(1749, 36);	 // "get_image_width"
        }
        break;
      }
      break;
    case 'v':	 // 4 strings to match.
      if (memcmp(Name.data()+1, "store_half_rt", 13) != 0)
        break;
      switch (Name[14]) {
      default: break;
      case 'e':	 // 1 string to match.
        return std::make_pair(1438, 8);	 // "vstore_half_rte"
      case 'n':	 // 1 string to match.
        return std::make_pair(1438, 8);	 // "vstore_half_rtn"
      case 'p':	 // 1 string to match.
        return std::make_pair(1438, 8);	 // "vstore_half_rtp"
      case 'z':	 // 1 string to match.
        return std::make_pair(1438, 8);	 // "vstore_half_rtz"
      }
      break;
    }
    break;
  case 16:	 // 59 strings to match.
    switch (Name[0]) {
    default: break;
    case 'c':	 // 42 strings to match.
      if (memcmp(Name.data()+1, "onvert_", 7) != 0)
        break;
      switch (Name[8]) {
      default: break;
      case 'c':	 // 5 strings to match.
        if (memcmp(Name.data()+9, "har_", 4) != 0)
          break;
        switch (Name[13]) {
        default: break;
        case 'r':	 // 4 strings to match.
          if (Name[14] != 't')
            break;
          switch (Name[15]) {
          default: break;
          case 'e':	 // 1 string to match.
            return std::make_pair(199, 11);	 // "convert_char_rte"
          case 'n':	 // 1 string to match.
            return std::make_pair(199, 11);	 // "convert_char_rtn"
          case 'p':	 // 1 string to match.
            return std::make_pair(199, 11);	 // "convert_char_rtp"
          case 'z':	 // 1 string to match.
            return std::make_pair(199, 11);	 // "convert_char_rtz"
          }
          break;
        case 's':	 // 1 string to match.
          if (memcmp(Name.data()+14, "at", 2) != 0)
            break;
          return std::make_pair(199, 11);	 // "convert_char_sat"
        }
        break;
      case 'd':	 // 1 string to match.
        if (memcmp(Name.data()+9, "ouble16", 7) != 0)
          break;
        return std::make_pair(45, 11);	 // "convert_double16"
      case 'h':	 // 5 strings to match.
        if (memcmp(Name.data()+9, "alf_", 4) != 0)
          break;
        switch (Name[13]) {
        default: break;
        case 'r':	 // 4 strings to match.
          if (Name[14] != 't')
            break;
          switch (Name[15]) {
          default: break;
          case 'e':	 // 1 string to match.
            return std::make_pair(133, 11);	 // "convert_half_rte"
          case 'n':	 // 1 string to match.
            return std::make_pair(133, 11);	 // "convert_half_rtn"
          case 'p':	 // 1 string to match.
            return std::make_pair(133, 11);	 // "convert_half_rtp"
          case 'z':	 // 1 string to match.
            return std::make_pair(133, 11);	 // "convert_half_rtz"
          }
          break;
        case 's':	 // 1 string to match.
          if (memcmp(Name.data()+14, "at", 2) != 0)
            break;
          return std::make_pair(133, 11);	 // "convert_half_sat"
        }
        break;
      case 'i':	 // 20 strings to match.
        if (memcmp(Name.data()+9, "nt", 2) != 0)
          break;
        switch (Name[11]) {
        default: break;
        case '2':	 // 5 strings to match.
          if (Name[12] != '_')
            break;
          switch (Name[13]) {
          default: break;
          case 'r':	 // 4 strings to match.
            if (Name[14] != 't')
              break;
            switch (Name[15]) {
            default: break;
            case 'e':	 // 1 string to match.
              return std::make_pair(474, 11);	 // "convert_int2_rte"
            case 'n':	 // 1 string to match.
              return std::make_pair(474, 11);	 // "convert_int2_rtn"
            case 'p':	 // 1 string to match.
              return std::make_pair(474, 11);	 // "convert_int2_rtp"
            case 'z':	 // 1 string to match.
              return std::make_pair(474, 11);	 // "convert_int2_rtz"
            }
            break;
          case 's':	 // 1 string to match.
            if (memcmp(Name.data()+14, "at", 2) != 0)
              break;
            return std::make_pair(474, 11);	 // "convert_int2_sat"
          }
          break;
        case '3':	 // 5 strings to match.
          if (Name[12] != '_')
            break;
          switch (Name[13]) {
          default: break;
          case 'r':	 // 4 strings to match.
            if (Name[14] != 't')
              break;
            switch (Name[15]) {
            default: break;
            case 'e':	 // 1 string to match.
              return std::make_pair(485, 11);	 // "convert_int3_rte"
            case 'n':	 // 1 string to match.
              return std::make_pair(485, 11);	 // "convert_int3_rtn"
            case 'p':	 // 1 string to match.
              return std::make_pair(485, 11);	 // "convert_int3_rtp"
            case 'z':	 // 1 string to match.
              return std::make_pair(485, 11);	 // "convert_int3_rtz"
            }
            break;
          case 's':	 // 1 string to match.
            if (memcmp(Name.data()+14, "at", 2) != 0)
              break;
            return std::make_pair(485, 11);	 // "convert_int3_sat"
          }
          break;
        case '4':	 // 5 strings to match.
          if (Name[12] != '_')
            break;
          switch (Name[13]) {
          default: break;
          case 'r':	 // 4 strings to match.
            if (Name[14] != 't')
              break;
            switch (Name[15]) {
            default: break;
            case 'e':	 // 1 string to match.
              return std::make_pair(496, 11);	 // "convert_int4_rte"
            case 'n':	 // 1 string to match.
              return std::make_pair(496, 11);	 // "convert_int4_rtn"
            case 'p':	 // 1 string to match.
              return std::make_pair(496, 11);	 // "convert_int4_rtp"
            case 'z':	 // 1 string to match.
              return std::make_pair(496, 11);	 // "convert_int4_rtz"
            }
            break;
          case 's':	 // 1 string to match.
            if (memcmp(Name.data()+14, "at", 2) != 0)
              break;
            return std::make_pair(496, 11);	 // "convert_int4_sat"
          }
          break;
        case '8':	 // 5 strings to match.
          if (Name[12] != '_')
            break;
          switch (Name[13]) {
          default: break;
          case 'r':	 // 4 strings to match.
            if (Name[14] != 't')
              break;
            switch (Name[15]) {
            default: break;
            case 'e':	 // 1 string to match.
              return std::make_pair(507, 11);	 // "convert_int8_rte"
            case 'n':	 // 1 string to match.
              return std::make_pair(507, 11);	 // "convert_int8_rtn"
            case 'p':	 // 1 string to match.
              return std::make_pair(507, 11);	 // "convert_int8_rtp"
            case 'z':	 // 1 string to match.
              return std::make_pair(507, 11);	 // "convert_int8_rtz"
            }
            break;
          case 's':	 // 1 string to match.
            if (memcmp(Name.data()+14, "at", 2) != 0)
              break;
            return std::make_pair(507, 11);	 // "convert_int8_sat"
          }
          break;
        }
        break;
      case 'l':	 // 5 strings to match.
        if (memcmp(Name.data()+9, "ong_", 4) != 0)
          break;
        switch (Name[13]) {
        default: break;
        case 'r':	 // 4 strings to match.
          if (Name[14] != 't')
            break;
          switch (Name[15]) {
          default: break;
          case 'e':	 // 1 string to match.
            return std::make_pair(595, 11);	 // "convert_long_rte"
          case 'n':	 // 1 string to match.
            return std::make_pair(595, 11);	 // "convert_long_rtn"
          case 'p':	 // 1 string to match.
            return std::make_pair(595, 11);	 // "convert_long_rtp"
          case 'z':	 // 1 string to match.
            return std::make_pair(595, 11);	 // "convert_long_rtz"
          }
          break;
        case 's':	 // 1 string to match.
          if (memcmp(Name.data()+14, "at", 2) != 0)
            break;
          return std::make_pair(595, 11);	 // "convert_long_sat"
        }
        break;
      case 'u':	 // 6 strings to match.
        switch (Name[9]) {
        default: break;
        case 'i':	 // 5 strings to match.
          if (memcmp(Name.data()+10, "nt_", 3) != 0)
            break;
          switch (Name[13]) {
          default: break;
          case 'r':	 // 4 strings to match.
            if (Name[14] != 't')
              break;
            switch (Name[15]) {
            default: break;
            case 'e':	 // 1 string to match.
              return std::make_pair(529, 11);	 // "convert_uint_rte"
            case 'n':	 // 1 string to match.
              return std::make_pair(529, 11);	 // "convert_uint_rtn"
            case 'p':	 // 1 string to match.
              return std::make_pair(529, 11);	 // "convert_uint_rtp"
            case 'z':	 // 1 string to match.
              return std::make_pair(529, 11);	 // "convert_uint_rtz"
            }
            break;
          case 's':	 // 1 string to match.
            if (memcmp(Name.data()+14, "at", 2) != 0)
              break;
            return std::make_pair(529, 11);	 // "convert_uint_sat"
          }
          break;
        case 's':	 // 1 string to match.
          if (memcmp(Name.data()+10, "hort16", 6) != 0)
            break;
          return std::make_pair(452, 11);	 // "convert_ushort16"
        }
        break;
      }
      break;
    case 'g':	 // 1 string to match.
      if (memcmp(Name.data()+1, "et_image_height", 15) != 0)
        break;
      return std::make_pair(1785, 27);	 // "get_image_height"
    case 'v':	 // 16 strings to match.
      if (memcmp(Name.data()+1, "store_half", 10) != 0)
        break;
      switch (Name[11]) {
      default: break;
      case '2':	 // 4 strings to match.
        if (memcmp(Name.data()+12, "_rt", 3) != 0)
          break;
        switch (Name[15]) {
        default: break;
        case 'e':	 // 1 string to match.
          return std::make_pair(1446, 8);	 // "vstore_half2_rte"
        case 'n':	 // 1 string to match.
          return std::make_pair(1446, 8);	 // "vstore_half2_rtn"
        case 'p':	 // 1 string to match.
          return std::make_pair(1446, 8);	 // "vstore_half2_rtp"
        case 'z':	 // 1 string to match.
          return std::make_pair(1446, 8);	 // "vstore_half2_rtz"
        }
        break;
      case '3':	 // 4 strings to match.
        if (memcmp(Name.data()+12, "_rt", 3) != 0)
          break;
        switch (Name[15]) {
        default: break;
        case 'e':	 // 1 string to match.
          return std::make_pair(1454, 8);	 // "vstore_half3_rte"
        case 'n':	 // 1 string to match.
          return std::make_pair(1454, 8);	 // "vstore_half3_rtn"
        case 'p':	 // 1 string to match.
          return std::make_pair(1454, 8);	 // "vstore_half3_rtp"
        case 'z':	 // 1 string to match.
          return std::make_pair(1454, 8);	 // "vstore_half3_rtz"
        }
        break;
      case '4':	 // 4 strings to match.
        if (memcmp(Name.data()+12, "_rt", 3) != 0)
          break;
        switch (Name[15]) {
        default: break;
        case 'e':	 // 1 string to match.
          return std::make_pair(1462, 8);	 // "vstore_half4_rte"
        case 'n':	 // 1 string to match.
          return std::make_pair(1462, 8);	 // "vstore_half4_rtn"
        case 'p':	 // 1 string to match.
          return std::make_pair(1462, 8);	 // "vstore_half4_rtp"
        case 'z':	 // 1 string to match.
          return std::make_pair(1462, 8);	 // "vstore_half4_rtz"
        }
        break;
      case '8':	 // 4 strings to match.
        if (memcmp(Name.data()+12, "_rt", 3) != 0)
          break;
        switch (Name[15]) {
        default: break;
        case 'e':	 // 1 string to match.
          return std::make_pair(1470, 8);	 // "vstore_half8_rte"
        case 'n':	 // 1 string to match.
          return std::make_pair(1470, 8);	 // "vstore_half8_rtn"
        case 'p':	 // 1 string to match.
          return std::make_pair(1470, 8);	 // "vstore_half8_rtp"
        case 'z':	 // 1 string to match.
          return std::make_pair(1470, 8);	 // "vstore_half8_rtz"
        }
        break;
      }
      break;
    }
    break;
  case 17:	 // 127 strings to match.
    switch (Name[0]) {
    default: break;
    case 'c':	 // 105 strings to match.
      if (memcmp(Name.data()+1, "onvert_", 7) != 0)
        break;
      switch (Name[8]) {
      default: break;
      case 'c':	 // 20 strings to match.
        if (memcmp(Name.data()+9, "har", 3) != 0)
          break;
        switch (Name[12]) {
        default: break;
        case '2':	 // 5 strings to match.
          if (Name[13] != '_')
            break;
          switch (Name[14]) {
          default: break;
          case 'r':	 // 4 strings to match.
            if (Name[15] != 't')
              break;
            switch (Name[16]) {
            default: break;
            case 'e':	 // 1 string to match.
              return std::make_pair(210, 11);	 // "convert_char2_rte"
            case 'n':	 // 1 string to match.
              return std::make_pair(210, 11);	 // "convert_char2_rtn"
            case 'p':	 // 1 string to match.
              return std::make_pair(210, 11);	 // "convert_char2_rtp"
            case 'z':	 // 1 string to match.
              return std::make_pair(210, 11);	 // "convert_char2_rtz"
            }
            break;
          case 's':	 // 1 string to match.
            if (memcmp(Name.data()+15, "at", 2) != 0)
              break;
            return std::make_pair(210, 11);	 // "convert_char2_sat"
          }
          break;
        case '3':	 // 5 strings to match.
          if (Name[13] != '_')
            break;
          switch (Name[14]) {
          default: break;
          case 'r':	 // 4 strings to match.
            if (Name[15] != 't')
              break;
            switch (Name[16]) {
            default: break;
            case 'e':	 // 1 string to match.
              return std::make_pair(221, 11);	 // "convert_char3_rte"
            case 'n':	 // 1 string to match.
              return std::make_pair(221, 11);	 // "convert_char3_rtn"
            case 'p':	 // 1 string to match.
              return std::make_pair(221, 11);	 // "convert_char3_rtp"
            case 'z':	 // 1 string to match.
              return std::make_pair(221, 11);	 // "convert_char3_rtz"
            }
            break;
          case 's':	 // 1 string to match.
            if (memcmp(Name.data()+15, "at", 2) != 0)
              break;
            return std::make_pair(221, 11);	 // "convert_char3_sat"
          }
          break;
        case '4':	 // 5 strings to match.
          if (Name[13] != '_')
            break;
          switch (Name[14]) {
          default: break;
          case 'r':	 // 4 strings to match.
            if (Name[15] != 't')
              break;
            switch (Name[16]) {
            default: break;
            case 'e':	 // 1 string to match.
              return std::make_pair(232, 11);	 // "convert_char4_rte"
            case 'n':	 // 1 string to match.
              return std::make_pair(232, 11);	 // "convert_char4_rtn"
            case 'p':	 // 1 string to match.
              return std::make_pair(232, 11);	 // "convert_char4_rtp"
            case 'z':	 // 1 string to match.
              return std::make_pair(232, 11);	 // "convert_char4_rtz"
            }
            break;
          case 's':	 // 1 string to match.
            if (memcmp(Name.data()+15, "at", 2) != 0)
              break;
            return std::make_pair(232, 11);	 // "convert_char4_sat"
          }
          break;
        case '8':	 // 5 strings to match.
          if (Name[13] != '_')
            break;
          switch (Name[14]) {
          default: break;
          case 'r':	 // 4 strings to match.
            if (Name[15] != 't')
              break;
            switch (Name[16]) {
            default: break;
            case 'e':	 // 1 string to match.
              return std::make_pair(243, 11);	 // "convert_char8_rte"
            case 'n':	 // 1 string to match.
              return std::make_pair(243, 11);	 // "convert_char8_rtn"
            case 'p':	 // 1 string to match.
              return std::make_pair(243, 11);	 // "convert_char8_rtp"
            case 'z':	 // 1 string to match.
              return std::make_pair(243, 11);	 // "convert_char8_rtz"
            }
            break;
          case 's':	 // 1 string to match.
            if (memcmp(Name.data()+15, "at", 2) != 0)
              break;
            return std::make_pair(243, 11);	 // "convert_char8_sat"
          }
          break;
        }
        break;
      case 'f':	 // 5 strings to match.
        if (memcmp(Name.data()+9, "loat_", 5) != 0)
          break;
        switch (Name[14]) {
        default: break;
        case 'r':	 // 4 strings to match.
          if (Name[15] != 't')
            break;
          switch (Name[16]) {
          default: break;
          case 'e':	 // 1 string to match.
            return std::make_pair(89, 11);	 // "convert_float_rte"
          case 'n':	 // 1 string to match.
            return std::make_pair(89, 11);	 // "convert_float_rtn"
          case 'p':	 // 1 string to match.
            return std::make_pair(89, 11);	 // "convert_float_rtp"
          case 'z':	 // 1 string to match.
            return std::make_pair(89, 11);	 // "convert_float_rtz"
          }
          break;
        case 's':	 // 1 string to match.
          if (memcmp(Name.data()+15, "at", 2) != 0)
            break;
          return std::make_pair(89, 11);	 // "convert_float_sat"
        }
        break;
      case 'h':	 // 20 strings to match.
        if (memcmp(Name.data()+9, "alf", 3) != 0)
          break;
        switch (Name[12]) {
        default: break;
        case '2':	 // 5 strings to match.
          if (Name[13] != '_')
            break;
          switch (Name[14]) {
          default: break;
          case 'r':	 // 4 strings to match.
            if (Name[15] != 't')
              break;
            switch (Name[16]) {
            default: break;
            case 'e':	 // 1 string to match.
              return std::make_pair(144, 11);	 // "convert_half2_rte"
            case 'n':	 // 1 string to match.
              return std::make_pair(144, 11);	 // "convert_half2_rtn"
            case 'p':	 // 1 string to match.
              return std::make_pair(144, 11);	 // "convert_half2_rtp"
            case 'z':	 // 1 string to match.
              return std::make_pair(144, 11);	 // "convert_half2_rtz"
            }
            break;
          case 's':	 // 1 string to match.
            if (memcmp(Name.data()+15, "at", 2) != 0)
              break;
            return std::make_pair(144, 11);	 // "convert_half2_sat"
          }
          break;
        case '3':	 // 5 strings to match.
          if (Name[13] != '_')
            break;
          switch (Name[14]) {
          default: break;
          case 'r':	 // 4 strings to match.
            if (Name[15] != 't')
              break;
            switch (Name[16]) {
            default: break;
            case 'e':	 // 1 string to match.
              return std::make_pair(155, 11);	 // "convert_half3_rte"
            case 'n':	 // 1 string to match.
              return std::make_pair(155, 11);	 // "convert_half3_rtn"
            case 'p':	 // 1 string to match.
              return std::make_pair(155, 11);	 // "convert_half3_rtp"
            case 'z':	 // 1 string to match.
              return std::make_pair(155, 11);	 // "convert_half3_rtz"
            }
            break;
          case 's':	 // 1 string to match.
            if (memcmp(Name.data()+15, "at", 2) != 0)
              break;
            return std::make_pair(155, 11);	 // "convert_half3_sat"
          }
          break;
        case '4':	 // 5 strings to match.
          if (Name[13] != '_')
            break;
          switch (Name[14]) {
          default: break;
          case 'r':	 // 4 strings to match.
            if (Name[15] != 't')
              break;
            switch (Name[16]) {
            default: break;
            case 'e':	 // 1 string to match.
              return std::make_pair(166, 11);	 // "convert_half4_rte"
            case 'n':	 // 1 string to match.
              return std::make_pair(166, 11);	 // "convert_half4_rtn"
            case 'p':	 // 1 string to match.
              return std::make_pair(166, 11);	 // "convert_half4_rtp"
            case 'z':	 // 1 string to match.
              return std::make_pair(166, 11);	 // "convert_half4_rtz"
            }
            break;
          case 's':	 // 1 string to match.
            if (memcmp(Name.data()+15, "at", 2) != 0)
              break;
            return std::make_pair(166, 11);	 // "convert_half4_sat"
          }
          break;
        case '8':	 // 5 strings to match.
          if (Name[13] != '_')
            break;
          switch (Name[14]) {
          default: break;
          case 'r':	 // 4 strings to match.
            if (Name[15] != 't')
              break;
            switch (Name[16]) {
            default: break;
            case 'e':	 // 1 string to match.
              return std::make_pair(177, 11);	 // "convert_half8_rte"
            case 'n':	 // 1 string to match.
              return std::make_pair(177, 11);	 // "convert_half8_rtn"
            case 'p':	 // 1 string to match.
              return std::make_pair(177, 11);	 // "convert_half8_rtp"
            case 'z':	 // 1 string to match.
              return std::make_pair(177, 11);	 // "convert_half8_rtz"
            }
            break;
          case 's':	 // 1 string to match.
            if (memcmp(Name.data()+15, "at", 2) != 0)
              break;
            return std::make_pair(177, 11);	 // "convert_half8_sat"
          }
          break;
        }
        break;
      case 'i':	 // 5 strings to match.
        if (memcmp(Name.data()+9, "nt16_", 5) != 0)
          break;
        switch (Name[14]) {
        default: break;
        case 'r':	 // 4 strings to match.
          if (Name[15] != 't')
            break;
          switch (Name[16]) {
          default: break;
          case 'e':	 // 1 string to match.
            return std::make_pair(518, 11);	 // "convert_int16_rte"
          case 'n':	 // 1 string to match.
            return std::make_pair(518, 11);	 // "convert_int16_rtn"
          case 'p':	 // 1 string to match.
            return std::make_pair(518, 11);	 // "convert_int16_rtp"
          case 'z':	 // 1 string to match.
            return std::make_pair(518, 11);	 // "convert_int16_rtz"
          }
          break;
        case 's':	 // 1 string to match.
          if (memcmp(Name.data()+15, "at", 2) != 0)
            break;
          return std::make_pair(518, 11);	 // "convert_int16_sat"
        }
        break;
      case 'l':	 // 20 strings to match.
        if (memcmp(Name.data()+9, "ong", 3) != 0)
          break;
        switch (Name[12]) {
        default: break;
        case '2':	 // 5 strings to match.
          if (Name[13] != '_')
            break;
          switch (Name[14]) {
          default: break;
          case 'r':	 // 4 strings to match.
            if (Name[15] != 't')
              break;
            switch (Name[16]) {
            default: break;
            case 'e':	 // 1 string to match.
              return std::make_pair(606, 11);	 // "convert_long2_rte"
            case 'n':	 // 1 string to match.
              return std::make_pair(606, 11);	 // "convert_long2_rtn"
            case 'p':	 // 1 string to match.
              return std::make_pair(606, 11);	 // "convert_long2_rtp"
            case 'z':	 // 1 string to match.
              return std::make_pair(606, 11);	 // "convert_long2_rtz"
            }
            break;
          case 's':	 // 1 string to match.
            if (memcmp(Name.data()+15, "at", 2) != 0)
              break;
            return std::make_pair(606, 11);	 // "convert_long2_sat"
          }
          break;
        case '3':	 // 5 strings to match.
          if (Name[13] != '_')
            break;
          switch (Name[14]) {
          default: break;
          case 'r':	 // 4 strings to match.
            if (Name[15] != 't')
              break;
            switch (Name[16]) {
            default: break;
            case 'e':	 // 1 string to match.
              return std::make_pair(617, 11);	 // "convert_long3_rte"
            case 'n':	 // 1 string to match.
              return std::make_pair(617, 11);	 // "convert_long3_rtn"
            case 'p':	 // 1 string to match.
              return std::make_pair(617, 11);	 // "convert_long3_rtp"
            case 'z':	 // 1 string to match.
              return std::make_pair(617, 11);	 // "convert_long3_rtz"
            }
            break;
          case 's':	 // 1 string to match.
            if (memcmp(Name.data()+15, "at", 2) != 0)
              break;
            return std::make_pair(617, 11);	 // "convert_long3_sat"
          }
          break;
        case '4':	 // 5 strings to match.
          if (Name[13] != '_')
            break;
          switch (Name[14]) {
          default: break;
          case 'r':	 // 4 strings to match.
            if (Name[15] != 't')
              break;
            switch (Name[16]) {
            default: break;
            case 'e':	 // 1 string to match.
              return std::make_pair(628, 11);	 // "convert_long4_rte"
            case 'n':	 // 1 string to match.
              return std::make_pair(628, 11);	 // "convert_long4_rtn"
            case 'p':	 // 1 string to match.
              return std::make_pair(628, 11);	 // "convert_long4_rtp"
            case 'z':	 // 1 string to match.
              return std::make_pair(628, 11);	 // "convert_long4_rtz"
            }
            break;
          case 's':	 // 1 string to match.
            if (memcmp(Name.data()+15, "at", 2) != 0)
              break;
            return std::make_pair(628, 11);	 // "convert_long4_sat"
          }
          break;
        case '8':	 // 5 strings to match.
          if (Name[13] != '_')
            break;
          switch (Name[14]) {
          default: break;
          case 'r':	 // 4 strings to match.
            if (Name[15] != 't')
              break;
            switch (Name[16]) {
            default: break;
            case 'e':	 // 1 string to match.
              return std::make_pair(639, 11);	 // "convert_long8_rte"
            case 'n':	 // 1 string to match.
              return std::make_pair(639, 11);	 // "convert_long8_rtn"
            case 'p':	 // 1 string to match.
              return std::make_pair(639, 11);	 // "convert_long8_rtp"
            case 'z':	 // 1 string to match.
              return std::make_pair(639, 11);	 // "convert_long8_rtz"
            }
            break;
          case 's':	 // 1 string to match.
            if (memcmp(Name.data()+15, "at", 2) != 0)
              break;
            return std::make_pair(639, 11);	 // "convert_long8_sat"
          }
          break;
        }
        break;
      case 's':	 // 5 strings to match.
        if (memcmp(Name.data()+9, "hort_", 5) != 0)
          break;
        switch (Name[14]) {
        default: break;
        case 'r':	 // 4 strings to match.
          if (Name[15] != 't')
            break;
          switch (Name[16]) {
          default: break;
          case 'e':	 // 1 string to match.
            return std::make_pair(331, 11);	 // "convert_short_rte"
          case 'n':	 // 1 string to match.
            return std::make_pair(331, 11);	 // "convert_short_rtn"
          case 'p':	 // 1 string to match.
            return std::make_pair(331, 11);	 // "convert_short_rtp"
          case 'z':	 // 1 string to match.
            return std::make_pair(331, 11);	 // "convert_short_rtz"
          }
          break;
        case 's':	 // 1 string to match.
          if (memcmp(Name.data()+15, "at", 2) != 0)
            break;
          return std::make_pair(331, 11);	 // "convert_short_sat"
        }
        break;
      case 'u':	 // 30 strings to match.
        switch (Name[9]) {
        default: break;
        case 'c':	 // 5 strings to match.
          if (memcmp(Name.data()+10, "har_", 4) != 0)
            break;
          switch (Name[14]) {
          default: break;
          case 'r':	 // 4 strings to match.
            if (Name[15] != 't')
              break;
            switch (Name[16]) {
            default: break;
            case 'e':	 // 1 string to match.
              return std::make_pair(265, 11);	 // "convert_uchar_rte"
            case 'n':	 // 1 string to match.
              return std::make_pair(265, 11);	 // "convert_uchar_rtn"
            case 'p':	 // 1 string to match.
              return std::make_pair(265, 11);	 // "convert_uchar_rtp"
            case 'z':	 // 1 string to match.
              return std::make_pair(265, 11);	 // "convert_uchar_rtz"
            }
            break;
          case 's':	 // 1 string to match.
            if (memcmp(Name.data()+15, "at", 2) != 0)
              break;
            return std::make_pair(265, 11);	 // "convert_uchar_sat"
          }
          break;
        case 'i':	 // 20 strings to match.
          if (memcmp(Name.data()+10, "nt", 2) != 0)
            break;
          switch (Name[12]) {
          default: break;
          case '2':	 // 5 strings to match.
            if (Name[13] != '_')
              break;
            switch (Name[14]) {
            default: break;
            case 'r':	 // 4 strings to match.
              if (Name[15] != 't')
                break;
              switch (Name[16]) {
              default: break;
              case 'e':	 // 1 string to match.
                return std::make_pair(540, 11);	 // "convert_uint2_rte"
              case 'n':	 // 1 string to match.
                return std::make_pair(540, 11);	 // "convert_uint2_rtn"
              case 'p':	 // 1 string to match.
                return std::make_pair(540, 11);	 // "convert_uint2_rtp"
              case 'z':	 // 1 string to match.
                return std::make_pair(540, 11);	 // "convert_uint2_rtz"
              }
              break;
            case 's':	 // 1 string to match.
              if (memcmp(Name.data()+15, "at", 2) != 0)
                break;
              return std::make_pair(540, 11);	 // "convert_uint2_sat"
            }
            break;
          case '3':	 // 5 strings to match.
            if (Name[13] != '_')
              break;
            switch (Name[14]) {
            default: break;
            case 'r':	 // 4 strings to match.
              if (Name[15] != 't')
                break;
              switch (Name[16]) {
              default: break;
              case 'e':	 // 1 string to match.
                return std::make_pair(551, 11);	 // "convert_uint3_rte"
              case 'n':	 // 1 string to match.
                return std::make_pair(551, 11);	 // "convert_uint3_rtn"
              case 'p':	 // 1 string to match.
                return std::make_pair(551, 11);	 // "convert_uint3_rtp"
              case 'z':	 // 1 string to match.
                return std::make_pair(551, 11);	 // "convert_uint3_rtz"
              }
              break;
            case 's':	 // 1 string to match.
              if (memcmp(Name.data()+15, "at", 2) != 0)
                break;
              return std::make_pair(551, 11);	 // "convert_uint3_sat"
            }
            break;
          case '4':	 // 5 strings to match.
            if (Name[13] != '_')
              break;
            switch (Name[14]) {
            default: break;
            case 'r':	 // 4 strings to match.
              if (Name[15] != 't')
                break;
              switch (Name[16]) {
              default: break;
              case 'e':	 // 1 string to match.
                return std::make_pair(562, 11);	 // "convert_uint4_rte"
              case 'n':	 // 1 string to match.
                return std::make_pair(562, 11);	 // "convert_uint4_rtn"
              case 'p':	 // 1 string to match.
                return std::make_pair(562, 11);	 // "convert_uint4_rtp"
              case 'z':	 // 1 string to match.
                return std::make_pair(562, 11);	 // "convert_uint4_rtz"
              }
              break;
            case 's':	 // 1 string to match.
              if (memcmp(Name.data()+15, "at", 2) != 0)
                break;
              return std::make_pair(562, 11);	 // "convert_uint4_sat"
            }
            break;
          case '8':	 // 5 strings to match.
            if (Name[13] != '_')
              break;
            switch (Name[14]) {
            default: break;
            case 'r':	 // 4 strings to match.
              if (Name[15] != 't')
                break;
              switch (Name[16]) {
              default: break;
              case 'e':	 // 1 string to match.
                return std::make_pair(573, 11);	 // "convert_uint8_rte"
              case 'n':	 // 1 string to match.
                return std::make_pair(573, 11);	 // "convert_uint8_rtn"
              case 'p':	 // 1 string to match.
                return std::make_pair(573, 11);	 // "convert_uint8_rtp"
              case 'z':	 // 1 string to match.
                return std::make_pair(573, 11);	 // "convert_uint8_rtz"
              }
              break;
            case 's':	 // 1 string to match.
              if (memcmp(Name.data()+15, "at", 2) != 0)
                break;
              return std::make_pair(573, 11);	 // "convert_uint8_sat"
            }
            break;
          }
          break;
        case 'l':	 // 5 strings to match.
          if (memcmp(Name.data()+10, "ong_", 4) != 0)
            break;
          switch (Name[14]) {
          default: break;
          case 'r':	 // 4 strings to match.
            if (Name[15] != 't')
              break;
            switch (Name[16]) {
            default: break;
            case 'e':	 // 1 string to match.
              return std::make_pair(661, 11);	 // "convert_ulong_rte"
            case 'n':	 // 1 string to match.
              return std::make_pair(661, 11);	 // "convert_ulong_rtn"
            case 'p':	 // 1 string to match.
              return std::make_pair(661, 11);	 // "convert_ulong_rtp"
            case 'z':	 // 1 string to match.
              return std::make_pair(661, 11);	 // "convert_ulong_rtz"
            }
            break;
          case 's':	 // 1 string to match.
            if (memcmp(Name.data()+15, "at", 2) != 0)
              break;
            return std::make_pair(661, 11);	 // "convert_ulong_sat"
          }
          break;
        }
        break;
      }
      break;
    case 'g':	 // 1 string to match.
      if (memcmp(Name.data()+1, "et_global_offset", 16) != 0)
        break;
      return std::make_pair(728, 1);	 // "get_global_offset"
    case 'v':	 // 20 strings to match.
      if (memcmp(Name.data()+1, "store", 5) != 0)
        break;
      switch (Name[6]) {
      default: break;
      case '_':	 // 4 strings to match.
        if (memcmp(Name.data()+7, "half16_rt", 9) != 0)
          break;
        switch (Name[16]) {
        default: break;
        case 'e':	 // 1 string to match.
          return std::make_pair(1478, 8);	 // "vstore_half16_rte"
        case 'n':	 // 1 string to match.
          return std::make_pair(1478, 8);	 // "vstore_half16_rtn"
        case 'p':	 // 1 string to match.
          return std::make_pair(1478, 8);	 // "vstore_half16_rtp"
        case 'z':	 // 1 string to match.
          return std::make_pair(1478, 8);	 // "vstore_half16_rtz"
        }
        break;
      case 'a':	 // 16 strings to match.
        if (memcmp(Name.data()+7, "_half", 5) != 0)
          break;
        switch (Name[12]) {
        default: break;
        case '2':	 // 4 strings to match.
          if (memcmp(Name.data()+13, "_rt", 3) != 0)
            break;
          switch (Name[16]) {
          default: break;
          case 'e':	 // 1 string to match.
            return std::make_pair(967, 10);	 // "vstorea_half2_rte"
          case 'n':	 // 1 string to match.
            return std::make_pair(967, 10);	 // "vstorea_half2_rtn"
          case 'p':	 // 1 string to match.
            return std::make_pair(967, 10);	 // "vstorea_half2_rtp"
          case 'z':	 // 1 string to match.
            return std::make_pair(967, 10);	 // "vstorea_half2_rtz"
          }
          break;
        case '3':	 // 4 strings to match.
          if (memcmp(Name.data()+13, "_rt", 3) != 0)
            break;
          switch (Name[16]) {
          default: break;
          case 'e':	 // 1 string to match.
            return std::make_pair(1081, 10);	 // "vstorea_half3_rte"
          case 'n':	 // 1 string to match.
            return std::make_pair(1081, 10);	 // "vstorea_half3_rtn"
          case 'p':	 // 1 string to match.
            return std::make_pair(1081, 10);	 // "vstorea_half3_rtp"
          case 'z':	 // 1 string to match.
            return std::make_pair(1081, 10);	 // "vstorea_half3_rtz"
          }
          break;
        case '4':	 // 4 strings to match.
          if (memcmp(Name.data()+13, "_rt", 3) != 0)
            break;
          switch (Name[16]) {
          default: break;
          case 'e':	 // 1 string to match.
            return std::make_pair(1195, 10);	 // "vstorea_half4_rte"
          case 'n':	 // 1 string to match.
            return std::make_pair(1195, 10);	 // "vstorea_half4_rtn"
          case 'p':	 // 1 string to match.
            return std::make_pair(1195, 10);	 // "vstorea_half4_rtp"
          case 'z':	 // 1 string to match.
            return std::make_pair(1195, 10);	 // "vstorea_half4_rtz"
          }
          break;
        case '8':	 // 4 strings to match.
          if (memcmp(Name.data()+13, "_rt", 3) != 0)
            break;
          switch (Name[16]) {
          default: break;
          case 'e':	 // 1 string to match.
            return std::make_pair(1309, 10);	 // "vstorea_half8_rte"
          case 'n':	 // 1 string to match.
            return std::make_pair(1309, 10);	 // "vstorea_half8_rtn"
          case 'p':	 // 1 string to match.
            return std::make_pair(1309, 10);	 // "vstorea_half8_rtp"
          case 'z':	 // 1 string to match.
            return std::make_pair(1309, 10);	 // "vstorea_half8_rtz"
          }
          break;
        }
        break;
      }
      break;
    case 'w':	 // 1 string to match.
      if (memcmp(Name.data()+1, "ait_group_events", 16) != 0)
        break;
      return std::make_pair(1490, 1);	 // "wait_group_events"
    }
    break;
  case 18:	 // 116 strings to match.
    switch (Name[0]) {
    default: break;
    case 'c':	 // 110 strings to match.
      if (memcmp(Name.data()+1, "onvert_", 7) != 0)
        break;
      switch (Name[8]) {
      default: break;
      case 'c':	 // 5 strings to match.
        if (memcmp(Name.data()+9, "har16_", 6) != 0)
          break;
        switch (Name[15]) {
        default: break;
        case 'r':	 // 4 strings to match.
          if (Name[16] != 't')
            break;
          switch (Name[17]) {
          default: break;
          case 'e':	 // 1 string to match.
            return std::make_pair(254, 11);	 // "convert_char16_rte"
          case 'n':	 // 1 string to match.
            return std::make_pair(254, 11);	 // "convert_char16_rtn"
          case 'p':	 // 1 string to match.
            return std::make_pair(254, 11);	 // "convert_char16_rtp"
          case 'z':	 // 1 string to match.
            return std::make_pair(254, 11);	 // "convert_char16_rtz"
          }
          break;
        case 's':	 // 1 string to match.
          if (memcmp(Name.data()+16, "at", 2) != 0)
            break;
          return std::make_pair(254, 11);	 // "convert_char16_sat"
        }
        break;
      case 'd':	 // 5 strings to match.
        if (memcmp(Name.data()+9, "ouble_", 6) != 0)
          break;
        switch (Name[15]) {
        default: break;
        case 'r':	 // 4 strings to match.
          if (Name[16] != 't')
            break;
          switch (Name[17]) {
          default: break;
          case 'e':	 // 1 string to match.
            return std::make_pair(56, 11);	 // "convert_double_rte"
          case 'n':	 // 1 string to match.
            return std::make_pair(56, 11);	 // "convert_double_rtn"
          case 'p':	 // 1 string to match.
            return std::make_pair(56, 11);	 // "convert_double_rtp"
          case 'z':	 // 1 string to match.
            return std::make_pair(56, 11);	 // "convert_double_rtz"
          }
          break;
        case 's':	 // 1 string to match.
          if (memcmp(Name.data()+16, "at", 2) != 0)
            break;
          return std::make_pair(56, 11);	 // "convert_double_sat"
        }
        break;
      case 'f':	 // 20 strings to match.
        if (memcmp(Name.data()+9, "loat", 4) != 0)
          break;
        switch (Name[13]) {
        default: break;
        case '2':	 // 5 strings to match.
          if (Name[14] != '_')
            break;
          switch (Name[15]) {
          default: break;
          case 'r':	 // 4 strings to match.
            if (Name[16] != 't')
              break;
            switch (Name[17]) {
            default: break;
            case 'e':	 // 1 string to match.
              return std::make_pair(100, 11);	 // "convert_float2_rte"
            case 'n':	 // 1 string to match.
              return std::make_pair(100, 11);	 // "convert_float2_rtn"
            case 'p':	 // 1 string to match.
              return std::make_pair(100, 11);	 // "convert_float2_rtp"
            case 'z':	 // 1 string to match.
              return std::make_pair(100, 11);	 // "convert_float2_rtz"
            }
            break;
          case 's':	 // 1 string to match.
            if (memcmp(Name.data()+16, "at", 2) != 0)
              break;
            return std::make_pair(100, 11);	 // "convert_float2_sat"
          }
          break;
        case '3':	 // 5 strings to match.
          if (Name[14] != '_')
            break;
          switch (Name[15]) {
          default: break;
          case 'r':	 // 4 strings to match.
            if (Name[16] != 't')
              break;
            switch (Name[17]) {
            default: break;
            case 'e':	 // 1 string to match.
              return std::make_pair(111, 11);	 // "convert_float3_rte"
            case 'n':	 // 1 string to match.
              return std::make_pair(111, 11);	 // "convert_float3_rtn"
            case 'p':	 // 1 string to match.
              return std::make_pair(111, 11);	 // "convert_float3_rtp"
            case 'z':	 // 1 string to match.
              return std::make_pair(111, 11);	 // "convert_float3_rtz"
            }
            break;
          case 's':	 // 1 string to match.
            if (memcmp(Name.data()+16, "at", 2) != 0)
              break;
            return std::make_pair(111, 11);	 // "convert_float3_sat"
          }
          break;
        case '4':	 // 5 strings to match.
          if (Name[14] != '_')
            break;
          switch (Name[15]) {
          default: break;
          case 'r':	 // 4 strings to match.
            if (Name[16] != 't')
              break;
            switch (Name[17]) {
            default: break;
            case 'e':	 // 1 string to match.
              return std::make_pair(122, 11);	 // "convert_float4_rte"
            case 'n':	 // 1 string to match.
              return std::make_pair(122, 11);	 // "convert_float4_rtn"
            case 'p':	 // 1 string to match.
              return std::make_pair(122, 11);	 // "convert_float4_rtp"
            case 'z':	 // 1 string to match.
              return std::make_pair(122, 11);	 // "convert_float4_rtz"
            }
            break;
          case 's':	 // 1 string to match.
            if (memcmp(Name.data()+16, "at", 2) != 0)
              break;
            return std::make_pair(122, 11);	 // "convert_float4_sat"
          }
          break;
        case '8':	 // 5 strings to match.
          if (Name[14] != '_')
            break;
          switch (Name[15]) {
          default: break;
          case 'r':	 // 4 strings to match.
            if (Name[16] != 't')
              break;
            switch (Name[17]) {
            default: break;
            case 'e':	 // 1 string to match.
              return std::make_pair(1, 11);	 // "convert_float8_rte"
            case 'n':	 // 1 string to match.
              return std::make_pair(1, 11);	 // "convert_float8_rtn"
            case 'p':	 // 1 string to match.
              return std::make_pair(1, 11);	 // "convert_float8_rtp"
            case 'z':	 // 1 string to match.
              return std::make_pair(1, 11);	 // "convert_float8_rtz"
            }
            break;
          case 's':	 // 1 string to match.
            if (memcmp(Name.data()+16, "at", 2) != 0)
              break;
            return std::make_pair(1, 11);	 // "convert_float8_sat"
          }
          break;
        }
        break;
      case 'h':	 // 5 strings to match.
        if (memcmp(Name.data()+9, "alf16_", 6) != 0)
          break;
        switch (Name[15]) {
        default: break;
        case 'r':	 // 4 strings to match.
          if (Name[16] != 't')
            break;
          switch (Name[17]) {
          default: break;
          case 'e':	 // 1 string to match.
            return std::make_pair(188, 11);	 // "convert_half16_rte"
          case 'n':	 // 1 string to match.
            return std::make_pair(188, 11);	 // "convert_half16_rtn"
          case 'p':	 // 1 string to match.
            return std::make_pair(188, 11);	 // "convert_half16_rtp"
          case 'z':	 // 1 string to match.
            return std::make_pair(188, 11);	 // "convert_half16_rtz"
          }
          break;
        case 's':	 // 1 string to match.
          if (memcmp(Name.data()+16, "at", 2) != 0)
            break;
          return std::make_pair(188, 11);	 // "convert_half16_sat"
        }
        break;
      case 'l':	 // 5 strings to match.
        if (memcmp(Name.data()+9, "ong16_", 6) != 0)
          break;
        switch (Name[15]) {
        default: break;
        case 'r':	 // 4 strings to match.
          if (Name[16] != 't')
            break;
          switch (Name[17]) {
          default: break;
          case 'e':	 // 1 string to match.
            return std::make_pair(650, 11);	 // "convert_long16_rte"
          case 'n':	 // 1 string to match.
            return std::make_pair(650, 11);	 // "convert_long16_rtn"
          case 'p':	 // 1 string to match.
            return std::make_pair(650, 11);	 // "convert_long16_rtp"
          case 'z':	 // 1 string to match.
            return std::make_pair(650, 11);	 // "convert_long16_rtz"
          }
          break;
        case 's':	 // 1 string to match.
          if (memcmp(Name.data()+16, "at", 2) != 0)
            break;
          return std::make_pair(650, 11);	 // "convert_long16_sat"
        }
        break;
      case 's':	 // 20 strings to match.
        if (memcmp(Name.data()+9, "hort", 4) != 0)
          break;
        switch (Name[13]) {
        default: break;
        case '2':	 // 5 strings to match.
          if (Name[14] != '_')
            break;
          switch (Name[15]) {
          default: break;
          case 'r':	 // 4 strings to match.
            if (Name[16] != 't')
              break;
            switch (Name[17]) {
            default: break;
            case 'e':	 // 1 string to match.
              return std::make_pair(342, 11);	 // "convert_short2_rte"
            case 'n':	 // 1 string to match.
              return std::make_pair(342, 11);	 // "convert_short2_rtn"
            case 'p':	 // 1 string to match.
              return std::make_pair(342, 11);	 // "convert_short2_rtp"
            case 'z':	 // 1 string to match.
              return std::make_pair(342, 11);	 // "convert_short2_rtz"
            }
            break;
          case 's':	 // 1 string to match.
            if (memcmp(Name.data()+16, "at", 2) != 0)
              break;
            return std::make_pair(342, 11);	 // "convert_short2_sat"
          }
          break;
        case '3':	 // 5 strings to match.
          if (Name[14] != '_')
            break;
          switch (Name[15]) {
          default: break;
          case 'r':	 // 4 strings to match.
            if (Name[16] != 't')
              break;
            switch (Name[17]) {
            default: break;
            case 'e':	 // 1 string to match.
              return std::make_pair(353, 11);	 // "convert_short3_rte"
            case 'n':	 // 1 string to match.
              return std::make_pair(353, 11);	 // "convert_short3_rtn"
            case 'p':	 // 1 string to match.
              return std::make_pair(353, 11);	 // "convert_short3_rtp"
            case 'z':	 // 1 string to match.
              return std::make_pair(353, 11);	 // "convert_short3_rtz"
            }
            break;
          case 's':	 // 1 string to match.
            if (memcmp(Name.data()+16, "at", 2) != 0)
              break;
            return std::make_pair(353, 11);	 // "convert_short3_sat"
          }
          break;
        case '4':	 // 5 strings to match.
          if (Name[14] != '_')
            break;
          switch (Name[15]) {
          default: break;
          case 'r':	 // 4 strings to match.
            if (Name[16] != 't')
              break;
            switch (Name[17]) {
            default: break;
            case 'e':	 // 1 string to match.
              return std::make_pair(364, 11);	 // "convert_short4_rte"
            case 'n':	 // 1 string to match.
              return std::make_pair(364, 11);	 // "convert_short4_rtn"
            case 'p':	 // 1 string to match.
              return std::make_pair(364, 11);	 // "convert_short4_rtp"
            case 'z':	 // 1 string to match.
              return std::make_pair(364, 11);	 // "convert_short4_rtz"
            }
            break;
          case 's':	 // 1 string to match.
            if (memcmp(Name.data()+16, "at", 2) != 0)
              break;
            return std::make_pair(364, 11);	 // "convert_short4_sat"
          }
          break;
        case '8':	 // 5 strings to match.
          if (Name[14] != '_')
            break;
          switch (Name[15]) {
          default: break;
          case 'r':	 // 4 strings to match.
            if (Name[16] != 't')
              break;
            switch (Name[17]) {
            default: break;
            case 'e':	 // 1 string to match.
              return std::make_pair(375, 11);	 // "convert_short8_rte"
            case 'n':	 // 1 string to match.
              return std::make_pair(375, 11);	 // "convert_short8_rtn"
            case 'p':	 // 1 string to match.
              return std::make_pair(375, 11);	 // "convert_short8_rtp"
            case 'z':	 // 1 string to match.
              return std::make_pair(375, 11);	 // "convert_short8_rtz"
            }
            break;
          case 's':	 // 1 string to match.
            if (memcmp(Name.data()+16, "at", 2) != 0)
              break;
            return std::make_pair(375, 11);	 // "convert_short8_sat"
          }
          break;
        }
        break;
      case 'u':	 // 50 strings to match.
        switch (Name[9]) {
        default: break;
        case 'c':	 // 20 strings to match.
          if (memcmp(Name.data()+10, "har", 3) != 0)
            break;
          switch (Name[13]) {
          default: break;
          case '2':	 // 5 strings to match.
            if (Name[14] != '_')
              break;
            switch (Name[15]) {
            default: break;
            case 'r':	 // 4 strings to match.
              if (Name[16] != 't')
                break;
              switch (Name[17]) {
              default: break;
              case 'e':	 // 1 string to match.
                return std::make_pair(276, 11);	 // "convert_uchar2_rte"
              case 'n':	 // 1 string to match.
                return std::make_pair(276, 11);	 // "convert_uchar2_rtn"
              case 'p':	 // 1 string to match.
                return std::make_pair(276, 11);	 // "convert_uchar2_rtp"
              case 'z':	 // 1 string to match.
                return std::make_pair(276, 11);	 // "convert_uchar2_rtz"
              }
              break;
            case 's':	 // 1 string to match.
              if (memcmp(Name.data()+16, "at", 2) != 0)
                break;
              return std::make_pair(276, 11);	 // "convert_uchar2_sat"
            }
            break;
          case '3':	 // 5 strings to match.
            if (Name[14] != '_')
              break;
            switch (Name[15]) {
            default: break;
            case 'r':	 // 4 strings to match.
              if (Name[16] != 't')
                break;
              switch (Name[17]) {
              default: break;
              case 'e':	 // 1 string to match.
                return std::make_pair(287, 11);	 // "convert_uchar3_rte"
              case 'n':	 // 1 string to match.
                return std::make_pair(287, 11);	 // "convert_uchar3_rtn"
              case 'p':	 // 1 string to match.
                return std::make_pair(287, 11);	 // "convert_uchar3_rtp"
              case 'z':	 // 1 string to match.
                return std::make_pair(287, 11);	 // "convert_uchar3_rtz"
              }
              break;
            case 's':	 // 1 string to match.
              if (memcmp(Name.data()+16, "at", 2) != 0)
                break;
              return std::make_pair(287, 11);	 // "convert_uchar3_sat"
            }
            break;
          case '4':	 // 5 strings to match.
            if (Name[14] != '_')
              break;
            switch (Name[15]) {
            default: break;
            case 'r':	 // 4 strings to match.
              if (Name[16] != 't')
                break;
              switch (Name[17]) {
              default: break;
              case 'e':	 // 1 string to match.
                return std::make_pair(298, 11);	 // "convert_uchar4_rte"
              case 'n':	 // 1 string to match.
                return std::make_pair(298, 11);	 // "convert_uchar4_rtn"
              case 'p':	 // 1 string to match.
                return std::make_pair(298, 11);	 // "convert_uchar4_rtp"
              case 'z':	 // 1 string to match.
                return std::make_pair(298, 11);	 // "convert_uchar4_rtz"
              }
              break;
            case 's':	 // 1 string to match.
              if (memcmp(Name.data()+16, "at", 2) != 0)
                break;
              return std::make_pair(298, 11);	 // "convert_uchar4_sat"
            }
            break;
          case '8':	 // 5 strings to match.
            if (Name[14] != '_')
              break;
            switch (Name[15]) {
            default: break;
            case 'r':	 // 4 strings to match.
              if (Name[16] != 't')
                break;
              switch (Name[17]) {
              default: break;
              case 'e':	 // 1 string to match.
                return std::make_pair(309, 11);	 // "convert_uchar8_rte"
              case 'n':	 // 1 string to match.
                return std::make_pair(309, 11);	 // "convert_uchar8_rtn"
              case 'p':	 // 1 string to match.
                return std::make_pair(309, 11);	 // "convert_uchar8_rtp"
              case 'z':	 // 1 string to match.
                return std::make_pair(309, 11);	 // "convert_uchar8_rtz"
              }
              break;
            case 's':	 // 1 string to match.
              if (memcmp(Name.data()+16, "at", 2) != 0)
                break;
              return std::make_pair(309, 11);	 // "convert_uchar8_sat"
            }
            break;
          }
          break;
        case 'i':	 // 5 strings to match.
          if (memcmp(Name.data()+10, "nt16_", 5) != 0)
            break;
          switch (Name[15]) {
          default: break;
          case 'r':	 // 4 strings to match.
            if (Name[16] != 't')
              break;
            switch (Name[17]) {
            default: break;
            case 'e':	 // 1 string to match.
              return std::make_pair(584, 11);	 // "convert_uint16_rte"
            case 'n':	 // 1 string to match.
              return std::make_pair(584, 11);	 // "convert_uint16_rtn"
            case 'p':	 // 1 string to match.
              return std::make_pair(584, 11);	 // "convert_uint16_rtp"
            case 'z':	 // 1 string to match.
              return std::make_pair(584, 11);	 // "convert_uint16_rtz"
            }
            break;
          case 's':	 // 1 string to match.
            if (memcmp(Name.data()+16, "at", 2) != 0)
              break;
            return std::make_pair(584, 11);	 // "convert_uint16_sat"
          }
          break;
        case 'l':	 // 20 strings to match.
          if (memcmp(Name.data()+10, "ong", 3) != 0)
            break;
          switch (Name[13]) {
          default: break;
          case '2':	 // 5 strings to match.
            if (Name[14] != '_')
              break;
            switch (Name[15]) {
            default: break;
            case 'r':	 // 4 strings to match.
              if (Name[16] != 't')
                break;
              switch (Name[17]) {
              default: break;
              case 'e':	 // 1 string to match.
                return std::make_pair(672, 11);	 // "convert_ulong2_rte"
              case 'n':	 // 1 string to match.
                return std::make_pair(672, 11);	 // "convert_ulong2_rtn"
              case 'p':	 // 1 string to match.
                return std::make_pair(672, 11);	 // "convert_ulong2_rtp"
              case 'z':	 // 1 string to match.
                return std::make_pair(672, 11);	 // "convert_ulong2_rtz"
              }
              break;
            case 's':	 // 1 string to match.
              if (memcmp(Name.data()+16, "at", 2) != 0)
                break;
              return std::make_pair(672, 11);	 // "convert_ulong2_sat"
            }
            break;
          case '3':	 // 5 strings to match.
            if (Name[14] != '_')
              break;
            switch (Name[15]) {
            default: break;
            case 'r':	 // 4 strings to match.
              if (Name[16] != 't')
                break;
              switch (Name[17]) {
              default: break;
              case 'e':	 // 1 string to match.
                return std::make_pair(683, 11);	 // "convert_ulong3_rte"
              case 'n':	 // 1 string to match.
                return std::make_pair(683, 11);	 // "convert_ulong3_rtn"
              case 'p':	 // 1 string to match.
                return std::make_pair(683, 11);	 // "convert_ulong3_rtp"
              case 'z':	 // 1 string to match.
                return std::make_pair(683, 11);	 // "convert_ulong3_rtz"
              }
              break;
            case 's':	 // 1 string to match.
              if (memcmp(Name.data()+16, "at", 2) != 0)
                break;
              return std::make_pair(683, 11);	 // "convert_ulong3_sat"
            }
            break;
          case '4':	 // 5 strings to match.
            if (Name[14] != '_')
              break;
            switch (Name[15]) {
            default: break;
            case 'r':	 // 4 strings to match.
              if (Name[16] != 't')
                break;
              switch (Name[17]) {
              default: break;
              case 'e':	 // 1 string to match.
                return std::make_pair(694, 11);	 // "convert_ulong4_rte"
              case 'n':	 // 1 string to match.
                return std::make_pair(694, 11);	 // "convert_ulong4_rtn"
              case 'p':	 // 1 string to match.
                return std::make_pair(694, 11);	 // "convert_ulong4_rtp"
              case 'z':	 // 1 string to match.
                return std::make_pair(694, 11);	 // "convert_ulong4_rtz"
              }
              break;
            case 's':	 // 1 string to match.
              if (memcmp(Name.data()+16, "at", 2) != 0)
                break;
              return std::make_pair(694, 11);	 // "convert_ulong4_sat"
            }
            break;
          case '8':	 // 5 strings to match.
            if (Name[14] != '_')
              break;
            switch (Name[15]) {
            default: break;
            case 'r':	 // 4 strings to match.
              if (Name[16] != 't')
                break;
              switch (Name[17]) {
              default: break;
              case 'e':	 // 1 string to match.
                return std::make_pair(705, 11);	 // "convert_ulong8_rte"
              case 'n':	 // 1 string to match.
                return std::make_pair(705, 11);	 // "convert_ulong8_rtn"
              case 'p':	 // 1 string to match.
                return std::make_pair(705, 11);	 // "convert_ulong8_rtp"
              case 'z':	 // 1 string to match.
                return std::make_pair(705, 11);	 // "convert_ulong8_rtz"
              }
              break;
            case 's':	 // 1 string to match.
              if (memcmp(Name.data()+16, "at", 2) != 0)
                break;
              return std::make_pair(705, 11);	 // "convert_ulong8_sat"
            }
            break;
          }
          break;
        case 's':	 // 5 strings to match.
          if (memcmp(Name.data()+10, "hort_", 5) != 0)
            break;
          switch (Name[15]) {
          default: break;
          case 'r':	 // 4 strings to match.
            if (Name[16] != 't')
              break;
            switch (Name[17]) {
            default: break;
            case 'e':	 // 1 string to match.
              return std::make_pair(397, 11);	 // "convert_ushort_rte"
            case 'n':	 // 1 string to match.
              return std::make_pair(397, 11);	 // "convert_ushort_rtn"
            case 'p':	 // 1 string to match.
              return std::make_pair(397, 11);	 // "convert_ushort_rtp"
            case 'z':	 // 1 string to match.
              return std::make_pair(397, 11);	 // "convert_ushort_rtz"
            }
            break;
          case 's':	 // 1 string to match.
            if (memcmp(Name.data()+16, "at", 2) != 0)
              break;
            return std::make_pair(397, 11);	 // "convert_ushort_sat"
          }
          break;
        }
        break;
      }
      break;
    case 'g':	 // 2 strings to match.
      if (memcmp(Name.data()+1, "et_", 3) != 0)
        break;
      switch (Name[4]) {
      default: break;
      case 'n':	 // 1 string to match.
        if (memcmp(Name.data()+5, "um_sub_groups", 13) != 0)
          break;
        return std::make_pair(1926, 1);	 // "get_num_sub_groups"
      case 's':	 // 1 string to match.
        if (memcmp(Name.data()+5, "ub_group_size", 13) != 0)
          break;
        return std::make_pair(1926, 1);	 // "get_sub_group_size"
      }
      break;
    case 'v':	 // 4 strings to match.
      if (memcmp(Name.data()+1, "storea_half16_rt", 16) != 0)
        break;
      switch (Name[17]) {
      default: break;
      case 'e':	 // 1 string to match.
        return std::make_pair(1423, 10);	 // "vstorea_half16_rte"
      case 'n':	 // 1 string to match.
        return std::make_pair(1423, 10);	 // "vstorea_half16_rtn"
      case 'p':	 // 1 string to match.
        return std::make_pair(1423, 10);	 // "vstorea_half16_rtp"
      case 'z':	 // 1 string to match.
        return std::make_pair(1423, 10);	 // "vstorea_half16_rtz"
      }
      break;
    }
    break;
  case 19:	 // 65 strings to match.
    switch (Name[0]) {
    default: break;
    case 'c':	 // 64 strings to match.
      if (memcmp(Name.data()+1, "onvert_", 7) != 0)
        break;
      switch (Name[8]) {
      default: break;
      case 'd':	 // 20 strings to match.
        if (memcmp(Name.data()+9, "ouble", 5) != 0)
          break;
        switch (Name[14]) {
        default: break;
        case '2':	 // 5 strings to match.
          if (Name[15] != '_')
            break;
          switch (Name[16]) {
          default: break;
          case 'r':	 // 4 strings to match.
            if (Name[17] != 't')
              break;
            switch (Name[18]) {
            default: break;
            case 'e':	 // 1 string to match.
              return std::make_pair(67, 11);	 // "convert_double2_rte"
            case 'n':	 // 1 string to match.
              return std::make_pair(67, 11);	 // "convert_double2_rtn"
            case 'p':	 // 1 string to match.
              return std::make_pair(67, 11);	 // "convert_double2_rtp"
            case 'z':	 // 1 string to match.
              return std::make_pair(67, 11);	 // "convert_double2_rtz"
            }
            break;
          case 's':	 // 1 string to match.
            if (memcmp(Name.data()+17, "at", 2) != 0)
              break;
            return std::make_pair(67, 11);	 // "convert_double2_sat"
          }
          break;
        case '3':	 // 5 strings to match.
          if (Name[15] != '_')
            break;
          switch (Name[16]) {
          default: break;
          case 'r':	 // 4 strings to match.
            if (Name[17] != 't')
              break;
            switch (Name[18]) {
            default: break;
            case 'e':	 // 1 string to match.
              return std::make_pair(12, 11);	 // "convert_double3_rte"
            case 'n':	 // 1 string to match.
              return std::make_pair(12, 11);	 // "convert_double3_rtn"
            case 'p':	 // 1 string to match.
              return std::make_pair(12, 11);	 // "convert_double3_rtp"
            case 'z':	 // 1 string to match.
              return std::make_pair(12, 11);	 // "convert_double3_rtz"
            }
            break;
          case 's':	 // 1 string to match.
            if (memcmp(Name.data()+17, "at", 2) != 0)
              break;
            return std::make_pair(12, 11);	 // "convert_double3_sat"
          }
          break;
        case '4':	 // 5 strings to match.
          if (Name[15] != '_')
            break;
          switch (Name[16]) {
          default: break;
          case 'r':	 // 4 strings to match.
            if (Name[17] != 't')
              break;
            switch (Name[18]) {
            default: break;
            case 'e':	 // 1 string to match.
              return std::make_pair(23, 11);	 // "convert_double4_rte"
            case 'n':	 // 1 string to match.
              return std::make_pair(23, 11);	 // "convert_double4_rtn"
            case 'p':	 // 1 string to match.
              return std::make_pair(23, 11);	 // "convert_double4_rtp"
            case 'z':	 // 1 string to match.
              return std::make_pair(23, 11);	 // "convert_double4_rtz"
            }
            break;
          case 's':	 // 1 string to match.
            if (memcmp(Name.data()+17, "at", 2) != 0)
              break;
            return std::make_pair(23, 11);	 // "convert_double4_sat"
          }
          break;
        case '8':	 // 5 strings to match.
          if (Name[15] != '_')
            break;
          switch (Name[16]) {
          default: break;
          case 'r':	 // 4 strings to match.
            if (Name[17] != 't')
              break;
            switch (Name[18]) {
            default: break;
            case 'e':	 // 1 string to match.
              return std::make_pair(34, 11);	 // "convert_double8_rte"
            case 'n':	 // 1 string to match.
              return std::make_pair(34, 11);	 // "convert_double8_rtn"
            case 'p':	 // 1 string to match.
              return std::make_pair(34, 11);	 // "convert_double8_rtp"
            case 'z':	 // 1 string to match.
              return std::make_pair(34, 11);	 // "convert_double8_rtz"
            }
            break;
          case 's':	 // 1 string to match.
            if (memcmp(Name.data()+17, "at", 2) != 0)
              break;
            return std::make_pair(34, 11);	 // "convert_double8_sat"
          }
          break;
        }
        break;
      case 'f':	 // 5 strings to match.
        if (memcmp(Name.data()+9, "loat16_", 7) != 0)
          break;
        switch (Name[16]) {
        default: break;
        case 'r':	 // 4 strings to match.
          if (Name[17] != 't')
            break;
          switch (Name[18]) {
          default: break;
          case 'e':	 // 1 string to match.
            return std::make_pair(78, 11);	 // "convert_float16_rte"
          case 'n':	 // 1 string to match.
            return std::make_pair(78, 11);	 // "convert_float16_rtn"
          case 'p':	 // 1 string to match.
            return std::make_pair(78, 11);	 // "convert_float16_rtp"
          case 'z':	 // 1 string to match.
            return std::make_pair(78, 11);	 // "convert_float16_rtz"
          }
          break;
        case 's':	 // 1 string to match.
          if (memcmp(Name.data()+17, "at", 2) != 0)
            break;
          return std::make_pair(78, 11);	 // "convert_float16_sat"
        }
        break;
      case 'i':	 // 4 strings to match.
        if (memcmp(Name.data()+9, "nt_sat_rt", 9) != 0)
          break;
        switch (Name[18]) {
        default: break;
        case 'e':	 // 1 string to match.
          return std::make_pair(463, 11);	 // "convert_int_sat_rte"
        case 'n':	 // 1 string to match.
          return std::make_pair(463, 11);	 // "convert_int_sat_rtn"
        case 'p':	 // 1 string to match.
          return std::make_pair(463, 11);	 // "convert_int_sat_rtp"
        case 'z':	 // 1 string to match.
          return std::make_pair(463, 11);	 // "convert_int_sat_rtz"
        }
        break;
      case 's':	 // 5 strings to match.
        if (memcmp(Name.data()+9, "hort16_", 7) != 0)
          break;
        switch (Name[16]) {
        default: break;
        case 'r':	 // 4 strings to match.
          if (Name[17] != 't')
            break;
          switch (Name[18]) {
          default: break;
          case 'e':	 // 1 string to match.
            return std::make_pair(386, 11);	 // "convert_short16_rte"
          case 'n':	 // 1 string to match.
            return std::make_pair(386, 11);	 // "convert_short16_rtn"
          case 'p':	 // 1 string to match.
            return std::make_pair(386, 11);	 // "convert_short16_rtp"
          case 'z':	 // 1 string to match.
            return std::make_pair(386, 11);	 // "convert_short16_rtz"
          }
          break;
        case 's':	 // 1 string to match.
          if (memcmp(Name.data()+17, "at", 2) != 0)
            break;
          return std::make_pair(386, 11);	 // "convert_short16_sat"
        }
        break;
      case 'u':	 // 30 strings to match.
        switch (Name[9]) {
        default: break;
        case 'c':	 // 5 strings to match.
          if (memcmp(Name.data()+10, "har16_", 6) != 0)
            break;
          switch (Name[16]) {
          default: break;
          case 'r':	 // 4 strings to match.
            if (Name[17] != 't')
              break;
            switch (Name[18]) {
            default: break;
            case 'e':	 // 1 string to match.
              return std::make_pair(320, 11);	 // "convert_uchar16_rte"
            case 'n':	 // 1 string to match.
              return std::make_pair(320, 11);	 // "convert_uchar16_rtn"
            case 'p':	 // 1 string to match.
              return std::make_pair(320, 11);	 // "convert_uchar16_rtp"
            case 'z':	 // 1 string to match.
              return std::make_pair(320, 11);	 // "convert_uchar16_rtz"
            }
            break;
          case 's':	 // 1 string to match.
            if (memcmp(Name.data()+17, "at", 2) != 0)
              break;
            return std::make_pair(320, 11);	 // "convert_uchar16_sat"
          }
          break;
        case 'l':	 // 5 strings to match.
          if (memcmp(Name.data()+10, "ong16_", 6) != 0)
            break;
          switch (Name[16]) {
          default: break;
          case 'r':	 // 4 strings to match.
            if (Name[17] != 't')
              break;
            switch (Name[18]) {
            default: break;
            case 'e':	 // 1 string to match.
              return std::make_pair(716, 11);	 // "convert_ulong16_rte"
            case 'n':	 // 1 string to match.
              return std::make_pair(716, 11);	 // "convert_ulong16_rtn"
            case 'p':	 // 1 string to match.
              return std::make_pair(716, 11);	 // "convert_ulong16_rtp"
            case 'z':	 // 1 string to match.
              return std::make_pair(716, 11);	 // "convert_ulong16_rtz"
            }
            break;
          case 's':	 // 1 string to match.
            if (memcmp(Name.data()+17, "at", 2) != 0)
              break;
            return std::make_pair(716, 11);	 // "convert_ulong16_sat"
          }
          break;
        case 's':	 // 20 strings to match.
          if (memcmp(Name.data()+10, "hort", 4) != 0)
            break;
          switch (Name[14]) {
          default: break;
          case '2':	 // 5 strings to match.
            if (Name[15] != '_')
              break;
            switch (Name[16]) {
            default: break;
            case 'r':	 // 4 strings to match.
              if (Name[17] != 't')
                break;
              switch (Name[18]) {
              default: break;
              case 'e':	 // 1 string to match.
                return std::make_pair(408, 11);	 // "convert_ushort2_rte"
              case 'n':	 // 1 string to match.
                return std::make_pair(408, 11);	 // "convert_ushort2_rtn"
              case 'p':	 // 1 string to match.
                return std::make_pair(408, 11);	 // "convert_ushort2_rtp"
              case 'z':	 // 1 string to match.
                return std::make_pair(408, 11);	 // "convert_ushort2_rtz"
              }
              break;
            case 's':	 // 1 string to match.
              if (memcmp(Name.data()+17, "at", 2) != 0)
                break;
              return std::make_pair(408, 11);	 // "convert_ushort2_sat"
            }
            break;
          case '3':	 // 5 strings to match.
            if (Name[15] != '_')
              break;
            switch (Name[16]) {
            default: break;
            case 'r':	 // 4 strings to match.
              if (Name[17] != 't')
                break;
              switch (Name[18]) {
              default: break;
              case 'e':	 // 1 string to match.
                return std::make_pair(419, 11);	 // "convert_ushort3_rte"
              case 'n':	 // 1 string to match.
                return std::make_pair(419, 11);	 // "convert_ushort3_rtn"
              case 'p':	 // 1 string to match.
                return std::make_pair(419, 11);	 // "convert_ushort3_rtp"
              case 'z':	 // 1 string to match.
                return std::make_pair(419, 11);	 // "convert_ushort3_rtz"
              }
              break;
            case 's':	 // 1 string to match.
              if (memcmp(Name.data()+17, "at", 2) != 0)
                break;
              return std::make_pair(419, 11);	 // "convert_ushort3_sat"
            }
            break;
          case '4':	 // 5 strings to match.
            if (Name[15] != '_')
              break;
            switch (Name[16]) {
            default: break;
            case 'r':	 // 4 strings to match.
              if (Name[17] != 't')
                break;
              switch (Name[18]) {
              default: break;
              case 'e':	 // 1 string to match.
                return std::make_pair(430, 11);	 // "convert_ushort4_rte"
              case 'n':	 // 1 string to match.
                return std::make_pair(430, 11);	 // "convert_ushort4_rtn"
              case 'p':	 // 1 string to match.
                return std::make_pair(430, 11);	 // "convert_ushort4_rtp"
              case 'z':	 // 1 string to match.
                return std::make_pair(430, 11);	 // "convert_ushort4_rtz"
              }
              break;
            case 's':	 // 1 string to match.
              if (memcmp(Name.data()+17, "at", 2) != 0)
                break;
              return std::make_pair(430, 11);	 // "convert_ushort4_sat"
            }
            break;
          case '8':	 // 5 strings to match.
            if (Name[15] != '_')
              break;
            switch (Name[16]) {
            default: break;
            case 'r':	 // 4 strings to match.
              if (Name[17] != 't')
                break;
              switch (Name[18]) {
              default: break;
              case 'e':	 // 1 string to match.
                return std::make_pair(441, 11);	 // "convert_ushort8_rte"
              case 'n':	 // 1 string to match.
                return std::make_pair(441, 11);	 // "convert_ushort8_rtn"
              case 'p':	 // 1 string to match.
                return std::make_pair(441, 11);	 // "convert_ushort8_rtp"
              case 'z':	 // 1 string to match.
                return std::make_pair(441, 11);	 // "convert_ushort8_rtz"
              }
              break;
            case 's':	 // 1 string to match.
              if (memcmp(Name.data()+17, "at", 2) != 0)
                break;
              return std::make_pair(441, 11);	 // "convert_ushort8_sat"
            }
            break;
          }
          break;
        }
        break;
      }
      break;
    case 'g':	 // 1 string to match.
      if (memcmp(Name.data()+1, "et_local_linear_id", 18) != 0)
        break;
      return std::make_pair(730, 1);	 // "get_local_linear_id"
    }
    break;
  case 20:	 // 45 strings to match.
    switch (Name[0]) {
    default: break;
    case 'c':	 // 42 strings to match.
      if (memcmp(Name.data()+1, "onvert_", 7) != 0)
        break;
      switch (Name[8]) {
      default: break;
      case 'c':	 // 4 strings to match.
        if (memcmp(Name.data()+9, "har_sat_rt", 10) != 0)
          break;
        switch (Name[19]) {
        default: break;
        case 'e':	 // 1 string to match.
          return std::make_pair(199, 11);	 // "convert_char_sat_rte"
        case 'n':	 // 1 string to match.
          return std::make_pair(199, 11);	 // "convert_char_sat_rtn"
        case 'p':	 // 1 string to match.
          return std::make_pair(199, 11);	 // "convert_char_sat_rtp"
        case 'z':	 // 1 string to match.
          return std::make_pair(199, 11);	 // "convert_char_sat_rtz"
        }
        break;
      case 'd':	 // 5 strings to match.
        if (memcmp(Name.data()+9, "ouble16_", 8) != 0)
          break;
        switch (Name[17]) {
        default: break;
        case 'r':	 // 4 strings to match.
          if (Name[18] != 't')
            break;
          switch (Name[19]) {
          default: break;
          case 'e':	 // 1 string to match.
            return std::make_pair(45, 11);	 // "convert_double16_rte"
          case 'n':	 // 1 string to match.
            return std::make_pair(45, 11);	 // "convert_double16_rtn"
          case 'p':	 // 1 string to match.
            return std::make_pair(45, 11);	 // "convert_double16_rtp"
          case 'z':	 // 1 string to match.
            return std::make_pair(45, 11);	 // "convert_double16_rtz"
          }
          break;
        case 's':	 // 1 string to match.
          if (memcmp(Name.data()+18, "at", 2) != 0)
            break;
          return std::make_pair(45, 11);	 // "convert_double16_sat"
        }
        break;
      case 'h':	 // 4 strings to match.
        if (memcmp(Name.data()+9, "alf_sat_rt", 10) != 0)
          break;
        switch (Name[19]) {
        default: break;
        case 'e':	 // 1 string to match.
          return std::make_pair(133, 11);	 // "convert_half_sat_rte"
        case 'n':	 // 1 string to match.
          return std::make_pair(133, 11);	 // "convert_half_sat_rtn"
        case 'p':	 // 1 string to match.
          return std::make_pair(133, 11);	 // "convert_half_sat_rtp"
        case 'z':	 // 1 string to match.
          return std::make_pair(133, 11);	 // "convert_half_sat_rtz"
        }
        break;
      case 'i':	 // 16 strings to match.
        if (memcmp(Name.data()+9, "nt", 2) != 0)
          break;
        switch (Name[11]) {
        default: break;
        case '2':	 // 4 strings to match.
          if (memcmp(Name.data()+12, "_sat_rt", 7) != 0)
            break;
          switch (Name[19]) {
          default: break;
          case 'e':	 // 1 string to match.
            return std::make_pair(474, 11);	 // "convert_int2_sat_rte"
          case 'n':	 // 1 string to match.
            return std::make_pair(474, 11);	 // "convert_int2_sat_rtn"
          case 'p':	 // 1 string to match.
            return std::make_pair(474, 11);	 // "convert_int2_sat_rtp"
          case 'z':	 // 1 string to match.
            return std::make_pair(474, 11);	 // "convert_int2_sat_rtz"
          }
          break;
        case '3':	 // 4 strings to match.
          if (memcmp(Name.data()+12, "_sat_rt", 7) != 0)
            break;
          switch (Name[19]) {
          default: break;
          case 'e':	 // 1 string to match.
            return std::make_pair(485, 11);	 // "convert_int3_sat_rte"
          case 'n':	 // 1 string to match.
            return std::make_pair(485, 11);	 // "convert_int3_sat_rtn"
          case 'p':	 // 1 string to match.
            return std::make_pair(485, 11);	 // "convert_int3_sat_rtp"
          case 'z':	 // 1 string to match.
            return std::make_pair(485, 11);	 // "convert_int3_sat_rtz"
          }
          break;
        case '4':	 // 4 strings to match.
          if (memcmp(Name.data()+12, "_sat_rt", 7) != 0)
            break;
          switch (Name[19]) {
          default: break;
          case 'e':	 // 1 string to match.
            return std::make_pair(496, 11);	 // "convert_int4_sat_rte"
          case 'n':	 // 1 string to match.
            return std::make_pair(496, 11);	 // "convert_int4_sat_rtn"
          case 'p':	 // 1 string to match.
            return std::make_pair(496, 11);	 // "convert_int4_sat_rtp"
          case 'z':	 // 1 string to match.
            return std::make_pair(496, 11);	 // "convert_int4_sat_rtz"
          }
          break;
        case '8':	 // 4 strings to match.
          if (memcmp(Name.data()+12, "_sat_rt", 7) != 0)
            break;
          switch (Name[19]) {
          default: break;
          case 'e':	 // 1 string to match.
            return std::make_pair(507, 11);	 // "convert_int8_sat_rte"
          case 'n':	 // 1 string to match.
            return std::make_pair(507, 11);	 // "convert_int8_sat_rtn"
          case 'p':	 // 1 string to match.
            return std::make_pair(507, 11);	 // "convert_int8_sat_rtp"
          case 'z':	 // 1 string to match.
            return std::make_pair(507, 11);	 // "convert_int8_sat_rtz"
          }
          break;
        }
        break;
      case 'l':	 // 4 strings to match.
        if (memcmp(Name.data()+9, "ong_sat_rt", 10) != 0)
          break;
        switch (Name[19]) {
        default: break;
        case 'e':	 // 1 string to match.
          return std::make_pair(595, 11);	 // "convert_long_sat_rte"
        case 'n':	 // 1 string to match.
          return std::make_pair(595, 11);	 // "convert_long_sat_rtn"
        case 'p':	 // 1 string to match.
          return std::make_pair(595, 11);	 // "convert_long_sat_rtp"
        case 'z':	 // 1 string to match.
          return std::make_pair(595, 11);	 // "convert_long_sat_rtz"
        }
        break;
      case 'u':	 // 9 strings to match.
        switch (Name[9]) {
        default: break;
        case 'i':	 // 4 strings to match.
          if (memcmp(Name.data()+10, "nt_sat_rt", 9) != 0)
            break;
          switch (Name[19]) {
          default: break;
          case 'e':	 // 1 string to match.
            return std::make_pair(529, 11);	 // "convert_uint_sat_rte"
          case 'n':	 // 1 string to match.
            return std::make_pair(529, 11);	 // "convert_uint_sat_rtn"
          case 'p':	 // 1 string to match.
            return std::make_pair(529, 11);	 // "convert_uint_sat_rtp"
          case 'z':	 // 1 string to match.
            return std::make_pair(529, 11);	 // "convert_uint_sat_rtz"
          }
          break;
        case 's':	 // 5 strings to match.
          if (memcmp(Name.data()+10, "hort16_", 7) != 0)
            break;
          switch (Name[17]) {
          default: break;
          case 'r':	 // 4 strings to match.
            if (Name[18] != 't')
              break;
            switch (Name[19]) {
            default: break;
            case 'e':	 // 1 string to match.
              return std::make_pair(452, 11);	 // "convert_ushort16_rte"
            case 'n':	 // 1 string to match.
              return std::make_pair(452, 11);	 // "convert_ushort16_rtn"
            case 'p':	 // 1 string to match.
              return std::make_pair(452, 11);	 // "convert_ushort16_rtp"
            case 'z':	 // 1 string to match.
              return std::make_pair(452, 11);	 // "convert_ushort16_rtz"
            }
            break;
          case 's':	 // 1 string to match.
            if (memcmp(Name.data()+18, "at", 2) != 0)
              break;
            return std::make_pair(452, 11);	 // "convert_ushort16_sat"
          }
          break;
        }
        break;
      }
      break;
    case 'g':	 // 2 strings to match.
      if (memcmp(Name.data()+1, "et_", 3) != 0)
        break;
      switch (Name[4]) {
      default: break;
      case 'g':	 // 1 string to match.
        if (memcmp(Name.data()+5, "lobal_linear_id", 15) != 0)
          break;
        return std::make_pair(730, 1);	 // "get_global_linear_id"
      case 'i':	 // 1 string to match.
        if (memcmp(Name.data()+5, "mage_array_size", 15) != 0)
          break;
        return std::make_pair(1842, 12);	 // "get_image_array_size"
      }
      break;
    case 'w':	 // 1 string to match.
      if (memcmp(Name.data()+1, "ork_group_broadcast", 19) != 0)
        break;
      return std::make_pair(1889, 3);	 // "work_group_broadcast"
    }
    break;
  case 21:	 // 89 strings to match.
    switch (Name[0]) {
    default: break;
    case 'a':	 // 1 string to match.
      if (memcmp(Name.data()+1, "sync_work_group_copy", 20) != 0)
        break;
      return std::make_pair(1486, 2);	 // "async_work_group_copy"
    case 'c':	 // 84 strings to match.
      if (memcmp(Name.data()+1, "onvert_", 7) != 0)
        break;
      switch (Name[8]) {
      default: break;
      case 'c':	 // 16 strings to match.
        if (memcmp(Name.data()+9, "har", 3) != 0)
          break;
        switch (Name[12]) {
        default: break;
        case '2':	 // 4 strings to match.
          if (memcmp(Name.data()+13, "_sat_rt", 7) != 0)
            break;
          switch (Name[20]) {
          default: break;
          case 'e':	 // 1 string to match.
            return std::make_pair(210, 11);	 // "convert_char2_sat_rte"
          case 'n':	 // 1 string to match.
            return std::make_pair(210, 11);	 // "convert_char2_sat_rtn"
          case 'p':	 // 1 string to match.
            return std::make_pair(210, 11);	 // "convert_char2_sat_rtp"
          case 'z':	 // 1 string to match.
            return std::make_pair(210, 11);	 // "convert_char2_sat_rtz"
          }
          break;
        case '3':	 // 4 strings to match.
          if (memcmp(Name.data()+13, "_sat_rt", 7) != 0)
            break;
          switch (Name[20]) {
          default: break;
          case 'e':	 // 1 string to match.
            return std::make_pair(221, 11);	 // "convert_char3_sat_rte"
          case 'n':	 // 1 string to match.
            return std::make_pair(221, 11);	 // "convert_char3_sat_rtn"
          case 'p':	 // 1 string to match.
            return std::make_pair(221, 11);	 // "convert_char3_sat_rtp"
          case 'z':	 // 1 string to match.
            return std::make_pair(221, 11);	 // "convert_char3_sat_rtz"
          }
          break;
        case '4':	 // 4 strings to match.
          if (memcmp(Name.data()+13, "_sat_rt", 7) != 0)
            break;
          switch (Name[20]) {
          default: break;
          case 'e':	 // 1 string to match.
            return std::make_pair(232, 11);	 // "convert_char4_sat_rte"
          case 'n':	 // 1 string to match.
            return std::make_pair(232, 11);	 // "convert_char4_sat_rtn"
          case 'p':	 // 1 string to match.
            return std::make_pair(232, 11);	 // "convert_char4_sat_rtp"
          case 'z':	 // 1 string to match.
            return std::make_pair(232, 11);	 // "convert_char4_sat_rtz"
          }
          break;
        case '8':	 // 4 strings to match.
          if (memcmp(Name.data()+13, "_sat_rt", 7) != 0)
            break;
          switch (Name[20]) {
          default: break;
          case 'e':	 // 1 string to match.
            return std::make_pair(243, 11);	 // "convert_char8_sat_rte"
          case 'n':	 // 1 string to match.
            return std::make_pair(243, 11);	 // "convert_char8_sat_rtn"
          case 'p':	 // 1 string to match.
            return std::make_pair(243, 11);	 // "convert_char8_sat_rtp"
          case 'z':	 // 1 string to match.
            return std::make_pair(243, 11);	 // "convert_char8_sat_rtz"
          }
          break;
        }
        break;
      case 'f':	 // 4 strings to match.
        if (memcmp(Name.data()+9, "loat_sat_rt", 11) != 0)
          break;
        switch (Name[20]) {
        default: break;
        case 'e':	 // 1 string to match.
          return std::make_pair(89, 11);	 // "convert_float_sat_rte"
        case 'n':	 // 1 string to match.
          return std::make_pair(89, 11);	 // "convert_float_sat_rtn"
        case 'p':	 // 1 string to match.
          return std::make_pair(89, 11);	 // "convert_float_sat_rtp"
        case 'z':	 // 1 string to match.
          return std::make_pair(89, 11);	 // "convert_float_sat_rtz"
        }
        break;
      case 'h':	 // 16 strings to match.
        if (memcmp(Name.data()+9, "alf", 3) != 0)
          break;
        switch (Name[12]) {
        default: break;
        case '2':	 // 4 strings to match.
          if (memcmp(Name.data()+13, "_sat_rt", 7) != 0)
            break;
          switch (Name[20]) {
          default: break;
          case 'e':	 // 1 string to match.
            return std::make_pair(144, 11);	 // "convert_half2_sat_rte"
          case 'n':	 // 1 string to match.
            return std::make_pair(144, 11);	 // "convert_half2_sat_rtn"
          case 'p':	 // 1 string to match.
            return std::make_pair(144, 11);	 // "convert_half2_sat_rtp"
          case 'z':	 // 1 string to match.
            return std::make_pair(144, 11);	 // "convert_half2_sat_rtz"
          }
          break;
        case '3':	 // 4 strings to match.
          if (memcmp(Name.data()+13, "_sat_rt", 7) != 0)
            break;
          switch (Name[20]) {
          default: break;
          case 'e':	 // 1 string to match.
            return std::make_pair(155, 11);	 // "convert_half3_sat_rte"
          case 'n':	 // 1 string to match.
            return std::make_pair(155, 11);	 // "convert_half3_sat_rtn"
          case 'p':	 // 1 string to match.
            return std::make_pair(155, 11);	 // "convert_half3_sat_rtp"
          case 'z':	 // 1 string to match.
            return std::make_pair(155, 11);	 // "convert_half3_sat_rtz"
          }
          break;
        case '4':	 // 4 strings to match.
          if (memcmp(Name.data()+13, "_sat_rt", 7) != 0)
            break;
          switch (Name[20]) {
          default: break;
          case 'e':	 // 1 string to match.
            return std::make_pair(166, 11);	 // "convert_half4_sat_rte"
          case 'n':	 // 1 string to match.
            return std::make_pair(166, 11);	 // "convert_half4_sat_rtn"
          case 'p':	 // 1 string to match.
            return std::make_pair(166, 11);	 // "convert_half4_sat_rtp"
          case 'z':	 // 1 string to match.
            return std::make_pair(166, 11);	 // "convert_half4_sat_rtz"
          }
          break;
        case '8':	 // 4 strings to match.
          if (memcmp(Name.data()+13, "_sat_rt", 7) != 0)
            break;
          switch (Name[20]) {
          default: break;
          case 'e':	 // 1 string to match.
            return std::make_pair(177, 11);	 // "convert_half8_sat_rte"
          case 'n':	 // 1 string to match.
            return std::make_pair(177, 11);	 // "convert_half8_sat_rtn"
          case 'p':	 // 1 string to match.
            return std::make_pair(177, 11);	 // "convert_half8_sat_rtp"
          case 'z':	 // 1 string to match.
            return std::make_pair(177, 11);	 // "convert_half8_sat_rtz"
          }
          break;
        }
        break;
      case 'i':	 // 4 strings to match.
        if (memcmp(Name.data()+9, "nt16_sat_rt", 11) != 0)
          break;
        switch (Name[20]) {
        default: break;
        case 'e':	 // 1 string to match.
          return std::make_pair(518, 11);	 // "convert_int16_sat_rte"
        case 'n':	 // 1 string to match.
          return std::make_pair(518, 11);	 // "convert_int16_sat_rtn"
        case 'p':	 // 1 string to match.
          return std::make_pair(518, 11);	 // "convert_int16_sat_rtp"
        case 'z':	 // 1 string to match.
          return std::make_pair(518, 11);	 // "convert_int16_sat_rtz"
        }
        break;
      case 'l':	 // 16 strings to match.
        if (memcmp(Name.data()+9, "ong", 3) != 0)
          break;
        switch (Name[12]) {
        default: break;
        case '2':	 // 4 strings to match.
          if (memcmp(Name.data()+13, "_sat_rt", 7) != 0)
            break;
          switch (Name[20]) {
          default: break;
          case 'e':	 // 1 string to match.
            return std::make_pair(606, 11);	 // "convert_long2_sat_rte"
          case 'n':	 // 1 string to match.
            return std::make_pair(606, 11);	 // "convert_long2_sat_rtn"
          case 'p':	 // 1 string to match.
            return std::make_pair(606, 11);	 // "convert_long2_sat_rtp"
          case 'z':	 // 1 string to match.
            return std::make_pair(606, 11);	 // "convert_long2_sat_rtz"
          }
          break;
        case '3':	 // 4 strings to match.
          if (memcmp(Name.data()+13, "_sat_rt", 7) != 0)
            break;
          switch (Name[20]) {
          default: break;
          case 'e':	 // 1 string to match.
            return std::make_pair(617, 11);	 // "convert_long3_sat_rte"
          case 'n':	 // 1 string to match.
            return std::make_pair(617, 11);	 // "convert_long3_sat_rtn"
          case 'p':	 // 1 string to match.
            return std::make_pair(617, 11);	 // "convert_long3_sat_rtp"
          case 'z':	 // 1 string to match.
            return std::make_pair(617, 11);	 // "convert_long3_sat_rtz"
          }
          break;
        case '4':	 // 4 strings to match.
          if (memcmp(Name.data()+13, "_sat_rt", 7) != 0)
            break;
          switch (Name[20]) {
          default: break;
          case 'e':	 // 1 string to match.
            return std::make_pair(628, 11);	 // "convert_long4_sat_rte"
          case 'n':	 // 1 string to match.
            return std::make_pair(628, 11);	 // "convert_long4_sat_rtn"
          case 'p':	 // 1 string to match.
            return std::make_pair(628, 11);	 // "convert_long4_sat_rtp"
          case 'z':	 // 1 string to match.
            return std::make_pair(628, 11);	 // "convert_long4_sat_rtz"
          }
          break;
        case '8':	 // 4 strings to match.
          if (memcmp(Name.data()+13, "_sat_rt", 7) != 0)
            break;
          switch (Name[20]) {
          default: break;
          case 'e':	 // 1 string to match.
            return std::make_pair(639, 11);	 // "convert_long8_sat_rte"
          case 'n':	 // 1 string to match.
            return std::make_pair(639, 11);	 // "convert_long8_sat_rtn"
          case 'p':	 // 1 string to match.
            return std::make_pair(639, 11);	 // "convert_long8_sat_rtp"
          case 'z':	 // 1 string to match.
            return std::make_pair(639, 11);	 // "convert_long8_sat_rtz"
          }
          break;
        }
        break;
      case 's':	 // 4 strings to match.
        if (memcmp(Name.data()+9, "hort_sat_rt", 11) != 0)
          break;
        switch (Name[20]) {
        default: break;
        case 'e':	 // 1 string to match.
          return std::make_pair(331, 11);	 // "convert_short_sat_rte"
        case 'n':	 // 1 string to match.
          return std::make_pair(331, 11);	 // "convert_short_sat_rtn"
        case 'p':	 // 1 string to match.
          return std::make_pair(331, 11);	 // "convert_short_sat_rtp"
        case 'z':	 // 1 string to match.
          return std::make_pair(331, 11);	 // "convert_short_sat_rtz"
        }
        break;
      case 'u':	 // 24 strings to match.
        switch (Name[9]) {
        default: break;
        case 'c':	 // 4 strings to match.
          if (memcmp(Name.data()+10, "har_sat_rt", 10) != 0)
            break;
          switch (Name[20]) {
          default: break;
          case 'e':	 // 1 string to match.
            return std::make_pair(265, 11);	 // "convert_uchar_sat_rte"
          case 'n':	 // 1 string to match.
            return std::make_pair(265, 11);	 // "convert_uchar_sat_rtn"
          case 'p':	 // 1 string to match.
            return std::make_pair(265, 11);	 // "convert_uchar_sat_rtp"
          case 'z':	 // 1 string to match.
            return std::make_pair(265, 11);	 // "convert_uchar_sat_rtz"
          }
          break;
        case 'i':	 // 16 strings to match.
          if (memcmp(Name.data()+10, "nt", 2) != 0)
            break;
          switch (Name[12]) {
          default: break;
          case '2':	 // 4 strings to match.
            if (memcmp(Name.data()+13, "_sat_rt", 7) != 0)
              break;
            switch (Name[20]) {
            default: break;
            case 'e':	 // 1 string to match.
              return std::make_pair(540, 11);	 // "convert_uint2_sat_rte"
            case 'n':	 // 1 string to match.
              return std::make_pair(540, 11);	 // "convert_uint2_sat_rtn"
            case 'p':	 // 1 string to match.
              return std::make_pair(540, 11);	 // "convert_uint2_sat_rtp"
            case 'z':	 // 1 string to match.
              return std::make_pair(540, 11);	 // "convert_uint2_sat_rtz"
            }
            break;
          case '3':	 // 4 strings to match.
            if (memcmp(Name.data()+13, "_sat_rt", 7) != 0)
              break;
            switch (Name[20]) {
            default: break;
            case 'e':	 // 1 string to match.
              return std::make_pair(551, 11);	 // "convert_uint3_sat_rte"
            case 'n':	 // 1 string to match.
              return std::make_pair(551, 11);	 // "convert_uint3_sat_rtn"
            case 'p':	 // 1 string to match.
              return std::make_pair(551, 11);	 // "convert_uint3_sat_rtp"
            case 'z':	 // 1 string to match.
              return std::make_pair(551, 11);	 // "convert_uint3_sat_rtz"
            }
            break;
          case '4':	 // 4 strings to match.
            if (memcmp(Name.data()+13, "_sat_rt", 7) != 0)
              break;
            switch (Name[20]) {
            default: break;
            case 'e':	 // 1 string to match.
              return std::make_pair(562, 11);	 // "convert_uint4_sat_rte"
            case 'n':	 // 1 string to match.
              return std::make_pair(562, 11);	 // "convert_uint4_sat_rtn"
            case 'p':	 // 1 string to match.
              return std::make_pair(562, 11);	 // "convert_uint4_sat_rtp"
            case 'z':	 // 1 string to match.
              return std::make_pair(562, 11);	 // "convert_uint4_sat_rtz"
            }
            break;
          case '8':	 // 4 strings to match.
            if (memcmp(Name.data()+13, "_sat_rt", 7) != 0)
              break;
            switch (Name[20]) {
            default: break;
            case 'e':	 // 1 string to match.
              return std::make_pair(573, 11);	 // "convert_uint8_sat_rte"
            case 'n':	 // 1 string to match.
              return std::make_pair(573, 11);	 // "convert_uint8_sat_rtn"
            case 'p':	 // 1 string to match.
              return std::make_pair(573, 11);	 // "convert_uint8_sat_rtp"
            case 'z':	 // 1 string to match.
              return std::make_pair(573, 11);	 // "convert_uint8_sat_rtz"
            }
            break;
          }
          break;
        case 'l':	 // 4 strings to match.
          if (memcmp(Name.data()+10, "ong_sat_rt", 10) != 0)
            break;
          switch (Name[20]) {
          default: break;
          case 'e':	 // 1 string to match.
            return std::make_pair(661, 11);	 // "convert_ulong_sat_rte"
          case 'n':	 // 1 string to match.
            return std::make_pair(661, 11);	 // "convert_ulong_sat_rtn"
          case 'p':	 // 1 string to match.
            return std::make_pair(661, 11);	 // "convert_ulong_sat_rtp"
          case 'z':	 // 1 string to match.
            return std::make_pair(661, 11);	 // "convert_ulong_sat_rtz"
          }
          break;
        }
        break;
      }
      break;
    case 'g':	 // 1 string to match.
      if (memcmp(Name.data()+1, "et_image_num_samples", 20) != 0)
        break;
      return std::make_pair(1914, 12);	 // "get_image_num_samples"
    case 'w':	 // 3 strings to match.
      if (memcmp(Name.data()+1, "ork_group_reduce_", 17) != 0)
        break;
      switch (Name[18]) {
      default: break;
      case 'a':	 // 1 string to match.
        if (memcmp(Name.data()+19, "dd", 2) != 0)
          break;
        return std::make_pair(1892, 1);	 // "work_group_reduce_add"
      case 'm':	 // 2 strings to match.
        switch (Name[19]) {
        default: break;
        case 'a':	 // 1 string to match.
          if (Name[20] != 'x')
            break;
          return std::make_pair(1892, 1);	 // "work_group_reduce_max"
        case 'i':	 // 1 string to match.
          if (Name[20] != 'n')
            break;
          return std::make_pair(1892, 1);	 // "work_group_reduce_min"
        }
        break;
      }
      break;
    }
    break;
  case 22:	 // 89 strings to match.
    switch (Name[0]) {
    default: break;
    case 'c':	 // 88 strings to match.
      if (memcmp(Name.data()+1, "onvert_", 7) != 0)
        break;
      switch (Name[8]) {
      default: break;
      case 'c':	 // 4 strings to match.
        if (memcmp(Name.data()+9, "har16_sat_rt", 12) != 0)
          break;
        switch (Name[21]) {
        default: break;
        case 'e':	 // 1 string to match.
          return std::make_pair(254, 11);	 // "convert_char16_sat_rte"
        case 'n':	 // 1 string to match.
          return std::make_pair(254, 11);	 // "convert_char16_sat_rtn"
        case 'p':	 // 1 string to match.
          return std::make_pair(254, 11);	 // "convert_char16_sat_rtp"
        case 'z':	 // 1 string to match.
          return std::make_pair(254, 11);	 // "convert_char16_sat_rtz"
        }
        break;
      case 'd':	 // 4 strings to match.
        if (memcmp(Name.data()+9, "ouble_sat_rt", 12) != 0)
          break;
        switch (Name[21]) {
        default: break;
        case 'e':	 // 1 string to match.
          return std::make_pair(56, 11);	 // "convert_double_sat_rte"
        case 'n':	 // 1 string to match.
          return std::make_pair(56, 11);	 // "convert_double_sat_rtn"
        case 'p':	 // 1 string to match.
          return std::make_pair(56, 11);	 // "convert_double_sat_rtp"
        case 'z':	 // 1 string to match.
          return std::make_pair(56, 11);	 // "convert_double_sat_rtz"
        }
        break;
      case 'f':	 // 16 strings to match.
        if (memcmp(Name.data()+9, "loat", 4) != 0)
          break;
        switch (Name[13]) {
        default: break;
        case '2':	 // 4 strings to match.
          if (memcmp(Name.data()+14, "_sat_rt", 7) != 0)
            break;
          switch (Name[21]) {
          default: break;
          case 'e':	 // 1 string to match.
            return std::make_pair(100, 11);	 // "convert_float2_sat_rte"
          case 'n':	 // 1 string to match.
            return std::make_pair(100, 11);	 // "convert_float2_sat_rtn"
          case 'p':	 // 1 string to match.
            return std::make_pair(100, 11);	 // "convert_float2_sat_rtp"
          case 'z':	 // 1 string to match.
            return std::make_pair(100, 11);	 // "convert_float2_sat_rtz"
          }
          break;
        case '3':	 // 4 strings to match.
          if (memcmp(Name.data()+14, "_sat_rt", 7) != 0)
            break;
          switch (Name[21]) {
          default: break;
          case 'e':	 // 1 string to match.
            return std::make_pair(111, 11);	 // "convert_float3_sat_rte"
          case 'n':	 // 1 string to match.
            return std::make_pair(111, 11);	 // "convert_float3_sat_rtn"
          case 'p':	 // 1 string to match.
            return std::make_pair(111, 11);	 // "convert_float3_sat_rtp"
          case 'z':	 // 1 string to match.
            return std::make_pair(111, 11);	 // "convert_float3_sat_rtz"
          }
          break;
        case '4':	 // 4 strings to match.
          if (memcmp(Name.data()+14, "_sat_rt", 7) != 0)
            break;
          switch (Name[21]) {
          default: break;
          case 'e':	 // 1 string to match.
            return std::make_pair(122, 11);	 // "convert_float4_sat_rte"
          case 'n':	 // 1 string to match.
            return std::make_pair(122, 11);	 // "convert_float4_sat_rtn"
          case 'p':	 // 1 string to match.
            return std::make_pair(122, 11);	 // "convert_float4_sat_rtp"
          case 'z':	 // 1 string to match.
            return std::make_pair(122, 11);	 // "convert_float4_sat_rtz"
          }
          break;
        case '8':	 // 4 strings to match.
          if (memcmp(Name.data()+14, "_sat_rt", 7) != 0)
            break;
          switch (Name[21]) {
          default: break;
          case 'e':	 // 1 string to match.
            return std::make_pair(1, 11);	 // "convert_float8_sat_rte"
          case 'n':	 // 1 string to match.
            return std::make_pair(1, 11);	 // "convert_float8_sat_rtn"
          case 'p':	 // 1 string to match.
            return std::make_pair(1, 11);	 // "convert_float8_sat_rtp"
          case 'z':	 // 1 string to match.
            return std::make_pair(1, 11);	 // "convert_float8_sat_rtz"
          }
          break;
        }
        break;
      case 'h':	 // 4 strings to match.
        if (memcmp(Name.data()+9, "alf16_sat_rt", 12) != 0)
          break;
        switch (Name[21]) {
        default: break;
        case 'e':	 // 1 string to match.
          return std::make_pair(188, 11);	 // "convert_half16_sat_rte"
        case 'n':	 // 1 string to match.
          return std::make_pair(188, 11);	 // "convert_half16_sat_rtn"
        case 'p':	 // 1 string to match.
          return std::make_pair(188, 11);	 // "convert_half16_sat_rtp"
        case 'z':	 // 1 string to match.
          return std::make_pair(188, 11);	 // "convert_half16_sat_rtz"
        }
        break;
      case 'l':	 // 4 strings to match.
        if (memcmp(Name.data()+9, "ong16_sat_rt", 12) != 0)
          break;
        switch (Name[21]) {
        default: break;
        case 'e':	 // 1 string to match.
          return std::make_pair(650, 11);	 // "convert_long16_sat_rte"
        case 'n':	 // 1 string to match.
          return std::make_pair(650, 11);	 // "convert_long16_sat_rtn"
        case 'p':	 // 1 string to match.
          return std::make_pair(650, 11);	 // "convert_long16_sat_rtp"
        case 'z':	 // 1 string to match.
          return std::make_pair(650, 11);	 // "convert_long16_sat_rtz"
        }
        break;
      case 's':	 // 16 strings to match.
        if (memcmp(Name.data()+9, "hort", 4) != 0)
          break;
        switch (Name[13]) {
        default: break;
        case '2':	 // 4 strings to match.
          if (memcmp(Name.data()+14, "_sat_rt", 7) != 0)
            break;
          switch (Name[21]) {
          default: break;
          case 'e':	 // 1 string to match.
            return std::make_pair(342, 11);	 // "convert_short2_sat_rte"
          case 'n':	 // 1 string to match.
            return std::make_pair(342, 11);	 // "convert_short2_sat_rtn"
          case 'p':	 // 1 string to match.
            return std::make_pair(342, 11);	 // "convert_short2_sat_rtp"
          case 'z':	 // 1 string to match.
            return std::make_pair(342, 11);	 // "convert_short2_sat_rtz"
          }
          break;
        case '3':	 // 4 strings to match.
          if (memcmp(Name.data()+14, "_sat_rt", 7) != 0)
            break;
          switch (Name[21]) {
          default: break;
          case 'e':	 // 1 string to match.
            return std::make_pair(353, 11);	 // "convert_short3_sat_rte"
          case 'n':	 // 1 string to match.
            return std::make_pair(353, 11);	 // "convert_short3_sat_rtn"
          case 'p':	 // 1 string to match.
            return std::make_pair(353, 11);	 // "convert_short3_sat_rtp"
          case 'z':	 // 1 string to match.
            return std::make_pair(353, 11);	 // "convert_short3_sat_rtz"
          }
          break;
        case '4':	 // 4 strings to match.
          if (memcmp(Name.data()+14, "_sat_rt", 7) != 0)
            break;
          switch (Name[21]) {
          default: break;
          case 'e':	 // 1 string to match.
            return std::make_pair(364, 11);	 // "convert_short4_sat_rte"
          case 'n':	 // 1 string to match.
            return std::make_pair(364, 11);	 // "convert_short4_sat_rtn"
          case 'p':	 // 1 string to match.
            return std::make_pair(364, 11);	 // "convert_short4_sat_rtp"
          case 'z':	 // 1 string to match.
            return std::make_pair(364, 11);	 // "convert_short4_sat_rtz"
          }
          break;
        case '8':	 // 4 strings to match.
          if (memcmp(Name.data()+14, "_sat_rt", 7) != 0)
            break;
          switch (Name[21]) {
          default: break;
          case 'e':	 // 1 string to match.
            return std::make_pair(375, 11);	 // "convert_short8_sat_rte"
          case 'n':	 // 1 string to match.
            return std::make_pair(375, 11);	 // "convert_short8_sat_rtn"
          case 'p':	 // 1 string to match.
            return std::make_pair(375, 11);	 // "convert_short8_sat_rtp"
          case 'z':	 // 1 string to match.
            return std::make_pair(375, 11);	 // "convert_short8_sat_rtz"
          }
          break;
        }
        break;
      case 'u':	 // 40 strings to match.
        switch (Name[9]) {
        default: break;
        case 'c':	 // 16 strings to match.
          if (memcmp(Name.data()+10, "har", 3) != 0)
            break;
          switch (Name[13]) {
          default: break;
          case '2':	 // 4 strings to match.
            if (memcmp(Name.data()+14, "_sat_rt", 7) != 0)
              break;
            switch (Name[21]) {
            default: break;
            case 'e':	 // 1 string to match.
              return std::make_pair(276, 11);	 // "convert_uchar2_sat_rte"
            case 'n':	 // 1 string to match.
              return std::make_pair(276, 11);	 // "convert_uchar2_sat_rtn"
            case 'p':	 // 1 string to match.
              return std::make_pair(276, 11);	 // "convert_uchar2_sat_rtp"
            case 'z':	 // 1 string to match.
              return std::make_pair(276, 11);	 // "convert_uchar2_sat_rtz"
            }
            break;
          case '3':	 // 4 strings to match.
            if (memcmp(Name.data()+14, "_sat_rt", 7) != 0)
              break;
            switch (Name[21]) {
            default: break;
            case 'e':	 // 1 string to match.
              return std::make_pair(287, 11);	 // "convert_uchar3_sat_rte"
            case 'n':	 // 1 string to match.
              return std::make_pair(287, 11);	 // "convert_uchar3_sat_rtn"
            case 'p':	 // 1 string to match.
              return std::make_pair(287, 11);	 // "convert_uchar3_sat_rtp"
            case 'z':	 // 1 string to match.
              return std::make_pair(287, 11);	 // "convert_uchar3_sat_rtz"
            }
            break;
          case '4':	 // 4 strings to match.
            if (memcmp(Name.data()+14, "_sat_rt", 7) != 0)
              break;
            switch (Name[21]) {
            default: break;
            case 'e':	 // 1 string to match.
              return std::make_pair(298, 11);	 // "convert_uchar4_sat_rte"
            case 'n':	 // 1 string to match.
              return std::make_pair(298, 11);	 // "convert_uchar4_sat_rtn"
            case 'p':	 // 1 string to match.
              return std::make_pair(298, 11);	 // "convert_uchar4_sat_rtp"
            case 'z':	 // 1 string to match.
              return std::make_pair(298, 11);	 // "convert_uchar4_sat_rtz"
            }
            break;
          case '8':	 // 4 strings to match.
            if (memcmp(Name.data()+14, "_sat_rt", 7) != 0)
              break;
            switch (Name[21]) {
            default: break;
            case 'e':	 // 1 string to match.
              return std::make_pair(309, 11);	 // "convert_uchar8_sat_rte"
            case 'n':	 // 1 string to match.
              return std::make_pair(309, 11);	 // "convert_uchar8_sat_rtn"
            case 'p':	 // 1 string to match.
              return std::make_pair(309, 11);	 // "convert_uchar8_sat_rtp"
            case 'z':	 // 1 string to match.
              return std::make_pair(309, 11);	 // "convert_uchar8_sat_rtz"
            }
            break;
          }
          break;
        case 'i':	 // 4 strings to match.
          if (memcmp(Name.data()+10, "nt16_sat_rt", 11) != 0)
            break;
          switch (Name[21]) {
          default: break;
          case 'e':	 // 1 string to match.
            return std::make_pair(584, 11);	 // "convert_uint16_sat_rte"
          case 'n':	 // 1 string to match.
            return std::make_pair(584, 11);	 // "convert_uint16_sat_rtn"
          case 'p':	 // 1 string to match.
            return std::make_pair(584, 11);	 // "convert_uint16_sat_rtp"
          case 'z':	 // 1 string to match.
            return std::make_pair(584, 11);	 // "convert_uint16_sat_rtz"
          }
          break;
        case 'l':	 // 16 strings to match.
          if (memcmp(Name.data()+10, "ong", 3) != 0)
            break;
          switch (Name[13]) {
          default: break;
          case '2':	 // 4 strings to match.
            if (memcmp(Name.data()+14, "_sat_rt", 7) != 0)
              break;
            switch (Name[21]) {
            default: break;
            case 'e':	 // 1 string to match.
              return std::make_pair(672, 11);	 // "convert_ulong2_sat_rte"
            case 'n':	 // 1 string to match.
              return std::make_pair(672, 11);	 // "convert_ulong2_sat_rtn"
            case 'p':	 // 1 string to match.
              return std::make_pair(672, 11);	 // "convert_ulong2_sat_rtp"
            case 'z':	 // 1 string to match.
              return std::make_pair(672, 11);	 // "convert_ulong2_sat_rtz"
            }
            break;
          case '3':	 // 4 strings to match.
            if (memcmp(Name.data()+14, "_sat_rt", 7) != 0)
              break;
            switch (Name[21]) {
            default: break;
            case 'e':	 // 1 string to match.
              return std::make_pair(683, 11);	 // "convert_ulong3_sat_rte"
            case 'n':	 // 1 string to match.
              return std::make_pair(683, 11);	 // "convert_ulong3_sat_rtn"
            case 'p':	 // 1 string to match.
              return std::make_pair(683, 11);	 // "convert_ulong3_sat_rtp"
            case 'z':	 // 1 string to match.
              return std::make_pair(683, 11);	 // "convert_ulong3_sat_rtz"
            }
            break;
          case '4':	 // 4 strings to match.
            if (memcmp(Name.data()+14, "_sat_rt", 7) != 0)
              break;
            switch (Name[21]) {
            default: break;
            case 'e':	 // 1 string to match.
              return std::make_pair(694, 11);	 // "convert_ulong4_sat_rte"
            case 'n':	 // 1 string to match.
              return std::make_pair(694, 11);	 // "convert_ulong4_sat_rtn"
            case 'p':	 // 1 string to match.
              return std::make_pair(694, 11);	 // "convert_ulong4_sat_rtp"
            case 'z':	 // 1 string to match.
              return std::make_pair(694, 11);	 // "convert_ulong4_sat_rtz"
            }
            break;
          case '8':	 // 4 strings to match.
            if (memcmp(Name.data()+14, "_sat_rt", 7) != 0)
              break;
            switch (Name[21]) {
            default: break;
            case 'e':	 // 1 string to match.
              return std::make_pair(705, 11);	 // "convert_ulong8_sat_rte"
            case 'n':	 // 1 string to match.
              return std::make_pair(705, 11);	 // "convert_ulong8_sat_rtn"
            case 'p':	 // 1 string to match.
              return std::make_pair(705, 11);	 // "convert_ulong8_sat_rtp"
            case 'z':	 // 1 string to match.
              return std::make_pair(705, 11);	 // "convert_ulong8_sat_rtz"
            }
            break;
          }
          break;
        case 's':	 // 4 strings to match.
          if (memcmp(Name.data()+10, "hort_sat_rt", 11) != 0)
            break;
          switch (Name[21]) {
          default: break;
          case 'e':	 // 1 string to match.
            return std::make_pair(397, 11);	 // "convert_ushort_sat_rte"
          case 'n':	 // 1 string to match.
            return std::make_pair(397, 11);	 // "convert_ushort_sat_rtn"
          case 'p':	 // 1 string to match.
            return std::make_pair(397, 11);	 // "convert_ushort_sat_rtp"
          case 'z':	 // 1 string to match.
            return std::make_pair(397, 11);	 // "convert_ushort_sat_rtz"
          }
          break;
        }
        break;
      }
      break;
    case 'g':	 // 1 string to match.
      if (memcmp(Name.data()+1, "et_max_sub_group_size", 21) != 0)
        break;
      return std::make_pair(1926, 1);	 // "get_max_sub_group_size"
    }
    break;
  case 23:	 // 50 strings to match.
    switch (Name[0]) {
    default: break;
    case 'c':	 // 48 strings to match.
      if (memcmp(Name.data()+1, "onvert_", 7) != 0)
        break;
      switch (Name[8]) {
      default: break;
      case 'd':	 // 16 strings to match.
        if (memcmp(Name.data()+9, "ouble", 5) != 0)
          break;
        switch (Name[14]) {
        default: break;
        case '2':	 // 4 strings to match.
          if (memcmp(Name.data()+15, "_sat_rt", 7) != 0)
            break;
          switch (Name[22]) {
          default: break;
          case 'e':	 // 1 string to match.
            return std::make_pair(67, 11);	 // "convert_double2_sat_rte"
          case 'n':	 // 1 string to match.
            return std::make_pair(67, 11);	 // "convert_double2_sat_rtn"
          case 'p':	 // 1 string to match.
            return std::make_pair(67, 11);	 // "convert_double2_sat_rtp"
          case 'z':	 // 1 string to match.
            return std::make_pair(67, 11);	 // "convert_double2_sat_rtz"
          }
          break;
        case '3':	 // 4 strings to match.
          if (memcmp(Name.data()+15, "_sat_rt", 7) != 0)
            break;
          switch (Name[22]) {
          default: break;
          case 'e':	 // 1 string to match.
            return std::make_pair(12, 11);	 // "convert_double3_sat_rte"
          case 'n':	 // 1 string to match.
            return std::make_pair(12, 11);	 // "convert_double3_sat_rtn"
          case 'p':	 // 1 string to match.
            return std::make_pair(12, 11);	 // "convert_double3_sat_rtp"
          case 'z':	 // 1 string to match.
            return std::make_pair(12, 11);	 // "convert_double3_sat_rtz"
          }
          break;
        case '4':	 // 4 strings to match.
          if (memcmp(Name.data()+15, "_sat_rt", 7) != 0)
            break;
          switch (Name[22]) {
          default: break;
          case 'e':	 // 1 string to match.
            return std::make_pair(23, 11);	 // "convert_double4_sat_rte"
          case 'n':	 // 1 string to match.
            return std::make_pair(23, 11);	 // "convert_double4_sat_rtn"
          case 'p':	 // 1 string to match.
            return std::make_pair(23, 11);	 // "convert_double4_sat_rtp"
          case 'z':	 // 1 string to match.
            return std::make_pair(23, 11);	 // "convert_double4_sat_rtz"
          }
          break;
        case '8':	 // 4 strings to match.
          if (memcmp(Name.data()+15, "_sat_rt", 7) != 0)
            break;
          switch (Name[22]) {
          default: break;
          case 'e':	 // 1 string to match.
            return std::make_pair(34, 11);	 // "convert_double8_sat_rte"
          case 'n':	 // 1 string to match.
            return std::make_pair(34, 11);	 // "convert_double8_sat_rtn"
          case 'p':	 // 1 string to match.
            return std::make_pair(34, 11);	 // "convert_double8_sat_rtp"
          case 'z':	 // 1 string to match.
            return std::make_pair(34, 11);	 // "convert_double8_sat_rtz"
          }
          break;
        }
        break;
      case 'f':	 // 4 strings to match.
        if (memcmp(Name.data()+9, "loat16_sat_rt", 13) != 0)
          break;
        switch (Name[22]) {
        default: break;
        case 'e':	 // 1 string to match.
          return std::make_pair(78, 11);	 // "convert_float16_sat_rte"
        case 'n':	 // 1 string to match.
          return std::make_pair(78, 11);	 // "convert_float16_sat_rtn"
        case 'p':	 // 1 string to match.
          return std::make_pair(78, 11);	 // "convert_float16_sat_rtp"
        case 'z':	 // 1 string to match.
          return std::make_pair(78, 11);	 // "convert_float16_sat_rtz"
        }
        break;
      case 's':	 // 4 strings to match.
        if (memcmp(Name.data()+9, "hort16_sat_rt", 13) != 0)
          break;
        switch (Name[22]) {
        default: break;
        case 'e':	 // 1 string to match.
          return std::make_pair(386, 11);	 // "convert_short16_sat_rte"
        case 'n':	 // 1 string to match.
          return std::make_pair(386, 11);	 // "convert_short16_sat_rtn"
        case 'p':	 // 1 string to match.
          return std::make_pair(386, 11);	 // "convert_short16_sat_rtp"
        case 'z':	 // 1 string to match.
          return std::make_pair(386, 11);	 // "convert_short16_sat_rtz"
        }
        break;
      case 'u':	 // 24 strings to match.
        switch (Name[9]) {
        default: break;
        case 'c':	 // 4 strings to match.
          if (memcmp(Name.data()+10, "har16_sat_rt", 12) != 0)
            break;
          switch (Name[22]) {
          default: break;
          case 'e':	 // 1 string to match.
            return std::make_pair(320, 11);	 // "convert_uchar16_sat_rte"
          case 'n':	 // 1 string to match.
            return std::make_pair(320, 11);	 // "convert_uchar16_sat_rtn"
          case 'p':	 // 1 string to match.
            return std::make_pair(320, 11);	 // "convert_uchar16_sat_rtp"
          case 'z':	 // 1 string to match.
            return std::make_pair(320, 11);	 // "convert_uchar16_sat_rtz"
          }
          break;
        case 'l':	 // 4 strings to match.
          if (memcmp(Name.data()+10, "ong16_sat_rt", 12) != 0)
            break;
          switch (Name[22]) {
          default: break;
          case 'e':	 // 1 string to match.
            return std::make_pair(716, 11);	 // "convert_ulong16_sat_rte"
          case 'n':	 // 1 string to match.
            return std::make_pair(716, 11);	 // "convert_ulong16_sat_rtn"
          case 'p':	 // 1 string to match.
            return std::make_pair(716, 11);	 // "convert_ulong16_sat_rtp"
          case 'z':	 // 1 string to match.
            return std::make_pair(716, 11);	 // "convert_ulong16_sat_rtz"
          }
          break;
        case 's':	 // 16 strings to match.
          if (memcmp(Name.data()+10, "hort", 4) != 0)
            break;
          switch (Name[14]) {
          default: break;
          case '2':	 // 4 strings to match.
            if (memcmp(Name.data()+15, "_sat_rt", 7) != 0)
              break;
            switch (Name[22]) {
            default: break;
            case 'e':	 // 1 string to match.
              return std::make_pair(408, 11);	 // "convert_ushort2_sat_rte"
            case 'n':	 // 1 string to match.
              return std::make_pair(408, 11);	 // "convert_ushort2_sat_rtn"
            case 'p':	 // 1 string to match.
              return std::make_pair(408, 11);	 // "convert_ushort2_sat_rtp"
            case 'z':	 // 1 string to match.
              return std::make_pair(408, 11);	 // "convert_ushort2_sat_rtz"
            }
            break;
          case '3':	 // 4 strings to match.
            if (memcmp(Name.data()+15, "_sat_rt", 7) != 0)
              break;
            switch (Name[22]) {
            default: break;
            case 'e':	 // 1 string to match.
              return std::make_pair(419, 11);	 // "convert_ushort3_sat_rte"
            case 'n':	 // 1 string to match.
              return std::make_pair(419, 11);	 // "convert_ushort3_sat_rtn"
            case 'p':	 // 1 string to match.
              return std::make_pair(419, 11);	 // "convert_ushort3_sat_rtp"
            case 'z':	 // 1 string to match.
              return std::make_pair(419, 11);	 // "convert_ushort3_sat_rtz"
            }
            break;
          case '4':	 // 4 strings to match.
            if (memcmp(Name.data()+15, "_sat_rt", 7) != 0)
              break;
            switch (Name[22]) {
            default: break;
            case 'e':	 // 1 string to match.
              return std::make_pair(430, 11);	 // "convert_ushort4_sat_rte"
            case 'n':	 // 1 string to match.
              return std::make_pair(430, 11);	 // "convert_ushort4_sat_rtn"
            case 'p':	 // 1 string to match.
              return std::make_pair(430, 11);	 // "convert_ushort4_sat_rtp"
            case 'z':	 // 1 string to match.
              return std::make_pair(430, 11);	 // "convert_ushort4_sat_rtz"
            }
            break;
          case '8':	 // 4 strings to match.
            if (memcmp(Name.data()+15, "_sat_rt", 7) != 0)
              break;
            switch (Name[22]) {
            default: break;
            case 'e':	 // 1 string to match.
              return std::make_pair(441, 11);	 // "convert_ushort8_sat_rte"
            case 'n':	 // 1 string to match.
              return std::make_pair(441, 11);	 // "convert_ushort8_sat_rtn"
            case 'p':	 // 1 string to match.
              return std::make_pair(441, 11);	 // "convert_ushort8_sat_rtp"
            case 'z':	 // 1 string to match.
              return std::make_pair(441, 11);	 // "convert_ushort8_sat_rtz"
            }
            break;
          }
          break;
        }
        break;
      }
      break;
    case 'g':	 // 2 strings to match.
      if (memcmp(Name.data()+1, "et_", 3) != 0)
        break;
      switch (Name[4]) {
      default: break;
      case 'e':	 // 1 string to match.
        if (memcmp(Name.data()+5, "nqueued_local_size", 18) != 0)
          break;
        return std::make_pair(729, 1);	 // "get_enqueued_local_size"
      case 'i':	 // 1 string to match.
        if (memcmp(Name.data()+5, "mage_channel_order", 18) != 0)
          break;
        return std::make_pair(1749, 36);	 // "get_image_channel_order"
      }
      break;
    }
    break;
  case 24:	 // 9 strings to match.
    switch (Name[0]) {
    default: break;
    case 'c':	 // 8 strings to match.
      if (memcmp(Name.data()+1, "onvert_", 7) != 0)
        break;
      switch (Name[8]) {
      default: break;
      case 'd':	 // 4 strings to match.
        if (memcmp(Name.data()+9, "ouble16_sat_rt", 14) != 0)
          break;
        switch (Name[23]) {
        default: break;
        case 'e':	 // 1 string to match.
          return std::make_pair(45, 11);	 // "convert_double16_sat_rte"
        case 'n':	 // 1 string to match.
          return std::make_pair(45, 11);	 // "convert_double16_sat_rtn"
        case 'p':	 // 1 string to match.
          return std::make_pair(45, 11);	 // "convert_double16_sat_rtp"
        case 'z':	 // 1 string to match.
          return std::make_pair(45, 11);	 // "convert_double16_sat_rtz"
        }
        break;
      case 'u':	 // 4 strings to match.
        if (memcmp(Name.data()+9, "short16_sat_rt", 14) != 0)
          break;
        switch (Name[23]) {
        default: break;
        case 'e':	 // 1 string to match.
          return std::make_pair(452, 11);	 // "convert_ushort16_sat_rte"
        case 'n':	 // 1 string to match.
          return std::make_pair(452, 11);	 // "convert_ushort16_sat_rtn"
        case 'p':	 // 1 string to match.
          return std::make_pair(452, 11);	 // "convert_ushort16_sat_rtp"
        case 'z':	 // 1 string to match.
          return std::make_pair(452, 11);	 // "convert_ushort16_sat_rtz"
        }
        break;
      }
      break;
    case 'g':	 // 1 string to match.
      if (memcmp(Name.data()+1, "et_image_num_mip_levels", 23) != 0)
        break;
      return std::make_pair(1893, 21);	 // "get_image_num_mip_levels"
    }
    break;
  case 27:	 // 1 string to match.
    if (memcmp(Name.data()+0, "get_image_channel_data_type", 27) != 0)
      break;
    return std::make_pair(1749, 36);	 // "get_image_channel_data_type"
  case 29:	 // 7 strings to match.
    switch (Name[0]) {
    default: break;
    case 'a':	 // 1 string to match.
      if (memcmp(Name.data()+1, "sync_work_group_strided_copy", 28) != 0)
        break;
      return std::make_pair(1488, 2);	 // "async_work_group_strided_copy"
    case 'w':	 // 6 strings to match.
      if (memcmp(Name.data()+1, "ork_group_scan_", 15) != 0)
        break;
      switch (Name[16]) {
      default: break;
      case 'e':	 // 3 strings to match.
        if (memcmp(Name.data()+17, "xclusive_", 9) != 0)
          break;
        switch (Name[26]) {
        default: break;
        case 'a':	 // 1 string to match.
          if (memcmp(Name.data()+27, "dd", 2) != 0)
            break;
          return std::make_pair(1892, 1);	 // "work_group_scan_exclusive_add"
        case 'm':	 // 2 strings to match.
          switch (Name[27]) {
          default: break;
          case 'a':	 // 1 string to match.
            if (Name[28] != 'x')
              break;
            return std::make_pair(1892, 1);	 // "work_group_scan_exclusive_max"
          case 'i':	 // 1 string to match.
            if (Name[28] != 'n')
              break;
            return std::make_pair(1892, 1);	 // "work_group_scan_exclusive_min"
          }
          break;
        }
        break;
      case 'i':	 // 3 strings to match.
        if (memcmp(Name.data()+17, "nclusive_", 9) != 0)
          break;
        switch (Name[26]) {
        default: break;
        case 'a':	 // 1 string to match.
          if (memcmp(Name.data()+27, "dd", 2) != 0)
            break;
          return std::make_pair(1892, 1);	 // "work_group_scan_inclusive_add"
        case 'm':	 // 2 strings to match.
          switch (Name[27]) {
          default: break;
          case 'a':	 // 1 string to match.
            if (Name[28] != 'x')
              break;
            return std::make_pair(1892, 1);	 // "work_group_scan_inclusive_max"
          case 'i':	 // 1 string to match.
            if (Name[28] != 'n')
              break;
            return std::make_pair(1892, 1);	 // "work_group_scan_inclusive_min"
          }
          break;
        }
        break;
      }
      break;
    }
    break;
  }
  return std::make_pair(0, 0);
} // isOpenCLBuiltin


// Convert an OpenCLTypeStruct type to a list of QualTypes.
// Generic types represent multiple types and vector sizes, thus a vector
// is returned. The conversion is done in two steps:
// Step 1: A switch statement fills a vector with scalar base types for the
//         Cartesian product of (vector sizes) x (types) for generic types,
//         or a single scalar type for non generic types.
// Step 2: Qualifiers and other type properties such as vector size are
//         applied.
static void OCL2Qual(ASTContext &Context, const OpenCLTypeStruct &Ty,
                     llvm::SmallVectorImpl<QualType> &QT) {
  // Number of scalar types in the GenType.
  unsigned GenTypeNumTypes;
  // Pointer to the list of vector sizes for the GenType.
  llvm::ArrayRef<unsigned> GenVectorSizes;
  constexpr unsigned ListVec1[] = {1, };
  constexpr unsigned ListVec1234[] = {1, 2, 3, 4, };
  constexpr unsigned ListVec16[] = {16, };
  constexpr unsigned ListVec2[] = {2, };
  constexpr unsigned ListVec4[] = {4, };
  constexpr unsigned ListVec8[] = {8, };
  constexpr unsigned ListVecAndScalar[] = {1, 2, 3, 4, 8, 16, };
  constexpr unsigned ListVecNoScalar[] = {2, 3, 4, 8, 16, };

  switch (Ty.ID) {
    case OCLT_Image1d:
      switch (Ty.AccessQualifier) {
        case OCLAQ_None:
          llvm_unreachable("Image without access qualifier");
        case OCLAQ_ReadOnly:
          QT.push_back(Context.OCLImage1dROTy);
          break;
        case OCLAQ_ReadWrite:
          QT.push_back(Context.OCLImage1dRWTy);
          break;
        case OCLAQ_WriteOnly:
          QT.push_back(Context.OCLImage1dWOTy);
          break;
      }
      break;
    case OCLT_Image1dArray:
      switch (Ty.AccessQualifier) {
        case OCLAQ_None:
          llvm_unreachable("Image without access qualifier");
        case OCLAQ_ReadOnly:
          QT.push_back(Context.OCLImage1dArrayROTy);
          break;
        case OCLAQ_ReadWrite:
          QT.push_back(Context.OCLImage1dArrayRWTy);
          break;
        case OCLAQ_WriteOnly:
          QT.push_back(Context.OCLImage1dArrayWOTy);
          break;
      }
      break;
    case OCLT_Image1dBuffer:
      switch (Ty.AccessQualifier) {
        case OCLAQ_None:
          llvm_unreachable("Image without access qualifier");
        case OCLAQ_ReadOnly:
          QT.push_back(Context.OCLImage1dBufferROTy);
          break;
        case OCLAQ_ReadWrite:
          QT.push_back(Context.OCLImage1dBufferRWTy);
          break;
        case OCLAQ_WriteOnly:
          QT.push_back(Context.OCLImage1dBufferWOTy);
          break;
      }
      break;
    case OCLT_Image2d:
      switch (Ty.AccessQualifier) {
        case OCLAQ_None:
          llvm_unreachable("Image without access qualifier");
        case OCLAQ_ReadOnly:
          QT.push_back(Context.OCLImage2dROTy);
          break;
        case OCLAQ_ReadWrite:
          QT.push_back(Context.OCLImage2dRWTy);
          break;
        case OCLAQ_WriteOnly:
          QT.push_back(Context.OCLImage2dWOTy);
          break;
      }
      break;
    case OCLT_Image2dArray:
      switch (Ty.AccessQualifier) {
        case OCLAQ_None:
          llvm_unreachable("Image without access qualifier");
        case OCLAQ_ReadOnly:
          QT.push_back(Context.OCLImage2dArrayROTy);
          break;
        case OCLAQ_ReadWrite:
          QT.push_back(Context.OCLImage2dArrayRWTy);
          break;
        case OCLAQ_WriteOnly:
          QT.push_back(Context.OCLImage2dArrayWOTy);
          break;
      }
      break;
    case OCLT_Image2dArrayDepth:
      switch (Ty.AccessQualifier) {
        case OCLAQ_None:
          llvm_unreachable("Image without access qualifier");
        case OCLAQ_ReadOnly:
          QT.push_back(Context.OCLImage2dArrayDepthROTy);
          break;
        case OCLAQ_ReadWrite:
          QT.push_back(Context.OCLImage2dArrayDepthRWTy);
          break;
        case OCLAQ_WriteOnly:
          QT.push_back(Context.OCLImage2dArrayDepthWOTy);
          break;
      }
      break;
    case OCLT_Image2dArrayMsaa:
      switch (Ty.AccessQualifier) {
        case OCLAQ_None:
          llvm_unreachable("Image without access qualifier");
        case OCLAQ_ReadOnly:
          QT.push_back(Context.OCLImage2dArrayMSAAROTy);
          break;
        case OCLAQ_ReadWrite:
          QT.push_back(Context.OCLImage2dArrayMSAARWTy);
          break;
        case OCLAQ_WriteOnly:
          QT.push_back(Context.OCLImage2dArrayMSAAWOTy);
          break;
      }
      break;
    case OCLT_Image2dArrayMsaaDepth:
      switch (Ty.AccessQualifier) {
        case OCLAQ_None:
          llvm_unreachable("Image without access qualifier");
        case OCLAQ_ReadOnly:
          QT.push_back(Context.OCLImage2dArrayMSAADepthROTy);
          break;
        case OCLAQ_ReadWrite:
          QT.push_back(Context.OCLImage2dArrayMSAADepthRWTy);
          break;
        case OCLAQ_WriteOnly:
          QT.push_back(Context.OCLImage2dArrayMSAADepthWOTy);
          break;
      }
      break;
    case OCLT_Image2dDepth:
      switch (Ty.AccessQualifier) {
        case OCLAQ_None:
          llvm_unreachable("Image without access qualifier");
        case OCLAQ_ReadOnly:
          QT.push_back(Context.OCLImage2dDepthROTy);
          break;
        case OCLAQ_ReadWrite:
          QT.push_back(Context.OCLImage2dDepthRWTy);
          break;
        case OCLAQ_WriteOnly:
          QT.push_back(Context.OCLImage2dDepthWOTy);
          break;
      }
      break;
    case OCLT_Image2dMsaa:
      switch (Ty.AccessQualifier) {
        case OCLAQ_None:
          llvm_unreachable("Image without access qualifier");
        case OCLAQ_ReadOnly:
          QT.push_back(Context.OCLImage2dMSAAROTy);
          break;
        case OCLAQ_ReadWrite:
          QT.push_back(Context.OCLImage2dMSAARWTy);
          break;
        case OCLAQ_WriteOnly:
          QT.push_back(Context.OCLImage2dMSAAWOTy);
          break;
      }
      break;
    case OCLT_Image2dMsaaDepth:
      switch (Ty.AccessQualifier) {
        case OCLAQ_None:
          llvm_unreachable("Image without access qualifier");
        case OCLAQ_ReadOnly:
          QT.push_back(Context.OCLImage2dMSAADepthROTy);
          break;
        case OCLAQ_ReadWrite:
          QT.push_back(Context.OCLImage2dMSAADepthRWTy);
          break;
        case OCLAQ_WriteOnly:
          QT.push_back(Context.OCLImage2dMSAADepthWOTy);
          break;
      }
      break;
    case OCLT_Image3d:
      switch (Ty.AccessQualifier) {
        case OCLAQ_None:
          llvm_unreachable("Image without access qualifier");
        case OCLAQ_ReadOnly:
          QT.push_back(Context.OCLImage3dROTy);
          break;
        case OCLAQ_ReadWrite:
          QT.push_back(Context.OCLImage3dRWTy);
          break;
        case OCLAQ_WriteOnly:
          QT.push_back(Context.OCLImage3dWOTy);
          break;
      }
      break;
    case OCLT_AGenTypeN:
      QT.append({Context.CharTy, Context.UnsignedCharTy, Context.ShortTy, Context.UnsignedShortTy, Context.IntTy, Context.UnsignedIntTy, Context.LongTy, Context.UnsignedLongTy, Context.FloatTy, Context.DoubleTy, Context.HalfTy, Context.CharTy, Context.UnsignedCharTy, Context.ShortTy, Context.UnsignedShortTy, Context.IntTy, Context.UnsignedIntTy, Context.LongTy, Context.UnsignedLongTy, Context.FloatTy, Context.DoubleTy, Context.HalfTy, Context.CharTy, Context.UnsignedCharTy, Context.ShortTy, Context.UnsignedShortTy, Context.IntTy, Context.UnsignedIntTy, Context.LongTy, Context.UnsignedLongTy, Context.FloatTy, Context.DoubleTy, Context.HalfTy, Context.CharTy, Context.UnsignedCharTy, Context.ShortTy, Context.UnsignedShortTy, Context.IntTy, Context.UnsignedIntTy, Context.LongTy, Context.UnsignedLongTy, Context.FloatTy, Context.DoubleTy, Context.HalfTy, Context.CharTy, Context.UnsignedCharTy, Context.ShortTy, Context.UnsignedShortTy, Context.IntTy, Context.UnsignedIntTy, Context.LongTy, Context.UnsignedLongTy, Context.FloatTy, Context.DoubleTy, Context.HalfTy, Context.CharTy, Context.UnsignedCharTy, Context.ShortTy, Context.UnsignedShortTy, Context.IntTy, Context.UnsignedIntTy, Context.LongTy, Context.UnsignedLongTy, Context.FloatTy, Context.DoubleTy, Context.HalfTy, });
      GenTypeNumTypes = 11;
      GenVectorSizes = ListVecAndScalar;
      break;
    case OCLT_AGenTypeNNoScalar:
      QT.append({Context.CharTy, Context.UnsignedCharTy, Context.ShortTy, Context.UnsignedShortTy, Context.IntTy, Context.UnsignedIntTy, Context.LongTy, Context.UnsignedLongTy, Context.FloatTy, Context.DoubleTy, Context.HalfTy, Context.CharTy, Context.UnsignedCharTy, Context.ShortTy, Context.UnsignedShortTy, Context.IntTy, Context.UnsignedIntTy, Context.LongTy, Context.UnsignedLongTy, Context.FloatTy, Context.DoubleTy, Context.HalfTy, Context.CharTy, Context.UnsignedCharTy, Context.ShortTy, Context.UnsignedShortTy, Context.IntTy, Context.UnsignedIntTy, Context.LongTy, Context.UnsignedLongTy, Context.FloatTy, Context.DoubleTy, Context.HalfTy, Context.CharTy, Context.UnsignedCharTy, Context.ShortTy, Context.UnsignedShortTy, Context.IntTy, Context.UnsignedIntTy, Context.LongTy, Context.UnsignedLongTy, Context.FloatTy, Context.DoubleTy, Context.HalfTy, Context.CharTy, Context.UnsignedCharTy, Context.ShortTy, Context.UnsignedShortTy, Context.IntTy, Context.UnsignedIntTy, Context.LongTy, Context.UnsignedLongTy, Context.FloatTy, Context.DoubleTy, Context.HalfTy, });
      GenTypeNumTypes = 11;
      GenVectorSizes = ListVecNoScalar;
      break;
    case OCLT_AI2UGenTypeN:
      QT.append({Context.UnsignedCharTy, Context.UnsignedCharTy, Context.UnsignedShortTy, Context.UnsignedShortTy, Context.UnsignedIntTy, Context.UnsignedIntTy, Context.UnsignedLongTy, Context.UnsignedLongTy, Context.UnsignedCharTy, Context.UnsignedCharTy, Context.UnsignedShortTy, Context.UnsignedShortTy, Context.UnsignedIntTy, Context.UnsignedIntTy, Context.UnsignedLongTy, Context.UnsignedLongTy, Context.UnsignedCharTy, Context.UnsignedCharTy, Context.UnsignedShortTy, Context.UnsignedShortTy, Context.UnsignedIntTy, Context.UnsignedIntTy, Context.UnsignedLongTy, Context.UnsignedLongTy, Context.UnsignedCharTy, Context.UnsignedCharTy, Context.UnsignedShortTy, Context.UnsignedShortTy, Context.UnsignedIntTy, Context.UnsignedIntTy, Context.UnsignedLongTy, Context.UnsignedLongTy, Context.UnsignedCharTy, Context.UnsignedCharTy, Context.UnsignedShortTy, Context.UnsignedShortTy, Context.UnsignedIntTy, Context.UnsignedIntTy, Context.UnsignedLongTy, Context.UnsignedLongTy, Context.UnsignedCharTy, Context.UnsignedCharTy, Context.UnsignedShortTy, Context.UnsignedShortTy, Context.UnsignedIntTy, Context.UnsignedIntTy, Context.UnsignedLongTy, Context.UnsignedLongTy, });
      GenTypeNumTypes = 8;
      GenVectorSizes = ListVecAndScalar;
      break;
    case OCLT_AIGenType1:
      QT.append({Context.CharTy, Context.UnsignedCharTy, Context.ShortTy, Context.UnsignedShortTy, Context.IntTy, Context.UnsignedIntTy, Context.LongTy, Context.UnsignedLongTy, });
      GenTypeNumTypes = 8;
      GenVectorSizes = ListVec1;
      break;
    case OCLT_AIGenTypeN:
      QT.append({Context.CharTy, Context.UnsignedCharTy, Context.ShortTy, Context.UnsignedShortTy, Context.IntTy, Context.UnsignedIntTy, Context.LongTy, Context.UnsignedLongTy, Context.CharTy, Context.UnsignedCharTy, Context.ShortTy, Context.UnsignedShortTy, Context.IntTy, Context.UnsignedIntTy, Context.LongTy, Context.UnsignedLongTy, Context.CharTy, Context.UnsignedCharTy, Context.ShortTy, Context.UnsignedShortTy, Context.IntTy, Context.UnsignedIntTy, Context.LongTy, Context.UnsignedLongTy, Context.CharTy, Context.UnsignedCharTy, Context.ShortTy, Context.UnsignedShortTy, Context.IntTy, Context.UnsignedIntTy, Context.LongTy, Context.UnsignedLongTy, Context.CharTy, Context.UnsignedCharTy, Context.ShortTy, Context.UnsignedShortTy, Context.IntTy, Context.UnsignedIntTy, Context.LongTy, Context.UnsignedLongTy, Context.CharTy, Context.UnsignedCharTy, Context.ShortTy, Context.UnsignedShortTy, Context.IntTy, Context.UnsignedIntTy, Context.LongTy, Context.UnsignedLongTy, });
      GenTypeNumTypes = 8;
      GenVectorSizes = ListVecAndScalar;
      break;
    case OCLT_AIGenTypeNNoScalar:
      QT.append({Context.CharTy, Context.UnsignedCharTy, Context.ShortTy, Context.UnsignedShortTy, Context.IntTy, Context.UnsignedIntTy, Context.LongTy, Context.UnsignedLongTy, Context.CharTy, Context.UnsignedCharTy, Context.ShortTy, Context.UnsignedShortTy, Context.IntTy, Context.UnsignedIntTy, Context.LongTy, Context.UnsignedLongTy, Context.CharTy, Context.UnsignedCharTy, Context.ShortTy, Context.UnsignedShortTy, Context.IntTy, Context.UnsignedIntTy, Context.LongTy, Context.UnsignedLongTy, Context.CharTy, Context.UnsignedCharTy, Context.ShortTy, Context.UnsignedShortTy, Context.IntTy, Context.UnsignedIntTy, Context.LongTy, Context.UnsignedLongTy, Context.CharTy, Context.UnsignedCharTy, Context.ShortTy, Context.UnsignedShortTy, Context.IntTy, Context.UnsignedIntTy, Context.LongTy, Context.UnsignedLongTy, });
      GenTypeNumTypes = 8;
      GenVectorSizes = ListVecNoScalar;
      break;
    case OCLT_FGenTypeN:
      QT.append({Context.FloatTy, Context.DoubleTy, Context.HalfTy, Context.FloatTy, Context.DoubleTy, Context.HalfTy, Context.FloatTy, Context.DoubleTy, Context.HalfTy, Context.FloatTy, Context.DoubleTy, Context.HalfTy, Context.FloatTy, Context.DoubleTy, Context.HalfTy, Context.FloatTy, Context.DoubleTy, Context.HalfTy, });
      GenTypeNumTypes = 3;
      GenVectorSizes = ListVecAndScalar;
      break;
    case OCLT_GenTypeCharVecAndScalar:
      QT.append({Context.CharTy, Context.CharTy, Context.CharTy, Context.CharTy, Context.CharTy, Context.CharTy, });
      GenTypeNumTypes = 1;
      GenVectorSizes = ListVecAndScalar;
      break;
    case OCLT_GenTypeCharVecNoScalar:
      QT.append({Context.CharTy, Context.CharTy, Context.CharTy, Context.CharTy, Context.CharTy, });
      GenTypeNumTypes = 1;
      GenVectorSizes = ListVecNoScalar;
      break;
    case OCLT_GenTypeDoubleVec1234:
      QT.append({Context.DoubleTy, Context.DoubleTy, Context.DoubleTy, Context.DoubleTy, });
      GenTypeNumTypes = 1;
      GenVectorSizes = ListVec1234;
      break;
    case OCLT_GenTypeDoubleVecAndScalar:
      QT.append({Context.DoubleTy, Context.DoubleTy, Context.DoubleTy, Context.DoubleTy, Context.DoubleTy, Context.DoubleTy, });
      GenTypeNumTypes = 1;
      GenVectorSizes = ListVecAndScalar;
      break;
    case OCLT_GenTypeDoubleVecNoScalar:
      QT.append({Context.DoubleTy, Context.DoubleTy, Context.DoubleTy, Context.DoubleTy, Context.DoubleTy, });
      GenTypeNumTypes = 1;
      GenVectorSizes = ListVecNoScalar;
      break;
    case OCLT_GenTypeFloatVec1234:
      QT.append({Context.FloatTy, Context.FloatTy, Context.FloatTy, Context.FloatTy, });
      GenTypeNumTypes = 1;
      GenVectorSizes = ListVec1234;
      break;
    case OCLT_GenTypeFloatVecAndScalar:
      QT.append({Context.FloatTy, Context.FloatTy, Context.FloatTy, Context.FloatTy, Context.FloatTy, Context.FloatTy, });
      GenTypeNumTypes = 1;
      GenVectorSizes = ListVecAndScalar;
      break;
    case OCLT_GenTypeFloatVecNoScalar:
      QT.append({Context.FloatTy, Context.FloatTy, Context.FloatTy, Context.FloatTy, Context.FloatTy, });
      GenTypeNumTypes = 1;
      GenVectorSizes = ListVecNoScalar;
      break;
    case OCLT_GenTypeHalfVec1234:
      QT.append({Context.HalfTy, Context.HalfTy, Context.HalfTy, Context.HalfTy, });
      GenTypeNumTypes = 1;
      GenVectorSizes = ListVec1234;
      break;
    case OCLT_GenTypeHalfVecAndScalar:
      QT.append({Context.HalfTy, Context.HalfTy, Context.HalfTy, Context.HalfTy, Context.HalfTy, Context.HalfTy, });
      GenTypeNumTypes = 1;
      GenVectorSizes = ListVecAndScalar;
      break;
    case OCLT_GenTypeHalfVecNoScalar:
      QT.append({Context.HalfTy, Context.HalfTy, Context.HalfTy, Context.HalfTy, Context.HalfTy, });
      GenTypeNumTypes = 1;
      GenVectorSizes = ListVecNoScalar;
      break;
    case OCLT_GenTypeIntVecAndScalar:
      QT.append({Context.IntTy, Context.IntTy, Context.IntTy, Context.IntTy, Context.IntTy, Context.IntTy, });
      GenTypeNumTypes = 1;
      GenVectorSizes = ListVecAndScalar;
      break;
    case OCLT_GenTypeIntVecNoScalar:
      QT.append({Context.IntTy, Context.IntTy, Context.IntTy, Context.IntTy, Context.IntTy, });
      GenTypeNumTypes = 1;
      GenVectorSizes = ListVecNoScalar;
      break;
    case OCLT_GenTypeLongVecAndScalar:
      QT.append({Context.LongTy, Context.LongTy, Context.LongTy, Context.LongTy, Context.LongTy, Context.LongTy, });
      GenTypeNumTypes = 1;
      GenVectorSizes = ListVecAndScalar;
      break;
    case OCLT_GenTypeLongVecNoScalar:
      QT.append({Context.LongTy, Context.LongTy, Context.LongTy, Context.LongTy, Context.LongTy, });
      GenTypeNumTypes = 1;
      GenVectorSizes = ListVecNoScalar;
      break;
    case OCLT_GenTypeShortVecAndScalar:
      QT.append({Context.ShortTy, Context.ShortTy, Context.ShortTy, Context.ShortTy, Context.ShortTy, Context.ShortTy, });
      GenTypeNumTypes = 1;
      GenVectorSizes = ListVecAndScalar;
      break;
    case OCLT_GenTypeShortVecNoScalar:
      QT.append({Context.ShortTy, Context.ShortTy, Context.ShortTy, Context.ShortTy, Context.ShortTy, });
      GenTypeNumTypes = 1;
      GenVectorSizes = ListVecNoScalar;
      break;
    case OCLT_GenTypeUCharVecAndScalar:
      QT.append({Context.UnsignedCharTy, Context.UnsignedCharTy, Context.UnsignedCharTy, Context.UnsignedCharTy, Context.UnsignedCharTy, Context.UnsignedCharTy, });
      GenTypeNumTypes = 1;
      GenVectorSizes = ListVecAndScalar;
      break;
    case OCLT_GenTypeUCharVecNoScalar:
      QT.append({Context.UnsignedCharTy, Context.UnsignedCharTy, Context.UnsignedCharTy, Context.UnsignedCharTy, Context.UnsignedCharTy, });
      GenTypeNumTypes = 1;
      GenVectorSizes = ListVecNoScalar;
      break;
    case OCLT_GenTypeUIntVecAndScalar:
      QT.append({Context.UnsignedIntTy, Context.UnsignedIntTy, Context.UnsignedIntTy, Context.UnsignedIntTy, Context.UnsignedIntTy, Context.UnsignedIntTy, });
      GenTypeNumTypes = 1;
      GenVectorSizes = ListVecAndScalar;
      break;
    case OCLT_GenTypeUIntVecNoScalar:
      QT.append({Context.UnsignedIntTy, Context.UnsignedIntTy, Context.UnsignedIntTy, Context.UnsignedIntTy, Context.UnsignedIntTy, });
      GenTypeNumTypes = 1;
      GenVectorSizes = ListVecNoScalar;
      break;
    case OCLT_GenTypeULongVecAndScalar:
      QT.append({Context.UnsignedLongTy, Context.UnsignedLongTy, Context.UnsignedLongTy, Context.UnsignedLongTy, Context.UnsignedLongTy, Context.UnsignedLongTy, });
      GenTypeNumTypes = 1;
      GenVectorSizes = ListVecAndScalar;
      break;
    case OCLT_GenTypeULongVecNoScalar:
      QT.append({Context.UnsignedLongTy, Context.UnsignedLongTy, Context.UnsignedLongTy, Context.UnsignedLongTy, Context.UnsignedLongTy, });
      GenTypeNumTypes = 1;
      GenVectorSizes = ListVecNoScalar;
      break;
    case OCLT_GenTypeUShortVecAndScalar:
      QT.append({Context.UnsignedShortTy, Context.UnsignedShortTy, Context.UnsignedShortTy, Context.UnsignedShortTy, Context.UnsignedShortTy, Context.UnsignedShortTy, });
      GenTypeNumTypes = 1;
      GenVectorSizes = ListVecAndScalar;
      break;
    case OCLT_GenTypeUShortVecNoScalar:
      QT.append({Context.UnsignedShortTy, Context.UnsignedShortTy, Context.UnsignedShortTy, Context.UnsignedShortTy, Context.UnsignedShortTy, });
      GenTypeNumTypes = 1;
      GenVectorSizes = ListVecNoScalar;
      break;
    case OCLT_IntLongFloatGenType1:
      QT.append({Context.IntTy, Context.UnsignedIntTy, Context.LongTy, Context.UnsignedLongTy, Context.FloatTy, Context.DoubleTy, Context.HalfTy, });
      GenTypeNumTypes = 7;
      GenVectorSizes = ListVec1;
      break;
    case OCLT_SGenTypeN:
      QT.append({Context.CharTy, Context.ShortTy, Context.IntTy, Context.LongTy, Context.CharTy, Context.ShortTy, Context.IntTy, Context.LongTy, Context.CharTy, Context.ShortTy, Context.IntTy, Context.LongTy, Context.CharTy, Context.ShortTy, Context.IntTy, Context.LongTy, Context.CharTy, Context.ShortTy, Context.IntTy, Context.LongTy, Context.CharTy, Context.ShortTy, Context.IntTy, Context.LongTy, });
      GenTypeNumTypes = 4;
      GenVectorSizes = ListVecAndScalar;
      break;
    case OCLT_UGenTypeN:
      QT.append({Context.UnsignedCharTy, Context.UnsignedShortTy, Context.UnsignedIntTy, Context.UnsignedLongTy, Context.UnsignedCharTy, Context.UnsignedShortTy, Context.UnsignedIntTy, Context.UnsignedLongTy, Context.UnsignedCharTy, Context.UnsignedShortTy, Context.UnsignedIntTy, Context.UnsignedLongTy, Context.UnsignedCharTy, Context.UnsignedShortTy, Context.UnsignedIntTy, Context.UnsignedLongTy, Context.UnsignedCharTy, Context.UnsignedShortTy, Context.UnsignedIntTy, Context.UnsignedLongTy, Context.UnsignedCharTy, Context.UnsignedShortTy, Context.UnsignedIntTy, Context.UnsignedLongTy, });
      GenTypeNumTypes = 4;
      GenVectorSizes = ListVecAndScalar;
      break;
    case OCLT_TLAllVec2:
      QT.append({Context.CharTy, Context.UnsignedCharTy, Context.ShortTy, Context.UnsignedShortTy, Context.IntTy, Context.UnsignedIntTy, Context.LongTy, Context.UnsignedLongTy, Context.FloatTy, Context.DoubleTy, Context.HalfTy, });
      GenTypeNumTypes = 11;
      GenVectorSizes = ListVec2;
      break;
    case OCLT_TLAllUnsignedVec2:
      QT.append({Context.UnsignedCharTy, Context.UnsignedCharTy, Context.UnsignedShortTy, Context.UnsignedShortTy, Context.UnsignedIntTy, Context.UnsignedIntTy, Context.UnsignedLongTy, Context.UnsignedLongTy, Context.UnsignedIntTy, Context.UnsignedLongTy, Context.UnsignedShortTy, });
      GenTypeNumTypes = 11;
      GenVectorSizes = ListVec2;
      break;
    case OCLT_TLAllVec4:
      QT.append({Context.CharTy, Context.UnsignedCharTy, Context.ShortTy, Context.UnsignedShortTy, Context.IntTy, Context.UnsignedIntTy, Context.LongTy, Context.UnsignedLongTy, Context.FloatTy, Context.DoubleTy, Context.HalfTy, });
      GenTypeNumTypes = 11;
      GenVectorSizes = ListVec4;
      break;
    case OCLT_TLAllVec8:
      QT.append({Context.CharTy, Context.UnsignedCharTy, Context.ShortTy, Context.UnsignedShortTy, Context.IntTy, Context.UnsignedIntTy, Context.LongTy, Context.UnsignedLongTy, Context.FloatTy, Context.DoubleTy, Context.HalfTy, });
      GenTypeNumTypes = 11;
      GenVectorSizes = ListVec8;
      break;
    case OCLT_TLAllVec16:
      QT.append({Context.CharTy, Context.UnsignedCharTy, Context.ShortTy, Context.UnsignedShortTy, Context.IntTy, Context.UnsignedIntTy, Context.LongTy, Context.UnsignedLongTy, Context.FloatTy, Context.DoubleTy, Context.HalfTy, });
      GenTypeNumTypes = 11;
      GenVectorSizes = ListVec16;
      break;
    case OCLT_TLAllUnsignedVec4:
      QT.append({Context.UnsignedCharTy, Context.UnsignedCharTy, Context.UnsignedShortTy, Context.UnsignedShortTy, Context.UnsignedIntTy, Context.UnsignedIntTy, Context.UnsignedLongTy, Context.UnsignedLongTy, Context.UnsignedIntTy, Context.UnsignedLongTy, Context.UnsignedShortTy, });
      GenTypeNumTypes = 11;
      GenVectorSizes = ListVec4;
      break;
    case OCLT_TLAllUnsignedVec8:
      QT.append({Context.UnsignedCharTy, Context.UnsignedCharTy, Context.UnsignedShortTy, Context.UnsignedShortTy, Context.UnsignedIntTy, Context.UnsignedIntTy, Context.UnsignedLongTy, Context.UnsignedLongTy, Context.UnsignedIntTy, Context.UnsignedLongTy, Context.UnsignedShortTy, });
      GenTypeNumTypes = 11;
      GenVectorSizes = ListVec8;
      break;
    case OCLT_TLAllUnsignedVec16:
      QT.append({Context.UnsignedCharTy, Context.UnsignedCharTy, Context.UnsignedShortTy, Context.UnsignedShortTy, Context.UnsignedIntTy, Context.UnsignedIntTy, Context.UnsignedLongTy, Context.UnsignedLongTy, Context.UnsignedIntTy, Context.UnsignedLongTy, Context.UnsignedShortTy, });
      GenTypeNumTypes = 11;
      GenVectorSizes = ListVec16;
      break;
    case OCLT_bool:
      QT.push_back(Context.BoolTy);
      break;
    case OCLT_char:
      QT.push_back(Context.CharTy);
      break;
    case OCLT_double:
      QT.push_back(Context.DoubleTy);
      break;
    case OCLT_Event:
      QT.push_back(Context.OCLEventTy);
      break;
    case OCLT_float:
      QT.push_back(Context.FloatTy);
      break;
    case OCLT_half:
      QT.push_back(Context.HalfTy);
      break;
    case OCLT_int:
      QT.push_back(Context.IntTy);
      break;
    case OCLT_intptr_t:
      QT.push_back(Context.getIntPtrType());
      break;
    case OCLT_long:
      QT.push_back(Context.LongTy);
      break;
    case OCLT_ptrdiff_t:
      QT.push_back(Context.getPointerDiffType());
      break;
    case OCLT_Sampler:
      QT.push_back(Context.OCLSamplerTy);
      break;
    case OCLT_short:
      QT.push_back(Context.ShortTy);
      break;
    case OCLT_size_t:
      QT.push_back(Context.getSizeType());
      break;
    case OCLT_uchar:
      QT.push_back(Context.UnsignedCharTy);
      break;
    case OCLT_uint:
      QT.push_back(Context.UnsignedIntTy);
      break;
    case OCLT_uintPtr_t:
      QT.push_back(Context.getUIntPtrType());
      break;
    case OCLT_ulong:
      QT.push_back(Context.UnsignedLongTy);
      break;
    case OCLT_ushort:
      QT.push_back(Context.UnsignedShortTy);
      break;
    case OCLT_void_t:
      QT.push_back(Context.VoidTy);
      break;
  } // end of switch (Ty.ID)

  // Construct the different vector types for each generic type.
  if (Ty.ID >= 31) {
    for (unsigned I = 0; I < QT.size(); I++) {
      // For scalars, size is 1.
      if (GenVectorSizes[I / GenTypeNumTypes] != 1) {
        QT[I] = Context.getExtVectorType(QT[I],
                          GenVectorSizes[I / GenTypeNumTypes]);
      }
    }
  }

  // Set vector size for non-generic vector types.
  if (Ty.VectorWidth > 1) {
    for (unsigned Index = 0; Index < QT.size(); Index++) {
      QT[Index] = Context.getExtVectorType(QT[Index], Ty.VectorWidth);
    }
  }

  if (Ty.IsVolatile != 0) {
    for (unsigned Index = 0; Index < QT.size(); Index++) {
      QT[Index] = Context.getVolatileType(QT[Index]);
    }
  }

  if (Ty.IsConst != 0) {
    for (unsigned Index = 0; Index < QT.size(); Index++) {
      QT[Index] = Context.getConstType(QT[Index]);
    }
  }

  // Transform the type to a pointer as the last step, if necessary.
  // Builtin functions only have pointers on [const|volatile], no
  // [const|volatile] pointers, so this is ok to do it as a last step.
  if (Ty.IsPointer != 0) {
    for (unsigned Index = 0; Index < QT.size(); Index++) {
      QT[Index] = Context.getAddrSpaceQualType(QT[Index], Ty.AS);
      QT[Index] = Context.getPointerType(QT[Index]);
    }
  }

} // OCL2Qual
